VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocMapcharSets 
   ClientHeight    =   3225
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8250
   KeyPreview      =   -1  'True
   ScaleHeight     =   3225
   ScaleWidth      =   8250
   ToolboxBitmap   =   "DBMDocMapcharSets.ctx":0000
   Begin MSComctlLib.ListView lvwMapcharSets 
      Height          =   1755
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   3096
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Code Type"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMDoc.DBMDocMapcharSet docMapcharSet 
      Height          =   1695
      Left            =   3360
      TabIndex        =   1
      Top             =   60
      Visible         =   0   'False
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   2990
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2820
      Top             =   420
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2820
      Top             =   60
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.Popup POP 
      Left            =   2820
      Top             =   780
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   2775
      Width           =   8250
      _ExtentX        =   14552
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuMapcharSets 
      Caption         =   "MapcharSets"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocMapcharSets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM

Const ERR_LOADMAPCHARS = "Error while loading mapchar sets!"
Const ERR_SAVEMAPCHARS = "Error while saving mapchar set!"

Private Enum MapCharsetsCommands
    cmdMapCharsets
    cmdMapcharSetNew
    cmdMapcharSetEdit
    cmdMapcharSetCopy
    cmdMapcharSetDelete
    cmdMapcharSetsRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdMapCharsets
Const CMD_LAST = cmdSeperator

Private Enum MediaPopupConstants
    popMapcharSets = 1
    popMapcharSet
End Enum


Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''

Private Enum MapcharSetsColumnConstants
    mcName
    mcType
End Enum

'''

Public Event MapCharsChanged(oDatabase As Object)

Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean
Private bFitColumnSize As Boolean
Private bMapcharSetOpen As Boolean

'''

Public Event WrongDBState()

Public Event MapcharSetClick(ByVal MapcharSet As DBMLib.MapcharSet)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_MAPCHARSETS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_MAPCHARSETS)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    UserControl.MousePointer = vbHourglass
    MapcharSetsRefresh
    UserControl.MousePointer = vbDefault
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwMapcharSets, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    docMapcharSet.Reset
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    docMapcharSet.CleanUp

    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub

Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True

    bMapcharSetOpen = False
    
    bFitColumnSize = True

    MapcharSetsInit
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwMapcharSets.Move 0, iTop, ScaleWidth, iHeight
    
    iHeight = ScaleHeight
    If iHeight < 0 Then iHeight = 0
    
    docMapcharSet.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwMapcharSets
'
Private Sub lvwMapcharSets_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ListViewUtil.SortColumn lvwMapcharSets, ColumnHeader
End Sub

Private Sub lvwMapcharSets_ItemClick(ByVal Item As MSComctlLib.ListItem)
    MapcharSetsSelectItem Item
End Sub

Private Sub lvwMapcharSets_DblClick()
    If bItemClick Then MapcharSetEdit
End Sub

Private Sub lvwMapcharSets_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwMapcharSets.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwMapcharSets_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwMapcharSets.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popMapcharSets
        Else
            POP.Show popMapcharSet
        End If
    End If
End Sub

Private Sub lvwMapcharSets_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdMapcharSetEdit).Enabled Then
                        MapcharSetEdit
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdMapcharSetsRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docMapcharSet
'
Private Sub docMapcharSet_Command(ByVal Command As MapcharSetCommands)
    Select Case Command
        Case cmdMapcharSetCancel:
            bMapcharSetOpen = False
            TIBCaption oTIB, Caption

            docMapcharSet.Visible = False
            lvwMapcharSets.SetFocus
    End Select
End Sub

Private Sub docMapcharSet_MapcharSetChanged(ByVal MapcharSet As DBMLib.MapcharSet)
    Dim oItem As MSComctlLib.ListItem

    If Not MapcharSet Is Nothing Then
        Set oItem = ListViewUtil.GetListItemByKey(lvwMapcharSets, MapcharSet.Name)
        If Not oItem Is Nothing Then
            oItem.SubItems(mcType) = MapcharSet.CodeTypeStr
        End If
    End If
    
    bMapcharSetOpen = False
    TIBCaption oTIB, Caption
    
    docMapcharSet.Visible = False
    lvwMapcharSets.SetFocus
End Sub

Private Sub docMapcharSet_MapcharSetCreated(ByVal MapcharSet As DBMLib.MapcharSet)
    Dim oItem As MSComctlLib.ListItem
    
    Set oItem = lvwMapcharSets.ListItems.Add(, MapcharSet.Name, MapcharSet.Name, , oRes.Bitmap16ID(IDB_16_MAPCHARSETS))
    oItem.SubItems(mcType) = MapcharSet.CodeTypeStr
    
    MapcharSetsSelectItem oItem

    bMapcharSetOpen = False
    TIBCaption oTIB, Caption
    
    docMapcharSet.Visible = False
    lvwMapcharSets.SetFocus
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdMapcharSetNew:      MapcharSetNew
        Case cmdMapcharSetCopy:     MapcharSetCopy
        Case cmdMapcharSetEdit:     MapcharSetEdit
        Case cmdMapcharSetDelete:   MapcharSetDelete
        Case cmdMapcharSetsRefresh: MapcharSetsRefresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdMapCharsets, "&MapcharSets", 0
        .Add cmdTypeDefault, cmdMapcharSetNew, "New", oRes.Bitmap16ID(IDB_16_MAPCHARSET_NEW)
        .Add cmdTypeDefault, cmdMapcharSetCopy, "Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdMapcharSetEdit, "Edit", oRes.Bitmap16ID(IDB_16_EDIT)
        .Add cmdTypeDefault, cmdMapcharSetDelete, "Delete", oRes.Bitmap16ID(IDB_16_DELETE)
        .Add cmdTypeDefault, cmdMapcharSetsRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdMapcharSetNew)
        Set oItem = .Add(cmdMapcharSetCopy)
        Set oItem = .Add(cmdMapcharSetEdit)
        Set oItem = .Add(cmdMapcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMapcharSetsRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdMapCharsets)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdMapcharSetNew)
        Set oItem = .Add(cmdMapcharSetCopy)
        Set oItem = .Add(cmdMapcharSetEdit)
        Set oItem = .Add(cmdMapcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMapcharSetsRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupMapcharSetsInit
    PopupMapcharSetInit
End Sub

Private Sub PopupMapcharSetsInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdMapcharSetNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMapcharSetsRefresh)
    End With
End Sub

Private Sub PopupMapcharSetInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdMapcharSetNew)
        Set oItem = .Add(cmdMapcharSetCopy)
        Set oItem = .Add(cmdMapcharSetEdit)
        Set oItem = .Add(cmdMapcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMapcharSetsRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    Dim oMapcharSet As DBMLib.MapcharSet
    
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            If oItemAct Is Nothing Then
                .Item(cmdMapcharSetCopy).Enabled = False
                .Item(cmdMapcharSetEdit).Enabled = False
                .Item(cmdMapcharSetDelete).Enabled = False
            Else
                .Item(cmdMapcharSetCopy).Enabled = True
                .Item(cmdMapcharSetEdit).Enabled = True
                .Item(cmdMapcharSetDelete).Enabled = True
            End If
            .Item(cmdMapcharSetsRefresh).Enabled = True
        Else
            .Item(cmdMapcharSetCopy).Enabled = False
            .Item(cmdMapcharSetEdit).Enabled = False
            .Item(cmdMapcharSetDelete).Enabled = False
            .Item(cmdMapcharSetsRefresh).Enabled = False
        End If
    End With
    
    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub MapcharSetsInit()
    lvwMapcharSets.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub MapcharSetsRefresh()
    Dim sError As String
    
    If Not oDB Is Nothing Then
        If Not oDB.MapcharSets.ReQuery(sError) Then
            If (Len(Trim(sError)) > 0) Then
                MsgBox ERR_LOADMAPCHARS + vbCrLf + vbCrLf + "(" + Trim(sError) + ")", vbExclamation
            Else
                MsgBox ERR_LOADMAPCHARS, vbExclamation
            End If
        End If
        
        MapcharSetsList
    End If
End Sub

Private Sub MapcharSetsList()
    Dim oMapcharSet As DBMLib.MapcharSet
    Dim oItem As MSComctlLib.ListItem
    
    If oDB Is Nothing Then Exit Sub
        
    lvwMapcharSets.ListItems.Clear
        
    For Each oMapcharSet In oDB.MapcharSets
        Set oItem = lvwMapcharSets.ListItems.Add(, oMapcharSet.Name, oMapcharSet.Name, , oRes.Bitmap16ID(IDB_16_MAPCHARSETS))
        oItem.SubItems(mcType) = oMapcharSet.CodeTypeStr
    Next
    
    If bFitColumnSize Then
        ListViewUtil.FitColumnSize lvwMapcharSets, True
        bFitColumnSize = False
    End If
    
    Set oItemAct = lvwMapcharSets.SelectedItem
    
    CommandsSet False
End Sub

Private Sub MapcharSetsSelectItem(ByVal oItem As MSComctlLib.ListItem)
    Dim oMapcharSet As DBMLib.MapcharSet
    
    Set oItemAct = oItem
    
    Set oMapcharSet = Nothing
    
    If Not oItemAct Is Nothing Then
        Set oMapcharSet = oDB.MapcharSets(oItemAct.Text)
        RaiseEvent MapcharSetClick(oMapcharSet)
    End If
    
    CommandsSet False
End Sub

Private Sub MapcharSetNew()
    bMapcharSetOpen = True
    
    With docMapcharSet
        Set .Database = oDB
        Set .MapcharSet = Nothing
        Set .CopyFromMapcharSet = Nothing
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub MapcharSetCopy()
    Dim oMapcharSet As DBMLib.MapcharSet
    
    If oItemAct Is Nothing Then Exit Sub
    
    bMapcharSetOpen = True
    
    Set oMapcharSet = oDB.MapcharSets(oItemAct.Text)
    
    With docMapcharSet
        Set .Database = oDB
        Set .MapcharSet = Nothing
        Set .CopyFromMapcharSet = oMapcharSet
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub MapcharSetEdit()
    Dim oMapcharSet As DBMLib.MapcharSet
    
    If oItemAct Is Nothing Then Exit Sub
    
    bMapcharSetOpen = True
    
    Set oMapcharSet = oDB.MapcharSets(oItemAct.Text)
    
    With docMapcharSet
        Set .Database = oDB
        Set .MapcharSet = oMapcharSet
        Set .CopyFromMapcharSet = Nothing
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub MapcharSetDelete()
    Dim oMapcharSet As DBMLib.MapcharSet
    Dim sMsg As String
    Dim sError As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    Set oMapcharSet = oDB.MapcharSets(oItemAct.Text)

    sMsg = "Delete mapcharset '" & oMapcharSet.Name & "'?"
    
    If MsgBox(sMsg, vbQuestion + vbOKCancel) = vbOK Then
        oMapcharSet.ToDelete = True
        If oMapcharSet.Save() Then
            lvwMapcharSets.ListItems.Remove oItemAct.Index
            Set oItemAct = Nothing
        Else
            MsgBox ERR_SAVEMAPCHARS + vbCrLf + vbCrLf + "(" + Trim(oDB.LastError.Text) + ")", vbExclamation
        End If
    End If

    CommandsSet False
End Sub
