VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocShows 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6105
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   6105
   ToolboxBitmap   =   "DBMDocShows.ctx":0000
   Begin MSComctlLib.ListView lvwShows 
      Height          =   1575
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   2778
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Description"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMDoc.DBMDocShow docShow 
      Height          =   1635
      Left            =   3540
      TabIndex        =   1
      Top             =   60
      Visible         =   0   'False
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   2884
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   720
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   360
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   3150
      Width           =   6105
      _ExtentX        =   10769
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   1080
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuShows 
      Caption         =   "Shows"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocShows"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Private Enum ShowsCommands
    cmdShows
    cmdShowView
    cmdShowsRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdShows
Const CMD_LAST = cmdSeperator

Private Enum ShowsPopupConstants
    popShows = 1
    popShow
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean


'''

Private Enum ShowsColumnConstants
    scName
    scDescription
End Enum

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean
Private bFitColumnSize As Boolean

Private oShowOpen As DBMLib.Show

'''

Public Event WrongDBState()

Public Event ShowClick(ByVal Show As DBMLib.Show)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_SHOWS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CHECK) + " - " + RS(IDS_G5_SERVER)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(ByVal NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    docShow.ToolBar = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
    Set docShow.TitleBar = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get ProtocolFont() As StdFont
    Set ProtocolFont = docShow.ProtocolFont
End Property
Public Property Set ProtocolFont(ByVal NewVal As StdFont)
    Set docShow.ProtocolFont = NewVal
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oDB Is Nothing Then
        At = oDB.Shows.At
    Else
        At = Empty
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    ShowsRefresh
End Sub

Public Sub ViewList()
    ShowClose True
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwShows, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    ShowClose False
    Cancel = False
End Sub

Public Sub Reset()
    docShow.Reset
    
    Set oDB = Nothing
    Set oShowOpen = Nothing
End Sub

Public Sub CleanUp()
    docShow.CleanUp

    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oShowOpen = Nothing
    
    bFitColumnSize = True
    
    ShowsInit
    ShowsReset
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwShows.Move 0, iTop, ScaleWidth, iHeight
    
    docShow.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwShows
'
Private Sub lvwShows_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ListViewUtil.SortColumn lvwShows, ColumnHeader
End Sub

Private Sub lvwShows_ItemClick(ByVal Item As MSComctlLib.ListItem)
    ShowsSelectItem Item
End Sub

Private Sub lvwShows_DblClick()
    If bItemClick Then ShowView
End Sub

Private Sub lvwShows_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwShows.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwShows_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwShows.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popShows
        Else
            POP.Show popShow
        End If
    End If
End Sub

Private Sub lvwShows_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdShowView).Enabled Then
                        ShowView
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdShowsRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docShow
'
Private Sub docShow_Command(ByVal Command As ShowCommands)
    Select Case Command
        Case cmdShowBack:   ShowClose True
    End Select
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_ShowsOpen(ByVal Error As Boolean)
    ShowsList
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdShowView:       ShowView
        Case cmdShowsRefresh:   Refresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdShows, "&CheckServer", 0
        .Add cmdTypeDefault, cmdShowView, "View", oRes.Bitmap16ID(IDB_16_SHOW_VIEW)
        .Add cmdTypeDefault, cmdShowsRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdShowView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowsRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdShows)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdShowView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowsRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupShowsInit
    PopupShowInit
End Sub

Private Sub PopupShowsInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdShowsRefresh)
    End With
End Sub

Private Sub PopupShowInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdShowView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowsRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            If oItemAct Is Nothing Then
                .Item(cmdShowView).Enabled = False
            Else
                .Item(cmdShowView).Enabled = True
            End If
            .Item(cmdShowsRefresh).Enabled = True
        Else
            .Item(cmdShowView).Enabled = False
            .Item(cmdShowsRefresh).Enabled = False
        End If
    End With
    
    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub ShowsInit()
    lvwShows.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub ShowsRefresh()
    ShowsReset
    
    If oDB Is Nothing Then Exit Sub
    
    If oDB.Shows.OpenShows(True) Then
        CommandsSet True
    End If
End Sub

Private Sub ShowsReset()
    Set oItemAct = Nothing
    lvwShows.ListItems.Clear
End Sub

Private Sub ShowsList()
    Dim oShow As DBMLib.Show
    Dim oItem As MSComctlLib.ListItem
    Dim lSizeKB As Long
    
    If oDB Is Nothing Then Exit Sub
    
    TIBAt oTIB, At
    
    lvwShows.ListItems.Clear
        
    For Each oShow In oDB.Shows
        Set oItem = lvwShows.ListItems.Add(, oShow.Name, oShow.Name, , oRes.Bitmap16ID(IDB_16_SHOW))
        oItem.SubItems(scDescription) = oShow.Description
    Next
    
    If bFitColumnSize Then
        ListViewUtil.FitColumnSize lvwShows, True
        bFitColumnSize = False
    End If
    
    Set oItemAct = lvwShows.SelectedItem
    
    CommandsSet False
End Sub

Private Sub ShowsSelectItem(ByVal oItem As MSComctlLib.ListItem)
    Dim oShow As DBMLib.Show
    
    Set oItemAct = oItem
    
    Set oShow = Nothing
    Set oShow = oDB.Shows(oItem.Key)
    
    RaiseEvent ShowClick(oShow)
    
    CommandsSet False
End Sub

Private Sub ShowView()
    If oItemAct Is Nothing Then Exit Sub

    Set oShowOpen = oDB.Shows(oItemAct.Key)

    With docShow
        Set .Database = oDB
        Set .Show = oShowOpen
        .Refresh

        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwShows.Visible = False
End Sub

Private Sub ShowClose(ByVal bSetFocus As Boolean)
    If Not oShowOpen Is Nothing Then
        Set oShowOpen = Nothing
        docShow.Visible = False
        lvwShows.Visible = True
        If bSetFocus Then
            lvwShows.SetFocus
        End If
    End If
    
    TIBAt oTIB, At
End Sub

