VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocUsers 
   ClientHeight    =   4980
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6315
   KeyPreview      =   -1  'True
   ScaleHeight     =   4980
   ScaleWidth      =   6315
   ToolboxBitmap   =   "DBMDocUsers.ctx":0000
   Begin MSComctlLib.ListView lvwUsers 
      Height          =   1755
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   2595
      _ExtentX        =   4577
      _ExtentY        =   3096
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Second Password"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Disabled"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Comment"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMDoc.DBMDocUser docUser 
      Height          =   2715
      Left            =   3360
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   2475
      _ExtentX        =   4366
      _ExtentY        =   4789
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   720
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   360
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   456
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   4524
      Width           =   6312
      _ExtentX        =   11139
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   1080
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuUsers 
      Caption         =   "Users"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Public Enum UsersCommands
    cmdUsers
    cmdUserNew
    cmdUserEdit
    cmdUserCopy
    cmdUserDelete
    cmdUsersRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdUsers
Const CMD_LAST = cmdSeperator

Private Enum UsersPopupConstants
    popUsers = 1
    popUser
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

'''

Private Enum UsersColumnConstants
    ucName
    ucSecondPWD
    ucDisabled
    ucComment
End Enum

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean
Private oEditUser As DBMLib.Medium
Private bFitColumnSize As Boolean
Private bUserOpen As Boolean

'''

Public Event WrongDBState()

Public Event UserClick(ByVal User As DBMLib.User)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_USERS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_USERS)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    docUser.ToolBar = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oDB Is Nothing Then
        At = oDB.Users.At
    Else
        At = Empty
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    UsersRefresh
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwUsers, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    UserClose False
    Cancel = False
End Sub

Public Sub Reset()
    docUser.Reset
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    docUser.CleanUp

    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    bUserOpen = False
    
    bFitColumnSize = True
    
    UsersInit
    UsersReset
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwUsers.Move 0, iTop, ScaleWidth, iHeight
    
    docUser.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwUsers
'
Private Sub lvwUsers_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ListViewUtil.SortColumn lvwUsers, ColumnHeader
End Sub

Private Sub lvwUsers_ItemClick(ByVal Item As MSComctlLib.ListItem)
    UsersSelectItem Item, True
End Sub

Private Sub lvwUsers_DblClick()
    If bItemClick Then UserEdit
End Sub

Private Sub lvwUsers_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwUsers.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwUsers_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwUsers.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popUsers
        Else
            POP.Show popUser
        End If
    End If
End Sub

Private Sub lvwUsers_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdUserEdit).Enabled Then
                        UserEdit
                    End If
                Case vbKeyDelete:
                    If CML.CommandItems.Item(cmdUserDelete).Enabled Then
                        UserDelete
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdUsersRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docUser
'
Private Sub docUser_UserChanged(ByVal User As DBMLib.User)
    Dim oItem As MSComctlLib.ListItem

    Set oItem = ListViewUtil.GetListItemByKey(lvwUsers, User.Name)
    
    If Not oItem Is Nothing Then
        UserFill oItem, User
    End If

    UserClose True
End Sub

Private Sub docUser_UserCreated(ByVal User As DBMLib.User)
    Dim oItem As MSComctlLib.ListItem
    
    Set oItem = lvwUsers.ListItems.Add(, User.Name, User.Name, , oRes.Bitmap16ID(IDB_16_USERS))
    UserFill oItem, User

    UserClose True
    
    UsersSelectItem oItem
End Sub

Private Sub docUser_UserCanceled(ByVal User As DBMLib.User)
    UserClose True
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_UsersAction(ByVal Error As Boolean, ByVal Action As DBMLib.DBMUsersActionConstants)
    Select Case Action
        Case dbmUsersActionOpen: UsersList
    End Select
End Sub

Private Sub oDB_UserAction(ByVal Error As Boolean, ByVal Action As DBMLib.DBMUserActionConstants, ByVal User As DBMLib.User)
    Select Case Action
        Case dbmUserActionDelete: UserDeleted User
    End Select
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdUserNew:        UserNew
        Case cmdUserCopy:       UserCopy
        Case cmdUserEdit:       UserEdit
        Case cmdUserDelete:     UserDelete
        Case cmdUsersRefresh:   Refresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdUsers, "&Users", 0
        .Add cmdTypeDefault, cmdUserNew, "New", oRes.Bitmap16ID(IDB_16_USER_NEW)
        .Add cmdTypeDefault, cmdUserCopy, "Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdUserEdit, "Edit", oRes.Bitmap16ID(IDB_16_EDIT)
        .Add cmdTypeDefault, cmdUserDelete, "Delete", oRes.Bitmap16ID(IDB_16_DELETE)
        .Add cmdTypeDefault, cmdUsersRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdUserNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUserEdit)
        Set oItem = .Add(cmdUserCopy)
        Set oItem = .Add(cmdUserDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUsersRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdUsers)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdUserNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUserEdit)
        Set oItem = .Add(cmdUserCopy)
        Set oItem = .Add(cmdUserDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUsersRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupUsersInit
    PopupUserInit
End Sub

Private Sub PopupUsersInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdUserNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUsersRefresh)
    End With
End Sub

Private Sub PopupUserInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdUserNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUserEdit)
        Set oItem = .Add(cmdUserCopy)
        Set oItem = .Add(cmdUserDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdUsersRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    Dim oUser As DBMLib.User
    Dim bCopy As Boolean
    Dim bDelete As Boolean
    
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            .Item(cmdUserNew).Enabled = True
            If oItemAct Is Nothing Then
                .Item(cmdUserCopy).Enabled = False
                .Item(cmdUserEdit).Enabled = False
                .Item(cmdUserDelete).Enabled = False
            Else
                Set oUser = oDB.Users(oItemAct.Text)
                Select Case oUser.UserType
                    Case dbmUTDBM: bDelete = False
                                   bCopy = False
                    Case dbmUTDBA: bDelete = False
                                   bCopy = False
                    Case Else:     bDelete = True
                                   bCopy = True
                End Select
                .Item(cmdUserCopy).Enabled = bCopy
                .Item(cmdUserEdit).Enabled = True
                .Item(cmdUserDelete).Enabled = bDelete
            End If
            .Item(cmdUsersRefresh).Enabled = True
        Else
            .Item(cmdUserNew).Enabled = False
            .Item(cmdUserCopy).Enabled = False
            .Item(cmdUserEdit).Enabled = False
            .Item(cmdUserDelete).Enabled = False
            .Item(cmdUsersRefresh).Enabled = False
        End If
    End With

    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub UsersInit()
    lvwUsers.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub UsersRefresh()
    UsersReset
    
    If oDB Is Nothing Then Exit Sub
    
    If oDB.Users.OpenUsers(True) Then
        CommandsSet True
    End If
End Sub

Private Sub UsersReset()
    Set oItemAct = Nothing
    Set oEditUser = Nothing
    lvwUsers.ListItems.Clear
End Sub

Private Sub UsersList()
    Dim oUser As DBMLib.User
    Dim oItem As MSComctlLib.ListItem
    Dim lImage As Long
    
    If oDB Is Nothing Then Exit Sub
    
    TIBAt oTIB, At
    
    lvwUsers.ListItems.Clear
        
    For Each oUser In oDB.Users
        If oUser.DBMUser Then
            Select Case oUser.UserType
                Case dbmUTDBM: lImage = oRes.Bitmap16ID(IDB_16_USER_DBM)
                Case dbmUTDBA: lImage = oRes.Bitmap16ID(IDB_16_USER_DBA)
                Case Else:     lImage = oRes.Bitmap16ID(IDB_16_USERS)
            End Select
            Set oItem = lvwUsers.ListItems.Add(, oUser.Name, oUser.Name, , lImage)
            UserFill oItem, oUser
        End If
    Next
    
    If bFitColumnSize Then
        ListViewUtil.FitColumnSize lvwUsers, True
        bFitColumnSize = False
    End If
    
    Set oItemAct = lvwUsers.SelectedItem
    
    CommandsSet False
End Sub

Private Sub UserFill(oItem As MSComctlLib.ListItem, oUser As DBMLib.User)
    If oUser.SecondPwdEnabled Then
        oItem.SubItems(ucSecondPWD) = "Yes"
    Else
        oItem.SubItems(ucSecondPWD) = "No"
    End If
    If oUser.Disabled Then
        oItem.SubItems(ucDisabled) = "Yes"
    Else
        oItem.SubItems(ucDisabled) = "No"
    End If
    oItem.SubItems(ucComment) = oUser.Comment
End Sub

Private Sub UsersSelectItem(oItem As MSComctlLib.ListItem, _
                            Optional ByVal bFromClick As Boolean = False)
    Dim oUser As DBMLib.User
    
    Set oItemAct = oItem
       
    Set oUser = Nothing
    
    If Not bFromClick Then
        Set lvwUsers.SelectedItem = oItemAct
    End If
    
    If Not oItemAct Is Nothing Then
        Set oUser = oDB.Users(oItemAct.Text)
        RaiseEvent UserClick(oUser)
    End If
    
    CommandsSet False
End Sub

Private Sub UserNew()
    bUserOpen = True
    
    With docUser
        Set .Database = oDB
        Set .User = Nothing
        Set .CopyFromUser = Nothing
        Set .DBMUser = oDB.Users(1)
        
        .Refresh

        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwUsers.Visible = False
    
    TIBCaption oTIB, Caption
End Sub

Private Sub UserCopy()
    Dim oUser As DBMLib.User
    
    If oItemAct Is Nothing Then Exit Sub
    
    bUserOpen = True
    
    Set oUser = oDB.Users(oItemAct.Text)
    
    With docUser
        Set .Database = oDB
        Set .User = Nothing
        Set .CopyFromUser = oUser
        Set .DBMUser = oDB.Users(1)
        .Refresh
    
        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwUsers.Visible = False
    
    TIBCaption oTIB, Caption
End Sub

Private Sub UserEdit()
    Dim oUser As DBMLib.User

    If oItemAct Is Nothing Then Exit Sub

    bUserOpen = True
    
    Set oUser = oDB.Users(oItemAct.Text)

    With docUser
        Set .Database = oDB
        Set .User = oUser
        Set .CopyFromUser = Nothing
        Set .DBMUser = oDB.Users(1)
        
        .Refresh

        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwUsers.Visible = False
    
    TIBCaption oTIB, Caption
End Sub

Private Sub UserDelete()
    Dim oUser As DBMLib.User
    Dim sMsg As String

    If oItemAct Is Nothing Then Exit Sub

    Set oUser = oDB.Users(oItemAct.Text)

    sMsg = "Are you sure you want delete user '" & oUser.Name & "'?"

    If MsgBox(sMsg, vbQuestion + vbYesNo, "Confirm User Delete") = vbYes Then
        If oUser.Delete(True) Then
            CommandsSet True
        End If
    End If
End Sub

Private Sub UserDeleted(oUser As User)
    lvwUsers.ListItems.Remove oUser.Name
    Set oItemAct = Nothing
    
    CommandsSet False
End Sub

Private Sub UserClose(ByVal bSetFocus As Boolean)
    If bUserOpen Then
        bUserOpen = False
        docUser.Visible = False
        lvwUsers.Visible = True
        If bSetFocus Then
            lvwUsers.SetFocus
        End If
    End If
End Sub

