VERSION 5.00
Begin VB.Form frmFind 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find"
   ClientHeight    =   1245
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5340
   Icon            =   "Find.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1245
   ScaleWidth      =   5340
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkMatchCase 
      Caption         =   "&Match Case"
      Height          =   195
      Left            =   1080
      TabIndex        =   5
      Top             =   900
      Width           =   2775
   End
   Begin VB.CheckBox chkWholeWord 
      Caption         =   "Find &Whole Word Only"
      Height          =   195
      Left            =   1080
      TabIndex        =   4
      Top             =   600
      Width           =   2775
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   4020
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "&Find Next"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   4020
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtFind 
      Height          =   315
      Left            =   1080
      TabIndex        =   1
      Top             =   120
      Width           =   2775
   End
   Begin VB.Label lblFind 
      Caption         =   "&Find what:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "frmFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Long

Public Function Find(sFind As String, _
                     bWholeWord As Boolean, _
                     bMatchCase As Boolean) As Boolean
                     
    Dim bOK As Boolean
    
    bOK = False
    lCommand = vbCancel
    
    txtFind.Text = sFind
    
    If bWholeWord Then
        chkWholeWord.Value = vbChecked
    Else
        chkWholeWord.Value = vbUnchecked
    End If
    
    If bMatchCase Then
        chkMatchCase.Value = vbChecked
    Else
        chkMatchCase.Value = vbUnchecked
    End If
    
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            sFind = Trim$(txtFind.Text)
            bWholeWord = (chkWholeWord.Value = vbChecked)
            bMatchCase = (chkMatchCase.Value = vbChecked)
            bOK = True
        Case vbCancel:
            bOK = False
    End Select
    
    Unload Me
    
    Find = bOK
End Function

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdFind_Click()
    lCommand = vbOK
    Me.Hide
End Sub

Private Sub txtFind_Change()
    SetForm
End Sub
Private Sub txtFind_GotFocus()
    txtFind.SelStart = 0
    txtFind.SelLength = Len(txtFind)
End Sub

Private Sub SetForm()
    Dim bEnabled As Boolean
    
    bEnabled = False
    
    If Len(Trim$(txtFind.Text)) > 0 Then
        bEnabled = True
    End If
    
    cmdFind.Enabled = bEnabled
End Sub


