VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CmdObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum CmdObjectTypeConstants
    cotNothing
    cotCombo
    cotTree
    cotDatabase
    cotDocument
End Enum

Private oItem As Object
Private lItemType As CmdObjectTypeConstants

Public Property Get Item() As Object
    Set Item = oItem
End Property
Public Property Set Item(ByVal NewVal As Object)
    Set oItem = NewVal
End Property

Public Property Get ItemType() As CmdObjectTypeConstants
    ItemType = lItemType
End Property
Public Property Let ItemType(ByVal NewVal As CmdObjectTypeConstants)
    lItemType = NewVal
End Property

Public Sub SetTo(ByVal Item As Object, _
                 ByVal ItemType As CmdObjectTypeConstants)
    Set oItem = Item
    lItemType = ItemType
End Sub

Private Sub Class_Initialize()
    Set oItem = Nothing
    lItemType = cotNothing
End Sub
