VERSION 5.00
Begin VB.Form frmDBConnect 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Connect to database"
   ClientHeight    =   2085
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4620
   Icon            =   "DBConnect.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2085
   ScaleWidth      =   4620
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtUsername 
      Height          =   315
      Left            =   1440
      TabIndex        =   2
      Top             =   720
      Width           =   3075
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1440
      PasswordChar    =   "*"
      TabIndex        =   4
      Top             =   1140
      Width           =   3075
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   345
      Left            =   2220
      TabIndex        =   5
      Top             =   1620
      Width           =   1125
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   345
      Left            =   3420
      TabIndex        =   6
      Top             =   1620
      Width           =   1125
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   120
      Picture         =   "DBConnect.frx":000C
      Top             =   120
      Width           =   480
   End
   Begin VB.Label lblInfo 
      Caption         =   "Connect failed. Enter user name and password of the Database Manager Operator."
      Height          =   495
      Left            =   720
      TabIndex        =   0
      Top             =   120
      Width           =   3795
   End
   Begin VB.Label lblUsername 
      Caption         =   "&User Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   780
      Width           =   1215
   End
   Begin VB.Label lblPassword 
      Caption         =   "&Password:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   1215
   End
End
Attribute VB_Name = "frmDBConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Long

Public Function Connect(ByVal sServer As String, _
                        ByVal sDatabase As String, _
                        sUsername As String, _
                        sPassword As String) As Boolean
    Connect = False
    
    If Len(sServer) > 0 Then
        Me.Caption = "Connect to database '" & sDatabase & "' on server '" & sServer & "'"
    Else
        Me.Caption = "Connect to database '" & sDatabase & "'"
    End If
    
    txtUsername.Text = sUsername
    txtPassword.Text = sPassword
    
    lCommand = vbCancel
    
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            sUsername = Trim(txtUsername.Text)
            sPassword = Trim(txtPassword.Text)
            Connect = True
    End Select
    
    Unload Me
End Function

'''

Private Sub Form_Activate()
    txtUsername.SetFocus
End Sub

'''

Private Sub txtPassword_Change()
    EnabledOK
End Sub

Private Sub txtUsername_Change()
    EnabledOK
End Sub

Private Sub txtUsername_GotFocus()
    txtUsername.SelStart = 0
    txtUsername.SelLength = Len(txtUsername.Text)
End Sub

Private Sub txtPassword_GotFocus()
    txtPassword.SelStart = 0
    txtPassword.SelLength = Len(txtPassword.Text)
End Sub

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = vbOK
    Me.Hide
End Sub

Private Sub EnabledOK()
    cmdOK.Enabled = (Len(Trim(txtUsername.Text)) > 0) And _
                    (Len(Trim(txtPassword.Text)) > 0)
End Sub


