VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Document"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private iIndex As Integer
Private lDoctype As DBMDocumentTypeConstants
Private oDatabase As DBMLib.Database
Private oControl As Object

Private bHideFlag As Boolean

Public Property Get Index() As Integer
    Index = iIndex
End Property
Public Property Let Index(ByVal NewVal As Integer)
    iIndex = NewVal
End Property

Public Property Get DocType() As DBMDocumentTypeConstants
    DocType = lDoctype
End Property
Public Property Let DocType(ByVal NewVal As DBMDocumentTypeConstants)
    lDoctype = NewVal
End Property

Public Property Get Database() As DBMLib.Database
    Set Database = oDatabase
End Property
Public Property Set Database(NewVal As DBMLib.Database)
    Set oDatabase = NewVal
End Property

Public Property Get Control() As Object
    Set Control = oControl
End Property
Public Property Set Control(NewVal As Object)
    Set oControl = NewVal
End Property

Public Property Get HideFlag() As Boolean
    HideFlag = bHideFlag
End Property
Public Property Let HideFlag(ByVal NewVal As Boolean)
    bHideFlag = NewVal
End Property

Private Sub Class_Initialize()
    bHideFlag = False
End Sub
