VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegShell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

' HKCR
'   .dbm
'
'   DBMConfigFile
'     DefaultIcon
'     Shell
'       Open
'         Command


Const KEY_DBMCFG = ".dbm"
Const KEY_DBMCFGFILE = "DBMConfigFile"
Const KEY_ICON = "DefaultIcon"
Const KEY_SHELL = "Shell"
Const KEY_OPEN = "Open"
Const KEY_CMD = "Command"

Const VAL_CMD = "Command"
Const VAL_SHORT = "IsShortCut"
Const VAL_NEVER = "NeverShowExt"

Const VAL_DBMCFG_TYPE = "DBM Config File"

'''

Public Sub Init()
    Dim sApp As String
    Dim sCmd As String
    Dim sIconCFG As String
    
    Dim oReg As New DBMReg.Registry
    Dim oDBMCFG As DBMReg.Key
        
    Dim oDBMCFGFile  As DBMReg.Key
    Dim oIcon As DBMReg.Key
    Dim oShell As DBMReg.Key
    Dim oOpen As DBMReg.Key
    Dim oOpenCmd As DBMReg.Key
    
    sApp = App.Path + "\" + App.EXEName + ".exe"
    sCmd = """" + sApp + """" + " -f ""%1"""
    sIconCFG = sApp + ",-" + CStr(icrConfigFile)
    
    Set oDBMCFG = oReg.Keys.Add(HKEY_CLASSES_ROOT, KEY_DBMCFG)
    oDBMCFG.Values.Add "", KEY_DBMCFGFILE, REG_SZ
    
    If Not oDBMCFG.Check(True, True) Then
        If Not oDBMCFG.Create(True, True) Then
            Exit Sub
        End If
    End If
    
    Set oDBMCFGFile = oReg.Keys.Add(HKEY_CLASSES_ROOT, KEY_DBMCFGFILE)
    oDBMCFGFile.Values.Add "", VAL_DBMCFG_TYPE, REG_SZ
    Set oIcon = oDBMCFGFile.Keys.Add(HKEY_CLASSES_ROOT, KEY_ICON)
    oIcon.Values.Add "", sIconCFG, REG_SZ
    Set oShell = oDBMCFGFile.Keys.Add(HKEY_CLASSES_ROOT, KEY_SHELL)
    Set oOpen = oShell.Keys.Add(HKEY_CLASSES_ROOT, KEY_OPEN)
    Set oOpenCmd = oOpen.Keys.Add(HKEY_CLASSES_ROOT, KEY_CMD)
    oOpenCmd.Values.Add "", sCmd, REG_SZ
    
    If Not oDBMCFGFile.Check(True, True) Then
        If Not oDBMCFGFile.Create(True, True) Then
            Exit Sub
        End If
    End If
End Sub
