VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmDBMIns 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SAPDB Database Manager Installer"
   ClientHeight    =   1455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4155
   Icon            =   "DBMIns.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1455
   ScaleWidth      =   4155
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdUnregister 
      Caption         =   "&Unregister"
      Height          =   375
      Left            =   1380
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdRegister 
      Caption         =   "&Register"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin MSComctlLib.ImageList imlStatus 
      Left            =   1800
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16711935
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   6
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":0442
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":0554
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":0AA6
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":0FF8
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":154A
            Key             =   ""
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "DBMIns.frx":1A9C
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Image imgComponent 
      Height          =   240
      Index           =   0
      Left            =   120
      Picture         =   "DBMIns.frx":1FEE
      Top             =   120
      Width           =   240
   End
   Begin VB.Label lblComponent 
      AutoSize        =   -1  'True
      Caption         =   "<Component>"
      Height          =   195
      Index           =   0
      Left            =   480
      TabIndex        =   0
      Top             =   180
      Width           =   990
   End
End
Attribute VB_Name = "frmDBMIns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const REGSVR = "REGSVR32.exe /S"
Const UNREGSVR = REGSVR & " /U"

Const UNREGEXE = "/unregserver"
Const REGEXE = "/regserver"

Const REGTLIB = "REGTLIB.exe -q"
Const UNREGTLIB = REGTLIB & " -u"

Const EXT_EXE = ".EXE"
Const EXT_OCX = ".OCX"
Const EXT_DLL = ".DLL"
Const EXT_TLB = ".TLB"

Private Enum ImageConstants
    imgDefault = 1
    imgOK
    imgError
    imgInfo
    imgWait
    imgCancel
End Enum

Private oComponents As New Collection

'''

Private Sub Form_Load()
    Init
    Display
End Sub

Private Sub cmdRegister_Click()
    Register
End Sub

Private Sub cmdUnregister_Click()
    Unregister
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

'''

Private Sub Init()
    Dim hFile As Integer
    Dim sFilename As String
    Dim oComponent As clsComponent
    
    hFile = FreeFile()
    
    Open App.Path + "\DBMIns.ini" For Input As hFile
    
    Do While Not EOF(hFile)
        Line Input #hFile, sFilename
        Set oComponent = New clsComponent
        oComponent.Filename = App.Path + "\" + sFilename
        
        If oComponent.Exists Then
            oComponent.Version.Create sFilename
        End If
        
        oComponents.Add oComponent, sFilename
        
        Set oComponent = Nothing
    Loop
    
    Close hFile
End Sub

Private Sub Display()
    Dim oComponent As clsComponent
    Dim lItem As Long
    Dim lMaxWidth As Long
    Dim lMinWidth As Long
    Dim lWidth As Long
    Dim y As Long
    
    lMaxWidth = 0
    
    lItem = 0
    For Each oComponent In oComponents
        If lItem > 0 Then
            Load imgComponent(lItem)
            imgComponent(lItem).Move imgComponent(lItem - 1).Left, imgComponent(lItem - 1).Top + imgComponent(lItem - 1).Height + 60
            
            Load lblComponent(lItem)
            lblComponent(lItem).Move imgComponent(lItem).Left + imgComponent(lItem).Width + 120, imgComponent(lItem).Top + 15
        Else
            lblComponent(lItem).Move imgComponent(lItem).Left + imgComponent(lItem).Width + 120, imgComponent(lItem).Top + 15
        End If
        
        imgComponent(lItem).Picture = imlStatus.ListImages(imgDefault).ExtractIcon
                
        With oComponent
            If .Exists Then
                imgComponent(lItem).Picture = imlStatus.ListImages(imgDefault).ExtractIcon
                lblComponent(lItem).Caption = .Filename & " - " & .Version.Description & " " & .Version.FullFileVersion
            Else
                imgComponent(lItem).Picture = imlStatus.ListImages(imgError).ExtractIcon
                lblComponent(lItem).Caption = .Filename & " - " & "NOT EXISTS!"
            End If
        End With
        
        imgComponent(lItem).Visible = True
        lblComponent(lItem).Visible = True
        
        If lMaxWidth < lblComponent(lItem).Width Then
            lMaxWidth = lblComponent(lItem).Width
        End If
        
        lItem = lItem + 1
    Next
    
    lMaxWidth = 120 + imgComponent(0).Width + 120 + lMaxWidth + 240
    lMinWidth = 120 + 4 * (cmdClose.Width + 60) + 120
    
    If lMaxWidth < lMinWidth Then
        lWidth = lMinWidth
    Else
        lWidth = lMaxWidth
    End If
    
    Width = lWidth
    
    y = imgComponent(oComponents.Count - 1).Top + imgComponent(oComponents.Count - 1).Height + 360
    
    cmdClose.Move ScaleWidth - cmdClose.Width - 120, y
    cmdUnregister.Move cmdClose.Left - cmdUnregister.Width - 120, y
    cmdRegister.Move cmdUnregister.Left - cmdRegister.Width - 60, y
    
    Height = cmdClose.Top + cmdClose.Height + 120 + (Height - ScaleHeight)
    
    y = imgComponent(oComponents.Count - 1).Top + imgComponent(oComponents.Count - 1).Height + 180
    
    Line (120, y)-(ScaleWidth - 120, y), vb3DShadow
    Line (120, y + 15)-(ScaleWidth - 120, y + 15), vb3DLight
End Sub

Private Sub Reset()
    Dim oComponent As clsComponent
    Dim lItem As Long
    
    For Each oComponent In oComponents
        imgComponent(lItem).Picture = imlStatus.ListImages(imgDefault).ExtractIcon
        lItem = lItem + 1
    Next
End Sub

Public Sub Check()
    Dim oComponent As clsComponent
    Dim lItem As Long
    Dim sCommand As String
    
    Reset
    
    lItem = 0
    For Each oComponent In oComponents
        If Not Exists(oComponent.Filename) Then
            imgComponent(lItem).Picture = imlStatus.ListImages(imgError).ExtractIcon
            imgComponent(lItem).Refresh
        End If
        lItem = lItem + 1
    Next
End Sub

Public Sub Register()
    Dim oComponent As clsComponent
    Dim lItem As Long
    Dim sCommand As String
    
    Reset
    
    lItem = 0
    For Each oComponent In oComponents
    
        Select Case UCase$(Right$(oComponent.Filename, Len(EXT_EXE)))
            Case EXT_EXE: sCommand = oComponent.Filename & " " & REGEXE
            Case EXT_OCX: sCommand = REGSVR & " " & oComponent.Filename
            Case EXT_DLL: sCommand = REGSVR & " " & oComponent.Filename
            Case EXT_TLB: sCommand = REGTLIB & " " & oComponent.Filename
        End Select
            
        imgComponent(lItem).Picture = imlStatus.ListImages(imgWait).ExtractIcon
        imgComponent(lItem).Refresh
        Process sCommand, 0, True
        imgComponent(lItem).Picture = imlStatus.ListImages(imgOK).ExtractIcon
        imgComponent(lItem).Refresh
        lItem = lItem + 1
    Next
End Sub

Public Sub Unregister()
    Dim oComponent As clsComponent
    Dim lItem As Long
    Dim sCommand As String
        
    Reset
    
    lItem = 0
    For Each oComponent In oComponents
    
        Select Case UCase$(Right$(oComponent.Filename, Len(EXT_EXE)))
            Case EXT_EXE: sCommand = oComponent.Filename & " " & UNREGEXE
            Case EXT_OCX: sCommand = UNREGSVR & " " & oComponent.Filename
            Case EXT_DLL: sCommand = UNREGSVR & " " & oComponent.Filename
            Case EXT_TLB: sCommand = UNREGTLIB & " " & oComponent.Filename
        End Select
        
        imgComponent(lItem).Picture = imlStatus.ListImages(imgWait).ExtractIcon
        imgComponent(lItem).Refresh
        Process sCommand, 0, True
        imgComponent(lItem).Picture = imlStatus.ListImages(imgCancel).ExtractIcon
        imgComponent(lItem).Refresh
        lItem = lItem + 1
    Next
End Sub

Private Sub lblComponent_DblClick(Index As Integer)
    Dim oComponent As clsComponent
   
    Set oComponent = oComponents(Index + 1)
    
    If oComponent.GetTypeLibInfo Then
        MsgBox "GUID = " & oComponent.TypeLibInfo.Guid
    End If
End Sub
