VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Database"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01E9E019B"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const ERR_LIB_OFFLINE = "Could not set DB state to 'Offline'."
Const ERR_LIB_COLD = "Could not set DB state to 'Cold'."
Const ERR_LIB_ONLINE = "Could not set DB state to 'Online'."
Const ERR_LIB_STOPINC = "Sorry, DB is in state 'Stopped Incorectly'."
Const ERR_LIB_UNKNOWN = "Sorry, DB has an unknown state."

'''

Public Enum DBMDatabaseInstanceTypeConstants
    dbmInstanceTypeNone
    dbmInstanceTypeOLTP
    dbmInstanceTypeLVC
    dbmInstanceTypeCS
    dbmInstanceTypeBW
End Enum

Public Enum DBMDatabaseKernelConstants
    dbmFastKernel
    dbmQuickKernel
    dbmSlowKernel
End Enum

Const OS_WIN32 = "WIN32"
Const OS_UNIX = "UNIX"

Public Enum DBMDatabaseVersionConstants
    dbmVersion71 = &H7010000
    dbmVersion72 = &H7020000
    dbmVersion723 = &H7020003
    dbmVersion724 = &H7020004
    dbmVersion725 = &H7020005
    dbmVersion73 = &H7030000
    dbmVersion74 = &H7040000
    dbmVersion741 = &H7040001
End Enum

'''

Public Enum DBMDatabaseEventTypeConstants
    dbmEventEMPTY
    dbmEventALIVE
    dbmEventAUTOSAVE
    dbmEventBACKUP_PAGES
    dbmEventDC_LOG_HITRATE
    dbmEventDC_OMSLOG_HITRATE
    dbmEventDC_OMS_HITRATE
    dbmEventDB_ABOVE_LIMIT
    dbmEventDB_BELOW_LIMIT
    dbmEventDB_FILL_CHANGE
    dbmEventDW_COMPRESS
    dbmEventDW_DISPLACE
    dbmEventEVENT
    dbmEventLOG_ABOVE_LIMIT
    dbmEventLOG_FILL_CHANGE
    dbmEventMIGRATION_PROGRESS
    dbmEventRESTART_SHUTDOWN
    dbmEventSAVEPOINT
    dbmEventSESSIONS
    dbmEventUPD_STAT_WANTED
    dbmEventWARNING
    dbmEventERROR
    dbmEventUNKNOWN
End Enum

Public Enum DBMLogModeConstants
    dbmLogModeNone
    dbmLogModeDemo
    dbmLogModeSingle
    dbmLogModeDual
    dbmLogModeSingleDemo
    dbmLogModeDualDemo
End Enum

'
' Action Constants
'

Public Enum DBMDatabaseActionConstants
    dbmDatabaseActionOpenSession
    dbmDatabaseActionOffline
    dbmDatabaseActionCold
    dbmDatabaseActionOnline
    dbmDatabaseActionClear
    dbmDatabaseActionCloseSession
    dbmDatabaseActionVerfiy
    dbmDatabaseActionInitConfig
    dbmDatabaseActionActivate
    dbmDatabaseActionDrop
    dbmDatabaseActionRegister
    dbmDatabaseActionUnregister
End Enum

'''

Public Enum DBMAutosaveActionConstants
    dbmAutosaveActioShow
    dbmAutosaveActionOn
    dbmAutosaveActionOff
    dbmAutosaveActionCancel
End Enum

'''

Public Enum DBMKernelTraceActionConstants
    dbmKernelTraceActionRefresh
    dbmKernelTraceActionOptionsOn
    dbmKernelTraceActionOptionsOff
    dbmKernelTraceActionOptionsShow
    dbmKernelTraceActionDefaultOn
    dbmKernelTraceActionDefaultOff
    dbmKernelTraceActionSetAdvanced
    dbmKernelTraceActionAuditSession
    dbmKernelTraceActionStopOnError
    dbmKernelTraceActionClear
    dbmKernelTraceActionFlush
    dbmKernelTraceActionProtOptionsShow
    dbmKernelTraceActionProtocolMake
End Enum

'''

Public Enum DBMFileActionConstants
    dbmFileActionOpenFile
    dbmFileActionReadLine
    dbmFileActionReadText
    dbmFileActionCloseFile
End Enum

'''

Public Enum DBMMediaActionConstants
    dbmMediaActionOpen
    dbmMediaActionSave
    dbmMediaActionDelete
End Enum

Public Enum DBMMediumActionConstants
    dbmMediumActionSave
    dbmMediumActionDelete
    dbmMediumActionRename
    dbmMediumActionReadLabel
End Enum
    
Public Enum DBMMediaGroupActionConstants
    dbmMediaGroupActionSave
    dbmMediaGroupActionDelete
    dbmMediaGroupActionRename
End Enum
    
Public Enum DBMHistoryActionConstants
    dbmHistoryActionRefresh
End Enum

Public Enum DBMExternalIDsActionConstants
    dbmExternalIDsActionRefresh
End Enum

Public Enum DBMBackupInitActionConstants
    dbmBackupInitActionInitForBackup
    dbmBackupInitActionInitForRestoreInit
    dbmBackupInitActionInitForRestore
    dbmBackupInitActionInitForCheck
End Enum

'''

Public Enum DBMUpdStatActionConstant
    dbmUpdStatActionOpen
    dbmUpdStatActionFetch
    dbmUpdStatActionClose
    dbmUpdStatActionExecute
End Enum

Public Enum DBMIndexActionConstant
    dbmIndexActionOpen
    dbmIndexActionFetch
    dbmIndexActionClose
    dbmIndexActionRecreate
    dbmIndexActionDrop
    dbmIndexActionEnable
End Enum

'''

Public Enum DBMParametersActionConstants
    dbmParametersActionOpen
    dbmParametersActionCheck
    dbmParametersActionSave
    dbmParametersActionClose
End Enum

Public Enum DBMParameterActionConstants
    dbmParameterActionRefresh
    dbmParameterActionCheck
    dbmParameterActionSave
    dbmParameterActionPutOnly
    dbmParameterActionPutConfirm
    dbmParameterActionDirectPut
    dbmParameterActionDirectDelete
End Enum

'''

Public Enum DBMDevSpaceActionConstants
    dbmDevSpaceActionRefresh
    dbmDevSpaceActionSave
    dbmDevSpaceActionDelete
End Enum

'''

Public Enum DBMUsersActionConstants
    dbmUsersActionOpen
    dbmUsersActionSave
End Enum

Public Enum DBMUserActionConstants
    dbmUserActionRefresh
    dbmUserActionCreate
    dbmUserActionSave
    dbmUserActionChangePassword
    dbmUserActionChangeSecondPassword
    dbmUserActionChangeSystemPassword
    dbmUserActionDelete
End Enum

'''

Public Enum DBMParameterStatusConstants
    dbmPSOK
    dbmPSRequest
    dbmPSConstraint
    dbmPSMandatory
    dbmPSUnknown
End Enum

'''

Public Enum DBMBackupStateActionConstants
    dbmBSStart
    dbmBSRefresh
    dbmBSStop
End Enum

'''

Public Enum DBMLogModeActionConstants
    dbmLogModeActionRefresh
    dbmLogModeActionDemo2Single
    dbmLogModeActionDemo2Dual
    dbmLogModeActionSingle2Dual
    dbmLogModeActionSingle2Demo
    dbmLogModeActionDual2Demo
    dbmLogModeActionDual2Single
    dbmLogModeActionSingle2SingleDemo
    dbmLogModeActionDual2DualDemo
End Enum

'
' Function IDs
'
Const FUNC_OPENSESSION = "OpenSession"
Const FUNC_CLOSESESSION = "CloseSession"

Const FUNC_OFFLINE = "Offline"
Const FUNC_COLD = "Cold"
Const FUNC_ONLINE = "Online"

Const FUNC_CLEAR = "Clear"
Const FUNC_COMMAND = "Command"
Const FUNC_VERIFY = "Verify"
Const FUNC_LOADSYSTAB = "LoadSysTab"
Const FUNC_INITCONFIG = "InitConfig"
Const FUNC_ACTIVATE = "Activate"
Const FUNC_DROP = "Drop"
Const FUNC_REGISTER = "Register"
Const FUNC_UNREGISTER = "Unregister"

'''

Const UTL_CMD_RESTART = "RESTART"
Const UTL_CMD_RESTARTUNTIL = "RESTART UNTIL"
Const UTL_CMD_SHUTDOWN = "SHUTDOWN"
Const UTL_CMD_SHUTDOWNQUICK = "SHUTDOWN QUICK"
Const UTL_CMD_VERIFY = "VERIFY"
Const UTL_CMD_INIT = "INIT CONFIG"

'''

Private oParent As Object

Private oDBMAPP As Object ' DBMAPP.Application
Private oDBMAPPEvents As Object ' DBMAPP.DatabaseEvents

Private WithEvents oServerObject As DBMSOB.ServerObject
Attribute oServerObject.VB_VarHelpID = -1

Private oRestartInfo As RestartInfo
Private oState As State
Private oBackup As Backup
Private oInfos As Infos

Private oParameters As Parameters
Private oDevSpaces As DevSpaces
Private oTermcharSets As TermcharSets
Private oMapcharSets As MapcharSets
Private oUsers As Users
Private oEvents As DatabaseEvents
Private oLogMode As LogMode

Private oKernelTrace As KernelTrace
Private oFiles As Files
Private oShows As Shows
Private oAutosave As Autosave
Private oCatalog As Catalog

Private oLastError As LastError

Private sName As String             ' logical name of registration
Private sUsername As String         ' DBM user
Private sPassword As String         ' DBM password
Private sDatabaseName As String     ' physical name of database
Private sServerName As String       ' physical name of server
Private oVersion As New Version
Private sInstRoot As String         ' installation path on server
Private sOSString As String         ' win32 or unix

Private lKernel As DBMDatabaseKernelConstants
Private lInstanceType As DBMDatabaseInstanceTypeConstants
Private lOS As DBMOSConstants

Private bNoExtBackup As Boolean     ' enable/disable external backup tool support

'''

Private bConnected As Boolean
Private bEnableEvents As Boolean
Private lPageSize As Long

'''

Private bBusy As Boolean
Private lBusy As Long

'''


' OpenSession
Private bRefresh As Boolean
Private bEvents As Boolean
' Create
Private sSystemUser As String
Private sSystemPassword As String
' Drop
Private bWithFiles As String
' Register/UnRegister
Private lRegKernel As DBMDatabaseKernelConstants
' Offline/Cold/Online
Private bUseUntilDate As Boolean
Private dUntilDate As Date
Private bImmediate As Boolean
' Command
Private sCommand As String
Private sResult As String
' LoadSysTab/Activate
Private sDBA As String
Private sDBAPwd As String
Private sDomPwd As String
' Drop
Private bWithoutFiles As Boolean

'''

' Eventhandling
Private oEventHandler As DBMEve.EventHandler
    
'''

Public Event DatabaseAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMDatabaseActionConstants)

Public Event AutosaveAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMAutosaveActionConstants)

Public Event CommandExecuted(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Command As String, ByVal Result As String)
Public Event SystemTablesLoaded(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Command As String, ByVal Result As String)
Public Event Verified()

Public Event Error(ByVal Number As Long, ByVal Description As String)

Public Event BusyStateChanged(ByVal Busy As Boolean)

Public Event StateRefreshed()
Public Event StateChanged()

Public Event InfoRefreshed(ByVal Error As Boolean, ByVal InfoType As Long)

Public Event KernelTraceAction(ByVal Error As Boolean, ByVal Action As DBMKernelTraceActionConstants)

Public Event FilesOpen(ByVal Error As Boolean)
Public Event FileAction(ByVal Error As Boolean, ByVal Action As DBMFileActionConstants, ByVal File As File)

Public Event ShowsOpen(ByVal Error As Boolean)
Public Event ShowRefreshed(ByVal Error As Boolean, ByVal Show As Show)

Public Event MediaAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMMediaActionConstants)
Public Event MediumAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMMediumActionConstants, ByVal Medium As Medium)
Public Event MediaGroupAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMMediaGroupActionConstants, ByVal MediaGroup As MediaGroup)

Public Event HistoryAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMHistoryActionConstants)

Public Event ExternalIDsAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMExternalIDsActionConstants)

Public Event UpdStatAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMUpdStatActionConstant)
Public Event IndexAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMIndexActionConstant)

Public Event ParametersAction(ByVal Error As Boolean, ByVal Action As DBMParametersActionConstants)
Public Event ParameterAction(ByVal Error As Boolean, ByVal Action As DBMParameterActionConstants, ByVal Parameter As Parameter)

Public Event DevSpacesOpen(ByVal SenderID As Long, ByVal Error As Boolean)
Public Event DevSpaceAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMDevSpaceActionConstants, ByVal DevSpace As DevSpace)

Public Event UsersAction(ByVal Error As Boolean, ByVal Action As DBMUsersActionConstants)
Public Event UserAction(ByVal Error As Boolean, ByVal Action As DBMUserActionConstants, ByVal User As User)

Public Event LogModeAction(ByVal Error As Boolean, ByVal Action As DBMLogModeActionConstants)

Public Event PropertyChanged(ByVal PropertyName As String)

Public Event DatabaseEvent( _
                ByVal EventType As DBMDatabaseEventTypeConstants, _
                ByVal Name As String, _
                ByVal Priority As String, _
                ByVal Occurrence As Date, _
                ByVal Count As Long, _
                ByVal Value1 As String, _
                ByVal Value2 As String, _
                ByVal Text As String, _
                ByVal Description As String)

'''

Public Event BackupInitAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMBackupInitActionConstants)

Public Event RestartInfoRefreshed(ByVal SenderID As Long, ByVal Error As Boolean)

Public Event BackupStart()
Public Event BackupReady()
Public Event BackupVolumeNext(ByVal Medium As Medium)
Public Event BackupCanceled()
Public Event BackupError()
Public Event BackupState(ByVal Action As DBMBackupStateActionConstants)

Public Event RestoreStart()
Public Event RestoreReady()
Public Event RestoreVolumeNext(ByVal Medium As Medium)
Public Event RestoreVolumeSkipped()
Public Event RestoreVolumeEnd()
Public Event RestoreVolumeWrong()
Public Event RestoreCanceled()
Public Event RestoreError()
Public Event RestoreState(ByVal Action As DBMBackupStateActionConstants)

Public Event BackupCheckStart()
Public Event BackupCheckReady()
Public Event BackupCheckVolumeNext(ByVal Medium As Medium)
Public Event BackupCheckVolumeEnd()
Public Event BackupCheckCanceled()
Public Event BackupCheckError()
Public Event BackupCheckState(ByVal Action As DBMBackupStateActionConstants)

'''
    
'
' Properties
'
Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTDatabase
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Public Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = Me
End Property

Public Property Get DBMAPP() As Object
    Set DBMAPP = oDBMAPP
End Property
Public Property Set DBMAPP(NewVal As Object)
    Set oDBMAPP = NewVal
End Property

Friend Property Get ServerObject() As DBMSOB.ServerObject
    Set ServerObject = oServerObject
End Property
'
'
'
Public Property Get RestartInfo() As RestartInfo
    If oRestartInfo Is Nothing Then
        Set oRestartInfo = New RestartInfo
        Set oRestartInfo.Parent = Me
    End If
    Set RestartInfo = oRestartInfo
End Property

Public Property Get State() As State
    If oState Is Nothing Then
        Set oState = New State
        Set oState.Parent = Me
    End If
    Set State = oState
End Property

Public Property Get Backup() As Backup
    If oBackup Is Nothing Then
        Set oBackup = New Backup
        Set oBackup.Parent = Me
    End If
    
    Set Backup = oBackup
End Property

Public Property Get Parameters() As Parameters
    If oParameters Is Nothing Then
        Set oParameters = New Parameters
        Set oParameters.Parent = Me
    End If
    
    Set Parameters = oParameters
End Property

Public Property Get DevSpaces() As DevSpaces
    If oDevSpaces Is Nothing Then
        Set oDevSpaces = New DevSpaces
        Set oDevSpaces.Parent = Me
    End If
    Set DevSpaces = oDevSpaces
End Property

Public Property Get TermcharSets() As TermcharSets
    If oTermcharSets Is Nothing Then
        Set oTermcharSets = New TermcharSets
        Set oTermcharSets.Parent = Me
    End If
    Set TermcharSets = oTermcharSets
End Property

Public Property Get MapcharSets() As MapcharSets
    If oMapcharSets Is Nothing Then
        Set oMapcharSets = New MapcharSets
        Set oMapcharSets.Parent = Me
    End If
    Set MapcharSets = oMapcharSets
End Property

Public Property Get Users() As Users
    If oUsers Is Nothing Then
        Set oUsers = New Users
        Set oUsers.Parent = Me
    End If
    Set Users = oUsers
End Property

Public Property Get DatabaseEvents() As DatabaseEvents
    If oEvents Is Nothing Then
        Set oEvents = New DatabaseEvents
        Set oEvents.Parent = Me
    End If
    Set DatabaseEvents = oEvents
End Property

Public Property Get LogMode() As LogMode
    If oLogMode Is Nothing Then
        Set oLogMode = New LogMode
        Set oLogMode.Parent = Me
    End If
    Set LogMode = oLogMode
End Property

Public Property Get Infos() As Infos
    If oInfos Is Nothing Then
        Set oInfos = New Infos
        Set oInfos.Parent = Me
        oInfos.MakeCollection
    End If
    Set Infos = oInfos
End Property

Public Property Get KernelTrace() As KernelTrace
    If oKernelTrace Is Nothing Then
        Set oKernelTrace = New KernelTrace
        Set oKernelTrace.Parent = Me
    End If
    Set KernelTrace = oKernelTrace
End Property

Public Property Get Files() As Files
    If oFiles Is Nothing Then
        Set oFiles = New Files
        Set oFiles.Parent = Me
    End If
    Set Files = oFiles
End Property

Public Property Get Shows() As Shows
    If oShows Is Nothing Then
        Set oShows = New Shows
        Set oShows.Parent = Me
    End If
    Set Shows = oShows
End Property

Public Property Get Autosave() As Autosave
    If oAutosave Is Nothing Then
        Set oAutosave = New Autosave
        Set oAutosave.Parent = Me
    End If
    Set Autosave = oAutosave
End Property

Public Property Get Catalog() As Catalog
    If oCatalog Is Nothing Then
        Set oCatalog = New Catalog
        Set oCatalog.Parent = Me
    End If
    Set Catalog = oCatalog
End Property

Public Property Get LastError() As LastError
    If oLastError Is Nothing Then
        Set oLastError = New LastError
    End If
    Set LastError = oLastError
End Property

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(NewVal As String)
    sName = NewVal
    PropertyChanged "Name"
End Property

Public Property Get UserName() As String
    UserName = sUsername
End Property
Public Property Let UserName(NewVal As String)
    sUsername = NewVal
    PropertyChanged "UserName"
End Property

Public Property Get Password() As String
    Password = sPassword
End Property
Public Property Let Password(NewVal As String)
    sPassword = NewVal
    PropertyChanged "Password"
End Property

Public Property Get DatabaseName() As String
    DatabaseName = sDatabaseName
End Property
Public Property Let DatabaseName(NewVal As String)
    sDatabaseName = NewVal
    PropertyChanged "DatabaseName"
End Property

Public Property Get ServerName() As String
    ServerName = sServerName
End Property
Public Property Let ServerName(NewVal As String)
    sServerName = NewVal
    PropertyChanged "ServerName"
End Property

Public Property Get Version() As Version
    Set Version = oVersion
End Property

Public Property Get InstRoot() As String
    InstRoot = sInstRoot
End Property
Public Property Let InstRoot(NewVal As String)
    sInstRoot = NewVal
End Property

Public Property Get OSString() As String
    OSString = sOSString
End Property
Public Property Let OSString(NewVal As String)
    sOSString = NewVal
End Property

Public Property Get Kernel() As DBMDatabaseKernelConstants
    Kernel = lKernel
End Property
Public Property Let Kernel(ByVal NewVal As DBMDatabaseKernelConstants)
    lKernel = NewVal
    PropertyChanged "Kernel"
End Property

Public Property Get KernelOption() As String
    KernelOption = GetKernelOpt(lKernel)
End Property

Public Property Get InstanceType() As DBMDatabaseInstanceTypeConstants
    InstanceType = lInstanceType
End Property
Public Property Let InstanceType(ByVal NewVal As DBMDatabaseInstanceTypeConstants)
    lInstanceType = NewVal
    PropertyChanged "InstanceType"
End Property

Public Property Get OS() As DBMOSConstants
    OS = lOS
End Property
Public Property Let OS(ByVal NewVal As DBMOSConstants)
    lOS = NewVal
End Property

Public Property Get Connected() As Boolean
    Connected = bConnected
End Property

Public Property Get PageSize() As Long
    PageSize = lPageSize
End Property
Public Property Let PageSize(ByVal NewVal As Long)
    lPageSize = NewVal
End Property

Public Property Get NoExternalBackup() As Boolean
    NoExternalBackup = bNoExtBackup
End Property
Public Property Let NoExternalBackup(ByVal NewVal As Boolean)
    bNoExtBackup = NewVal
End Property

'''

Public Property Get Autorefresh() As Boolean
    If Not oDBMAPP Is Nothing Then
        Autorefresh = oDBMAPP.Autorefresh
    Else
        Autorefresh = False
    End If
End Property
Public Property Let Autorefresh(ByVal NewVal As Boolean)
    If Not oDBMAPP Is Nothing Then
        oDBMAPP.Autorefresh = NewVal
    End If
End Property

Public Property Get Interval() As Long
    If Not oDBMAPP Is Nothing Then
        Interval = oDBMAPP.Interval
    Else
        Interval = 0
    End If
End Property
Public Property Let Interval(ByVal NewVal As Long)
    If Not oDBMAPP Is Nothing Then
        oDBMAPP.Interval = NewVal
    End If
End Property

'''

Public Property Get EnableEvents() As Boolean
    EnableEvents = bEnableEvents
End Property
Public Property Let EnableEvents(ByVal NewVal As Boolean)
    bEnableEvents = NewVal
End Property

Public Sub SetEvents(ByVal Enable As Boolean)
    If Enable Then
        If oDBMAPPEvents Is Nothing Then
            Set oDBMAPPEvents = CreateObject("DBMApp.DatabaseEvents")
        End If
        Set oDBMAPPEvents.Parent = Me
        Set oDBMAPPEvents.Database = Me
        
        #If DBG Then
            Set oDBMAPPEvents.DebugTrace = oDbgTrace
        #End If
                
        oDBMAPPEvents.EventsOn
    Else
        If Not oDBMAPPEvents Is Nothing Then
            oDBMAPPEvents.EventsOff
            oDBMAPPEvents.CleanUp
            Set oDBMAPPEvents = Nothing
        End If
    End If
End Sub

'''

Public Property Get Busy() As Boolean
    Busy = bBusy
End Property
Public Property Let Busy(ByVal NewVal As Boolean)
    Select Case NewVal
        
        Case True:
            lBusy = lBusy + 1
            If Not bBusy Then
                bBusy = True
                RaiseEvent BusyStateChanged(bBusy)
                If Not oEventHandler Is Nothing Then
                    oEventHandler.BusyStateChanged Me, Busy
                End If
                DoEvents
           End If
        
        Case False:
            lBusy = lBusy - 1
            If bBusy And lBusy = 0 Then
                bBusy = False
                RaiseEvent BusyStateChanged(bBusy)
                If Not oEventHandler Is Nothing Then
                    oEventHandler.BusyStateChanged Me, Busy
                End If
                DoEvents
            End If
    
    End Select
End Property

' Eventshandling

Public Property Get EventHandler() As DBMEve.EventHandler
    Set EventHandler = oEventHandler
End Property
Public Property Set EventHandler(ByVal NewVal As DBMEve.EventHandler)
    Set oEventHandler = NewVal
End Property
'
' Methods
'
Public Function Check() As Boolean
    Check = bConnected
End Function

Public Function OpenSession(Optional ByVal Refresh As Boolean = False, _
                            Optional ByVal Events As Boolean = False, _
                            Optional ByVal Asynchron As Boolean = False, _
                            Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    bRefresh = Refresh
    bEvents = Events
    
    If Not Asynchron Then
        bOK = Execute(FUNC_OPENSESSION, False, SenderID)
    Else
        QUEUE.QueueItems.Add Me, FUNC_OPENSESSION, SenderID
        bOK = True
    End If
    
    OpenSession = bOK
End Function

Public Function CloseSession(Optional ByVal Asynchron As Boolean = False, _
                             Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Not Asynchron Then
        bOK = Execute(FUNC_CLOSESESSION, False, SenderID)
    Else
        QUEUE.QueueItems.Add Me, FUNC_CLOSESESSION, SenderID
        bOK = True
    End If
    
    CloseSession = bOK
End Function

Public Function OfflineDB(Optional ByVal Immediate As Boolean = False, _
                          Optional ByVal Asynchron As Boolean = False, _
                          Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        bImmediate = Immediate
        
        If Not Asynchron Then
            bOK = Execute(FUNC_OFFLINE, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_OFFLINE, SenderID
            bOK = True
        End If
    End If
    
    OfflineDB = bOK
End Function

Public Function ColdDB(Optional ByVal Immediate As Boolean = False, _
                       Optional ByVal Asynchron As Boolean = False, _
                       Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        bImmediate = Immediate
        
        If Not Asynchron Then
            bOK = Execute(FUNC_COLD, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_COLD, SenderID
            bOK = True
        End If
    End If
    
    ColdDB = bOK
End Function

Public Function OnlineDB(Optional ByVal UseUntildate As Boolean = False, _
                         Optional ByVal UntilDate As Date, _
                         Optional ByVal Asynchron As Boolean = False, _
                         Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        bUseUntilDate = UseUntildate
        dUntilDate = UntilDate
    
        If Not Asynchron Then
            bOK = Execute(FUNC_ONLINE, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_ONLINE, SenderID
            bOK = True
        End If
    End If
    
    OnlineDB = bOK
End Function

Public Function Clear(Optional ByVal Asynchron As Boolean = False, _
                      Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CLEAR, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CLEAR, SenderID
            bOK = True
        End If
    End If
    
    Clear = bOK
End Function

Public Function Command(CommandStr As String, _
                        Optional Result As String, _
                        Optional ByVal Asynchron As Boolean = False, _
                        Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        sCommand = CommandStr
        
        If Not Asynchron Then
            bOK = Execute(FUNC_COMMAND, False, SenderID)
            Result = sResult
        Else
            QUEUE.QueueItems.Add Me, FUNC_COMMAND, SenderID
            bOK = True
        End If
    End If
    
    Command = bOK
End Function

Public Function Verify(Optional ByVal Asynchron As Boolean = False, _
                       Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_VERIFY, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_VERIFY, SenderID
            bOK = True
        End If
    End If
    
    Verify = bOK
End Function

Public Function LoadSysTab(Optional DBA As String = "", _
                           Optional DBAPwd As String = "", _
                           Optional DOMPwd As String = "", _
                           Optional ByVal Asynchron As Boolean = False, _
                           Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        sDBA = DBA
        sDBAPwd = DBAPwd
        sDomPwd = DOMPwd
    
        If Not Asynchron Then
            bOK = Execute(FUNC_LOADSYSTAB, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_LOADSYSTAB, SenderID
            bOK = True
        End If
    End If
    
    LoadSysTab = bOK
End Function

Public Function InitConfig(Optional ByVal Asynchron As Boolean = False, _
                           Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_INITCONFIG, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_INITCONFIG, SenderID
            bOK = True
        End If
    End If
    
    InitConfig = bOK
End Function

Public Function Activate(Optional DBA As String = "", _
                         Optional DBAPwd As String = "", _
                         Optional ByVal Asynchron As Boolean = False, _
                         Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        sDBA = DBA
        sDBAPwd = DBAPwd
        
        If Not Asynchron Then
            bOK = Execute(FUNC_ACTIVATE, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_ACTIVATE, SenderID
            bOK = True
        End If
    End If
    
    Activate = bOK
End Function

Public Function Drop(Optional ByVal WithoutFiles As Boolean = False, _
                     Optional ByVal Asynchron As Boolean = False, _
                     Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        bWithoutFiles = WithoutFiles
        
        If Not Asynchron Then
            bOK = Execute(FUNC_DROP, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DROP, SenderID
            bOK = True
        End If
    End If
    
    Drop = bOK
End Function

Public Function Register(ByVal RegKernel As DBMDatabaseKernelConstants, _
                         Optional ByVal Asynchron As Boolean = False, _
                         Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        lRegKernel = RegKernel
        
        If Not Asynchron Then
            bOK = Execute(FUNC_REGISTER, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_REGISTER, SenderID
            bOK = True
        End If
    End If
    
    Register = bOK
End Function

Public Function Unregister(ByVal RegKernel As DBMDatabaseKernelConstants, _
                           Optional ByVal Asynchron As Boolean = False, _
                           Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        lRegKernel = RegKernel
        
        If Not Asynchron Then
            bOK = Execute(FUNC_UNREGISTER, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_UNREGISTER, SenderID
            bOK = True
        End If
    End If
    
    Unregister = bOK
End Function

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    
    Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_OPENSESSION:  bOK = ExecuteOpenSession(Asynchron, SenderID)
        Case FUNC_CLOSESESSION: bOK = ExecuteCloseSession(Asynchron, SenderID)
        Case FUNC_OFFLINE:      bOK = ExecuteOfflineDB(Asynchron, SenderID)
        Case FUNC_COLD:         bOK = ExecuteColdDB(Asynchron, SenderID)
        Case FUNC_ONLINE:       bOK = ExecuteOnlineDB(Asynchron, SenderID)
        Case FUNC_CLEAR:        bOK = ExecuteClear(Asynchron, SenderID)
        Case FUNC_COMMAND:      bOK = ExecuteCommand(Asynchron, SenderID)
        Case FUNC_VERIFY:       bOK = ExecuteVerify(Asynchron, SenderID)
        Case FUNC_LOADSYSTAB:   bOK = ExecuteLoadSysTab(Asynchron, SenderID)
        Case FUNC_INITCONFIG:   bOK = ExecuteInitConfig(Asynchron, SenderID)
        Case FUNC_ACTIVATE:     bOK = ExecuteActivate(Asynchron, SenderID)
        Case FUNC_DROP:         bOK = ExecuteDrop(Asynchron, SenderID)
        Case FUNC_REGISTER:     bOK = ExecuteRegister(Asynchron, SenderID)
        Case FUNC_UNREGISTER:   bOK = ExecuteUnregister(Asynchron, SenderID)
    End Select
    
    Busy = False
    
    Execute = bOK
End Function

'''

Public Function UtilConnect(Optional UserName As String = "", _
                            Optional Password As String = "") As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVUtil.Connect(oServerObject, UserName, Password) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    UtilConnect = bOK
End Function

Public Function UtilExecute(ByVal Command As String, _
                            Optional Result As String = "") As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVUtil.Execute(oServerObject, Command, Result) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    UtilExecute = bOK
End Function

Public Function UtilRelease() As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVUtil.Release(oServerObject) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    UtilRelease = bOK
End Function

'''

Public Function SQLConnect(Optional UserName As String = "", _
                           Optional Password As String = "") As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVSQL.Connect(oServerObject, UserName, Password) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    SQLConnect = bOK
End Function

Public Function SQLExecute(ByVal Command As String, _
                           Optional Result As String = "") As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVSQL.Execute(oServerObject, Command, Result) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    SQLExecute = bOK
End Function

Public Function SQLRelease() As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVSQL.Release(oServerObject) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    SQLRelease = bOK
End Function

'''

Public Function ServiceConnect() As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVService.Connect(oServerObject) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    ServiceConnect = bOK
End Function

Public Function ServiceRelease() As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If DBMSRVService.Release(oServerObject) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    ServiceRelease = bOK
End Function

'''

Public Sub Cancel()
    If Not oServerObject Is Nothing Then
        oServerObject.Cancel
    End If
End Sub

'''

Public Sub RaiseError(ByVal Number As Long, _
                      ByVal Description As String)
    Dim sHelpFile As String
    Dim lHelpContext  As Long
    
    sHelpFile = ""
    lHelpContext = 0
    
    RaiseEvent Error(Number, Description)
    
    If Not oEventHandler Is Nothing Then
        oEventHandler.Error Me, Number, App.Title, Description, sHelpFile, lHelpContext
    End If
End Sub

'''

Friend Sub EventStateRefreshed()
    RaiseEvent StateRefreshed
    If Not oEventHandler Is Nothing Then
        oEventHandler.DatabaseStateRefreshed Me
    End If
End Sub

Friend Sub EventStateChanged()
    RaiseEvent StateChanged
End Sub

Friend Sub EventInfoRefreshed(ByVal Error As Boolean, ByVal InfoType As Long)
    RaiseEvent InfoRefreshed(Error, InfoType)
End Sub

Friend Sub EventKernelTraceAction(ByVal bError As Boolean, ByVal lAction As DBMKernelTraceActionConstants)
    RaiseEvent KernelTraceAction(bError, lAction)
End Sub

Friend Sub EventFilesOpen(ByVal Error As Boolean)
    RaiseEvent FilesOpen(Error)
End Sub
Friend Sub EventFileAction(ByVal Error As Boolean, ByVal Action As DBMFileActionConstants, ByVal File As File)
    RaiseEvent FileAction(Error, Action, File)
End Sub

Friend Sub EventShowsOpen(ByVal Error As Boolean)
    RaiseEvent ShowsOpen(Error)
End Sub
Friend Sub EventShowRefreshed(ByVal Error As Boolean, ByVal Show As Show)
    RaiseEvent ShowRefreshed(Error, Show)
End Sub

Friend Sub EventAutosaveAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMAutosaveActionConstants)
    RaiseEvent AutosaveAction(lSenderID, bError, lAction)
    If Not oEventHandler Is Nothing Then
        oEventHandler.AutosaveAction Me, lAction
    End If
End Sub

Friend Sub EventMediaAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMMediaActionConstants)
    RaiseEvent MediaAction(lSenderID, bError, lAction)
End Sub

Friend Sub EventMediumAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMMediumActionConstants, ByVal oMedium As Medium)
    RaiseEvent MediumAction(lSenderID, bError, lAction, oMedium)
End Sub

Friend Sub EventMediaGroupAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMMediaGroupActionConstants, ByVal oMediaGroup As MediaGroup)
    RaiseEvent MediaGroupAction(lSenderID, bError, lAction, oMediaGroup)
End Sub

Friend Sub EventUpdStatAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMUpdStatActionConstant)
    RaiseEvent UpdStatAction(lSenderID, bError, lAction)
End Sub

Friend Sub EventIndexAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMIndexActionConstant)
    RaiseEvent IndexAction(lSenderID, bError, lAction)
End Sub

Friend Sub EventParametersAction(ByVal bError As Boolean, ByVal lAction As DBMParametersActionConstants)
    RaiseEvent ParametersAction(bError, lAction)
End Sub

Friend Sub EventParameterAction(ByVal bError As Boolean, ByVal lAction As DBMParameterActionConstants, oParameter As Parameter)
    RaiseEvent ParameterAction(bError, lAction, oParameter)
End Sub

Friend Sub EventDevSpacesOpen(ByVal lSenderID As Long, ByVal bError As Boolean)
    RaiseEvent DevSpacesOpen(lSenderID, bError)
End Sub
Friend Sub EventDevSpaceAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMDevSpaceActionConstants, ByVal oDevSpace As DevSpace)
    RaiseEvent DevSpaceAction(lSenderID, bError, lAction, oDevSpace)
End Sub

Friend Sub EventUsersAction(ByVal bError As Boolean, ByVal lAction As DBMUsersActionConstants)
    RaiseEvent UsersAction(bError, lAction)
End Sub
Friend Sub EventUserAction(ByVal bError As Boolean, ByVal lAction As DBMUserActionConstants, ByVal oUser As User)
    RaiseEvent UserAction(bError, lAction, oUser)
End Sub

Friend Sub EventLogModeAction(ByVal bError As Boolean, ByVal lAction As DBMLogModeActionConstants)
    RaiseEvent LogModeAction(bError, lAction)
End Sub

Public Sub EventDatabaseEvent(ByVal Name As String, _
                              ByVal Priority As String, _
                              ByVal Occurrence As Date, _
                              ByVal Count As Long, _
                              ByVal Value1 As String, _
                              ByVal Value2 As String, _
                              ByVal Text As String, _
                              ByVal Description As String)
    Dim lEventType As DBMDatabaseEventTypeConstants
    lEventType = DBMSRVEve.GetEventType(Name)
    RaiseEvent DatabaseEvent(lEventType, Name, Priority, Occurrence, Count, Value1, Value2, Text, Description)
    If Not oEventHandler Is Nothing Then
        oEventHandler.DatabaseEvent Me, lEventType, Name, Priority, Occurrence, Count, Value1, Value2, Text, Description
    End If
End Sub

Friend Sub EventHistoryAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMHistoryActionConstants)
    RaiseEvent HistoryAction(lSenderID, bError, dbmHistoryActionRefresh)
End Sub

Friend Sub EventExternalIDsAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMExternalIDsActionConstants)
    RaiseEvent ExternalIDsAction(lSenderID, bError, dbmExternalIDsActionRefresh)
End Sub

Friend Sub EventBackupInitAction(ByVal lSenderID As Long, ByVal bError As Boolean, ByVal lAction As DBMBackupInitActionConstants)
    RaiseEvent BackupInitAction(lSenderID, bError, lAction)
End Sub

Friend Sub EventRestartInfoRefreshed(ByVal lSenderID As Long, ByVal bError As Boolean)
    RaiseEvent RestartInfoRefreshed(lSenderID, bError)
End Sub

Public Sub EventBackupStart()
    RaiseEvent BackupStart
End Sub
Public Sub EventBackupReady()
    RaiseEvent BackupReady
End Sub
Public Sub EventBackupVolumeNext(ByVal Medium As Medium)
    RaiseEvent BackupVolumeNext(Medium)
End Sub

Public Sub EventBackupCanceled()
    RaiseEvent BackupCanceled
End Sub
Public Sub EventBackupError()
    RaiseEvent BackupError
End Sub
Public Sub EventBackupState(ByVal Action As DBMBackupStateActionConstants)
    RaiseEvent BackupState(Action)
    If Not oEventHandler Is Nothing Then
        Select Case Action
            Case dbmBSStart: oEventHandler.BackupStateStart Me
            Case dbmBSRefresh: oEventHandler.BackupStateRefresh Me
            Case dbmBSStop: oEventHandler.BackupStateStop Me
        End Select
    End If
End Sub

Public Sub EventRestoreStart()
    RaiseEvent RestoreStart
End Sub
Public Sub EventRestoreReady()
    RaiseEvent RestoreReady
End Sub
Public Sub EventRestoreVolumeNext(ByVal Medium As Medium)
    RaiseEvent RestoreVolumeNext(Medium)
End Sub
Public Sub EventRestoreVolumeSkipped()
    RaiseEvent RestoreVolumeSkipped
End Sub
Public Sub EventRestoreVolumeEnd()
    RaiseEvent RestoreVolumeEnd
End Sub
Public Sub EventRestoreVolumeWrong()
    RaiseEvent RestoreVolumeWrong
End Sub
Public Sub EventRestoreCanceled()
    RaiseEvent RestoreCanceled
End Sub
Public Sub EventRestoreError()
    RaiseEvent RestoreError
End Sub
Public Sub EventRestoreState(ByVal Action As DBMBackupStateActionConstants)
    RaiseEvent RestoreState(Action)
    If Not oEventHandler Is Nothing Then
        Select Case Action
            Case dbmBSStart: oEventHandler.BackupStateStart Me
            Case dbmBSRefresh: oEventHandler.BackupStateRefresh Me
            Case dbmBSStop: oEventHandler.BackupStateStop Me
        End Select
    End If
End Sub

'''

Public Sub EventBackupCheckStart()
    RaiseEvent BackupCheckStart
End Sub
Public Sub EventBackupCheckReady()
    RaiseEvent BackupCheckReady
End Sub
Public Sub EventBackupCheckVolumeNext(ByVal Medium As Medium)
    RaiseEvent BackupCheckVolumeNext(Medium)
End Sub
Public Sub EventBackupCheckVolumeEnd()
    RaiseEvent BackupCheckVolumeEnd
End Sub
Public Sub EventBackupCheckCanceled()
    RaiseEvent BackupCheckCanceled
End Sub
Public Sub EventBackupCheckError()
    RaiseEvent BackupCheckError
End Sub
Public Sub EventBackupCheckState(ByVal Action As DBMBackupStateActionConstants)
    RaiseEvent BackupCheckState(Action)
    If Not oEventHandler Is Nothing Then
        Select Case Action
            Case dbmBSStart: oEventHandler.BackupStateStart Me
            Case dbmBSRefresh: oEventHandler.BackupStateRefresh Me
            Case dbmBSStop: oEventHandler.BackupStateStop Me
        End Select
    End If
End Sub

'''

Public Sub CleanUpObjects()
    If Not oRestartInfo Is Nothing Then oRestartInfo.CleanUp
    If Not oState Is Nothing Then oState.CleanUp
    If Not oBackup Is Nothing Then oBackup.CleanUp
    If Not oInfos Is Nothing Then oInfos.CleanUp
    If Not oParameters Is Nothing Then oParameters.CleanUp
    If Not oDevSpaces Is Nothing Then oDevSpaces.CleanUp
    If Not oTermcharSets Is Nothing Then oTermcharSets.CleanUp
    If Not oMapcharSets Is Nothing Then oMapcharSets.CleanUp
    If Not oUsers Is Nothing Then oUsers.CleanUp
    If Not oEvents Is Nothing Then oEvents.CleanUp
    If Not oLogMode Is Nothing Then oLogMode.CleanUp
    If Not oKernelTrace Is Nothing Then oKernelTrace.CleanUp
    If Not oFiles Is Nothing Then oFiles.CleanUp
    If Not oShows Is Nothing Then oShows.CleanUp
    If Not oAutosave Is Nothing Then oAutosave.CleanUp
    If Not oCatalog Is Nothing Then oCatalog.CleanUp
    If Not oDBMAPPEvents Is Nothing Then oDBMAPPEvents.CleanUp
    
    Set oRestartInfo = Nothing
    Set oState = Nothing
    Set oBackup = Nothing
    Set oInfos = Nothing
    Set oParameters = Nothing
    Set oDevSpaces = Nothing
    Set oTermcharSets = Nothing
    Set oMapcharSets = Nothing
    Set oUsers = Nothing
    Set oEvents = Nothing
    Set oLogMode = Nothing
    Set oKernelTrace = Nothing
    Set oFiles = Nothing
    Set oShows = Nothing
    Set oAutosave = Nothing
    Set oCatalog = Nothing
    Set oDBMAPPEvents = Nothing
End Sub

Public Sub CleanUp()
    Set oEventHandler = Nothing
    
    CloseSession
    
    CleanUpObjects

    Set oLastError = Nothing

    Set oServerObject = Nothing
    
    Set oParent = Nothing
    
    Set oDBMAPP = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    sName = ""
    sUsername = ""
    sPassword = ""
    sDatabaseName = ""
    sServerName = ""
    sInstRoot = ""
    sOSString = ""
        
    lKernel = dbmFastKernel
    lInstanceType = dbmInstanceTypeNone
    lOS = dbmOSUnknown
        
    bNoExtBackup = False
    
    lPageSize = 0
        
    bEnableEvents = False
        
    bConnected = False
    
    Set oServerObject = New DBMSOB.ServerObject
    
    Set oRestartInfo = Nothing
    Set oState = Nothing
    Set oBackup = Nothing
    Set oInfos = Nothing
    Set oParameters = Nothing
    Set oDevSpaces = Nothing
    Set oTermcharSets = Nothing
    Set oMapcharSets = Nothing
    Set oUsers = Nothing
    Set oEvents = Nothing
    Set oLogMode = Nothing
    Set oKernelTrace = Nothing
    Set oFiles = Nothing
    Set oShows = Nothing
    Set oAutosave = Nothing
    Set oCatalog = Nothing
    
    QUEUE.Initialize
    
    bBusy = False
    lBusy = 0
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType

    Set oRestartInfo = Nothing
    Set oState = Nothing
    Set oBackup = Nothing
    Set oInfos = Nothing
    Set oParameters = Nothing
    Set oDevSpaces = Nothing
    Set oTermcharSets = Nothing
    Set oMapcharSets = Nothing
    Set oUsers = Nothing
    Set oEvents = Nothing
    Set oLogMode = Nothing
    Set oKernelTrace = Nothing
    Set oFiles = Nothing
    Set oShows = Nothing
    Set oAutosave = Nothing
    Set oCatalog = Nothing
    
    Set oServerObject = Nothing
    
    QUEUE.Terminate
End Sub

'''

Private Function ExecuteOpenSession(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If oServerObject.OpenSession(sServerName, sDatabaseName, sUsername, sPassword) Then
        bConnected = True
        bOK = True
        GetSessionInfos
        GetGeneralParameters
        If Not oEventHandler Is Nothing Then
            oEventHandler.DatabaseSessionOpen Me
        End If
        
        If bRefresh Then
            State.Refresh True
        End If
        
        If bEvents Then
            bEnableEvents = True
            If State.Value = dbmDBStateCold Or _
               State.Value = dbmDBStateWarm _
            Then
                SetEvents True
            End If
        Else
            bEnableEvents = False
        End If
    Else
        LastError.SetByServerObject oServerObject
    End If
        
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionOpenSession)
    End If
        
    ExecuteOpenSession = bOK
End Function

Private Function ExecuteCloseSession(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    SetEvents False
    
    oServerObject.CloseSession
    
    bOK = True
    
    bConnected = False
    
    If Not oEventHandler Is Nothing Then
        oEventHandler.DatabaseSessionClosed Me
    End If
        
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionCloseSession)
    End If
    
    ExecuteCloseSession = True
End Function

Private Function ExecuteOfflineDB(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
    
    SetEvents False
    
    If oVersion.Number < dbmVersion72 Then
        Select Case State.Value
            Case dbmDBStateOffline:
                bOK = True
            Case dbmDBStateCold:
                ' STOP
                If oServerObject.Command(DBMSRV_CMD_DB_STOP, sData) Then
                    bOK = True
                Else
                    LastError.SetByServerObject oServerObject
                End If
            Case dbmDBStateWarm:
                ' SHUTDOWN
                If UtilConnect Then
                    If Not bImmediate Then
                        sCmd = UTL_CMD_SHUTDOWN
                    Else
                        sCmd = UTL_CMD_SHUTDOWNQUICK
                    End If
                    If UtilExecute(sCmd) Then
                        bOK = True
                    End If
                    UtilRelease
                End If
                ' STOP
                If bOK Then
                    If oServerObject.Command(DBMSRV_CMD_DB_STOP, sData) Then
                        bOK = True
                    Else
                        LastError.SetByServerObject oServerObject
                    End If
                End If
            Case dbmDBStateStoppedIncorrectly:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_STOPINC
                    RaiseError .Number, .Text
                End With
            Case dbmDBStateUnknown:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_UNKNOWN
                    RaiseError .Number, .Text
                End With
        End Select
    Else
        sCmd = DBMSRV_CMD_DB_OFFLINE
        If bImmediate Then
            sCmd = DBMSRV_CMD_DB_OFFLINE + " -immediate"
        End If
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bOK Then
        bOK = State.Refresh()
        If bOK Then
            If State.Value <> dbmDBStateOffline Then
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_OFFLINE
                    RaiseError .Number, .Text
                End With
            End If
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionOffline)
    End If
    
    ExecuteOfflineDB = bOK
End Function

Private Function ExecuteColdDB(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
        
    If oVersion.Number < dbmVersion72 Then
        Select Case State.Value
            Case dbmDBStateOffline:
                ' START
                sCmd = DBMSRV_CMD_DB_START
                sCmd = sCmd + " " + GetKernelOpt(lKernel)
                If oServerObject.Command(sCmd, sData) Then
                    bOK = True
                Else
                    LastError.SetByServerObject oServerObject
                End If
            Case dbmDBStateCold:
                bOK = True
            Case dbmDBStateWarm:
                ' SHUTDOWN
                If UtilConnect Then
                    If Not bImmediate Then
                        sCmd = UTL_CMD_SHUTDOWN
                    Else
                        sCmd = UTL_CMD_SHUTDOWNQUICK
                    End If
                    If UtilExecute(sCmd) Then
                        bOK = True
                    End If
                    UtilRelease
                End If
            Case dbmDBStateStoppedIncorrectly:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_STOPINC
                    RaiseError .Number, .Text
                End With
            Case dbmDBStateUnknown:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_UNKNOWN
                    RaiseError .Number, .Text
                End With
        End Select
    Else
        SetEvents False
        
        sCmd = DBMSRV_CMD_DB_COLD
        If bImmediate Then
            sCmd = DBMSRV_CMD_DB_COLD + " -immediate"
        End If
        sCmd = sCmd + " " + GetKernelOpt(lKernel)
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bOK Then
        bOK = State.Refresh()
        If bOK Then
            If State.Value <> dbmDBStateCold Then
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_COLD
                    RaiseError .Number, .Text
                End With
            End If
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bOK And bEnableEvents Then
        SetEvents True
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionCold)
    End If
    
    ExecuteColdDB = bOK
End Function

Private Function ExecuteOnlineDB(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
    
    If oVersion.Number < dbmVersion72 Then
        Select Case State.Value
            Case dbmDBStateOffline:
                ' START
                sCmd = DBMSRV_CMD_DB_START
                sCmd = sCmd + " " + GetKernelOpt(lKernel)
                If oServerObject.Command(sCmd, sData) Then
                    bOK = True
                Else
                    LastError.SetByServerObject oServerObject
                End If
                ' RESTART
                If bOK Then
                    If UtilConnect Then
                        If bUseUntilDate Then
                            sCmd = UTL_CMD_RESTARTUNTIL + " '" + Format$(dUntilDate, "YYYYMMDD") + "' '" + Format$(dUntilDate, "HHNNSS") + "'"
                        Else
                            sCmd = UTL_CMD_RESTART
                        End If
                        If UtilExecute(sCmd) Then
                            bOK = True
                        End If
                        UtilRelease
                    End If
                End If
            Case dbmDBStateCold:
                ' RESTART
                If UtilConnect Then
                    If bUseUntilDate Then
                        sCmd = UTL_CMD_RESTARTUNTIL + " '" + Format$(dUntilDate, "YYYYMMDD") + "' '" + Format$(dUntilDate, "HHNNSS") + "'"
                    Else
                        sCmd = UTL_CMD_RESTART
                    End If
                    If UtilExecute(sCmd) Then
                        bOK = True
                    End If
                    UtilRelease
                End If
            
            Case dbmDBStateWarm:
                bOK = True
            Case dbmDBStateStoppedIncorrectly:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_STOPINC
                    RaiseError .Number, .Text
                End With
            Case dbmDBStateUnknown:
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_UNKNOWN
                    RaiseError .Number, .Text
                End With
        End Select
    Else
        sCmd = DBMSRV_CMD_DB_ONLINE
        sCmd = sCmd + " " + GetKernelOpt(lKernel)
        If bUseUntilDate Then
            sCmd = sCmd + " -u " + Format$(dUntilDate, "YYYYMMDD") + " " + Format$(dUntilDate, "HHNNSS")
        End If
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bOK Then
        bOK = State.Refresh()
        If bOK Then
            If State.Value <> dbmDBStateWarm Then
                bOK = False
                With LastError
                    .SetByApplication ERR_LIB_ONLINE
                    RaiseError .Number, .Text
                End With
            End If
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If oVersion.Number < dbmVersion72 And bOK Then
        If DBMSRVSQL.Connect(oServerObject) Then
            If DBMSRVSQL.Execute(oServerObject, "MONITOR ON") Then
            End If
            DBMSRVSQL.Release oServerObject
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bOK And bEnableEvents Then
        SetEvents True
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionOnline)
    End If
    
    ExecuteOnlineDB = bOK
End Function

Private Function ExecuteClear(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    bOK = False
    
    If oServerObject.Command(DBMSRV_CMD_DB_CLEAR, sData, bAsynchron) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    If bOK Then
        State.Refresh
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionClear)
    End If
    
    ExecuteClear = bOK
End Function

Public Function ExecuteCommand(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim sStatement As String
    Dim bOK As Boolean
    
    bOK = False
    
    If oServerObject.Command(sCommand, sResult) Then
        bOK = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    If bAsynchron Then
        RaiseEvent CommandExecuted(lSenderID, Not bOK, sCommand, sResult)
    End If
    
    ExecuteCommand = bOK
End Function

Public Function ExecuteVerify(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If UtilConnect() Then
        If UtilExecute(UTL_CMD_VERIFY) Then
            bOK = True
            RaiseEvent Verified
        Else
            LastError.SetByServerObject oServerObject
        End If
        UtilRelease
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionVerfiy)
    End If
    
    ExecuteVerify = bOK
End Function

Public Function ExecuteLoadSysTab(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    
    bOK = False
            
    If Check() Then
    
        sCmd = DBMSRV_CMD_LOAD_SYSTAB
        sCmd = sCmd & IIf(Len(sDBA) > 0, " -u " & sDBA & "," & sDBAPwd, "")
        sCmd = sCmd & IIf(Len(sDomPwd) > 0, " -ud " & sDomPwd, "")
        
        If oServerObject.Command(sCmd, sResult) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent SystemTablesLoaded(lSenderID, Not bOK, sCmd, sResult)
    End If
    
    ExecuteLoadSysTab = bOK
End Function

Public Function ExecuteInitConfig(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Check() Then
        If UtilConnect() Then
        
            If UtilExecute(UTL_CMD_INIT) Then
                bOK = True
            Else
                LastError.SetByServerObject oServerObject
            End If
            UtilRelease
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionInitConfig)
    End If
    
    ExecuteInitConfig = bOK
End Function

Public Function ExecuteActivate(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    bOK = False
    
    If Check() Then
        If UtilConnect() Then
            If oServerObject.Command(DBMSRV_CMD_UTIL_ACTIVATE + " " & sDBA + "," + sDBAPwd, sData) Then
                bOK = True
            Else
                LastError.SetByServerObject oServerObject
            End If
            UtilRelease
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionActivate)
    End If
    
    ExecuteActivate = bOK
End Function

Public Function ExecuteDrop(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String

    bOK = False

    sCmd = DBMSRV_CMD_DB_DROP
    If bWithoutFiles Then sCmd = sCmd + " WITHOUTFILES"
    
    If Check() Then
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionDrop)
    End If
    
    ExecuteDrop = bOK
End Function

Public Function ExecuteRegister(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String

    bOK = False

    sCmd = DBMSRV_CMD_DB_REG + " " + GetKernelOpt(lRegKernel)
    
    If Check() Then
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionRegister)
    End If
    
    ExecuteRegister = bOK
End Function

Public Function ExecuteUnregister(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String

    bOK = False

    sCmd = DBMSRV_CMD_DB_UNREG + " " + GetKernelOpt(lRegKernel)
    
    If Check() Then
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
    End If
    
    If bAsynchron Then
        RaiseEvent DatabaseAction(lSenderID, Not bOK, dbmDatabaseActionUnregister)
    End If
    
    ExecuteUnregister = bOK
End Function

'''

Private Function GetSessionInfos() As Boolean
    Dim sData As String
    Dim sLine As String
    Dim lPos As Long
    
    Dim sName As String
    Dim sValue As String
    
    Dim lP1 As Long
    
    GetSessionInfos = False
    
    If oServerObject.Command(DBMSRV_CMD_DBM_VERSION, sData) Then
        GetSessionInfos = True
        lPos = 1
        Do While (lPos <= Len(sData))
            sName = oServerObject.GetProp(sData, lPos, sValue)
            Select Case UCase$(sName)
                Case "VERSION":
                    oVersion.Text = sValue
                
                Case "BUILD":
                    sValue = UCase$(sValue)
                    lP1 = InStr(1, sValue, "BUILD")
                    If lP1 > 0 Then
                        oVersion.Build = Trim$(Mid$(sValue, lP1 + 5))
                    Else
                        oVersion.Build = sValue
                    End If
                    
                Case "OS":
                    sOSString = sValue
                    
                Case "INSTROOT":
                    sInstRoot = sValue
                    
'                Case "LOGON":
'                Case "CODE":
'                Case "SWAP":
            End Select
        Loop
    Else
        If oServerObject.Command(DBMSRV_CMD_VERSION, sData) Then
            GetSessionInfos = True
            lPos = 1
            sLine = oServerObject.GetLine(sData, lPos)  ' Header
            sLine = oServerObject.GetLine(sData, lPos)  ' Value
            lPos = 1
            oVersion.Text = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos))))
            sOSString = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos))))
            sInstRoot = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos))))
            
            Select Case sOSString
                Case OS_WIN32: lOS = dbmOSWin32
                Case Else:     lOS = dbmOSUnix
            End Select
        End If
    End If
End Function

'''

Private Function GetGeneralParameters() As Boolean
    Dim bOK As Boolean
    Dim sData As String
    Dim lPos As Long
    Dim sValue As String
        
    sValue = ""
        
    If lPageSize = 0 Then
        If oServerObject.CommandNorm(DBMSRV_CMD_PARAM_GETVALUE + " " + PARAM_PAGESIZE, sData) Then
            bOK = True
            lPos = 1
            lPageSize = Val(Trim$(oServerObject.GetLine(sData, lPos)))
        End If
    End If
    
    If oVersion.Number >= dbmVersion72 Then
        If oServerObject.CommandNorm(DBMSRV_CMD_PARAM_GETVALUE + " " + PARAM_INSTANCETYPE, sData) Then
            bOK = True
            lPos = 1
            sValue = UCase$(Trim$(oServerObject.GetLine(sData, lPos)))
            
            Select Case sValue
                Case "OLTP":    lInstanceType = dbmInstanceTypeOLTP
                Case "LVC":     lInstanceType = dbmInstanceTypeLVC
                Case "CS":      lInstanceType = dbmInstanceTypeCS
                Case "BW":      lInstanceType = dbmInstanceTypeBW
                Case Else:      lInstanceType = dbmInstanceTypeNone
            End Select
        End If
    End If
    
    GetGeneralParameters = bOK
End Function

'''

Private Function GetKernelOpt(ByVal Kernel As DBMDatabaseKernelConstants) As String
    Select Case Kernel
        Case dbmFastKernel:    GetKernelOpt = DBMSRV_OPT_START_FAST
        Case dbmQuickKernel:   GetKernelOpt = DBMSRV_OPT_START_QUICK
        Case dbmSlowKernel:    GetKernelOpt = DBMSRV_OPT_START_SLOW
    End Select
End Function

'''

Private Sub PropertyChanged(sPropertyName As String)
    RaiseEvent PropertyChanged(sPropertyName)
End Sub

'''

Private Sub oServerObject_BusyStateChanged(ByVal Busy As Boolean)
    Busy = Busy
End Sub

Private Sub oServerObject_Error(ByVal ReturnCode As Long, ByVal ErrorText As String)
    RaiseError ReturnCode, ErrorText
End Sub

'''

#If DBG Then

Public Property Get DebugTrace() As Object
    Set DebugTrace = oDbgTrace
End Property
Public Property Set DebugTrace(NewVal As Object)
    Set oDbgTrace = NewVal
    If Not oServerObject Is Nothing Then
        Set oServerObject.DebugTrace = oDbgTrace
    End If
End Property

Public Sub TraceText(Text As String)
    If Not oDbgTrace Is Nothing Then
        oDbgTrace.Text "DBMLIB(" + sDatabaseName + "): " + Text
    End If
End Sub

#Else

Public Sub Trace(Text As String)
End Sub

#End If

