VERSION 5.00
Begin VB.UserControl ctlDatabaseName 
   ClientHeight    =   2940
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4365
   ScaleHeight     =   2940
   ScaleWidth      =   4365
   Begin VB.Frame fraDatabase 
      Caption         =   "Install &database instance:"
      Height          =   855
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4095
      Begin VB.TextBox txtDatabaseName 
         Height          =   285
         Left            =   1260
         MaxLength       =   8
         TabIndex        =   2
         Top             =   360
         Width           =   2655
      End
      Begin VB.Label lblDatabaseName 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   180
         TabIndex        =   1
         Top             =   420
         Width           =   1035
      End
   End
   Begin VB.Frame fraServer 
      Caption         =   "Install database instance on &server:"
      Height          =   1635
      Left            =   0
      TabIndex        =   3
      Top             =   1020
      Width           =   4095
      Begin VB.TextBox txtServerName 
         Height          =   285
         Left            =   1260
         TabIndex        =   5
         Top             =   360
         Width           =   2655
      End
      Begin VB.TextBox txtServerPassword 
         BackColor       =   &H8000000F&
         Enabled         =   0   'False
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1260
         PasswordChar    =   "*"
         TabIndex        =   9
         Top             =   1140
         Width           =   2655
      End
      Begin VB.TextBox txtServerUser 
         BackColor       =   &H8000000F&
         Enabled         =   0   'False
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1260
         TabIndex        =   7
         Top             =   780
         Width           =   2655
      End
      Begin VB.Label lblServerName 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   180
         TabIndex        =   4
         Top             =   420
         Width           =   1035
      End
      Begin VB.Label lblServerPassword 
         Caption         =   "&Password:"
         Enabled         =   0   'False
         Height          =   195
         Left            =   180
         TabIndex        =   8
         Top             =   1200
         Width           =   1035
      End
      Begin VB.Label lblServerUser 
         Caption         =   "&User Name:"
         Enabled         =   0   'False
         Height          =   195
         Left            =   180
         TabIndex        =   6
         Top             =   840
         Width           =   1035
      End
   End
End
Attribute VB_Name = "ctlDatabaseName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const DEFAULT_SERVER = ""

Private iMinWidth As Integer
Private iMinHeight As Integer

Public Property Get StepName() As String
    StepName = "Database/Server Name"
End Property

Public Property Get Info() As String
    Info = INFO_DBNAME
End Property

Public Property Get DatabaseName() As String
    DatabaseName = UCase(Trim(txtDatabaseName))
End Property

Public Property Get ServerName() As String
    ServerName = Trim(txtServerName)
    
    If Len(ServerName) = 0 Then
        ServerName = DEFAULT_SERVER
    End If
End Property

Public Property Get ServerUser() As String
    ServerUser = Trim(txtServerUser)
End Property

Public Property Get ServerPassword() As String
    ServerPassword = Trim(txtServerPassword)
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Private Sub UserControl_Initialize()
    iMinWidth = fraServer.Width
    iMinHeight = fraServer.Top + fraServer.Height
End Sub

Private Sub UserControl_Resize()
    If Ambient.UserMode Then
        If ScaleWidth < iMinWidth Or ScaleHeight < iMinHeight Then
            Size iMinWidth, iMinHeight
        End If
    End If
End Sub

Private Sub UserControl_EnterFocus()
    CheckReady
End Sub

'''

Private Sub txtDatabaseName_Change()
    CheckReady
End Sub

Private Sub txtDatabaseName_GotFocus()
    txtDatabaseName.SelStart = 0
    txtDatabaseName.SelLength = Len(txtDatabaseName)
End Sub

Private Sub txtServerName_Change()
    If Len(Trim(txtServerName)) > 0 Then
        lblServerUser.Enabled = True
        txtServerUser.Enabled = True
        txtServerUser.BackColor = vbWindowBackground
        lblServerPassword.Enabled = True
        txtServerPassword.Enabled = True
        txtServerPassword.BackColor = vbWindowBackground
    Else
        lblServerUser.Enabled = False
        lblServerPassword.Enabled = False
        txtServerUser.Text = ""
        txtServerUser.Enabled = False
        txtServerUser.BackColor = vbButtonFace
        txtServerPassword.Text = ""
        txtServerPassword.Enabled = False
        txtServerPassword.BackColor = vbButtonFace
    End If
End Sub

Private Sub txtServerName_GotFocus()
    txtServerName.SelStart = 0
    txtServerName.SelLength = Len(txtServerName)
End Sub

Private Sub txtServerUser_GotFocus()
    txtServerUser.SelStart = 0
    txtServerUser.SelLength = Len(txtServerUser)
End Sub

Private Sub txtServerPassword_GotFocus()
    txtServerPassword.SelStart = 0
    txtServerPassword.SelLength = Len(txtServerPassword)
End Sub

'''

Private Sub CheckReady()
    FRM.cmdNext.Enabled = (Len(Trim(txtDatabaseName)) > 0)
    FRM.TBR.Buttons(BUTTON_OPEN).Enabled = (Len(Trim(txtDatabaseName)) = 0)
    FRM.TBR.Buttons(BUTTON_SAVE).Enabled = (Len(Trim(txtDatabaseName)) > 0)
End Sub



