VERSION 5.00
Begin VB.UserControl ctlInstallMode 
   ClientHeight    =   1035
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3855
   ScaleHeight     =   1035
   ScaleWidth      =   3855
   Begin VB.OptionButton optMode 
      Caption         =   "&Install instance"
      Height          =   252
      Index           =   0
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Value           =   -1  'True
      Width           =   3492
   End
   Begin VB.OptionButton optMode 
      Caption         =   "&Restore instance"
      Height          =   252
      Index           =   1
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   3492
   End
End
Attribute VB_Name = "ctlInstallMode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private iMinWidth As Integer
Private iMinHeight As Integer

Private lInstallMode As DBMWizInstallModeConstants

'''

Public Property Get StepName() As String
    StepName = "Installation mode"
End Property

Public Property Get Info() As String
    Info = INFO_INSTMODE
End Property

Public Property Get InstallMode() As DBMWizInstallModeConstants
    InstallMode = lInstallMode
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Private Sub UserControl_Initialize()
    iMinWidth = -1
    iMinHeight = -1
    
    optMode(dbmWizInstallModeInstall).Tag = dbmWizInstallModeInstall
    optMode(dbmWizInstallModeRestore).Tag = dbmWizInstallModeRestore
    lInstallMode = dbmWizInstallModeInstall
End Sub

Private Sub UserControl_EnterFocus()
    CheckReady
End Sub

'''

Private Sub optMode_Click(Index As Integer)
    lInstallMode = optMode(Index).Tag
    CheckReady
End Sub

'''

Private Sub CheckReady()
    FRM.cmdNext.Enabled = True
End Sub


