VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSComCtl.ocx"
Begin VB.UserControl ctlInstallations 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin MSComctlLib.ListView lvwInstallations 
      Height          =   2895
      Left            =   0
      TabIndex        =   1
      Top             =   300
      Width           =   4515
      _ExtentX        =   7964
      _ExtentY        =   5106
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Version"
         Object.Width           =   1270
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "InstRoot"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Label lblInstallations 
      Caption         =   "&Installations:"
      Height          =   195
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4515
   End
End
Attribute VB_Name = "ctlInstallations"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private iMinWidth As Integer
Private iMinHeight As Integer

Private sServerName As String

'''

Public Property Let ServerName(sNewVal As String)
    sServerName = sNewVal
    
    lblInstallations = "&Installations on"
    If Len(sServerName) = 0 Then
        lblInstallations = lblInstallations & " local server:"
    Else
        lblInstallations = lblInstallations & " '" + sServerName + "':"
    End If
End Property

Public Property Get StepName() As String
    StepName = "Installations"
End Property

Public Property Get Info() As String
    Info = INFO_INSTALLS
End Property

Public Property Get Version() As String
    Version = ""
    
    If Not lvwInstallations.SelectedItem Is Nothing Then
        Version = lvwInstallations.SelectedItem.Text
    End If
End Property

Public Property Get InstRoot() As String
    InstRoot = ""
    
    If Not lvwInstallations.SelectedItem Is Nothing Then
        InstRoot = lvwInstallations.SelectedItem.SubItems(1)
    End If
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Public Sub ClearList()
    lvwInstallations.ListItems.Clear
End Sub

Public Sub AddInstallation(sVersion As String, sInstRoot As String)
    Dim oItem As MSComCtlLib.ListItem
    Set oItem = lvwInstallations.ListItems.Add(, , sVersion)
    oItem.SubItems(1) = sInstRoot
    If lvwInstallations.ListItems.Count = 1 Then
        oItem.SubItems(2) = "Default"
        oItem.Selected = True
    End If
End Sub

'''

Private Sub UserControl_Initialize()
    iMinWidth = -1
    iMinHeight = -1
End Sub

Private Sub UserControl_EnterFocus()
    CheckReady
End Sub

Private Sub UserControl_Resize()
    Dim iHeight As Integer
    
    iHeight = ScaleHeight - lvwInstallations.Top
    If iHeight < 0 Then iHeight = 0
    lvwInstallations.Height = iHeight
    
    lvwInstallations.Width = ScaleWidth
End Sub

'''

Private Sub lvwInstallations_ItemClick(ByVal Item As MSComCtlLib.ListItem)
    CheckReady
End Sub

Private Sub CheckReady()
    FRM.cmdNext.Enabled = Not (lvwInstallations.SelectedItem Is Nothing)
End Sub

