VERSION 5.00
Object = "{8A774550-D889-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMDoc.ocx"
Begin VB.UserControl ctlParameters 
   ClientHeight    =   4260
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6660
   ScaleHeight     =   4260
   ScaleWidth      =   6660
   Begin DBMDoc.DBMDocParameters docParameters 
      Height          =   3735
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6435
      _ExtentX        =   11351
      _ExtentY        =   6588
      Mode            =   1
      Asynchron       =   0   'False
   End
End
Attribute VB_Name = "ctlParameters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const PARAM_MIRROREDDATA_V71 = "MIRRORED_DATA"
Const PARAM_MIRROREDDATA_V72 = "_MIRRORED_DATA"

Const PARAM_LOGMODE = "LOG_MODE"

Const PARAM_MAXDATADEVS = "MAXDATADEVSPACES"
Const PARAM_MAXLOGDEVS = "MAXARCHIVELOGS"

Private iMinWidth As Integer
Private iMinHeight As Integer

'''

Public Property Get StepName() As String
    StepName = "Parameters"
End Property

Public Property Get Info() As String
    Info = INFO_PARAMS
End Property

Public Property Get Document() As DBMDocParameters
    Set Document = docParameters
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Private Sub UserControl_Initialize()
    iMinWidth = -1
    iMinHeight = -1
End Sub

Private Sub UserControl_EnterFocus()
    CheckReady
End Sub

Private Sub UserControl_Resize()
    docParameters.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

'''

Private Sub docParameters_ParameterBeforeChange(ByVal Parameter As dbmlib.Parameter, NewValue As String, Cancel As Boolean)
    Dim bCheck As Boolean
    
    bCheck = False
    
'    If Not Parameter Is Nothing Then
'        Select Case Parameter.Name
'            Case PARAM_MIRROREDDATA_V71, _
'                 PARAM_MIRROREDDATA_V72, _
'                 PARAM_LOGMODE, _
'                 PARAM_MAXDATADEVS, _
'                 PARAM_MAXLOGDEVS:
'
'                bCheck = True
'
'        End Select
'    End If
    
    If bCheck Then
        If docParameters.Database.DevSpaces.Dirty Then
            If MsgBox("If you change the parameter '" + Parameter.Name + "' now, changes in devspaces will be lost.", vbExclamation + vbOKCancel, App.Title) = vbCancel Then
                Cancel = True
            End If
        End If
    End If
End Sub

'''

Private Sub CheckReady()
    FRM.cmdNext.Enabled = True
End Sub

