VERSION 5.00
Begin VB.UserControl ctlUsers 
   ClientHeight    =   4035
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5340
   ScaleHeight     =   4035
   ScaleWidth      =   5340
   Begin VB.Frame fraDBM 
      Caption         =   "Database Manager Operator:"
      Height          =   1575
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4455
      Begin VB.TextBox txtDBM 
         Height          =   285
         Left            =   1620
         TabIndex        =   2
         Top             =   360
         Width           =   2655
      End
      Begin VB.TextBox txtDBMPassword 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1620
         PasswordChar    =   "*"
         TabIndex        =   4
         Top             =   780
         Width           =   2655
      End
      Begin VB.TextBox txtDBMConfirm 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1620
         PasswordChar    =   "*"
         TabIndex        =   6
         Top             =   1140
         Width           =   2655
      End
      Begin VB.Label lblDBM 
         Caption         =   "&User Name:"
         Height          =   195
         Left            =   180
         TabIndex        =   1
         Top             =   420
         Width           =   1395
      End
      Begin VB.Label lblDBMPassword 
         Caption         =   "&Password:"
         Height          =   255
         Left            =   180
         TabIndex        =   3
         Top             =   780
         Width           =   1395
      End
      Begin VB.Label lblDBMConfirm 
         Caption         =   "&Confirm Password:"
         Height          =   255
         Left            =   180
         TabIndex        =   5
         Top             =   1140
         Width           =   1395
      End
   End
   Begin VB.Frame fraDBA 
      Caption         =   "Database System Administrator:"
      Height          =   1575
      Left            =   0
      TabIndex        =   7
      Top             =   1740
      Width           =   4455
      Begin VB.TextBox txtDBAPassword 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1620
         PasswordChar    =   "*"
         TabIndex        =   11
         Top             =   780
         Width           =   2655
      End
      Begin VB.TextBox txtDBAConfirm 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1620
         PasswordChar    =   "*"
         TabIndex        =   13
         Top             =   1140
         Width           =   2655
      End
      Begin VB.TextBox txtDBA 
         Height          =   285
         Left            =   1620
         TabIndex        =   9
         Top             =   360
         Width           =   2655
      End
      Begin VB.Label lblDBAPassword 
         Caption         =   "&Password:"
         Height          =   255
         Left            =   180
         TabIndex        =   10
         Top             =   780
         Width           =   1395
      End
      Begin VB.Label lblDBAConfirm 
         Caption         =   "&Confirm Password:"
         Height          =   255
         Left            =   180
         TabIndex        =   12
         Top             =   1140
         Width           =   1395
      End
      Begin VB.Label lblDBA 
         Caption         =   "&User Name:"
         Height          =   195
         Left            =   180
         TabIndex        =   8
         Top             =   420
         Width           =   1395
      End
   End
End
Attribute VB_Name = "ctlUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private iMinWidth As Integer
Private iMinHeight As Integer

'''

Public Property Get StepName() As String
    StepName = "Database Users"
End Property

Public Property Get Info() As String
    Info = INFO_USERS
End Property

Public Property Get DBMUser() As String
    DBMUser = UCase(Trim(txtDBM))
End Property

Public Property Get DBMPassword() As String
    DBMPassword = UCase(Trim(txtDBMPassword))
End Property

Public Property Get DBAUser() As String
    DBAUser = UCase(Trim(txtDBA))
End Property

Public Property Get DBAPassword() As String
    DBAPassword = UCase(Trim(txtDBAPassword))
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Private Sub UserControl_Initialize()
    iMinWidth = fraDBA.Width
    iMinHeight = fraDBA.Top + fraDBA.Height
End Sub

Private Sub UserControl_Resize()
    If Ambient.UserMode Then
        If ScaleWidth < iMinWidth Or ScaleHeight < iMinHeight Then
            Size iMinWidth, iMinHeight
        End If
    End If
End Sub

Private Sub UserControl_EnterFocus()
    CheckReady
End Sub

'''

Private Sub txtDBM_Change()
    CheckReady
End Sub

Private Sub txtDBM_GotFocus()
    txtDBM.SelStart = 0
    txtDBM.SelLength = Len(txtDBM)
End Sub

Private Sub txtDBM_LostFocus()
    If Not CheckUsers(txtDBM.Text, txtDBA.Text) Then
        txtDBM.Text = ""
        txtDBM.SetFocus
    End If
End Sub

'''

Private Sub txtDBMPassword_Change()
    txtDBMConfirm = ""
    CheckReady
End Sub

Private Sub txtDBMPassword_GotFocus()
    txtDBMPassword.SelStart = 0
    txtDBMPassword.SelLength = Len(txtDBMPassword)
End Sub

Private Sub txtDBMConfirm_Change()
    CheckReady
End Sub

Private Sub txtDBMConfirm_GotFocus()
    txtDBMConfirm.SelStart = 0
    txtDBMConfirm.SelLength = Len(txtDBMConfirm)
End Sub

Private Sub txtDBMConfirm_LostFocus()
  If Not CheckPassword(txtDBMPassword.Text, txtDBMConfirm.Text) Then
     txtDBMPassword = ""
     txtDBMConfirm = ""
     txtDBMPassword.SetFocus
  End If
  CheckReady
End Sub

'''

Private Sub txtDBA_Change()
    CheckReady
End Sub

Private Sub txtDBA_GotFocus()
    txtDBA.SelStart = 0
    txtDBA.SelLength = Len(txtDBA)
End Sub

Private Sub txtDBA_LostFocus()
    If Not CheckUsers(txtDBM.Text, txtDBA.Text) Then
        txtDBA.Text = ""
        txtDBA.SetFocus
    End If
End Sub

'''

Private Sub txtDBAPassword_Change()
    txtDBAConfirm = ""
    CheckReady
End Sub

Private Sub txtDBAPassword_GotFocus()
    txtDBAPassword.SelStart = 0
    txtDBAPassword.SelLength = Len(txtDBAPassword)
End Sub

Private Sub txtDBAConfirm_Change()
    CheckReady
End Sub

Private Sub txtDBAConfirm_GotFocus()
    txtDBAConfirm.SelStart = 0
    txtDBAConfirm.SelLength = Len(txtDBAConfirm)
End Sub

Private Sub txtDBAConfirm_LostFocus()
  If Not CheckPassword(txtDBAPassword.Text, txtDBAConfirm.Text) Then
     txtDBAPassword = ""
     txtDBAConfirm = ""
     txtDBAPassword.SetFocus
  End If
  CheckReady
End Sub

'''

Private Function CheckUsers(ByVal sUser1 As String, ByVal sUser2 As String)
    sUser1 = UCase$(Trim$(sUser1))
    sUser2 = UCase$(Trim$(sUser2))
    
    CheckUsers = True
    
    If Len(sUser1) > 0 And Len(sUser2) > 0 Then
        CheckUsers = (sUser1 <> sUser2)
        If Not CheckUsers Then
            MsgBox "The usernames for Database Manager User and Database Administrator must be different.", vbExclamation, App.Title
        End If
    End If
End Function

Private Function CheckPassword(sPwd1 As String, sPwd2 As String) As Boolean
    CheckPassword = (sPwd1 = sPwd2)
  
    If Not CheckPassword Then
        MsgBox "The password you typed do not match. Type the new password in both text boxes.", vbExclamation, App.Title
    End If
End Function

Private Sub CheckReady()
    FRM.cmdNext.Enabled = Len(Trim(txtDBM)) > 0 And _
                           Len(Trim(txtDBA)) > 0 And _
                           Len(Trim(txtDBMPassword)) > 0 And _
                           Len(Trim(txtDBMConfirm)) > 0 And _
                           txtDBMPassword = txtDBMConfirm And _
                           Len(Trim(txtDBAPassword)) > 0 And _
                           Len(Trim(txtDBAConfirm)) > 0 And _
                           txtDBAPassword = txtDBAConfirm
End Sub

