VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "About"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit


'''

Private Const RESOURCE_OFFSET = 1002

'''

Private fAbout          As frmAbout
Private fSplash         As frmSplash

Private pVersion        As String

'''

Private oFiles As files

'''

Public Function showAboutForm(Optional ByVal ParentHWND As Long)

    Set fAbout = New frmAbout
    With fAbout
        .IDSAppName = RESOURCE_OFFSET
        .IDBAppIcon = RESOURCE_OFFSET
        .ParentHWND = ParentHWND
        .version = pVersion
    End With
    
    If Not oFiles Is Nothing Then
        Set fAbout.files = oFiles
    End If
    
    fAbout.show vbModal
    
End Function

Public Function showSplashForm(Optional ByVal Delay As Long, _
                               Optional ByVal AlwaysOnTop As Boolean, _
                               Optional ByVal OnClickClose As Boolean)
                               
    Set fSplash = New frmSplash
    
    With fSplash
        .IDSAppName = RESOURCE_OFFSET
        .IDBAppIcon = RESOURCE_OFFSET
        .AllwaysOnTop = AlwaysOnTop
        .OnClickClose = OnClickClose
        .version = pVersion
    End With
        
    fSplash.show
    
    If Delay > 0 Then _
       Timer.startTimer Me, Delay
        
    DoEvents
    
End Function

'''

Public Function hideAboutForm()
    On Error Resume Next
    Unload fAbout
    Set fAbout = Nothing
End Function

Public Function hideSplashForm()
    On Error Resume Next
    Timer.stopTimer
    Unload fSplash
    Set fSplash = Nothing
End Function

'''

Public Property Get files() As files
    If oFiles Is Nothing Then
        Set oFiles = New files
    End If
    Set files = oFiles
End Property

'''

Public Function timerEvent()
Attribute timerEvent.VB_MemberFlags = "40"
    hideSplashForm
End Function

'''

Private Sub Class_Initialize()

    Set oFiles = Nothing
    pVersion = ""
    
End Sub

Private Sub Class_Terminate()
    hideAboutForm
    hideSplashForm
End Sub

Public Property Get version() As String
    
    version = pVersion
    
End Property

Public Property Let version(NewVersion As String)
    
    pVersion = NewVersion
    
End Property

