VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl AutoSuppose 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   DefaultCancel   =   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin MSComctlLib.ListView lstSupposes 
      Height          =   1155
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2355
      _ExtentX        =   4154
      _ExtentY        =   2037
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      _Version        =   393217
      Icons           =   "imlSupposes"
      SmallIcons      =   "imlSupposes"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   1
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Object.Width           =   2540
      EndProperty
   End
   Begin MSComctlLib.ImageList imlSupposes 
      Left            =   2250
      Top             =   2760
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   4
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "AutoSuppose.ctx":0000
            Key             =   "icoSmSQL"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "AutoSuppose.ctx":0552
            Key             =   "icoSmStatement"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "AutoSuppose.ctx":0AA4
            Key             =   "icoSmInfo"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "AutoSuppose.ctx":0DBE
            Key             =   "icoSmUser"
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "AutoSuppose"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' ActiveX:    AutoSuppose
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "AutoSuppose"

Const ICON_WIDTH_IN_PIXELS = 20
Const ADDITIONAL_LISTBOX_WIDTH_IN_PIXELS = 40

' Event Declarations
Event ShowSupposeList(ByVal x As Single, ByVal y As Single, ByVal BestWidth As Single)
Event TextModified(ByVal NewText As String)
Event selected(ByVal NewText As String, ByVal NewCursorPos As Long)
Event Canceled(ByVal NewCursorPos As Long)
Event LostMyFocus()
Event Error(ByVal ModuleName As String, ByVal FunctionName As String, ByVal ErrorNumber As Long, ByVal ErrorDescription As String)

' Private copy of properties
Private pAutoSuppose            As New ASObject

' Private variables
Private SQLKeyIndex             As Long
Private StatementKeyIndex       As Long
Private InfoKeyIndex            As Long
Private UserKeyIndex            As Long
Private ParseTextLeft           As String
Private ParseTextToFind         As String
Private ParseTextRight          As String
Private bIgnoreItemClick        As Boolean
Private BestWidth               As Single

Private m_bLeftButton           As Boolean

Private CurrentListItem         As ListItem
Public Property Set autoSuppose(ByVal NewAutoSuppose As ASObject)
    On Error GoTo errP_SET_AutoSuppose

    Const FUNCTION_NAME = "P_Set autoSuppose"

    Set pAutoSuppose = Nothing
    Set pAutoSuppose = NewAutoSuppose

    loadSupposeLists

    Exit Property

errP_SET_AutoSuppose:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get autoSuppose() As ASObject
    On Error GoTo errP_Get_AutoSuppose

    Const FUNCTION_NAME = "P_Get autoSuppose"

    Set autoSuppose = pAutoSuppose

    Exit Property

errP_Get_AutoSuppose:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Function resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"

    lstSupposes.Width = ScaleWidth
    lstSupposes.Height = ScaleHeight

    Exit Function

errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub lstSupposes_ItemClick(ByVal item As MSComctlLib.ListItem)
    On Error GoTo errLstSupposes_ItemClick

    Const FUNCTION_NAME = "lstSupposes_ItemClick"

    If bIgnoreItemClick Then
        bIgnoreItemClick = False
        Exit Sub
    End If

    'select on typed keyword, don't imitate standard listview behaviour
    '10.11.99, decided with dm
    Set lstSupposes.SelectedItem = lstSupposes.FindItem(ParseTextToFind, , 1, lvwPartial)
    If Not lstSupposes.SelectedItem Is Nothing Then
    
        lstSupposes.SelectedItem.EnsureVisible
    Else
        Set lstSupposes.SelectedItem = item
        If Not lstSupposes.SelectedItem Is Nothing Then
            lstSupposes.SelectedItem.EnsureVisible
        End If
    End If

    Exit Sub

errLstSupposes_ItemClick:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub lstSupposes_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errLstSupposes_KeyDown

    Const FUNCTION_NAME = "lstSupposes_KeyDown"

            
    Select Case KeyCode
    
        Case vbKeySpace:
            If lstSupposes.SelectedItem.selected Then
            
                fireEventSelected True
            Else
                RaiseEvent Canceled(Len(ParseTextToFind))
            End If
    
            KeyCode = 0
                
        Case vbKeyReturn:
            If lstSupposes.SelectedItem.selected Then
            
                fireEventSelected False
            Else
                RaiseEvent Canceled(Len(ParseTextToFind))
            End If
            KeyCode = 0
    End Select
    
    bIgnoreItemClick = True

    Exit Sub

errLstSupposes_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub lstSupposes_KeyPress(KeyAscii As Integer)
    On Error GoTo errLstSupposes_KeyPress

    Const FUNCTION_NAME = "lstSupposes_KeyPress"
    
    'variables
    Dim LastSelectedItem   As ListItem
    
    'init
    Set LastSelectedItem = lstSupposes.SelectedItem

    Select Case KeyAscii
        Case 27:    ' ESCAPE
            RaiseEvent Canceled(Len(ParseTextToFind))

            Exit Sub

        Case 13:    ' ENTER
            fireEventSelected False

            Exit Sub

        Case 32:    ' SPACE
        
            If lstSupposes.SelectedItem.selected Then
            
                fireEventSelected True
            Else
                RaiseEvent Canceled(Len(ParseTextToFind))
            End If

            Exit Sub

        Case 8: 'Back Space
        
            If Len(ParseTextToFind) < 1 Then Exit Sub
            ParseTextToFind = Left$(ParseTextToFind, Len(ParseTextToFind) - 1)

            If Len(ParseTextToFind) <> 0 Then
                RaiseEvent TextModified(ParseTextLeft + ParseTextToFind + ParseTextRight)
                'RaiseEvent TextModified(ParseTextToFind)
            Else
                RaiseEvent selected(ParseTextLeft + ParseTextRight, Len(ParseTextLeft))
                'RaiseEvent Selected(ParseTextRight, Len(ParseTextLeft))
            End If

            Set lstSupposes.SelectedItem = lstSupposes.FindItem(ParseTextToFind, , 1, lvwPartial)
            If Not lstSupposes.SelectedItem Is Nothing Then
                lstSupposes.SelectedItem.EnsureVisible
            End If

        Case Else:
            bIgnoreItemClick = False
            ParseTextToFind = ParseTextToFind + Chr$(KeyAscii)

            If Len(ParseTextToFind) <> 0 Then
            
                Set lstSupposes.SelectedItem = lstSupposes.FindItem(ParseTextToFind, , 1, lvwPartial)
                If Not lstSupposes.SelectedItem Is Nothing Then
                    lstSupposes.SelectedItem.EnsureVisible
                Else
                    Set lstSupposes.SelectedItem = LastSelectedItem
                    lstSupposes.SelectedItem.selected = False
                End If

                RaiseEvent TextModified(ParseTextLeft + ParseTextToFind + ParseTextRight)
            Else
                RaiseEvent selected(ParseTextLeft + ParseTextRight, Len(ParseTextLeft))
            End If
    End Select

    Exit Sub

errLstSupposes_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._MouseDown
'    description:   Occur when the user presses  a mouse button.
'    arguments:     [in] Button, which button is pressed
'                   [in] Shift, An integer that corresponds to the state of the SHIFT, CTRL, and ALT keys
'                   [in] x, x position
'                   [in] y, y position
'
'    return value:  /
'
'=========================================================================================
Private Sub lstSupposes_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
   On Error GoTo errLstSupposes_MouseDown

    Const FUNCTION_NAME = "lstSupposes_MouseDown"
    
    

    Exit Sub

errLstSupposes_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, which button is pressed
'                   [in] Shift, An integer that corresponds to the state of the SHIFT, CTRL, and ALT keys
'                   [in] x, x position
'                   [in] y, y position
'
'    return value:  /
'
'=========================================================================================
Private Sub lstSupposes_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
   On Error GoTo errLstSupposes_MouseMove

    Const FUNCTION_NAME = "lstSupposes_MouseMove"

    'set the mousepointer to an arrow
    UserControl.MousePointer = vbArrow
    
    RaiseEvent LostMyFocus

    Exit Sub

errLstSupposes_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lstSupposes_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errLstSupposes_MouseUp

    Const FUNCTION_NAME = "lstSupposes_MouseUp"


    Set CurrentListItem = lstSupposes.hitTest(x, y)
     ' Which button is pressed
    Select Case button

        Case vbLeftButton:
            If Not CurrentListItem Is Nothing Then
    
                m_bLeftButton = True
                fireEventSelected False
            End If
    End Select

    Exit Sub

errLstSupposes_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub UserControl_Initialize()
    On Error GoTo ErrUserControl_Initialize

    Const FUNCTION_NAME = "UserControl_Initialize"

    initParseInfos

    initKey asTypeSQL
    initKey asTypeStatement
    initKey asTypeInfo
    initKey asTypeUser

    m_bLeftButton = False

    Set CurrentListItem = Nothing

    Exit Sub

ErrUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrUserControl_KeyDown

    Const FUNCTION_NAME = "UserControl_KeyDown"

    Select Case KeyCode
    
        Case vbKeySpace:
            If lstSupposes.SelectedItem.selected Then
            
                fireEventSelected True
            Else
                RaiseEvent Canceled(Len(ParseTextToFind))
            End If
            KeyCode = 0
            
        Case vbKeyEscape:
            RaiseEvent Canceled(Len(ParseTextToFind))
            KeyCode = 0
            
        Case vbKeyReturn:
            fireEventSelected False
            KeyCode = 0
            
    End Select

    If lstSupposes.Visible Then lstSupposes.SetFocus
    
    Exit Sub

ErrUserControl_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub UserControl_Resize()
    On Error GoTo ErrUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"

    resizeControls

    Exit Sub

ErrUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function initKey(ByVal SupposeType As SupposeType)
    On Error GoTo errInitKey

    Const FUNCTION_NAME = "initKey"

    Select Case SupposeType
        Case asTypeSQL:
            SQLKeyIndex = 0
        Case asTypeStatement:
            StatementKeyIndex = 0
        Case asTypeInfo:
            InfoKeyIndex = 0
        Case asTypeUser:
            UserKeyIndex = 0
    End Select

    Exit Function

errInitKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function nextKey(ByVal SupposeType As SupposeType) As String
    On Error GoTo errNextKey

    Const FUNCTION_NAME = "nextKey"

    Select Case SupposeType
        Case asTypeSQL:
            SQLKeyIndex = SQLKeyIndex + 1
            nextKey = "xSQL" + Trim$(Str$(SQLKeyIndex))
        Case asTypeStatement:
            StatementKeyIndex = StatementKeyIndex + 1
            nextKey = "xStatement" + Trim$(Str$(StatementKeyIndex))
        Case asTypeInfo:
            InfoKeyIndex = InfoKeyIndex + 1
            nextKey = "xInfo" + Trim$(Str$(InfoKeyIndex))
        Case asTypeUser:
            UserKeyIndex = UserKeyIndex + 1
            nextKey = "xUser" + Trim$(Str$(UserKeyIndex))
    End Select

    Exit Function

errNextKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function parse(ByVal text As String, ByVal CursorPos As Long)
    On Error GoTo errParse

    Const FUNCTION_NAME = "parse"

    Dim i                   As Long
    Dim TokenLeftPos        As Long
    Dim TokenRightPos       As Long
    Dim TextLen             As Long
    Dim CurrentChar         As String
    Dim AsciiCurrentChar    As Integer
    Dim x                   As Single
    Dim y                   As Single

    ' Inits
    ParseTextLeft = ""
    ParseTextToFind = ""
    ParseTextRight = ""

    ' Reset
    initParseInfos

    If lstSupposes.ListItems.count > 0 Then
    
        Set lstSupposes.SelectedItem = lstSupposes.ListItems.item(1)
        lstSupposes.SelectedItem.EnsureVisible
    End If

    ' Checks
    If CursorPos < 1 Then CursorPos = 1
    
    ' Get text pieces
    If Len(text) > 0 Then
        TextLen = Len(text)

        ' Find left pos of token
        TokenLeftPos = 1
        For i = CursorPos To 1 Step -1
            CurrentChar = Mid$(text, i, 1)
            AsciiCurrentChar = Asc(CurrentChar)
            If AsciiCurrentChar < 48 Or (AsciiCurrentChar > 57 And AsciiCurrentChar < 65) Or (AsciiCurrentChar > 90 And AsciiCurrentChar < 97) Or (AsciiCurrentChar > 122 And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "") Then
                TokenLeftPos = i + 1
                Exit For
            End If
        Next

        ' Find right pos of token
        TokenRightPos = TextLen
        For i = CursorPos + 1 To TextLen
            CurrentChar = Mid$(text, i, 1)
            AsciiCurrentChar = Asc(CurrentChar)
            If AsciiCurrentChar < 48 Or (AsciiCurrentChar > 57 And AsciiCurrentChar < 65) Or (AsciiCurrentChar > 90 And AsciiCurrentChar < 97) Or (AsciiCurrentChar > 122 And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "" And CurrentChar <> "") Then
                TokenRightPos = i - 1
                Exit For
            End If
        Next

        'if -1 is used, a one char string is not taken into consideration
        ParseTextLeft = Left$(text, TokenLeftPos - 1)
        
        If CursorPos >= TokenLeftPos Then '+ 1 Then
        
            ParseTextToFind = Mid$(text, TokenLeftPos, CursorPos - TokenLeftPos + 1)
        Else
            ParseTextToFind = ""
        End If
        
        If TextLen >= TokenRightPos Then
        
            ParseTextRight = Right$(text, TextLen - TokenRightPos)
        Else
            ParseTextRight = ""
        End If

        If Len(ParseTextToFind) > 0 Then
            Set lstSupposes.SelectedItem = lstSupposes.FindItem(ParseTextToFind, , , lvwPartial)
            If Not lstSupposes.SelectedItem Is Nothing Then
                lstSupposes.SelectedItem.EnsureVisible

                ' Is there another suppose?
                If lstSupposes.SelectedItem.index + 1 <= lstSupposes.ListItems.count Then
                    If lstSupposes.FindItem(ParseTextToFind, , lstSupposes.SelectedItem.index + 1, lvwPartial) Is Nothing Then
                        fireEventSelected False

                        Exit Function
                    End If
                End If
            ElseIf lstSupposes.ListItems.count > 0 Then
                Set lstSupposes.SelectedItem = lstSupposes.ListItems.item(1)
                If Not lstSupposes.SelectedItem Is Nothing Then
                    lstSupposes.SelectedItem.EnsureVisible
                End If
            End If
        End If
    End If

    getTextPos text, CursorPos, x, y
    RaiseEvent ShowSupposeList(x, y, BestWidth + ((ICON_WIDTH_IN_PIXELS + ADDITIONAL_LISTBOX_WIDTH_IN_PIXELS) * Screen.TwipsPerPixelX))

    Exit Function

errParse:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'not bwithspace is besides one ecxeption (Left MouseButton Down) vk_return
'not to break binary compability this exception is resolved with a flag
Private Function fireEventSelected(ByVal bWithSpace As Boolean)
    On Error GoTo errFireEventSelected

    Const FUNCTION_NAME = "fireEventSelected"
    
    If lstSupposes.SelectedItem Is Nothing Then Exit Function

    If bWithSpace Then
        RaiseEvent selected(ParseTextLeft + lstSupposes.SelectedItem.text + " " + ParseTextRight, Len(ParseTextLeft) + Len(lstSupposes.SelectedItem.text) + 1)
    Else
        If m_bLeftButton = True Then
        
            m_bLeftButton = False
            RaiseEvent selected(ParseTextLeft + lstSupposes.SelectedItem.text + ParseTextRight, Len(ParseTextLeft) + Len(lstSupposes.SelectedItem.text))
        Else
            RaiseEvent selected(ParseTextLeft + lstSupposes.SelectedItem.text + vbCrLf + ParseTextRight, Len(ParseTextLeft) + Len(lstSupposes.SelectedItem.text) + 1)
        End If
    End If

    Exit Function

errFireEventSelected:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function initParseInfos()
    On Error GoTo errInitParseInfos

    Const FUNCTION_NAME = "initParseInfos"

    ParseTextLeft = ""
    ParseTextToFind = ""
    ParseTextRight = ""
    
    m_bLeftButton = False

    Exit Function

errInitParseInfos:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getTextPos(ByVal text As String, ByVal CursorPos As Long, x As Single, y As Single)
    On Error GoTo errGetTextPos

    Const FUNCTION_NAME = "GetTextPos"

    Dim i           As Long
    Dim RowCount    As Long
    Dim LastRow     As String

    ''Init
    RowCount = 1
    LastRow = text
        
    For i = 1 To CursorPos
        If Mid$(text, i, 2) = vbCrLf Then
            RowCount = RowCount + 1
            
            'if there is vbCrLf at the end leave For Loop
            If CursorPos - i - 2 < 0 Then Exit For
            
            LastRow = Mid$(text, i + 2, CursorPos - i - 2)
            i = i + 2
        End If
    Next

    y = UserControl.TextHeight(LastRow) * RowCount + 120
    x = UserControl.TextWidth(LastRow) + 120

    Exit Function

errGetTextPos:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function loadSupposeLists()
    On Error GoTo errLoadSupposeLists

    Const FUNCTION_NAME = "LoadSupposeLists"

    Dim NewWidth        As Single

    ' Inits
    loadSupposeLists = False

    BestWidth = 1000
    lstSupposes.ListItems.clear

    If pAutoSuppose.supposeTypeSQL And pAutoSuppose.sqlSupposeList.count > 0 Then
        loadSupposeList asTypeSQL
    End If

    If pAutoSuppose.supposeTypeStatement And pAutoSuppose.statementSupposeList.count > 0 Then
        loadSupposeList asTypeStatement
    End If

    If pAutoSuppose.supposeTypeInfo And pAutoSuppose.infoSupposeList.count > 0 Then
        loadSupposeList asTypeInfo
    End If

    If pAutoSuppose.supposeTypeUser And pAutoSuppose.userSupposeList.count > 0 Then
        loadSupposeList asTypeUser
    End If

    ' Set best width
    For Each CurrentListItem In lstSupposes.ListItems
        NewWidth = UserControl.TextWidth(CurrentListItem.text)
        If NewWidth > BestWidth Then
            BestWidth = NewWidth
        End If
    Next
    lstSupposes.ColumnHeaders.item(1).Width = BestWidth + (ICON_WIDTH_IN_PIXELS * Screen.TwipsPerPixelX)

    ' Set rc
    loadSupposeLists = True

    Exit Function

errLoadSupposeLists:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function loadSupposeList(ByVal SupposeType As SupposeType) As Boolean
    On Error GoTo errLoadSupposeList

    Const FUNCTION_NAME = "LoadSupposeList"

    Dim SupposeList As Collection
    Dim Suppose     As Variant
    Dim Icon        As String

    ' Inits
    loadSupposeList = False

    Select Case SupposeType
        Case asTypeSQL:
            initKey asTypeSQL
            Set SupposeList = pAutoSuppose.sqlSupposeList
            Icon = "icoSmSQL"
        Case asTypeStatement:
            initKey asTypeStatement
            Set SupposeList = pAutoSuppose.statementSupposeList
            Icon = "icoSmStatement"
        Case asTypeInfo:
            initKey asTypeInfo
            Set SupposeList = pAutoSuppose.infoSupposeList
            Icon = "icoSmInfo"
        Case asTypeUser:
            initKey asTypeUser
            Set SupposeList = pAutoSuppose.userSupposeList
            Icon = "icoSmUser"
    End Select

    For Each Suppose In SupposeList
        lstSupposes.ListItems.add , nextKey(SupposeType), Suppose, , Icon
    Next

    ' Set rc
    loadSupposeList = True

    Exit Function

errLoadSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function refreshList()
    On Error GoTo errRefreshList

    Const FUNCTION_NAME = "RefreshList"

    loadSupposeLists

    Exit Function

errRefreshList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


