VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl Navigation 
   Alignable       =   -1  'True
   ClientHeight    =   1455
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3750
   LockControls    =   -1  'True
   ScaleHeight     =   1455
   ScaleWidth      =   3750
   ToolboxBitmap   =   "Navigation.ctx":0000
   Begin VB.Timer timStart 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   330
      Top             =   750
   End
   Begin VB.Timer timClick 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2220
      Top             =   750
   End
   Begin MSComctlLib.ImageList imgList 
      Left            =   1410
      Top             =   330
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   8
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":00FA
            Key             =   "FirstUp"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":020C
            Key             =   "PreviousUp"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":031E
            Key             =   "NextUp"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":0430
            Key             =   "LastUp"
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":0542
            Key             =   "FirstDown"
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":0654
            Key             =   "PreviousDown"
         EndProperty
         BeginProperty ListImage7 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":0766
            Key             =   "NextDown"
         EndProperty
         BeginProperty ListImage8 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Navigation.ctx":0878
            Key             =   "LastDown"
         EndProperty
      EndProperty
   End
   Begin VB.Label lblRowInfo 
      Alignment       =   2  'Center
      Caption         =   "? / ?"
      Height          =   195
      Left            =   1140
      TabIndex        =   0
      Top             =   60
      Width           =   1200
   End
   Begin VB.Image cmdPrevious 
      Height          =   240
      Left            =   270
      Picture         =   "Navigation.ctx":098A
      Stretch         =   -1  'True
      Top             =   30
      Width           =   240
   End
   Begin VB.Image cmdLast 
      Height          =   240
      Left            =   3255
      Picture         =   "Navigation.ctx":0A8C
      Stretch         =   -1  'True
      Top             =   30
      Width           =   240
   End
   Begin VB.Image cmdNext 
      Height          =   240
      Left            =   3015
      Picture         =   "Navigation.ctx":0B8E
      Stretch         =   -1  'True
      Top             =   30
      Width           =   240
   End
   Begin VB.Image cmdFirst 
      Height          =   240
      Left            =   30
      Picture         =   "Navigation.ctx":0C90
      Stretch         =   -1  'True
      Top             =   30
      Width           =   240
   End
   Begin VB.Image pnlNavigation 
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   0
      Top             =   0
      Width           =   3525
   End
End
Attribute VB_Name = "Navigation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' ActiveX:    Navigation
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SAPDBxNavigation.Navigation"

' Type declaration
Private Enum ButtonType
    navButtonNone = 0
    navButtonFirst = 1
    navButtonPrevious = 2
    navButtonNext = 3
    navButtonLast = 4
End Enum

' Event Declarations
Event Error(ByVal ModuleName As String, ByVal FunctionName As String, ByVal ErrorNumber As Long, ByVal ErrorDescription As String)
Event FirstRow()
Event PreviousRow(ByVal currentRow As Long)
Event NextRow(ByVal currentRow As Long)
Event LastRow()

' Private copy of properties
Private pCurrentRow As Long
Private pTotalRows  As Long

' Private variables
Private CurrentButton

Private Sub internalError(ByVal CurrentError As Object, ByVal ModuleName As String, ByVal FunctionName As String)
    RaiseEvent Error(ModuleName, FunctionName, CurrentError.Number, CurrentError.Description)
End Sub

Public Property Let currentRow(ByVal NewCurrentRow As Long)
    On Error GoTo errP_Let_CurrentRow

    Const FUNCTION_NAME = "P_Let currentRow"
    
    pCurrentRow = NewCurrentRow
    
    setRowInfo
    
    Exit Property
    
errP_Let_CurrentRow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get currentRow() As Long
    On Error GoTo errP_Get_CurrentRow

    Const FUNCTION_NAME = "P_Get currentRow"
    
    currentRow = pCurrentRow
    
    Exit Property
    
errP_Get_CurrentRow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let totalRows(ByVal NewTotalRows As Long)
    On Error GoTo errP_Let_TotalRows

    Const FUNCTION_NAME = "P_Let totalRows"
    
    pTotalRows = NewTotalRows
    
    setRowInfo
    
    Exit Property
    
errP_Let_TotalRows:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get totalRows() As Long
    On Error GoTo errP_Get_TotalRows

    Const FUNCTION_NAME = "P_Get totalRows"
    
    totalRows = pTotalRows
    
    Exit Property
    
errP_Get_TotalRows:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Function setRowInfo()
    On Error GoTo errSetRowInfo

    Const FUNCTION_NAME = "SetRowInfo"
    
    Dim sInfo   As String
    
    If pCurrentRow < 0 Then
        sInfo = "? / "
    Else
        sInfo = Trim$(Str$(pCurrentRow)) + " / "
    End If
    
    If pTotalRows < 0 Then
        sInfo = sInfo + "?"
    Else
        sInfo = sInfo + Trim$(Str$(pTotalRows))
    End If
    
    lblRowInfo.caption = sInfo
    
    DoEvents

    Exit Function

errSetRowInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub cmdFirst_Click()
    On Error GoTo ErrcmdFirst_Click

    Const FUNCTION_NAME = "cmdFirst_Click"
    
    RaiseEvent FirstRow

    Exit Sub

ErrcmdFirst_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub cmdFirst_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdFirst_MouseDown

    Const FUNCTION_NAME = "cmdFirst_MouseDown"
    
    Set cmdFirst.Picture = imgList.ListImages("FirstDown").Picture
    timStart.enabled = False
    CurrentButton = navButtonFirst
    timStart.enabled = True
    DoEvents

    Exit Sub

ErrcmdFirst_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub cmdFirst_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdFirst_MouseMove

    Const FUNCTION_NAME = "cmdFirst_MouseMove"
    
    If x > cmdFirst.Width Or x < 0 Or y > cmdFirst.Height Or y < 0 Then
        Set cmdFirst.Picture = imgList.ListImages("FirstUp").Picture
        DoEvents
    End If

    Exit Sub

ErrcmdFirst_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdFirst_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdFirst_MouseUp

    Const FUNCTION_NAME = "cmdFirst_MouseUp"
    
    Set cmdFirst.Picture = imgList.ListImages("FirstUp").Picture
    timStart.enabled = False
    timClick.enabled = False
    CurrentButton = navButtonNone
    DoEvents

    Exit Sub

ErrcmdFirst_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdLast_Click()
    On Error GoTo ErrcmdLast_Click

    Const FUNCTION_NAME = "cmdLast_Click"
    
    RaiseEvent LastRow

    Exit Sub

ErrcmdLast_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdLast_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdLast_MouseDown

    Const FUNCTION_NAME = "cmdLast_MouseDown"
    
    Set cmdLast.Picture = imgList.ListImages("LastDown").Picture
    timStart.enabled = False
    CurrentButton = navButtonLast
    timStart.enabled = True
    DoEvents

    Exit Sub

ErrcmdLast_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdLast_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdLast_MouseMove

    Const FUNCTION_NAME = "cmdLast_MouseMove"
    
    If x > cmdLast.Width Or x < 0 Or y > cmdLast.Height Or y < 0 Then
        Set cmdLast.Picture = imgList.ListImages("LastUp").Picture
        DoEvents
    End If

    Exit Sub

ErrcmdLast_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdLast_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdLast_MouseUp

    Const FUNCTION_NAME = "cmdLast_MouseUp"
    
    Set cmdLast.Picture = imgList.ListImages("LastUp").Picture
    timStart.enabled = False
    timClick.enabled = False
    CurrentButton = navButtonNone
    DoEvents

    Exit Sub

ErrcmdLast_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdNext_Click()
    On Error GoTo ErrcmdNext_Click

    Const FUNCTION_NAME = "cmdNext_Click"
    
    RaiseEvent NextRow(pCurrentRow)

    Exit Sub

ErrcmdNext_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdNext_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdNext_MouseDown

    Const FUNCTION_NAME = "cmdNext_MouseDown"
    
    Set cmdNext.Picture = imgList.ListImages("NextDown").Picture
    timStart.enabled = False
    CurrentButton = navButtonNext
    timStart.enabled = True
    DoEvents

    Exit Sub

ErrcmdNext_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdNext_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdNext_MouseMove

    Const FUNCTION_NAME = "cmdNext_MouseMove"
    
    If x > cmdNext.Width Or x < 0 Or y > cmdNext.Height Or y < 0 Then
        Set cmdNext.Picture = imgList.ListImages("NextUp").Picture
        DoEvents
    End If

    Exit Sub

ErrcmdNext_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdNext_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdNext_MouseUp

    Const FUNCTION_NAME = "cmdNext_MouseUp"
    
    Set cmdNext.Picture = imgList.ListImages("NextUp").Picture
    timStart.enabled = False
    timClick.enabled = False
    CurrentButton = navButtonNone
    DoEvents

    Exit Sub

ErrcmdNext_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdPrevious_Click()
    On Error GoTo ErrcmdPrevious_Click

    Const FUNCTION_NAME = "cmdPrevious_Click"
    
    RaiseEvent PreviousRow(pCurrentRow)

    Exit Sub

ErrcmdPrevious_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdPrevious_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdPrevious_MouseDown

    Const FUNCTION_NAME = "cmdPrevious_MouseDown"
    
    Set cmdPrevious.Picture = imgList.ListImages("PreviousDown").Picture
    timStart.enabled = False
    CurrentButton = navButtonPrevious
    timStart.enabled = True
    DoEvents

    Exit Sub

ErrcmdPrevious_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdPrevious_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdPrevious_MouseMove

    Const FUNCTION_NAME = "cmdPrevious_MouseMove"
    
    If x > cmdPrevious.Width Or x < 0 Or y > cmdPrevious.Height Or y < 0 Then
        Set cmdPrevious.Picture = imgList.ListImages("PreviousUp").Picture
        DoEvents
    End If

    Exit Sub

ErrcmdPrevious_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdPrevious_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo ErrcmdPrevious_MouseUp

    Const FUNCTION_NAME = "cmdPrevious_MouseUp"
    
    Set cmdPrevious.Picture = imgList.ListImages("PreviousUp").Picture
    timStart.enabled = False
    timClick.enabled = False
    CurrentButton = navButtonNone
    DoEvents

    Exit Sub

ErrcmdPrevious_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub timClick_Timer()
    On Error GoTo ErrtimClick_Timer

    Const FUNCTION_NAME = "timClick_Timer"
    
    Select Case CurrentButton
        Case navButtonPrevious:
            RaiseEvent PreviousRow(pCurrentRow)
        Case navButtonNext:
            RaiseEvent NextRow(pCurrentRow)
    End Select
    
    Exit Sub
    
ErrtimClick_Timer:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub timStart_Timer()
    On Error GoTo ErrtimStart_Timer

    Const FUNCTION_NAME = "timStart_Timer"
    
    timStart.enabled = False
    timClick.enabled = True
    
    Exit Sub
    
ErrtimStart_Timer:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_Resize()
    On Error GoTo ErrUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
ErrUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    ' Width greate then height?
    'If UserControl.ScaleWidth < UserControl.ScaleHeight Then
        'Set cmdFirst.Picture = imgList.ListImages("vFirstUp").Picture
        'Set cmdPrevious.Picture = imgList.ListImages("vPreviousUp").Picture
        'Set cmdNext.Picture = imgList.ListImages("vNextUp").Picture
        'Set cmdLast.Picture = imgList.ListImages("vLastUp").Picture
    'Else
        'Set cmdFirst.Picture = imgList.ListImages("vFirstUp").Picture
        'Set cmdPrevious.Picture = imgList.ListImages("vPreviousUp").Picture
        'Set cmdNext.Picture = imgList.ListImages("vNextUp").Picture
        'Set cmdLast.Picture = imgList.ListImages("vLastUp").Picture
        
        ' Horizontal adjustment
        If UserControl.ScaleWidth >= getTwipsX(64) Then
            pnlNavigation.Width = UserControl.ScaleWidth
            cmdLast.Left = pnlNavigation.Width - cmdLast.Width - getTwipsX(1)
            cmdNext.Left = cmdLast.Left - cmdNext.Width - getTwipsX(1)
            lblRowInfo.Left = (pnlNavigation.Width / 2) - (lblRowInfo.Width / 2)
        End If
    
        ' Vertical adjustment
        If UserControl.ScaleHeight >= getTwipsY(6) Then
            pnlNavigation.Height = UserControl.ScaleHeight
            cmdFirst.Height = pnlNavigation.Height - getTwipsY(4)
            cmdPrevious.Height = cmdFirst.Height
            cmdNext.Height = cmdFirst.Height
            cmdLast.Height = cmdFirst.Height
            If pnlNavigation.Height >= getTwipsY(21) Then
                lblRowInfo.Top = (pnlNavigation.Height / 2) - getTwipsY(6.5)
                lblRowInfo.Height = getTwipsY(13)
            Else
                lblRowInfo.Top = getTwipsY(4)
                If pnlNavigation.Height - getTwipsY(8) < 0 Then
                    lblRowInfo.Height = 0
                Else
                    lblRowInfo.Height = pnlNavigation.Height - getTwipsY(8)
                End If
            End If
        End If
    'End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Function getTwipsX(ByVal Pixels As Single) As Single
    On Error GoTo errGetTwipsX

    Const FUNCTION_NAME = "GetTwipsX"
    
    getTwipsX = Pixels * Screen.TwipsPerPixelX
    
    Exit Function
    
errGetTwipsX:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Function getTwipsY(ByVal Pixels As Single) As Single
    On Error GoTo errGetTwipsY

    Const FUNCTION_NAME = "GetTwipsY"
    
    getTwipsY = Pixels * Screen.TwipsPerPixelY
    
    Exit Function
    
errGetTwipsY:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

