VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "Msflxgrd.ocx"
Object = "{6FBA474E-43AC-11CE-9A0E-00AA0062BB4C}#1.0#0"; "sysinfo.ocx"
Begin VB.UserControl ViewDefinition 
   ClientHeight    =   8385
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   10155
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   8385
   ScaleWidth      =   10155
   Begin VB.Frame frameMisc 
      Height          =   540
      Left            =   600
      TabIndex        =   9
      Top             =   7440
      Width           =   7335
      Begin VB.CheckBox chkReplace 
         Caption         =   "Replace existing View"
         Height          =   375
         Left            =   150
         TabIndex        =   12
         TabStop         =   0   'False
         Top             =   135
         Width           =   1920
      End
      Begin VB.CheckBox chkCheck 
         Caption         =   "Check on Insert or Update"
         Height          =   375
         Left            =   2280
         TabIndex        =   11
         TabStop         =   0   'False
         Top             =   135
         Width           =   2170
      End
      Begin VB.CheckBox chkUpperCase 
         Caption         =   "Identifiers uppercase"
         Height          =   375
         Left            =   4650
         TabIndex        =   10
         Top             =   135
         Width           =   1800
      End
   End
   Begin VB.TextBox lblQuery 
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      BorderStyle     =   0  'None
      Height          =   330
      Left            =   1830
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   735
      Width           =   7965
   End
   Begin SysInfoLib.SysInfo sysInfo 
      Left            =   8640
      Top             =   7440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin VB.Frame fraInput 
      BackColor       =   &H80000001&
      BorderStyle     =   0  'None
      Height          =   515
      Left            =   4440
      TabIndex        =   7
      Top             =   1680
      Visible         =   0   'False
      Width           =   1755
      Begin VB.TextBox txtInput 
         Height          =   315
         HideSelection   =   0   'False
         Left            =   100
         MultiLine       =   -1  'True
         TabIndex        =   0
         TabStop         =   0   'False
         Top             =   100
         Width           =   1560
      End
   End
   Begin VB.Frame fraComment 
      Caption         =   "Comment"
      Height          =   1730
      Left            =   200
      OLEDropMode     =   1  'Manual
      TabIndex        =   5
      Top             =   5425
      Width           =   9675
      Begin VB.TextBox txtComment 
         Height          =   1200
         Left            =   200
         MultiLine       =   -1  'True
         OLEDropMode     =   1  'Manual
         ScrollBars      =   2  'Vertical
         TabIndex        =   4
         TabStop         =   0   'False
         Top             =   330
         Width           =   9165
      End
   End
   Begin MSFlexGridLib.MSFlexGrid grdColumns 
      Height          =   3495
      Left            =   200
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1200
      Width           =   9735
      _ExtentX        =   17171
      _ExtentY        =   6165
      _Version        =   393216
      Cols            =   3
      ScrollBars      =   2
      OLEDropMode     =   1
   End
   Begin VB.TextBox txtViewname 
      Height          =   330
      Left            =   1830
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   300
      Width           =   7965
   End
   Begin VB.Label lblQueryLabel 
      Caption         =   "Based on Query:"
      Height          =   255
      Left            =   195
      OLEDropMode     =   1  'Manual
      TabIndex        =   6
      Top             =   750
      Width           =   1455
   End
   Begin VB.Label lblViewname 
      Caption         =   "View Name:"
      Height          =   255
      Left            =   200
      OLEDropMode     =   1  'Manual
      TabIndex        =   3
      Top             =   360
      Width           =   975
   End
   Begin VB.Menu mnuViewDefinition 
      Caption         =   "View &Definition"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuCreateView 
         Caption         =   "&Create View"
      End
      Begin VB.Menu mnuShowSQL 
         Caption         =   "Export to DirectS&QL"
      End
   End
End
Attribute VB_Name = "ViewDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      ViewDefinition.ctl
'
'========================================================================================
'
' responsible:    RalfS/WolfgangA
'
' special area:   SQLStudio
'
' description:    Control for creating a new view definition.
'
'========================================================================================

Option Explicit

'==============================================================================
' Constant definitions
'==============================================================================
Const MODULE_NAME = "SQLStudio.ViewDefinitionControl"
Const MX_COLUMN_NAME = 256

'==============================================================================
' Event declarations
'==============================================================================
Event CloseMe()

Event ShowSQLInDirectSQL(oSFC As SQLStudioMan.storedFileContent)
'==============================================================================
' Private members
'==============================================================================
Private m_lParentWnd                As Long
Private m_oGlobalInfo               As SQLStudioMan.globalInfo
Private m_oConnection               As SQLStudioDBLayer.connection
Private m_oSFC                      As New SQLStudioMan.storedFileContent
Private m_sSQL                      As String
Private m_lOldWidth                 As Long
Private m_lOldHeight                As Long
Private m_bNoPopup                  As Boolean
Private m_bLoaded                   As Boolean
Private m_iCurrentRow               As Integer
Private m_iVisibleRows              As Integer
Private m_iLastVisibleRow           As Integer
Private m_bKeyPressed               As Boolean


Private m_lAppVersion               As Long

Private m_oSQLStatement             As New BreakStatement

Private m_bReadOnly                 As Boolean
Private m_bUpperCase                As Boolean

'=========================================================================================
'    property:      AppVersion (Let)
'    description:   Sets the private member m_lAppVersion to the given value.
'    arguments:     [in] NewAppVersion - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let appVersion(NewAppVersion As Long)
    On Error GoTo errP_LET_AppVersion

    Const FUNCTION_NAME = "p_let appVersion"
    
    m_lAppVersion = NewAppVersion
    
    Exit Property
    
errP_LET_AppVersion:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Set the private member m_lParentWnd to the given value
'==============================================================================
Public Property Let callingWindow(hWnd As Long)
    On Error GoTo errP_LET_CallingWindow

    Const FUNCTION_NAME = "p_LET CallingWindow"

    m_lParentWnd = hWnd

    Exit Property

errP_LET_CallingWindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the globalInfo class and store it in the private
' member m_oGlobalInfo.
'==============================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "p_SET globalInfo"

    Set m_oGlobalInfo = newGlobalInfo
    
    '--------------------------------------------------------------------------
    ' Initializations
    '--------------------------------------------------------------------------
    'check initial value of uppercase value
    If m_oGlobalInfo.UserProfile.identifiersCaseSensitiv Then
        chkUpperCase.value = vbUnchecked
        m_bUpperCase = False
    Else
        chkUpperCase.value = vbChecked
        m_bUpperCase = True
    End If
    
    Exit Property

errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the Connection class and store it in the
' private member m_oConnection.
'==============================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "p_SET Connection"
    
    Set m_oConnection = NewConnection
    
    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the private member m_oConnection
'==============================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "G_GET Connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Set the property Statement to the given value.
'==============================================================================
Public Property Let statement(value As String)
    On Error GoTo errP_LET_Statement

    Const FUNCTION_NAME = "p_LET Statement"
    
    m_sSQL = value
    
    Exit Property
    
errP_LET_Statement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the property Statement.
'==============================================================================
Public Property Get statement() As String
    On Error GoTo errP_Get_Statement

    Const FUNCTION_NAME = "G_GET Statement"
    
    statement = m_sSQL
    
    Exit Property
    
errP_Get_Statement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'==============================================================================
' Get the value of the parent control.
'==============================================================================
Public Property Get parentControl() As Object
    On Error GoTo errP_Get_ParentControl

    Const FUNCTION_NAME = "G_GET ParentControl"

    Set parentControl = Parent

    Exit Property

errP_Get_ParentControl:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Set the property Management to the given value.
'==============================================================================
Public Property Set storedFileContent(newSFC As storedFileContent)
    On Error GoTo errP_SET_StoredFileContent

    Const FUNCTION_NAME = "p_SET_StoredFileContent"

    If newSFC Is Nothing Then
        Set newSFC = New storedFileContent
        newSFC.fileType = fileTypeDraftView
    End If

    Set m_oSFC = Nothing
    Set m_oSFC = newSFC

''    m_cTableDef.setDescription m_oSFC
''
''    txtTablename.text = m_cTableDef.tablename
''    ctlColumnDefinition.updateColumnDefinition
''    ctlConstraintDefinition.updateConstraintDefinition
''    ctlRefIntegrityDefinition.updateRefIntegrityDefinition
''    ctlMiscDefinition.updateMiscDefinition
''
''    If m_cTableDef.ValidColumns > 0 Then
''        tabTableProperties.TabEnabled(1) = True
''        tabTableProperties.TabEnabled(2) = True
''    End If
    
    Exit Property

errP_SET_StoredFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the property Management.
'==============================================================================
Public Property Get storedFileContent() As storedFileContent
    On Error GoTo errP_Get_StoredFileContent

    Const FUNCTION_NAME = "p_GET_StoredFileContent"

    Set storedFileContent = m_oSFC

    Exit Property

errP_Get_StoredFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Handle the KeyDown event for the Check on Insert or Update checkbox.
'==============================================================================
Private Sub chkCheck_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkCheck_KeyDown
    
    Const FUNCTION_NAME = "chkCheck_KeyDown"
    
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            If txtComment.Visible = True Then txtComment.SetFocus
        Else
            If chkReplace.Visible = True Then chkReplace.SetFocus
        End If
    End If
    
    Exit Sub
    
errChkCheck_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub chkCheck_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkCheck_MouseUp
    
    Const FUNCTION_NAME = "chkCheck_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errChkCheck_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Check on Insert or Update checkbox.
'==============================================================================
Private Sub chkCheck_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkCheck_OLEDragDrop
    
    Const FUNCTION_NAME = "chkCheck_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errChkCheck_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Replace existing View checkbox.
'==============================================================================
Private Sub chkReplace_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkReplace_KeyDown
    
    Const FUNCTION_NAME = "chkReplace_KeyDown"
    
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            If chkCheck.Visible = True Then chkCheck.SetFocus
        Else
            '------------------------------------------------------------------
            ' Set the focus to the last visible row of the flex grid.
            '------------------------------------------------------------------
            If m_bLoaded = True Then
                grdColumns.row = m_iLastVisibleRow
            Else
                grdColumns.row = 1
            End If
            grdColumns.col = 2
    
            If grdColumns.Visible = True Then grdColumns.SetFocus
        End If
    End If
    
    Exit Sub
    
errChkReplace_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub chkReplace_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkReplace_MouseUp
    
    Const FUNCTION_NAME = "chkReplace_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errChkReplace_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Replace existing View checkbox.
'==============================================================================
Private Sub chkReplace_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkReplace_OLEDragDrop
    
    Const FUNCTION_NAME = "chkReplace_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errChkReplace_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkUpperCase_Click()
 On Error GoTo ErrchkUpperCase_Click
    
    Const FUNCTION_NAME = "chkUpperCase_Click"
    
    Dim i As Integer
    
    If chkUpperCase.value = vbChecked Then
    
        txtViewname = UCase(txtViewname)
        
        For i = 1 To grdColumns.Rows - 1
            If grdColumns.TextMatrix(i, 2) <> "" Then
                grdColumns.TextMatrix(i, 2) = UCase(grdColumns.TextMatrix(i, 2))
                Exit For
            End If
        Next
        
        m_bUpperCase = True
    Else
        m_bUpperCase = False
    End If
    
    Exit Sub
    
ErrchkUpperCase_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkUpperCase_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 On Error GoTo errchkUpperCase_MouseUp
    
    Const FUNCTION_NAME = "chkUpperCase_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errchkUpperCase_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub fraComment_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_MouseUp
    
    Const FUNCTION_NAME = "fraComment_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
ErrfraComment_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Comment frame.
'==============================================================================
Private Sub fraComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_OLEDragDrop
    
    Const FUNCTION_NAME = "fraComment_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
ErrfraComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the FlexGrid.
'==============================================================================
Private Sub grdColumns_Click()
    On Error GoTo ErrgrdColumns_Click
    
    Const FUNCTION_NAME = "grdColumns_Click"
    
    enterCell
    
    Exit Sub
    
ErrgrdColumns_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the FlexGrid.
'==============================================================================
Private Sub grdColumns_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrgrdColumns_KeyDown
    
    Const FUNCTION_NAME = "grdColumns_KeyDown"
    
    Select Case KeyCode
    Case vbKeyTab
        If Shift = 0 Then
            If chkReplace.Visible = True Then chkReplace.SetFocus
        Else
            If txtViewname.Visible = True And txtViewname.Enabled = True Then txtViewname.SetFocus
        End If
        
    Case vbKeyReturn
        m_bKeyPressed = True
        enterCell
    End Select
    
    Exit Sub
    
ErrgrdColumns_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub grdColumns_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrgrdColumns_MouseUp
    
    Const FUNCTION_NAME = "grdColumns_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
ErrgrdColumns_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the FlexGrid.
'==============================================================================
Private Sub grdColumns_OLEDragDrop(Data As MSFlexGridLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrgrdColumns_OLEDragDrop
    
    Const FUNCTION_NAME = "grdColumns_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
ErrgrdColumns_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the FlexGrid.
'==============================================================================
Private Sub grdColumns_Scroll()
    On Error GoTo ErrgrdColumns_Scroll
    
    Const FUNCTION_NAME = "grdColumns_Scroll"
    
    fraInput.Visible = False
    m_iLastVisibleRow = grdColumns.TopRow + m_iVisibleRows - 1
    
    Exit Sub
    
ErrgrdColumns_Scroll:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblQuery_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblQuery_MouseUp
    
    Const FUNCTION_NAME = "lblQuery_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errLblQuery_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Based on Query field.
'==============================================================================
Private Sub lblQuery_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblQuery_OLEDragDrop
    
    Const FUNCTION_NAME = "lblQuery_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errLblQuery_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblQueryLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblQueryLabel_MouseUp
    
    Const FUNCTION_NAME = "lblQueryLabel_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errLblQueryLabel_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the label of the Based on Query field.
'==============================================================================
Private Sub lblQueryLabel_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblQueryLabel_OLEDragDrop
    
    Const FUNCTION_NAME = "lblQueryLabel_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errLblQueryLabel_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblViewname_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblViewname_MouseUp
    
    Const FUNCTION_NAME = "lblViewname_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errLblViewname_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the label of the View Name field.
'==============================================================================
Private Sub lblViewname_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblViewname_OLEDragDrop
    
    Const FUNCTION_NAME = "lblViewname_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errLblViewname_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the Click event for the table menu item "Create Table".
'==============================================================================
Private Sub mnuCreateView_Click()
    On Error GoTo errMnuCreateView_Click
    
    Const FUNCTION_NAME = "mnuCreateView_Click"
    
    execute
    
    Exit Sub
    
errMnuCreateView_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' When the menu "Show SQL" was clicked, compose an SQL statement with
' the currently entered values.
'==============================================================================
Private Sub mnuShowSQL_Click()
    On Error GoTo errMnuShowSQL_Click
    
    Const FUNCTION_NAME = "mnuShowSQL_Click"
    
    Dim sStatement As String
    
    fraInput.Visible = False
    
    sStatement = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no view name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    Select Case sStatement
    Case ""
        MsgBox LoadResString(611), vbExclamation, LoadResString(610)
        
    Case "Error"
        MsgBox LoadResString(618), vbExclamation, LoadResString(617)
        
    Case Else
        showSQLStatement (sStatement)
    End Select
    
    Exit Sub
    
errMnuShowSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the comment box.
'==============================================================================
Private Sub txtComment_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtComment_KeyDown
    
    Const FUNCTION_NAME = "txtComment_KeyDown"
    
    If m_bNoPopup = True Then Exit Sub
    
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            If txtViewname.Visible = True And txtViewname.Enabled = True Then txtViewname.SetFocus
            KeyCode = 0
        Else
            If chkCheck.Visible = True Then chkCheck.SetFocus
            KeyCode = 0
        End If
    End If
    
    Exit Sub
    
ErrtxtComment_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyPress event for the comment box.
'==============================================================================
Private Sub txtComment_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtComment_KeyPress
    
    Const FUNCTION_NAME = "txtComment_KeyPress"
    
    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyAscii = 9 Then KeyAscii = 0
    
    Exit Sub
    
ErrtxtComment_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Comment field.
'==============================================================================
Private Sub txtComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtComment_OLEDragDrop
    
    Const FUNCTION_NAME = "txtComment_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
ErrtxtComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the input line.
'==============================================================================
Private Sub txtInput_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtInput_KeyDown
    
    Const FUNCTION_NAME = "txtInput_KeyDown"
    
    Dim this   As MSFlexGrid
    Set this = grdColumns

    Select Case KeyCode
    Case vbKeyTab
        '----------------------------------------------------------------------
        ' The TAB key was pressed.
        '----------------------------------------------------------------------
        fraInput.Visible = False
        If Shift = 0 Then
            chkReplace.SetFocus
        Else
            If txtViewname.Visible = True And txtViewname.Enabled = True Then txtViewname.SetFocus
        End If
    
    Case vbKeyDown
        '----------------------------------------------------------------------
        ' The DOWN key was pressed.
        '----------------------------------------------------------------------
        moveInputLine 1
    
    Case vbKeyUp
        '----------------------------------------------------------------------
        ' The UP key was pressed.
        '----------------------------------------------------------------------
        moveInputLine -1
        
    Case vbKeyEscape
        '----------------------------------------------------------------------
        ' The ESCAPE key was pressed.
        '----------------------------------------------------------------------
        fraInput.Visible = False
        grdColumns.SetFocus
        
    Case vbKeyReturn
        '----------------------------------------------------------------------
        ' The RETURN key was pressed.
        '----------------------------------------------------------------------
        If checkForDoubleNames = False Then Exit Sub
        grdColumns.text = txtInput.text
        grdColumns.row = m_iCurrentRow
        grdColumns.SetFocus
        fraInput.Visible = False
    End Select
    
    Exit Sub
    
ErrtxtInput_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtInput_KeyPress(KeyAscii As Integer)
 On Error GoTo ErrtxtInput_KeyPress
    
    Const FUNCTION_NAME = "txtInput_KeyPress"

    If m_bUpperCase Then
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
    
    Exit Sub
    
ErrtxtInput_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the GotFocus event.
'==============================================================================
Private Sub txtViewname_GotFocus()
    On Error GoTo ErrtxtViewname_GotFocus
    
    Const FUNCTION_NAME = "txtViewname_GotFocus"
    
    If m_bNoPopup = True Then Exit Sub
    
    If m_bLoaded = True Then
        grdColumns.row = m_iLastVisibleRow - m_iVisibleRows + 1
    Else
        grdColumns.row = 1
    End If
    grdColumns.col = 2
    
    Exit Sub
    
ErrtxtViewname_GotFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the View Name field.
'==============================================================================
Private Sub txtViewname_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtViewname_KeyDown
    
    Const FUNCTION_NAME = "txtViewname_KeyDown"
    
    If m_bNoPopup = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        If grdColumns.Visible = True Then grdColumns.SetFocus
    Else
        If txtComment.Visible = True Then txtComment.SetFocus
    End If
    
    Exit Sub
    
ErrtxtViewname_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtViewname_KeyPress(KeyAscii As Integer)
   On Error GoTo ErrtxtViewname_KeyPress
    
    Const FUNCTION_NAME = "txtViewname_KeyPress"

    If m_bUpperCase Then
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
    
    Exit Sub
    
ErrtxtViewname_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event for the user control.
'==============================================================================
Private Sub txtViewname_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtViewname_MouseUp
    
    Const FUNCTION_NAME = "txtViewname_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
ErrtxtViewname_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the View Name field.
'==============================================================================
Private Sub txtViewname_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtViewname_OLEDragDrop
    
    Const FUNCTION_NAME = "txtViewname_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
ErrtxtViewname_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the user control.
'==============================================================================
Private Sub UserControl_Initialize()
    On Error GoTo errUserControl_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    Dim i As Integer
    
    m_bNoPopup = True
    m_bLoaded = False
    m_bKeyPressed = False
    m_iVisibleRows = 1
    m_iLastVisibleRow = 1
    
    '--------------------------------------------------------------------------
    ' Initialization of the strings.
    '--------------------------------------------------------------------------
    lblViewname.Caption = LoadResString(600)
    lblQueryLabel.Caption = LoadResString(601)
    lblQuery.text = LoadResString(602)
    chkReplace.Caption = LoadResString(605)
    chkCheck.Caption = LoadResString(606)
    fraComment.Caption = LoadResString(607)
    grdColumns.TextMatrix(0, 1) = LoadResString(603)
    grdColumns.TextMatrix(0, 2) = LoadResString(604)
    
    '--------------------------------------------------------------------------
    ' Initialization of the flex grid.
    '--------------------------------------------------------------------------
    grdColumns.AllowBigSelection = False
    grdColumns.ScrollTrack = True
    
    grdColumns.col = 0
    grdColumns.row = 1
    grdColumns.text = "1"
    grdColumns.ColAlignment(0) = flexAlignCenterCenter
    grdColumns.CellFontBold = True
    grdColumns.row = 0
    For i = 1 To 2
        grdColumns.col = i
        grdColumns.ColAlignment(i) = flexAlignCenterCenter
        grdColumns.CellFontBold = True
    Next
    
    m_bNoPopup = False
    
    m_oSQLStatement.addComment "//"
    m_oSQLStatement.addComment "--"
    
    m_lAppVersion = 72200
    
    m_bReadOnly = False
    
    Exit Sub
    
errUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event for the user control.
'==============================================================================
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseUp
    
    Const FUNCTION_NAME = "UserControl_MouseUp"
    
    Select Case Button
    Case vbLeftButton:
        fraInput.Visible = False
    Case vbRightButton:
        PopupMenu mnuViewDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errUserControl_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the user control.
'==============================================================================
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_OLEDragDrop
    
    Const FUNCTION_NAME = "UserControl_OLEDragDrop"
    
    statement = ""
    loadQueryDefinition
    
    Exit Sub
    
errUserControl_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the resize event for the control.
'==============================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'==============================================================================
' Check if the column names of the view are unique.
'==============================================================================
Private Function checkForDoubleNames() As Boolean
    On Error GoTo errCheckForDoubleNames

    Const FUNCTION_NAME = "checkForDoubleNames"
    
    Dim i              As Integer
    Dim bAliasDefined  As Boolean
    Dim col            As Integer
    Dim msg            As String
    
    checkForDoubleNames = False
    
    '----------------------------------------------------------------------
    ' Check if alias names have been defined.
    '----------------------------------------------------------------------
    bAliasDefined = False
    For i = 1 To grdColumns.Rows - 1
        If grdColumns.TextMatrix(i, 2) <> "" Then
            bAliasDefined = True
            Exit For
        End If
    Next
    
    '----------------------------------------------------------------------
    ' Check the alias names if defined. Otherwise, check the column names
    ' of the result table of the query.
    '----------------------------------------------------------------------
    If bAliasDefined = True Then
        col = 2
        msg = LoadResString(623)
    Else
        col = 1
        msg = LoadResString(624)
    End If
    
    For i = 1 To grdColumns.Rows - 1
        If grdColumns.TextMatrix(i, col) = txtInput.text And i <> m_iCurrentRow Then
            MsgBox msg, vbExclamation, LoadResString(622)
            txtInput.text = ""
            txtInput.SetFocus
            Exit Function
        End If
    Next
    
    checkForDoubleNames = True
    
    Exit Function
    
errCheckForDoubleNames:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'==============================================================================
' Compose the CREATE statement with the values currently entered in the widgets.
'==============================================================================
Private Function composeSQLStatement() As String
    On Error GoTo errComposeSQLStatement

    Const FUNCTION_NAME = "composeSQLStatement"
    
    Dim sSQL           As String
    Dim i              As Integer
    Dim sAlias         As String
    Dim sSeperator     As String
    Dim bAliasDefined  As Boolean
    
    sSeperator = vbNewLine + "//" + vbNewLine
    
    '--------------------------------------------------------------------------
    ' Check if a query was given.
    '--------------------------------------------------------------------------
    If m_bLoaded = False Then
        composeSQLStatement = "Error"
        Exit Function
    End If
    
    '--------------------------------------------------------------------------
    ' Check if a view name was given. If not, an empty string will be
    ' returned.
    '--------------------------------------------------------------------------
    If txtViewname.text = "" Then
        composeSQLStatement = ""
        Exit Function
    End If
    
    '----------------------------------------------------------------------
    ' Create the CREATE VIEW clause with the entered view name.
    '----------------------------------------------------------------------
    If chkReplace.value = 0 Then
        sSQL = vbNewLine + "CREATE VIEW "
    Else
        sSQL = vbNewLine + "CREATE OR REPLACE VIEW "
    End If
                
    If m_bUpperCase Then
        sSQL = sSQL + Chr(34) + UCase(txtViewname.text) + Chr(34)
    Else
        sSQL = sSQL + Chr(34) + txtViewname.text + Chr(34)
    End If
    
    '----------------------------------------------------------------------
    ' Check if alias names have been defined.
    '----------------------------------------------------------------------
    bAliasDefined = False
    For i = 1 To grdColumns.Rows - 1
        If grdColumns.TextMatrix(i, 2) <> "" Then
            bAliasDefined = True
            Exit For
        End If
    Next
    
    '----------------------------------------------------------------------
    ' If alias names were defined, add them.
    '----------------------------------------------------------------------
    If bAliasDefined = True Then
        sSQL = sSQL + vbNewLine + " (" + vbNewLine
        
        For i = 1 To grdColumns.Rows - 1
            If grdColumns.TextMatrix(i, 2) <> "" Then
                If m_bUpperCase Then
                    sAlias = UCase(grdColumns.TextMatrix(i, 2))
                Else
                    sAlias = grdColumns.TextMatrix(i, 2)
                End If
            Else
                If m_bUpperCase Then
                    sAlias = UCase(grdColumns.TextMatrix(i, 1))
                Else
                    sAlias = grdColumns.TextMatrix(i, 1)
                End If
            End If
            
            sSQL = sSQL + Chr(vbKeyTab) + Chr(34) + sAlias + Chr(34) + ", " + vbNewLine
        Next
        
        sSQL = Left(sSQL, Len(sSQL) - 4) + vbNewLine + ")"
    End If
    
    '----------------------------------------------------------------------
    ' Append the SQL statement for query expression.
    '----------------------------------------------------------------------
    sSQL = sSQL + vbNewLine + "AS " + m_sSQL
    
    '----------------------------------------------------------------------
    ' Append the check option.
    '----------------------------------------------------------------------
    If chkCheck.value = 1 Then sSQL = sSQL + vbNewLine + "WITH CHECK OPTION"
    
    '----------------------------------------------------------------------
    ' Append the SQL statement for the entered comment.
    '----------------------------------------------------------------------
    If txtComment <> "" Then
        sSQL = sSQL + sSeperator + "COMMENT ON TABLE " + Chr(34)
        
        If m_bUpperCase Then
            sSQL = sSQL + UCase(txtViewname.text) + Chr(34)
        Else
            sSQL = sSQL + txtViewname.text
        End If
         
        sSQL = sSQL + Chr(34) + " IS '" + txtComment.text + "'"
    End If
    
    composeSQLStatement = sSQL
    
    Exit Function
    
errComposeSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'==============================================================================
' Display the input line when the cell is entered.
'==============================================================================
Private Sub enterCell()
    On Error GoTo errEnterCell
    
    Const FUNCTION_NAME = "enterCell"
    
    'if read only mode exit enter cell
    If m_bReadOnly Then Exit Sub
    
    If m_bNoPopup = True Or _
       (grdColumns.MouseRow = 0 And m_bKeyPressed = False) Or _
       m_bLoaded = False Then
        fraInput.Visible = False
        Exit Sub
    End If
    
    If fraInput.Visible = True Then
        If checkForDoubleNames = False Then Exit Sub
        grdColumns.TextMatrix(m_iCurrentRow, 2) = txtInput.text
    End If
    
    grdColumns.col = 2
    m_iCurrentRow = grdColumns.row
    
    fraInput.Visible = True
    fraInput.Left = grdColumns.CellLeft + 100
    fraInput.top = grdColumns.top + grdColumns.CellTop - 100
    fraInput.Width = grdColumns.CellWidth - sysInfo.ScrollBarSize + 100
    txtInput.Width = fraInput.Width - 200
    txtInput.text = grdColumns.text
    txtInput.selStart = 0
    txtInput.SelLength = Len(txtInput.text)
    If txtInput.Visible = True Then txtInput.SetFocus
    
    m_bKeyPressed = False
    
    Exit Sub
    
errEnterCell:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Execute the resulting SQL statement.
'==============================================================================
Public Function execute()
    On Error GoTo errExecute
    
    Const FUNCTION_NAME = "execute"
    
    Dim sSQL            As String
    Dim oResult         As SQLStudioDBLayer.Result
    
    fraInput.Visible = False
    
    
    
    '--------------------------------------------------------------------------
    ' Generate the SQL statements depending on the input of the user.
    '--------------------------------------------------------------------------
    sSQL = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no view name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be sent to the database.
    '--------------------------------------------------------------------------
    Select Case sSQL
    Case ""
        MsgBox LoadResString(611), vbExclamation, LoadResString(610)
    
    Case "Error"
        MsgBox LoadResString(618), vbExclamation, LoadResString(617)
    
    Case Else
        '----------------------------------------------------------------------
        ' Initialize the SQL statement object
        '----------------------------------------------------------------------
        Set m_oSQLStatement.connection = m_oConnection
        m_oSQLStatement.resultMode = sapdbSimpleMode
        m_oSQLStatement.callingWindow = m_lParentWnd
        m_oSQLStatement.statement = sSQL
        
        '----------------------------------------------------------------------
        ' Execute each SQL statement of the given string.
        '----------------------------------------------------------------------
        While Not m_oSQLStatement.eos And _
              Len(Trim$(m_oSQLStatement.currentStatement)) > 0 And _
              Trim$(m_oSQLStatement.currentStatement) <> vbCrLf
            If m_oSQLStatement.execute(oResult, Internal) Then
                m_oSQLStatement.nextStatement
            Else
                m_oConnection.Error.showError
                m_oSQLStatement.statement = "ROLLBACK"
                m_oSQLStatement.execute oResult, Internal
                Exit Function
            End If
        Wend
                
        m_oSQLStatement.statement = "COMMIT"
        m_oSQLStatement.execute oResult, Internal
        
        '----------------------------------------------------------------------
        ' Display a feedback messagebox.
        '----------------------------------------------------------------------
        MsgBox LoadResString(621), vbExclamation, LoadResString(620)
    
        RaiseEvent CloseMe
    End Select
    
    Exit Function
    
errExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Load the definition of a given query.
'==============================================================================
Public Function loadQueryDefinition()
    On Error GoTo errLoadQueryDefinition

    Const FUNCTION_NAME = "loadQueryDefinition"
    
    Dim s               As String
    Dim pos             As Integer
    Dim oDragObject     As Object
    Dim sQuery          As String
    Dim sOrigin         As String
    Dim sTable          As String
    Dim sKey            As String
    Dim sObjectName     As String
    Dim oResult         As New SQLStudioDBLayer.Result
    
    fraInput.Visible = False
    
    '--------------------------------------------------------------------------
    ' If the Statement property contains an empty string a stored statement
    ' was dropped in the window --> load the dropped statement.
    ' Otherwise, it comes directly from a DirectSQL, Query-by-Example or a
    ' VisualQuery window.
    '--------------------------------------------------------------------------
    If m_sSQL = "" Then
        '--------------------------------------------------------------------------
        ' Identify the dropped item.
        '--------------------------------------------------------------------------
        For Each oDragObject In m_oGlobalInfo.dragObjects
        
            If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then
                
                Select Case oDragObject.fileType

                    Case fileTypeStatement
                        Exit For
                    Case fileTypeQueryByExample
                        Exit For
                    Case fileTypeVisualQuery
                        Exit For
                    Case Else
                        Exit Function
                End Select
            Else
                If oDragObject.Format = DBOStoredObject Then Exit For
            End If
        Next
    
        '--------------------------------------------------------------------------
        ' If no stored object was dropped, an error message is displayed.
        '--------------------------------------------------------------------------
        If oDragObject Is Nothing Then
            MsgBox LoadResString(609), vbExclamation, LoadResString(608)
            Exit Function
        End If
        
        m_oGlobalInfo.clearDragObjects
    
        If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then
            
            sQuery = oDragObject.FileName
            Select Case oDragObject.fileType
                Case fileTypeStatement:
                    sOrigin = LoadResString(625)
                Case fileTypeVisualQuery:
                    sOrigin = LoadResString(626)
                Case fileTypeQueryByExample:
                    sOrigin = LoadResString(627)
            End Select
            
            If setFromSQL(oDragObject.sqlData, sOrigin, sQuery) = False Then Exit Function
        End If
    End If
    

    Exit Function
    
errLoadQueryDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Load the definition of a given view.
'==============================================================================
Public Function loadViewDefinition(sName As String, sOwner As String)
    On Error GoTo errLoadViewDefinition

    Const FUNCTION_NAME = "loadViewDefinition"
    
    
    Dim s               As String
    Dim sql             As String
    Dim i               As Integer
    Dim iStart          As Integer
    Dim iEnd            As Integer
    Dim sStatement      As String
    Dim oResult         As New SQLStudioDBLayer.Result
    
    Set oResult.connection = m_oConnection
    
    '--------------------------------------------------------------------------
    ' Set the view name.
    '--------------------------------------------------------------------------
    txtViewname.text = sName
    
    '--------------------------------------------------------------------------
    ' Load the SQL statement on which the view was based.
    '--------------------------------------------------------------------------
    sql = "SELECT definition FROM viewdefs WHERE viewname = '" + sName + "' AND owner = '" + sOwner + "'"
    If Not oResult.openResult(sql, Internal) Then Exit Function
    If oResult.noRows Then Exit Function
    If Not oResult.fetch() Then Exit Function
    If Not oResult.GetData() Then Exit Function

    sStatement = oResult.Columns(1).colValue
    m_oComFunc.replaceNonChars sStatement
    iStart = InStr(sStatement, " AS ")
    iEnd = InStr(iStart + 4, sStatement, " WITH CHECK OPTION")
    If iEnd = 0 Then
        sStatement = Mid(sStatement, iStart + 4)
        chkCheck.value = 0
    Else
        sStatement = Mid(sStatement, iStart + 4, iEnd - iStart - 4)
        chkCheck.value = 1
    End If
    
    m_sSQL = sStatement
    lblQuery.text = sStatement
    
    '--------------------------------------------------------------------------
    ' Load the names and alias names of the columns in the view.
    '--------------------------------------------------------------------------
    sql = "SELECT columnname, viewcolumnname FROM viewcolumns WHERE viewname = '" + sName + "' AND owner = '" + sOwner + "'"
    If Not oResult.openResult(sql, Internal) Then Exit Function
    If Not oResult.fetch() Then Exit Function
    
    i = 1
    While Not oResult.noRows
        If Not oResult.GetData() Then Exit Function
        
        With grdColumns
            .Rows = i + 1
            .col = 0
            .row = i
            .CellFontBold = True
            .text = CStr(i)
            .TextMatrix(i, 1) = oResult.Columns(1).colValue
            .TextMatrix(i, 2) = oResult.Columns(2).colValue
        End With
        i = i + 1
        
        If Not oResult.fetch() Then Exit Function
    Wend
    
    '--------------------------------------------------------------------------
    ' Load the comment of the view.
    '--------------------------------------------------------------------------
    sql = "SELECT comment FROM views WHERE viewname = '" + sName + "' AND owner = '" + sOwner + "'"
    If Not oResult.openResult(sql, Internal) Then Exit Function
    If oResult.noRows Then Exit Function
    If Not oResult.fetch() Then Exit Function
    If Not oResult.GetData() Then Exit Function
    If oResult.Columns(1).colValue <> oResult.representationOfNullValue Then _
        txtComment.text = oResult.Columns(1).colValue
    
    '--------------------------------------------------------------------------
    ' Disable the GUI.
    '--------------------------------------------------------------------------
    txtViewname.Locked = True
    txtComment.Locked = True
    chkCheck.Enabled = False
    chkReplace.Enabled = False
    chkUpperCase.Enabled = False
    'if the view def is just shown don't allow any changes on uppercase value
    chkUpperCase.value = vbUnchecked
    
    m_bReadOnly = True
    
    
    mnuCreateView.Enabled = False
    m_bNoPopup = True
    m_bLoaded = True
    
    Exit Function
    
errLoadViewDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
    
Private Function setFromSQL(sStatement As String, _
                            sOrigin As String, _
                            sQuery As String) As Boolean
    On Error GoTo errSetFromSQL
        
    Const FUNCTION_NAME = "setFromSQL"
    
    Dim i               As Integer
    Dim sOneLine        As String
    Dim hStmt           As Long
    Dim nColCount       As Integer
    Dim sColName        As String
    Dim nColNameLen     As Integer
    Dim sColType        As String
    Dim nColLength      As Long
    Dim nColDecimal     As Integer
    Dim bColNotNull     As Boolean
    
    Dim oDBFunc                 As New SQLStudioDBLayer.Functions
    Dim oBreakStatement         As New BreakStatement
    
    If m_sSQL = "" Then
    
        '----------------------------------------------------------------------
        ' Check, if the stored statement is a SELECT statement (comment lines
        ' and additional statements after the first SELECT statement are ignored).
        '----------------------------------------------------------------------
        
        oBreakStatement.addComment "//"
        oBreakStatement.addComment "--"
        oBreakStatement.statement = sStatement
        
        'init
        m_sSQL = ""
        
        'obreakstatement.NextStatement alredy executed in Statement property
        sOneLine = oBreakStatement.currentStatement
        Do While Len(sOneLine) > 0
        
            If UCase(Left(sOneLine, 6)) = "SELECT" Then
            
                m_sSQL = sOneLine
                Exit Do
            End If
            sOneLine = oBreakStatement.nextStatement
        Loop
        
        If Len(m_sSQL) < 1 Then
            MsgBox LoadResString(613), vbExclamation, LoadResString(612)
            Exit Function
        End If
    Else
        sQuery = LoadResString(614)
        sOrigin = LoadResString(97)
    End If
    
    '--------------------------------------------------------------------------
    ' Load the column description of the result of the query. This is done
    ' by preparing the SQL statement and requesting the column description
    ' after that.
    '--------------------------------------------------------------------------
    Set oDBFunc.connection = m_oConnection
    If Not oDBFunc.allocStmt(hStmt) Then Exit Function

    m_oConnection.Error.statement = m_sSQL
    If Not oDBFunc.prepareStmt(hStmt, m_sSQL, Internal) Then
        oDBFunc.freeStmt hStmt
        MsgBox LoadResString(616), vbExclamation, LoadResString(615)
        Exit Function
    End If

    nColCount = oDBFunc.numberOfCols(hStmt)
    If nColCount = -1 Then Exit Function
    
    sColName = Space$(MX_COLUMN_NAME)
    grdColumns.Rows = nColCount + 1
    
    m_bNoPopup = True
    
    For i = 1 To nColCount
        If oDBFunc.getColumnDescription(hStmt, i, sColName, nColNameLen, sColType, _
                                        nColLength, nColDecimal, bColNotNull) = False Then
            Exit Function
        End If

        With grdColumns
            .col = 0
            .row = i
            .CellFontBold = True
            .text = CStr(i)
            
            If nColNameLen > 0 Then
                .TextMatrix(i, 1) = Left(sColName, nColNameLen)
                .TextMatrix(i, 2) = ""
            Else
                .TextMatrix(i, 1) = ""
                .TextMatrix(i, 2) = ""
            End If
        End With
    Next
    
    m_bNoPopup = False
    m_bLoaded = True
    m_iLastVisibleRow = m_iVisibleRows
    
    chkReplace.value = 0
    chkCheck.value = 0
    txtComment.text = ""
    
    lblQuery.text = sQuery + "     (" + sOrigin + ")"
    lblQuery.ToolTipText = m_sSQL
        
    If Not Parent Is Nothing Then Parent.ZOrder
    If txtViewname.Visible = True And txtViewname.Enabled = True Then txtViewname.SetFocus
    
    Exit Function
    
errSetFromSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Move the input line n steps in the given direction (+ --> move down,
' - --> move up).
'==============================================================================
Private Function moveInputLine(steps As Integer)
    On Error GoTo errMoveInputLine

    Const FUNCTION_NAME = "moveInputLine"
    
    If steps = 0 Then Exit Function
    
    If steps > 0 Then
        '----------------------------------------------------------------------
        ' Move the input line down.
        '----------------------------------------------------------------------
        If m_iCurrentRow < grdColumns.Rows - 1 Then
            If m_iCurrentRow + steps > m_iLastVisibleRow Then
                grdColumns.TopRow = grdColumns.TopRow + steps
            End If
            grdColumns.row = m_iCurrentRow + steps
            enterCell
        Else
'            fraInput.Visible = False
'            chkReplace.SetFocus
        End If
    Else
        '----------------------------------------------------------------------
        ' Move the input line up.
        '----------------------------------------------------------------------
        If m_iCurrentRow > 1 Then
            If m_iCurrentRow + steps < grdColumns.TopRow Then
                grdColumns.TopRow = grdColumns.TopRow + steps
            End If
            grdColumns.row = m_iCurrentRow + steps
            enterCell
        End If
    End If
    
    Exit Function
    
errMoveInputLine:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Resize the single widgets according to the enclosing form.
'==============================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
       
    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> UserControl.ScaleWidth Then
        
        txtViewname.Width = UserControl.ScaleWidth - txtViewname.Left - 100
        lblQuery.Width = txtViewname.Width
        fraComment.Left = 100
        grdColumns.Left = 100
        frameMisc.Left = grdColumns.Left
        
        grdColumns.Width = UserControl.ScaleWidth - 200
        grdColumns.ColWidth(0) = 500
        grdColumns.ColWidth(1) = (grdColumns.Width - 500) \ 2
        grdColumns.ColWidth(2) = grdColumns.ColWidth(1)
        
        frameMisc.Width = UserControl.ScaleWidth - 200
        fraComment.Width = UserControl.ScaleWidth - 200
        txtComment.Left = 100
        
        txtComment.Width = fraComment.Width - 200
        m_lOldWidth = UserControl.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> UserControl.ScaleHeight Then
    
        
        grdColumns.Height = UserControl.ScaleHeight \ 3
        frameMisc.top = grdColumns.top + grdColumns.Height + 100
        fraComment.top = frameMisc.top + frameMisc.Height + 100
        
        fraComment.Height = UserControl.ScaleHeight - fraComment.top - 100
        txtComment.Height = fraComment.Height - txtComment.top - 100
        
        m_lOldHeight = UserControl.ScaleHeight
        m_iVisibleRows = grdColumns.Height \ grdColumns.CellHeight - 2
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Show the resulting SQL statement in a separate window.
'==============================================================================
Private Sub showSQLStatement(sStatement As String)
    On Error GoTo errShowSQLStatement

    Const FUNCTION_NAME = "showSQLStatement"
        
    Dim oSFC As New SQLStudioMan.storedFileContent
    
    oSFC.sqlData = sStatement
    'the saved object has to have actual version numbers
    oSFC.appVersion = m_lAppVersion
    oSFC.version = m_lAppVersion
    oSFC.storedIcon = cmStoredDSQL
    
    oSFC.FileName = ""
    
    RaiseEvent ShowSQLInDirectSQL(oSFC)
    
    Exit Sub
    
errShowSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Split the statement linewise.
'==============================================================================
Private Sub splitStatement(strings As Collection, statement As String)
    On Error GoTo errSplitStatement

    Const FUNCTION_NAME = "splitStatement"
        
    Dim s         As String
    Dim iStart    As Integer
    Dim iEnd      As Integer
    
    iStart = 1
    iEnd = InStr(statement, vbNewLine)
    
    '--------------------------------------------------------------------------
    ' If no newline character is found in the statement the entire statment
    ' is added to the collection and the function is left.
    '--------------------------------------------------------------------------
    If iEnd = 0 Then
        strings.Add statement
        Exit Sub
    End If
    
    While iEnd > 0
        strings.Add Mid(statement, iStart, iEnd - iStart)
        iStart = iEnd + 2
        iEnd = InStr(iStart, statement, vbNewLine)
    Wend
    
    Exit Sub
    
errSplitStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

