VERSION 5.00
Object = "{2F7D79C0-01AC-11D5-B32A-0050DADF6C37}#1.4#0"; "SQLStudioCDCon.ocx"
Begin VB.Form frmCreateTable 
   Caption         =   "Table Definition"
   ClientHeight    =   7875
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   12075
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "CreateTable.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   MousePointer    =   1  'Arrow
   ScaleHeight     =   7875
   ScaleWidth      =   12075
   Begin SQLStudioCDCon.TableDefinition ctlTableDefinition 
      Height          =   7095
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   11415
      _ExtentX        =   20135
      _ExtentY        =   12515
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuFileConnect 
         Caption         =   "&Connect"
      End
      Begin VB.Menu mnuFileDisconnect 
         Caption         =   "&Disconnect"
      End
      Begin VB.Menu mnuFileNewInstance 
         Caption         =   "&New SQL Sutdio"
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect1"
         Index           =   0
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect2"
         Index           =   1
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect3"
         Index           =   2
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect4"
         Index           =   3
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect5"
         Index           =   4
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect6"
         Index           =   5
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect7"
         Index           =   6
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect8"
         Index           =   7
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect9"
         Index           =   8
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect10"
         Index           =   9
      End
      Begin VB.Menu mnuFileSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuViewDirectSQL 
         Caption         =   "&Direct SQL"
      End
      Begin VB.Menu mnuViewDirectSQLAC 
         Caption         =   "Direct SQL &Auto Commit Off"
      End
      Begin VB.Menu mnuViewNewQueryByExample 
         Caption         =   "&Query By Example"
      End
      Begin VB.Menu mnuViewNewVisualQuery 
         Caption         =   "&Visual Query"
      End
      Begin VB.Menu mnuViewSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSettings 
         Caption         =   "&Settings"
      End
      Begin VB.Menu mnuViewSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuViewLastDBError 
         Caption         =   "&Last DB Error"
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      NegotiatePosition=   3  'Right
      Begin VB.Menu mnuWindowTileHorizontally 
         Caption         =   "Tile &Horizontally"
      End
      Begin VB.Menu mnuWindowTileVertically 
         Caption         =   "Tile &Vertically"
      End
      Begin VB.Menu mnuWindowCascade 
         Caption         =   "&Cascade"
      End
      Begin VB.Menu mnuWindowArrangeIcons 
         Caption         =   "&Arrange Icons"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      NegotiatePosition=   3  'Right
      Begin VB.Menu mnuHelpTopics 
         Caption         =   "SQL Studio &Topics"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuHelpSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About SQL Studio"
      End
   End
End
Attribute VB_Name = "frmCreateTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form:       SQLStudio.frmCreateTable - Form for Creating a new Table Definition
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Const MODULE_NAME = "SQLStudio.frmCreateTable"


'=========================================================================================
'    property:      globalInfo
'    description:   sets a object of type globalInfo
'    arguments:     newGlobalInfo, a globalcom object
'
'    return value:  /
'
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "P_SET globalInfo"
    
    Set ctlTableDefinition.globalInfo = newGlobalInfo
    
    Exit Property
    
errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      Connection
'    description:   sets a sapdb connection object
'    arguments:     NewConnection, connection object
'
'    return value:  /
'
'=========================================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_Set connection"

    Set ctlTableDefinition.connection = NewConnection

    Exit Property

errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      storedFileContent
'    description:   set a sql studio object management
'    arguments:     [in] newSFC, new sql studio object management
'
'    return value:  /
'
'=========================================================================================
Public Property Set StoredFileContent(newSFC As StoredFileContent)
    On Error GoTo errP_SET_storedFileContent

    Const FUNCTION_NAME = "P_Set storedFileContent"

    If newSFC Is Nothing Then
    
        'if objectmanagement is nothing set actual appversion
        ctlTableDefinition.appVersion = CLng(SQLSTOBJECTSVERSION)
        Set ctlTableDefinition.StoredFileContent = Nothing
    Else
        Me.Caption = newSFC.fileName
        Set ctlTableDefinition.StoredFileContent = newSFC
    End If

    Exit Property

errP_SET_storedFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get StoredFileContent() As StoredFileContent
    On Error GoTo errP_GET_storedFileContent

    Const FUNCTION_NAME = "P_Get storedFileContent"

    Set StoredFileContent = ctlTableDefinition.StoredFileContent

    Exit Property

errP_GET_storedFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let mode(vData As Variant)
    On Error GoTo errP_SET_Mode

    Const FUNCTION_NAME = "P_SET Mode"

    ctlTableDefinition.mode = vData

    Exit Property

errP_SET_Mode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Sub ctlTableDefinition_CloseMe()
    On Error GoTo errCtlTableDefinition_CloseMe

    Const FUNCTION_NAME = "ctlTableDefinition_CloseMe"
    
    Unload Me
    
    Exit Sub
    
errCtlTableDefinition_CloseMe:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub ctlTableDefinition_SaveMe(oSFC As StoredFileContent, bSaveAs As Boolean)
    On Error GoTo errCtlTableDefinition_SaveMe

    Const FUNCTION_NAME = "ctlTableDefinition_SaveMe"

    Dim lPos  As Long
    Dim pSave As New frmSaveSO
   
    'set properties
    Set pSave.connection = m_oAdminCon
    Set pSave.globalInfo = m_oGlobalInfo
    
    'split the fullname into filename ands filepath
    lPos = InStrRev(oSFC.fileName, "/")
    If lPos > 0 Then
    
        pSave.fileName = Right(oSFC.fileName, Len(oSFC.fileName) - lPos)
        pSave.filePath = Left(oSFC.fileName, lPos - 1)
        
        'special check for root
        If pSave.filePath = "" Then pSave.filePath = "/"
    End If
        
    If bSaveAs Then
    
        pSave.loadFolders
        pSave.Show vbModal, frmMain
    Else
        pSave.replaceOrUpdate = True
    End If

    
    If Len(pSave.fullFileName) > 0 And pSave.fullFileName <> "/" Then
        
        'if dialog was up, check for new objectname
        If bSaveAs Then
        
            'check for root
'            If pSave.FilePath <> "/" Then oSFC.fileName = pSave.FilePath'
'            oSFC.fileName = oSFC.fileName + "/" + pSave.FileName
            oSFC.fileName = pSave.fullFileName
        End If
        
        If frmMain.ctlCM.SaveFileInFolder(oSFC, _
                                            pSave.filePath, _
                                            pSave.fileName, _
                                            pSave.replaceOrUpdate) = Saved _
        Then
            ctlTableDefinition.ResetDirty
            Me.Caption = oSFC.fileName
            ctlTableDefinition.StoredFileContent.fileName = oSFC.fileName
            
            setState LoadResString(623), True
        Else
            setState LoadResString(624), True 'Error while saving
        End If

    End If

    Set pSave = Nothing

    Exit Sub

errCtlTableDefinition_SaveMe:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      errCtlTableDefinition_ShowSQLInDirectSQL
'    description:   show the sql of a create table dialog in sql window
'    arguments:     [in] oSFC, object of a tabledef dialog
'
'    return value:  /
'
'=========================================================================================

Private Sub ctlTableDefinition_ShowSQLInDirectSQL(oSFC As SQLStudioMan.StoredFileContent)
    On Error GoTo errCtlTableDefinition_ShowSQLInDirectSQL

    Const FUNCTION_NAME = "ctlTableDefinition_ShowSQLInDirectSQL"
    
    openDirectSQL oSFC
    
    Exit Sub
    
errCtlTableDefinition_ShowSQLInDirectSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Activate
'    description:   occurs when an object becomes the active window.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Activate()
    On Error GoTo errForm_Activate

    Const FUNCTION_NAME = "Form_Activate"
     
    frmMain.tbrMain.Buttons("Execute").Enabled = True
        
    Exit Sub
    
errForm_Activate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._GotFocus
'    description:   Occurs when an object receives the focus,
'                   either by user action, such as tabbing to or clicking the object,
'                   or by changing the focus in code using the SetFocus method.
'                   A form receives the focus only when all visible controls
'                   are disabled.
'    arguments:     /
'
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_GotFocus()
  On Error GoTo errForm_GotFocus

    Const FUNCTION_NAME = "Form_GotFocus"
    
    'activate execute button
    frmMain.tbrMain.Buttons("Execute").Enabled = True
                
    Exit Sub
    
errForm_GotFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load

    Dim i      As Integer
    
    Const FUNCTION_NAME = "Form_Load"
    
    Me.Height = 3 * frmMain.ScaleHeight \ 4
    If frmMain.ScaleWidth > 13150 Then
        Me.Width = 13150
    Else
        Me.Width = frmMain.ScaleWidth
    End If
    Me.Move 0, (Forms.count - 2) * 300
    
    For i = 0 To 9
    
        mnuLRUConnect(i).Caption = frmMain.mnuLRUConnect(i).Caption
        mnuLRUConnect(i).Visible = frmMain.mnuLRUConnect(i).Visible
    Next i
    
    mnuFileSep1.Visible = frmMain.mnuFileSep1.Visible
    ctlTableDefinition.CallingWindow = frmMain.hwnd
    
    mnuViewDirectSQLAC.Enabled = frmMain.mnuViewDirectSQLAC.Enabled
    mnuViewNewQueryByExample.Enabled = frmMain.mnuViewNewQueryByExample.Enabled
    mnuViewNewVisualQuery.Enabled = frmMain.mnuViewNewVisualQuery.Enabled
    mnuSettings.Enabled = frmMain.mnuSettings.Enabled
    
    
    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._QueryUnload
'    description:   Occurs before a form or application closes.
'    arguments:     [out] cancel,  setting this argument to any value other than 0 stops the QueryUnload event in all loaded forms and stops the form and application from closing.
'                   [in] unloadmode,a value or constant indicating the cause of the QueryUnload event, as described in Return Values.
'                                   {vbFormControlMenu ,vbFormCode,vbAppWindows,vbAppTaskManager,vbFormMDIForm,vbFormOwner }
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error GoTo errForm_QueryUnload

    Const FUNCTION_NAME = "Form_QueryUnload"

    ctlTableDefinition.QueryUnload Cancel, UnloadMode
    
    If frmMain.WindowState <> vbMinimized And frmMain.ctlCMContainer.Visible Then frmMain.ctlCMContainer.SetFocus

    Exit Sub

errForm_QueryUnload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"

    resizeControls

    Exit Sub

errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    Const MAX_WIDTH = 5000
    Const MAX_HEIGHT = 3000
    
    
    If Me.WindowState = vbMinimized Then Exit Sub
    
    If Me.Width < 4096 And Me.WindowState <> vbMaximized Then Me.Width = 4096
    If Me.Height < 4096 And Me.WindowState <> vbMaximized Then Me.Height = 4096
    
    If ScaleWidth > MAX_WIDTH Then
        ctlTableDefinition.Width = ScaleWidth
    End If
    
    If ScaleHeight > MAX_HEIGHT Then
        ctlTableDefinition.Height = ScaleHeight
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Unload
'    description:   Occurs when a form is about to be removed from the screen.
'                   This event is triggered by a user closing the form using
'                   the Close command on the Control menu or an Unload statement.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"
    
    'disable execute button
    If Forms.count < 3 Then
    
       frmMain.tbrMain.Buttons("Execute").Enabled = False
       If frmMain.WindowState <> vbMinimized And frmMain.ctlCMContainer.Visible Then frmMain.ctlCMContainer.SetFocus
    End If
    
    Exit Sub

errForm_Unload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Private Sub mnuFile_Click()
    On Error GoTo ErrmnuFile_Click

    Const FUNCTION_NAME = "mnuFile_Click"
    
    mnuFile = frmMain.mnuFile

    mnuFileConnect = frmMain.mnuFileConnect
    mnuFileDisconnect = frmMain.mnuFileDisconnect
    mnuFileExit = frmMain.mnuFileExit
       
    Exit Sub
    
ErrmnuFile_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileConnect_Click()
    On Error GoTo ErrmnuFileConnect_Click

    Const FUNCTION_NAME = "mnuFileConnect_Click"
    
    frmMain.mnuFileConnect_Click
    
    Exit Sub
    
ErrmnuFileConnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileDisconnect_Click()
    On Error GoTo ErrmnuFileDisconnect_Click

    Const FUNCTION_NAME = "mnuFileDisconnect_Click"
    
    frmMain.mnuFileDisconnect_Click
    
    Exit Sub
    
ErrmnuFileDisconnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileNewInstance_Click()
    On Error GoTo ErrmnuFileNewInstance_Click
    
    Const FUNCTION_NAME = "mnuFileNewInstance_Click"
    
    Dim sPath As String
    
    sPath = App.Path + "\" + App.EXEName + ".EXE"
    
    setWindowSettings frmMain, 200, 200, 0, 0
   
    Shell sPath, vbNormalNoFocus
    
    Exit Sub
    
ErrmnuFileNewInstance_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Sub mnuLRUConnect_Click(Index As Integer)
    On Error GoTo ErrmnuLRUConnect_Click
    
    Const FUNCTION_NAME = "mnuLRUConnect_Click"
    
    frmMain.mnuLRUConnect_Click Index
    
    Exit Sub
    
ErrmnuLRUConnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileExit_Click()
    On Error GoTo ErrmnuFileExit_Click

    Const FUNCTION_NAME = "mnuFileExit_Click"
    
    frmMain.mnuFileExit_Click
    
    Exit Sub
    
ErrmnuFileExit_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuView_Click()
    On Error GoTo ErrmnuView_Click

    Const FUNCTION_NAME = "mnuView_Click"
    
    mnuView = frmMain.mnuView

    mnuViewDirectSQL = frmMain.mnuViewDirectSQL
    mnuViewNewVisualQuery = frmMain.mnuViewNewVisualQuery
    mnuViewNewQueryByExample = frmMain.mnuViewNewQueryByExample
    mnuViewLastDBError = frmMain.mnuViewLastDBError
        
    Exit Sub
    
ErrmnuView_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuViewDirectSQL_Click()
    On Error GoTo ErrmnuViewDirectSQL_Click

    Const FUNCTION_NAME = "mnuViewDirectSQL_Click"
    
    frmMain.mnuViewDirectSQL_Click
    
    Exit Sub
    
ErrmnuViewDirectSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuViewDirectSQLAC_Click()
    On Error GoTo ErrmnuViewDirectSQL_Click

    Const FUNCTION_NAME = "mnuViewDirectSQL_Click"
    
    frmMain.mnuViewDirectSQLAC_Click
    
    Exit Sub
    
ErrmnuViewDirectSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Sub

Private Sub mnuViewNewQueryByExample_Click()
    On Error GoTo ErrmnuViewNewQueryByExample_Click

    Const FUNCTION_NAME = "mnuViewNewQueryByExample_Click"
    
    frmMain.mnuViewNewQueryByExample_Click
    
    Exit Sub
    
ErrmnuViewNewQueryByExample_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuViewNewVisualQuery_Click()
    On Error GoTo ErrmnuViewNewVisualQuery_Click

    Const FUNCTION_NAME = "mnuViewNewVisualQuery_Click"
    
    frmMain.mnuViewNewVisualQuery_Click
    
    Exit Sub
    
ErrmnuViewNewVisualQuery_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuSettings_Click()
    On Error GoTo ErrmnuSettings_Click

    Const FUNCTION_NAME = "mnuSettings_Click"
    
    showSettings
    
    Exit Sub
    
ErrmnuSettings_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuViewLastDBError_Click()
    On Error GoTo ErrmnuViewLastDBError_Click

    Const FUNCTION_NAME = "mnuViewLastDBError_Click"
    
    showLastDBError
        
    Exit Sub
    
ErrmnuViewLastDBError_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindow_Click()
    On Error GoTo ErrmnuWindow_Click

    Const FUNCTION_NAME = "mnuWindow_Click"
    
    mnuWindow = frmMain.mnuWindow

    mnuWindowTileHorizontally = frmMain.mnuWindowTileHorizontally
    mnuWindowTileVertically = frmMain.mnuWindowTileVertically
    mnuWindowCascade = frmMain.mnuWindowCascade
    mnuWindowArrangeIcons = frmMain.mnuWindowArrangeIcons
    
    Exit Sub
    
ErrmnuWindow_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowTileHorizontally_Click()
    On Error GoTo ErrmnuWindowTileHorizontally_Click

    Const FUNCTION_NAME = "mnuWindowTileHorizontally_Click"
    
    frmMain.mnuWindowTileHorizontally_Click
    
    Exit Sub
    
ErrmnuWindowTileHorizontally_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowTileVertically_Click()
    On Error GoTo ErrmnuWindowTileVertically_Click

    Const FUNCTION_NAME = "mnuWindowTileVertically_Click"
    
    frmMain.mnuWindowTileVertically_Click
    
    Exit Sub
    
ErrmnuWindowTileVertically_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowCascade_Click()
    On Error GoTo ErrmnuWindowCascade_Click

    Const FUNCTION_NAME = "mnuWindowCascade_Click"
    
    frmMain.mnuWindowCascade_Click
    
    Exit Sub
    
ErrmnuWindowCascade_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowArrangeIcons_Click()
    On Error GoTo ErrmnuWindowArrangeIcons_Click

    Const FUNCTION_NAME = "mnuWindowArrangeIcons_Click"
    
    frmMain.mnuWindowArrangeIcons_Click
    
    Exit Sub
    
ErrmnuWindowArrangeIcons_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuHelp_Click()
    On Error GoTo ErrmnuWindow_Click

    Const FUNCTION_NAME = "mnuWindow_Click"
    
    mnuHelp = frmMain.mnuHelp
    mnuHelpAbout = frmMain.mnuHelpAbout
    
    Exit Sub
    
ErrmnuWindow_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuHelpTopics_Click()
 On Error GoTo ErrmnuHelpTopics_Click

    Const FUNCTION_NAME = "mnuHelpTopics_Click"
    
    showHelp hlpRoot + hlpTablesMain
    
    Exit Sub
    
ErrmnuHelpTopics_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuHelpAbout_Click()
    On Error GoTo ErrmnuHelpAbout_Click

    Const FUNCTION_NAME = "mnuHelpAbout_Click"
    
    frmMain.mnuHelpAbout_Click
    
    Exit Sub
    
ErrmnuHelpAbout_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Function execute()
    On Error GoTo ErrExecute
    
    Const FUNCTION_NAME = "Execute"
    
    ctlTableDefinition.execute
    
    Exit Function
    
ErrExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function showLastDBError()
    On Error GoTo errShowLastDBError
    
    Const FUNCTION_NAME = "ShowLastDBError"
    
    ctlTableDefinition.connection.showLastDBError
    
    Exit Function
    
errShowLastDBError:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      InitializeAlterTable
'    description:   Initialize the form for altering the table definition, i.e. load
'                   the table definition of the given table.
'    arguments:     [in] Tablename - name of the table to be loaded
'                   [in] owner     - owner of the table to be loaded
'                   [in] itemTpye, if itemTpye is cmTable the control is read onyl but all
'                                  information is shown
'                                  if itemTpye is cmSystem just the columninformation is shown
'    return value:  -
'=========================================================================================
Public Function InitializeAlterTable(tablename As String, _
                                owner As String, _
                                Optional itemType As cvItemType)
    On Error GoTo ErrInitializeAlterTable
    
    Const FUNCTION_NAME = "InitializeAlterTable"
    
    ctlTableDefinition.InitializeAlterTable tablename, owner, itemType
    
    Exit Function
    
ErrInitializeAlterTable:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

