VERSION 5.00
Object = "{C5996774-01AB-11D5-B32A-0050DADF6C37}#1.2#0"; "SQLStudioQCon.ocx"
Begin VB.Form frmDirectSQL 
   Caption         =   "SQL Statement"
   ClientHeight    =   3765
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   5850
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "DirectSQL.frx":0000
   LinkTopic       =   "DSQL"
   MDIChild        =   -1  'True
   ScaleHeight     =   3765
   ScaleWidth      =   5850
   ShowInTaskbar   =   0   'False
   Begin SQLStudioQCon.DirectSQL ctlDirectSQL 
      Height          =   3645
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5790
      _ExtentX        =   10213
      _ExtentY        =   6429
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuFileConnect 
         Caption         =   "&Connect"
      End
      Begin VB.Menu mnuFileDisconnect 
         Caption         =   "&Disconnect"
      End
      Begin VB.Menu mnuFileNewInstance 
         Caption         =   "&New SQL Studio"
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect1"
         Index           =   0
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect2"
         Index           =   1
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect3"
         Index           =   2
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect4"
         Index           =   3
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect5"
         Index           =   4
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect6"
         Index           =   5
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect7"
         Index           =   6
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect8"
         Index           =   7
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect9"
         Index           =   8
         Visible         =   0   'False
      End
      Begin VB.Menu mnuLRUConnect 
         Caption         =   "Connect10"
         Index           =   9
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuViewDirectSQL 
         Caption         =   "&Direct SQL"
      End
      Begin VB.Menu mnuViewDirectSQLAC 
         Caption         =   "Direct SQL &Auto Commit Off"
      End
      Begin VB.Menu mnuViewNewQueryByExample 
         Caption         =   "&Query By Example"
      End
      Begin VB.Menu mnuViewNewVisualQuery 
         Caption         =   "&Visual Query"
      End
      Begin VB.Menu mnuViewSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSettings 
         Caption         =   "&Settings"
      End
      Begin VB.Menu mnuViewSep5 
         Caption         =   "-"
      End
      Begin VB.Menu mnuViewLastDBError 
         Caption         =   "&Last DB Error"
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      NegotiatePosition=   3  'Right
      WindowList      =   -1  'True
      Begin VB.Menu mnuWindowTileHorizontally 
         Caption         =   "Tile &Horizontally"
      End
      Begin VB.Menu mnuWindowTileVertically 
         Caption         =   "Tile &Vertically"
      End
      Begin VB.Menu mnuWindowCascade 
         Caption         =   "&Cascade"
      End
      Begin VB.Menu mnuWindowArrangeIcons 
         Caption         =   "&Arrange Icons"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      NegotiatePosition=   3  'Right
      Begin VB.Menu mnuHelpTopics 
         Caption         =   "SQL Studio &Topics"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuHelpSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About SQL Studio"
      End
   End
End
Attribute VB_Name = "frmDirectSQL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      frmDirectSQL - Form for Direct SQL Dialog
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  module for global varibles, functions ...
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.frmDirectSQL"

'=========================================================================================
'    property:      globalInfo
'    description:   sets a object of type globalInfo
'    arguments:     newGlobalInfo
'
'    return value:  /
'
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "P_SET globalInfo"
    
    Set ctlDirectSQL.globalInfo = newGlobalInfo
    
    Exit Property
    
errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      Connection
'    description:   sets a sapdb connection object
'    arguments:     NewConnection, connection object
'
'    return value:  /
'
'=========================================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_Set connection"

    Set ctlDirectSQL.connection = NewConnection

    Exit Property

errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      storedFileContent
'    description:   set a sql studio object storedFileContent
'    arguments:     [in] newFile, new sql studio object storedFileContent
'
'    return value:  /
'
'=========================================================================================
Public Property Set StoredFileContent(newFile As StoredFileContent)
    On Error GoTo errP_SET_storedFileContent

    Const FUNCTION_NAME = "P_Set storedFileContent"

    If newFile Is Nothing Then
    
        'if objectstoredFileContent is nothing set actual appversion
        ctlDirectSQL.appVersion = CLng(SQLSTOBJECTSVERSION)

        Set ctlDirectSQL.StoredFileContent = Nothing
        Me.Caption = LoadResString(207)
    Else
        Set ctlDirectSQL.StoredFileContent = newFile
        If Len(newFile.fileName) > 0 Then
            Me.Caption = newFile.fileName 'set form caption
        Else
            Me.Caption = LoadResString(207)
        End If
    End If
    

    Exit Property

errP_SET_storedFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get StoredFileContent() As StoredFileContent
    On Error GoTo errP_GET_storedFileContent

    Const FUNCTION_NAME = "P_Get storedFileContent"

    Set StoredFileContent = ctlDirectSQL.StoredFileContent

    Exit Property

errP_GET_storedFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set statementList(newStatementList As SQLStudioUtil.History)
    On Error GoTo errP_SET_StatementList
    
    Const FUNCTION_NAME = "P_SET tatementList"
    
    Set ctlDirectSQL.statementList = newStatementList
    
    Exit Property
    
errP_SET_StatementList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, An integer that corresponds to
'                               the state of the mouse buttons in which
'                               a bit is set if the button is down.
'                   [in] shift, An integer that corresponds to the
'                               state of the SHIFT, CTRL, and ALT keys.
'                   [in] x; y,  a number that specifies
'                               the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub ctlDirectSQL_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errCtlDirectSQL_MouseMove

    Const FUNCTION_NAME = "ctlDirectSQL_MouseMove"

    If m_oGlobalInfo.Hourglass.State = qpArrowWEOn Then _
       m_oGlobalInfo.Hourglass.State = qpArrowWEOff
    
    If m_oGlobalInfo.Hourglass.State = qpIBeam Then _
       m_oGlobalInfo.Hourglass.State = qpHourglassOff
    
    Exit Sub
    
errCtlDirectSQL_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub ctlDirectSQL_SaveMe(oStoredFileContent As StoredFileContent, bSaveAs As Boolean)
    On Error GoTo errCtlDirectSQL_SaveMe

    Const FUNCTION_NAME = "ctlDirectSQL_SaveMe"

    Dim lPos  As Long
    Dim pSave As New frmSaveSO
   
    'set properties
    Set pSave.connection = m_oAdminCon
    Set pSave.globalInfo = m_oGlobalInfo
    
    'split the fullname into filename ands filepath
    lPos = InStrRev(oStoredFileContent.fileName, "/")
    If lPos > 0 Then
    
        pSave.fileName = Right(oStoredFileContent.fileName, Len(oStoredFileContent.fileName) - lPos)
        pSave.filePath = Left(oStoredFileContent.fileName, lPos - 1)
        
        'special check for root
        If pSave.filePath = "" Then pSave.filePath = "/"
    End If
        
    If bSaveAs Then
    
        pSave.loadFolders
        pSave.Show vbModal, frmMain
    Else
        pSave.replaceOrUpdate = True
    End If
    
    If Len(pSave.fullFileName) > 0 And pSave.fullFileName <> "/" Then
        
        'if dialog was up, check for new objectname
        If bSaveAs Then oStoredFileContent.fileName = pSave.fullFileName
                
        If frmMain.ctlCM.SaveFileInFolder(oStoredFileContent, _
                                        pSave.filePath, _
                                        pSave.fileName, _
                                        pSave.replaceOrUpdate) = Saved _
        Then
            'set objectname and other properties
            ctlDirectSQL.IsDirty = False
            Me.Caption = oStoredFileContent.fileName
            ctlDirectSQL.StoredFileContent.fileName = oStoredFileContent.fileName
            
            setState LoadResString(622), True
        Else
            setState LoadResString(624), True 'Error while saving
        End If
    End If

    Unload pSave
    
    Set pSave = Nothing

    Exit Sub

errCtlDirectSQL_SaveMe:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Activate
'    description:   occurs when an object becomes the active window.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Activate()
    On Error GoTo errForm_Activate

    Const FUNCTION_NAME = "Form_Activate"
    
    frmMain.tbrMain.Buttons("Execute").Enabled = True
                
    Exit Sub
    
errForm_Activate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._GotFocus
'    description:   Occurs when an object receives the focus,
'                   either by user action, such as tabbing to or clicking the object,
'                   or by changing the focus in code using the SetFocus method.
'                   A form receives the focus only when all visible controls
'                   are disabled.
'    arguments:     /
'
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_GotFocus()
  On Error GoTo errForm_GotFocus

    Const FUNCTION_NAME = "Form_GotFocus"
    
    'activate execute button
    If frmMain.tbrMain.Buttons("Execute").Visible Then _
       frmMain.tbrMain.Buttons("Execute").Enabled = True
    
    If ctlDirectSQL.Visible Then ctlDirectSQL.SetFocus
                
    Exit Sub
    
errForm_GotFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load

    Dim i      As Integer
    
    Const FUNCTION_NAME = "Form_Load"
    
    Me.Height = 2 * frmMain.ScaleHeight \ 3
    Me.Width = frmMain.ScaleWidth - 100
    Me.Move 0, (Forms.count - 2) * 300
    
    For i = 0 To 9
    
        mnuLRUConnect(i).Caption = frmMain.mnuLRUConnect(i).Caption
        mnuLRUConnect(i).Visible = frmMain.mnuLRUConnect(i).Visible
    Next i
    
    mnuFileSep1.Visible = frmMain.mnuFileSep1.Visible
    mnuViewDirectSQLAC.Enabled = frmMain.mnuViewDirectSQLAC.Enabled
    mnuViewNewQueryByExample.Enabled = frmMain.mnuViewNewQueryByExample.Enabled
    mnuViewNewVisualQuery.Enabled = frmMain.mnuViewNewVisualQuery.Enabled
    mnuSettings.Enabled = frmMain.mnuSettings.Enabled
    
    Set ctlDirectSQL.AutoSuppose = m_oAutoSuppose
    ctlDirectSQL.CallingWindow = frmMain.hwnd
    
    ctlDirectSQL.KeyWordList = m_oAutoSuppose.AllSingleKeyWords
    
            
    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function refreshFont()
    On Error GoTo errRefreshFont
    
    Const FUNCTION_NAME = "RefreshFont"
    
    ctlDirectSQL.refreshFont
    
    Exit Function
    
errRefreshFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, An integer that corresponds to
'                               the state of the mouse buttons in which
'                               a bit is set if the button is down.
'                   [in] shift, An integer that corresponds to the
'                               state of the SHIFT, CTRL, and ALT keys.
'                   [in] x; y,  a number that specifies
'                               the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errForm_MouseMove

    Const FUNCTION_NAME = "Form_MouseMove"

    If m_oGlobalInfo.Hourglass.State = qpArrowWEOn Then _
       m_oGlobalInfo.Hourglass.State = qpArrowWEOff
    
    If m_oGlobalInfo.Hourglass.State = qpIBeam Then _
       m_oGlobalInfo.Hourglass.State = qpHourglassOff
    
    Exit Sub
    
errForm_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._QueryUnload
'    description:   Occurs before a form or application closes.
'    arguments:     [out] cancel,  setting this argument to any value other than 0 stops the QueryUnload event in all loaded forms and stops the form and application from closing.
'                   [in] unloadmode,a value or constant indicating the cause of the QueryUnload event, as described in Return Values.
'                                   {vbFormControlMenu ,vbFormCode,vbAppWindows,vbAppTaskManager,vbFormMDIForm,vbFormOwner }
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error GoTo errForm_QueryUnload

    Const FUNCTION_NAME = "Form_QueryUnload"
    
    ' Send QueryUnload message
    ctlDirectSQL.QueryUnload Cancel, UnloadMode
    
    If frmMain.WindowState <> vbMinimized And frmMain.ctlCMContainer.Visible Then frmMain.ctlCMContainer.SetFocus
    
    Exit Sub
    
errForm_QueryUnload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Unload
'    description:   Occurs when a form is about to be removed from the screen.
'                   This event is triggered by a user closing the form using
'                   the Close command on the Control menu or an Unload statement.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"
    
    'disable execute button
    If Forms.count < 3 Then
    
       frmMain.tbrMain.Buttons("Execute").Enabled = False
       If frmMain.WindowState <> vbMinimized And frmMain.ctlCMContainer.Visible Then frmMain.ctlCMContainer.SetFocus
    End If
              
    Set ctlDirectSQL.AutoSuppose = Nothing
    
    Exit Sub
    
errForm_Unload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFile_Click()
    On Error GoTo ErrmnuFile_Click

    Const FUNCTION_NAME = "mnuFile_Click"
    
    mnuFile = frmMain.mnuFile

    mnuFileConnect = frmMain.mnuFileConnect
    mnuFileDisconnect = frmMain.mnuFileDisconnect
    mnuFileExit = frmMain.mnuFileExit
       
    Exit Sub
    
ErrmnuFile_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuHelpTopics_Click()
 On Error GoTo ErrmnuHelpTopics_Click

    Const FUNCTION_NAME = "mnuHelpTopics_Click"
    
    showHelp hlpRoot + hlpDirectSQLMain
    
    Exit Sub
    
ErrmnuHelpTopics_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Sub mnuLRUConnect_Click(Index As Integer)
    On Error GoTo ErrmnuLRUConnect_Click
    
    Const FUNCTION_NAME = "mnuLRUConnect_Click"
    
    frmMain.mnuLRUConnect_Click Index
    
    Exit Sub
    
ErrmnuLRUConnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileConnect_Click()
    On Error GoTo ErrmnuFileConnect_Click

    Const FUNCTION_NAME = "mnuFileConnect_Click"
    
    frmMain.mnuFileConnect_Click
    
    Exit Sub
    
ErrmnuFileConnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileDisconnect_Click()
    On Error GoTo ErrmnuFileDisconnect_Click

    Const FUNCTION_NAME = "mnuFileDisconnect_Click"
    
    frmMain.mnuFileDisconnect_Click
    
    Exit Sub
    
ErrmnuFileDisconnect_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuFileExit_Click()
    On Error GoTo ErrmnuFileExit_Click

    Const FUNCTION_NAME = "mnuFileExit_Click"
    
    frmMain.mnuFileExit_Click
    
    Exit Sub
    
ErrmnuFileExit_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuFileNewInstance_Click()
    On Error GoTo ErrmnuFileNewInstance_Click
    
    Const FUNCTION_NAME = "mnuFileNewInstance_Click"
    
    Dim sPath As String
    
    sPath = App.Path + "\" + App.EXEName + ".EXE"
    
    setWindowSettings frmMain, 200, 200, 0, 0
   
    Shell sPath, vbNormalNoFocus
    
    Exit Sub
    
ErrmnuFileNewInstance_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuHelp_Click()
    On Error GoTo ErrmnuWindow_Click

    Const FUNCTION_NAME = "mnuWindow_Click"
    
    mnuHelp = frmMain.mnuHelp

    mnuHelpAbout = frmMain.mnuHelpAbout
    
    Exit Sub
    
ErrmnuWindow_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuHelpAbout_Click()
    On Error GoTo ErrmnuHelpAbout_Click

    Const FUNCTION_NAME = "mnuHelpAbout_Click"
    
    frmMain.mnuHelpAbout_Click
    
    Exit Sub
    
ErrmnuHelpAbout_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuView_Click()
    On Error GoTo ErrmnuView_Click

    Const FUNCTION_NAME = "mnuView_Click"
    
    mnuView = frmMain.mnuView

    mnuViewDirectSQL = frmMain.mnuViewDirectSQL
    
    mnuViewNewVisualQuery = frmMain.mnuViewNewVisualQuery
    mnuViewNewQueryByExample = frmMain.mnuViewNewQueryByExample
    
    mnuViewLastDBError = frmMain.mnuViewLastDBError
        
    Exit Sub
    
ErrmnuView_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuViewDirectSQLAC_Click()
    On Error GoTo ErrmnuViewDirectSQL_Click

    Const FUNCTION_NAME = "mnuViewDirectSQL_Click"
    
    frmMain.mnuViewDirectSQLAC_Click
    
    Exit Sub
    
ErrmnuViewDirectSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Sub
Private Sub mnuViewDirectSQL_Click()
    On Error GoTo ErrmnuViewDirectSQL_Click

    Const FUNCTION_NAME = "mnuViewDirectSQL_Click"
    
    frmMain.mnuViewDirectSQL_Click
    
    Exit Sub
    
ErrmnuViewDirectSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuViewLastDBError_Click()
    On Error GoTo ErrmnuViewLastDBError_Click

    Const FUNCTION_NAME = "mnuViewLastDBError_Click"
    
    showLastDBError
        
    Exit Sub
    
ErrmnuViewLastDBError_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuViewNewQueryByExample_Click()
    On Error GoTo ErrmnuViewNewQueryByExample_Click

    Const FUNCTION_NAME = "mnuViewNewQueryByExample_Click"
    
    frmMain.mnuViewNewQueryByExample_Click
    
    Exit Sub
    
ErrmnuViewNewQueryByExample_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuSettings_Click()
    On Error GoTo ErrmnuSettings_Click

    Const FUNCTION_NAME = "mnuSettings_Click"
    
    showSettings
    
    Exit Sub
    
ErrmnuSettings_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuViewNewVisualQuery_Click()
    On Error GoTo ErrmnuViewNewVisualQuery_Click

    Const FUNCTION_NAME = "mnuViewNewVisualQuery_Click"
    
    frmMain.mnuViewNewVisualQuery_Click
    
    Exit Sub
    
ErrmnuViewNewVisualQuery_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub mnuWindow_Click()
    On Error GoTo ErrmnuWindow_Click

    Const FUNCTION_NAME = "mnuWindow_Click"
    
    mnuWindow = frmMain.mnuWindow

    mnuWindowTileHorizontally = frmMain.mnuWindowTileHorizontally
    mnuWindowTileVertically = frmMain.mnuWindowTileVertically
    mnuWindowCascade = frmMain.mnuWindowCascade
    mnuWindowArrangeIcons = frmMain.mnuWindowArrangeIcons
    
    Exit Sub
    
ErrmnuWindow_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowArrangeIcons_Click()
    On Error GoTo ErrmnuWindowArrangeIcons_Click

    Const FUNCTION_NAME = "mnuWindowArrangeIcons_Click"
    
    frmMain.mnuWindowArrangeIcons_Click
    
    Exit Sub
    
ErrmnuWindowArrangeIcons_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowCascade_Click()
    On Error GoTo ErrmnuWindowCascade_Click

    Const FUNCTION_NAME = "mnuWindowCascade_Click"
    
    frmMain.mnuWindowCascade_Click
    
    Exit Sub
    
ErrmnuWindowCascade_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowTileHorizontally_Click()
    On Error GoTo ErrmnuWindowTileHorizontally_Click

    Const FUNCTION_NAME = "mnuWindowTileHorizontally_Click"
    
    frmMain.mnuWindowTileHorizontally_Click
    
    Exit Sub
    
ErrmnuWindowTileHorizontally_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuWindowTileVertically_Click()
    On Error GoTo ErrmnuWindowTileVertically_Click

    Const FUNCTION_NAME = "mnuWindowTileVertically_Click"
    
    frmMain.mnuWindowTileVertically_Click
    
    Exit Sub
    
ErrmnuWindowTileVertically_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Activate
'    description:   occurs when an object becomes the active window.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub ctlDirectSQL_Activate()
    On Error GoTo errCtlDirectSQL_Activate

    Const FUNCTION_NAME = "ctlDirectSQL_Activate"
    
    'check windows state
    If WindowState = vbMaximized Then Exit Sub
    
    'activate form
    Form_Activate
    
   ' activate form
    If WindowState = vbNormal And ctlDirectSQL.Visible Then ctlDirectSQL.SetFocus

    'restore window
    WindowState = vbNormal
        
    Exit Sub
    
errCtlDirectSQL_Activate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"

    resizeControls

    Exit Sub

errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    If Me.WindowState = vbMinimized Then Exit Sub
    
    If Me.Width < 4096 And Me.WindowState <> vbMaximized Then Me.Width = 4096
    If Me.Height < 4096 And Me.WindowState <> vbMaximized Then Me.Height = 4096
    
    
    ctlDirectSQL.Width = ScaleWidth
    ctlDirectSQL.Height = ScaleHeight
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Function execute()
    On Error GoTo ErrExecute
    
    Const FUNCTION_NAME = "Execute"
    
    ' Execute statement
    ctlDirectSQL.execute
    
    Exit Function
    
ErrExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function showLastDBError()
    On Error GoTo errShowLastDBError
    
    Const FUNCTION_NAME = "ShowLastDBError"
    
    ctlDirectSQL.connection.showLastDBError
    
    Exit Function
    
errShowLastDBError:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

