VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.UserControl ImportStoredObjects 
   ClientHeight    =   4155
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6360
   DefaultCancel   =   -1  'True
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   ScaleHeight     =   4155
   ScaleWidth      =   6360
   ToolboxBitmap   =   "ImportStoredObjects.ctx":0000
   Begin MSComctlLib.ListView lstStoredObjects 
      Height          =   2985
      Left            =   15
      TabIndex        =   0
      Top             =   0
      Width           =   6345
      _ExtentX        =   11192
      _ExtentY        =   5265
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   393217
      SmallIcons      =   "imgStoredObjects"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   5
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   5292
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Owner"
         Object.Width           =   2117
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "AutoCommit Mode"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "SQL Mode"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Isolation Level"
         Object.Width           =   2540
      EndProperty
   End
   Begin MSComDlg.CommonDialog ctrCommonDialog 
      Left            =   324
      Top             =   3276
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComctlLib.ImageList imgStoredObjects 
      Left            =   5130
      Top             =   3240
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "ImportStoredObjects.ctx":0312
            Key             =   "Statement"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "ImportStoredObjects.ctx":0864
            Key             =   "VisualQuery"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "ImportStoredObjects.ctx":0DB6
            Key             =   "TableDefinition"
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "ImportStoredObjects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      ImportStoredOBjects
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  Import Stored Commands Dialog
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.StoredObjects"


'  Private copy of properties
Dim m_oGlobalInfo              As SQLStudioMan.globalInfo
Dim m_emFileType               As fileType



'  Other local variables
Private DragObject          As ListItem
'=========================================================================================
'    property:      globalInfo
'    description:   sets a object of type globalInfo
'    arguments:     newGlobalInfo
'
'    return value:  /
'
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "P_SET globalInfo"
    
    Set m_oGlobalInfo = newGlobalInfo
    
    Exit Property
    
errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let fileType(newFileType As fileType)
    On Error GoTo errP_LET_fileType

    Const FUNCTION_NAME = "P_Let fileType"
    
    m_emFileType = newFileType
    
    Exit Property
    
errP_LET_fileType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      ..._MouseDown
'    description:   Occur when the user presses (MouseDown)  a mouse button.
'    arguments:     [in] Button, returns an integer that identifies
'                        the button that was pressed (MouseDown) to cause the event.
'                        The button argument is a bit field.
'                   [in] shift, returns an integer that corresponds
'                        to the state of the SHIFT, CTRL, and ALT
'                        keys when the button specified in the button
'                        argument is pressed.
'                   [in] x, y returns a number that specifies
'                        the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub lstStoredObjects_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLstStoredObjects_MouseDown

    Const FUNCTION_NAME = "lstStoredObjects_MouseDown"
    
    Dim item    As ListItem
    
    'is right button pressed?
    If Button = vbRightButton Or Shift = 0 Then
    
        'which object is selected?
        Set item = lstStoredObjects.HitTest(30, Y)
        If Not item Is Nothing Then
            If Not item.Selected Then

                unselectAllListItems
                item.EnsureVisible
                Set lstStoredObjects.SelectedItem = item
            End If
        End If
    End If
    
    Exit Sub
    
errLstStoredObjects_MouseDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, An integer that corresponds to
'                               the state of the mouse buttons in which
'                               a bit is set if the button is down.
'                   [in] shift, An integer that corresponds to the
'                               state of the SHIFT, CTRL, and ALT keys.
'                   [in] x; y,  a number that specifies
'                               the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub lstStoredObjects_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLstStoredObjects_MouseMove

    Const FUNCTION_NAME = "lstStoredObjects_MouseMove"
    
    'if move mouse with pressing left button then begin dragging
    If Button = vbLeftButton Then

        Set DragObject = lstStoredObjects.HitTest(X, Y)
        If Not DragObject Is Nothing Then lstStoredObjects.OLEDrag
    End If
    
    If m_oGlobalInfo.Hourglass.State = qpArrowWEOn Then _
       m_oGlobalInfo.Hourglass.State = qpArrowWEOff
    
    If m_oGlobalInfo.Hourglass.State = qpIBeam Then _
       m_oGlobalInfo.Hourglass.State = qpHourglassOff

    Exit Sub
    
errLstStoredObjects_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._OLEDragStart
'    description:   In a manual OLE drag operation, when the user begins dragging the source and the OLEDrag method is called, the control's OLEStartDrag event fires.
'    arguments:     [in] Data, a DataObject object containing formats that the source
'                              will provide and, in addition, possibly the data for those formats.
'                   [in] AllowedEffects, specifies which drop effects the drag source supports.
'
'    return value:  /
'
'=========================================================================================
Private Sub lstStoredObjects_OLEStartDrag(Data As MSComctlLib.DataObject, AllowedEffects As Long)
    On Error GoTo errLstStoredObjects_OLEStartDrag

    Const FUNCTION_NAME = "lstStoredObjects_OLEStartDrag"

    Dim sObjectList  As String
    
    m_oGlobalInfo.ClearDragObjects              '  Clear drag objects

    selectedStoredObjects sObjectList

    Clipboard.SetText sObjectList              'set clipboard

    Data.SetData sObjectList, vbCFText         'set data and allowed effects
    AllowedEffects = vbDropEffectCopy

    Exit Sub

errLstStoredObjects_OLEStartDrag:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function loadStoredObjects(oConnection As SQLStudioDBLayer.connection) As Boolean
    On Error GoTo errLoadStoredObjects

    Const FUNCTION_NAME = "LoadStoredObjects"
    
    Dim LastListItem    As ListItem

    'rc
    loadStoredObjects = False
    
    'inits
    lstStoredObjects.ListItems.clear
    
    fillList oConnection
        
    loadStoredObjects = True            'set rc

    Exit Function
    
errLoadStoredObjects:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub lstStoredObjects_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    On Error GoTo errLstStoredObjects_ColumnClick

    Const FUNCTION_NAME = "lstStoredObjects_ColumnClick"
        
    If lstStoredObjects.SortKey = ColumnHeader.Index - 1 Then
    
        If lstStoredObjects.SortOrder = lvwAscending Then
        
            lstStoredObjects.SortOrder = lvwDescending
        Else
            lstStoredObjects.SortOrder = lvwAscending
        End If
    Else
        lstStoredObjects.SortKey = ColumnHeader.Index - 1
        lstStoredObjects.SortOrder = lvwAscending
    End If
   
    Exit Sub
    
errLstStoredObjects_ColumnClick:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._MouseUp
'    description:   Occur when the user releases (MouseUp) a mouse button
'    arguments:     [in] Button, returns an integer that identifies
'                        the button that was released (MouseUp) to cause the event.
'                        The button argument is a bit field.
'                   [in] shift, returns an integer that corresponds
'                        to the state of the SHIFT, CTRL, and ALT
'                        keys when the button specified in the button
'                        argument is released.
'                   [in] x, y returns a number that specifies
'                        the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub lstStoredObjects_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLstStoredObjects_MouseUp

    Const FUNCTION_NAME = "lstStoredObjects_MouseUp"
    
    Dim item    As ListItem
    
    '  Is right button pressed?
    If Button = vbRightButton Or Shift = 0 Then
        '  Which object is selected?
        Set item = lstStoredObjects.HitTest(30, Y)
        If Not item Is Nothing Then
            If Not item.Selected Then
            
                Set lstStoredObjects.SelectedItem = item
            End If
        End If
    End If
    
    Exit Sub
    
errLstStoredObjects_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, An integer that corresponds to
'                               the state of the mouse buttons in which
'                               a bit is set if the button is down.
'                   [in] shift, An integer that corresponds to the
'                               state of the SHIFT, CTRL, and ALT keys.
'                   [in] x; y,  a number that specifies
'                               the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseMove

    Const FUNCTION_NAME = "UserControl_MouseMove"
    
    If m_oGlobalInfo.Hourglass.State = qpArrowWEOn Then _
       m_oGlobalInfo.Hourglass.State = qpArrowWEOff
    
    If m_oGlobalInfo.Hourglass.State = qpIBeam Then _
       m_oGlobalInfo.Hourglass.State = qpHourglassOff
       
       Exit Sub
    
errUserControl_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    lstStoredObjects.Left = 0
    lstStoredObjects.Top = 0
    lstStoredObjects.Width = UserControl.ScaleWidth
    lstStoredObjects.Height = UserControl.ScaleHeight
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub selectedStoredObjects(sObjectList As String)
    On Error GoTo errSelectedStoredObjects
    
    Const FUNCTION_NAME = "selectedStoredObjects"
    
    Dim StoredObject    As ListItem
    Dim ObjectListLen   As Long
    
    For Each StoredObject In lstStoredObjects.ListItems
    
        '  If object is selected?
        If StoredObject.Selected Then
        
            'add object to list
            sObjectList = sObjectList + Chr$(34) + StoredObject.Text + Chr$(34) + ", "
            'add object to drag objects
            m_oGlobalInfo.AddStoredDragObject StoredObject.Key, StoredObject.SubItems(1), StoredObject.Text, m_emFileType
        End If
    Next
    
    'reformat list
    ObjectListLen = Len(sObjectList)
    If ObjectListLen > 1 Then sObjectList = Left$(sObjectList, ObjectListLen - 2)
    
    Exit Sub
    
errSelectedStoredObjects:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function unselectAllListItems()
    On Error GoTo errUnselectAllListItems

    Const FUNCTION_NAME = "unselectAllListItems"
    
    Dim item    As ListItem
    
    'scan list
    For Each item In lstStoredObjects.ListItems
    
        item.Selected = False
    Next
    
    Set lstStoredObjects.SelectedItem = Nothing
    Set lstStoredObjects.DropHighlight = Nothing
    
    Exit Function
    
errUnselectAllListItems:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error GoTo errUserControl_ReadProperties
    
    Const FUNCTION_NAME = "UserControl_ReadProperties"
    
    With PropBag
        m_emFileType = .ReadProperty("fileType", fileTypeUnknown)
    End With
    
    Exit Sub
    
errUserControl_ReadProperties:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error GoTo errUserControl_WriteProperties
    
    Const FUNCTION_NAME = "UserControl_WriteProperties"
    
    With PropBag
        .WriteProperty "fileType", m_emFileType, fileTypeUnknown
    End With
    
    Exit Sub
    
errUserControl_WriteProperties:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      fillList
'    description:   open all previous versions stored objects of a user
'    arguments:     /
'
'    return value:  true if success
'
'=========================================================================================
Public Function fillList(oConnection As SQLStudioDBLayer.connection) As Boolean
    On Error GoTo errFillList

    Const FUNCTION_NAME = "fillList"
    
    Dim oResult           As New SQLStudioDBLayer.Result
    Dim CmdStr            As String
    Dim IconType          As Integer
    Dim sObjectOwner      As String
    Dim sObjectName       As String
    Dim sObjectId         As String
    Dim lVersion          As Long
    Dim sAttributes       As String
    Dim emAutoCommit      As SQLStudioDBLayer.AutoCommit
    Dim emIsoLevel        As SQLStudioDBLayer.isoLevel
    Dim emSQLMode         As SQLStudioDBLayer.sqlMode
    Dim LastListItem      As ListItem
    
    'rc
    fillList = False
    
    'inits
    Set oResult.connection = oConnection
    
    'build query
    CmdStr = "SELECT OWNER,  NAME, ID, ATTRIBUTES FROM SYSDBA.SYSQP_MY_OBJECTS"
    If m_emFileType <> fileTypeUnknown Then _
       CmdStr = CmdStr + " WHERE OBJTYPE = '" + Trim$(Str$(m_emFileType)) + "'"
        
    'Open result
    If Not oResult.OpenResult(CmdStr, Internal) Then
    
        MsgBox LoadResString(626), vbCritical
        Exit Function
    End If
    
    Select Case m_emFileType

        Case fileTypeStatement:
            IconType = 1
        Case fileTypeVisualQuery:
            IconType = 2
        Case fileTypeDraftTable:
            IconType = 3
    End Select
    
    'get next row
    If Not oResult.Fetch Then Exit Function
    While Not oResult.NoRows
    
        oResult.LimitForLong = -1
        If Not oResult.GetData() Then Exit Function
        
        sObjectOwner = oResult.Columns.item(1).ColValue
        sObjectName = oResult.Columns.item(2).ColValue
        sObjectId = oResult.Columns.item(3).ColValue
        
        'set object description
        sAttributes = oResult.Columns.item(4).ColValue
        splitAttributes sAttributes, lVersion, emAutoCommit, emSQLMode, emIsoLevel
        
        Set LastListItem = lstStoredObjects.ListItems.add(, "x" + sObjectId, sObjectName, , IconType)
        LastListItem.SubItems(1) = sObjectOwner
        setItemAttributes LastListItem, emAutoCommit, emSQLMode, emIsoLevel
        
        'fetch next row
        If Not oResult.Fetch Then Exit Function
    Wend
    
    'set rc
    fillList = True
    
    Exit Function
    
errFillList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      splitAttributes
'    description:   split attributes of stored sql studio object
'    arguments:     [in] sAttributes, string which contains attributes
'                   [out] lVersion, version of stored sql studio object
'                   [out] AutoCommit,commit mode of stored sql studio object
'                   [out] SQLMode,sql mode of stored sql studio object
'                   [out] IsoLevel,iso level of stored sql studio object
'
'    return value:  /
'
'=========================================================================================
Private Function splitAttributes(ByVal sAttributes As String, _
                            lVersion As Long, _
                            AutoCommit As SQLStudioDBLayer.AutoCommit, _
                            sqlMode As SQLStudioDBLayer.sqlMode, _
                            isoLevel As SQLStudioDBLayer.isoLevel)
    On Error GoTo errSplitAttributes
    
                                       
' The BYTE Column is fetched as String
' This is the reason, why all Operations are with '00' or '02'
' The Database is expecting a HEX value with two digits

    Const FUNCTION_NAME = "splitAttributes"

    Dim SplitAttributesLen           As Integer
    Dim SplitAttributesSepPos        As Integer
    Dim SplitAttributesLastSepPos    As Integer
    Dim sConnectionProperties        As String
    Dim sTemp                        As String
    Dim oResult                      As New SQLStudioDBLayer.Result
    
    
    'inits
    If sAttributes = oResult.representationOfNullValue Then sAttributes = "000100020001"
    sConnectionProperties = sAttributes
    SplitAttributesLen = Len(sConnectionProperties)
        
        
    AutoCommit = AutoCommitOn
    sqlMode = Internal
    isoLevel = Committed

    SplitAttributesSepPos = InStr(sConnectionProperties, "00")
    
    If SplitAttributesLen > SplitAttributesSepPos + 1 And SplitAttributesSepPos > 0 Then
        sConnectionProperties = Trim(Right$(sConnectionProperties, SplitAttributesLen - SplitAttributesSepPos - 1))
        sTemp = Left$(sConnectionProperties, 2)
        If Left(sTemp, 2) = "00" Then
            AutoCommit = AutoCommitOff
        Else
            AutoCommit = AutoCommitOn
        End If
    End If
        
    sConnectionProperties = Trim(Right$(sConnectionProperties, Len(sConnectionProperties) - 2))
    SplitAttributesLen = Len(sConnectionProperties)
    SplitAttributesSepPos = InStr(sConnectionProperties, "00")
    
    If SplitAttributesLen > SplitAttributesSepPos + 1 And SplitAttributesSepPos > 0 Then
        sConnectionProperties = Trim(Right$(sConnectionProperties, SplitAttributesLen - SplitAttributesSepPos - 1))
        sTemp = Left$(sConnectionProperties, 2)
        Select Case sTemp
             Case "00"
                 sqlMode = Empty
             Case "01"
                 sqlMode = Internal
             Case "02"
                 sqlMode = DB2
             Case "03"
                 sqlMode = Ansi
             Case "04"
                 sqlMode = Oracle
             Case "05"
                 sqlMode = SAPR3
        End Select
    End If
    
    sConnectionProperties = Trim(Right$(sConnectionProperties, Len(sConnectionProperties) - 2))
    SplitAttributesLen = Len(sConnectionProperties)
    SplitAttributesSepPos = InStr(sConnectionProperties, "00")
    
    If SplitAttributesLen > SplitAttributesSepPos + 1 And SplitAttributesSepPos > 0 Then
        sConnectionProperties = Trim(Right$(sConnectionProperties, SplitAttributesLen - SplitAttributesSepPos - 1))
        sTemp = Left$(sConnectionProperties, 2)
        Select Case sTemp
            Case "01"
                isoLevel = UnCommitted
            Case "02"
                isoLevel = Committed
            Case "04"
                isoLevel = Repeatable
            Case "08"
                isoLevel = Serializable
            Case "16"
                isoLevel = Versionizing
        End Select
    End If
    
    sConnectionProperties = Trim(Right$(sConnectionProperties, Len(sConnectionProperties) - 2))
    SplitAttributesLen = Len(sConnectionProperties)
    SplitAttributesSepPos = InStr(sConnectionProperties, "00")
    
    If SplitAttributesLen > SplitAttributesSepPos + 1 And SplitAttributesSepPos > 0 Then
    
        sConnectionProperties = Trim(Right$(sConnectionProperties, SplitAttributesLen - SplitAttributesSepPos - 1))
        sTemp = Left$(sConnectionProperties, 6)
        If IsNumeric(sTemp) Then lVersion = CLng(sTemp)
    End If


    Exit Function

errSplitAttributes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


Private Function setItemAttributes(oListitem As ListItem, _
                              emAutoCommit As SQLStudioDBLayer.AutoCommit, _
                              emSQLMode As SQLStudioDBLayer.sqlMode, _
                              emIsoLevel As SQLStudioDBLayer.isoLevel)
    On Error GoTo errSetItemAttributes
    
    Const FUNCTION_NAME = "SetItemAttributes"
            
    oListitem.SubItems(2) = LoadResString(530)
    If emAutoCommit = AutoCommitOff Then oListitem.SubItems(2) = LoadResString(531)
    
    Select Case emSQLMode
        Case SQLStudioDBLayer.Internal
            oListitem.SubItems(3) = LoadResString(511)
        Case SQLStudioDBLayer.DB2
            oListitem.SubItems(3) = LoadResString(512)
        Case SQLStudioDBLayer.Ansi
            oListitem.SubItems(3) = LoadResString(513)
        Case SQLStudioDBLayer.Oracle
            oListitem.SubItems(3) = LoadResString(514)
        Case SQLStudioDBLayer.SAPR3
            oListitem.SubItems(3) = LoadResString(515)
    End Select
    
    Select Case emIsoLevel
        Case SQLStudioDBLayer.UnCommitted
             oListitem.SubItems(4) = LoadResString(501)
        Case SQLStudioDBLayer.Committed
             oListitem.SubItems(4) = LoadResString(502)
        Case SQLStudioDBLayer.Repeatable
            oListitem.SubItems(4) = LoadResString(503)
        Case SQLStudioDBLayer.Serializable
            oListitem.SubItems(4) = LoadResString(504)
        Case SQLStudioDBLayer.Versionizing
            oListitem.SubItems(4) = LoadResString(505)
    End Select

    Exit Function

errSetItemAttributes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


