VERSION 5.00
Begin VB.Form frmJoinDefinition 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Join Definition"
   ClientHeight    =   2595
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6765
   Icon            =   "JoinDefinition.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2595
   ScaleWidth      =   6765
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   5340
      TabIndex        =   7
      Top             =   60
      Width           =   1200
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   5340
      TabIndex        =   6
      Top             =   510
      Width           =   1200
   End
   Begin VB.TextBox txtLeftTable 
      Height          =   315
      Left            =   1260
      Locked          =   -1  'True
      TabIndex        =   5
      Top             =   72
      Width           =   3510
   End
   Begin VB.TextBox txtLeftColumn 
      Height          =   315
      Left            =   1260
      Locked          =   -1  'True
      TabIndex        =   4
      Top             =   468
      Width           =   3510
   End
   Begin VB.TextBox txtRightTable 
      Height          =   315
      Left            =   1260
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   852
      Width           =   3510
   End
   Begin VB.TextBox txtRightColumn 
      Height          =   315
      Left            =   1260
      Locked          =   -1  'True
      TabIndex        =   2
      Top             =   1248
      Width           =   3510
   End
   Begin VB.ComboBox cboJoinType 
      Height          =   315
      ItemData        =   "JoinDefinition.frx":030A
      Left            =   0
      List            =   "JoinDefinition.frx":031A
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   2070
      Width           =   2475
   End
   Begin VB.ComboBox cboJoinCompareOperator 
      Height          =   315
      ItemData        =   "JoinDefinition.frx":034B
      Left            =   2670
      List            =   "JoinDefinition.frx":0361
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   2070
      Width           =   2475
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Left Table:"
      Height          =   192
      Left            =   324
      TabIndex        =   13
      Top             =   132
      Width           =   756
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Left Column:"
      Height          =   192
      Left            =   216
      TabIndex        =   12
      Top             =   528
      Width           =   864
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Right Table:"
      Height          =   192
      Left            =   204
      TabIndex        =   11
      Top             =   912
      Width           =   876
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Right Column:"
      Height          =   192
      Left            =   96
      TabIndex        =   10
      Top             =   1308
      Width           =   984
   End
   Begin VB.Label lblJoinType 
      Caption         =   "Join Type"
      Height          =   225
      Left            =   0
      TabIndex        =   9
      Top             =   1800
      Width           =   1500
   End
   Begin VB.Label lblJoinCompareOperator 
      Caption         =   "Join Compare Operator"
      Height          =   225
      Left            =   2670
      TabIndex        =   8
      Top             =   1800
      Width           =   2460
   End
End
Attribute VB_Name = "frmJoinDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmJoinDefinition
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "frmJoinDefinition"

'  Private properties
Private m_oJoinLine         As Join
Private m_bJoinIsModified   As Boolean

'  Private variables
Private m_oCopyOfJoinLine   As New Join

Public Property Set joinLine(NewJoinLine As Join)
    On Error GoTo err_SET_JoinLine
    
    Const FUNCTION_NAME = "P_Set joinLine"
    
    'set property
    Set m_oJoinLine = NewJoinLine
    
    '  Make copy
    m_oCopyOfJoinLine.compareOperator = m_oJoinLine.compareOperator
    m_oCopyOfJoinLine.JoinType = m_oJoinLine.JoinType
    
    'set left table and his column
    txtLeftTable.Text = m_oJoinLine.leftTableName
    txtLeftColumn.Text = m_oJoinLine.leftColumnName
    
    'set right table and his column
    txtRightTable.Text = m_oJoinLine.rightTableName
    txtRightColumn.Text = m_oJoinLine.rightColumnName
    
    'Set join type
    cboJoinType.ListIndex = m_oJoinLine.JoinType
    
    'Set join compare operator
    Select Case m_oJoinLine.compareOperator
        Case "="
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareEqual
        Case ">"
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareGreater
        Case "<"
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareSmaller
        Case ">="
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareEqualGreater
        Case "<="
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareEqualSmaller
        Case "<>"
            cboJoinCompareOperator.ListIndex = SQLStudioMan.PredicateCompareUnequal
    End Select
        
    
    Exit Property
    
err_SET_JoinLine:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get joinIsModified() As Boolean
    On Error GoTo err_GET_JoinIsModified
    
    Const FUNCTION_NAME = "P_Get joinIsModified"
    
    joinIsModified = m_bJoinIsModified
    
    Exit Property
    
err_GET_JoinIsModified:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click
    
    Const FUNCTION_NAME = "cmdCancel_Click"
    
    m_bJoinIsModified = False
    
    '  Restore join line
    m_oJoinLine.compareOperator = m_oCopyOfJoinLine.compareOperator
    m_oJoinLine.JoinType = m_oCopyOfJoinLine.JoinType
    
    '  Hide form
    Me.Hide
    
    Exit Sub
    
errCmdCancel_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
    
    Dim sCompare As String
    
    'Set join compare operator
    Select Case cboJoinCompareOperator.ListIndex
        Case SQLStudioMan.PredicateCompareEqual
             sCompare = "="
        Case SQLStudioMan.PredicateCompareGreater
            sCompare = ">"
        Case SQLStudioMan.PredicateCompareSmaller
            sCompare = "<"
        Case SQLStudioMan.PredicateCompareEqualGreater
            sCompare = ">="
        Case SQLStudioMan.PredicateCompareEqualSmaller
             sCompare = "<="
        Case SQLStudioMan.PredicateCompareUnequal
            sCompare = "<>"
        Case Else
            sCompare = "="
    End Select
    
    If sCompare <> m_oCopyOfJoinLine.compareOperator Or cboJoinType.ListIndex <> m_oCopyOfJoinLine.JoinType Then
        m_bJoinIsModified = True
        
        m_oJoinLine.compareOperator = sCompare
        m_oJoinLine.JoinType = cboJoinType.ListIndex
    Else
        m_bJoinIsModified = False
    End If
    
    '  Hide form
    Me.Hide
    
    Exit Sub
    
errCmdOk_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

