VERSION 5.00
Begin VB.Form frmPredicateBetween 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Predicate Between"
   ClientHeight    =   1995
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4635
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "PredicateBetween.frx":0000
   LinkTopic       =   "Form"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1995
   ScaleWidth      =   4635
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraPredicate 
      Caption         =   "Between Predicate"
      Height          =   1755
      Left            =   75
      TabIndex        =   2
      Top             =   135
      Width           =   3150
      Begin VB.TextBox txtExpression2 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   75
         TabIndex        =   1
         Top             =   1260
         Width           =   2955
      End
      Begin VB.TextBox txtExpression1 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   75
         TabIndex        =   0
         Top             =   570
         Width           =   2955
      End
      Begin VB.Label lblAnd 
         Caption         =   "And"
         Height          =   255
         Left            =   75
         TabIndex        =   4
         Top             =   990
         Width           =   3000
      End
      Begin VB.Label lblBetween 
         Caption         =   "Between"
         Height          =   255
         Left            =   75
         TabIndex        =   3
         Top             =   255
         Width           =   3000
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   570
      Width           =   1200
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   150
      Width           =   1200
   End
End
Attribute VB_Name = "frmPredicateBetween"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmPredicateBetween - Form for Between Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmPredicateBetween"

'local copy of properties
Dim m_oPredicateBetween       As SQLStudioMan.predicateBetween
Dim m_oColDef                 As SQLStudioDBLayer.Column

'local variables
Dim m_oPredicateBetweenCopy   As New SQLStudioMan.predicateBetween
Private Sub copyPredicate(DestPredicate As SQLStudioMan.predicateBetween, SrcPredicate As SQLStudioMan.predicateBetween)
    On Error GoTo errCopyPredicate

    Const FUNCTION_NAME = "copyPredicate"
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.IsNot = SrcPredicate.IsNot
    DestPredicate.Value1 = SrcPredicate.Value1
    DestPredicate.Value2 = SrcPredicate.Value2
    
    Exit Sub
    
errCopyPredicate:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Property Set predicateBetween(NewPredicateBetween As SQLStudioMan.predicateBetween)
    On Error GoTo errP_SET_PredicateBetween

    Const FUNCTION_NAME = "P_SET PredicateBetween"
    
    If NewPredicateBetween Is Nothing Then Exit Property
    
    Set m_oPredicateBetween = NewPredicateBetween
    
    '  Copy predicate
    copyPredicate m_oPredicateBetweenCopy, NewPredicateBetween
    
    txtExpression1.Text = m_oPredicateBetween.Value1
    txtExpression2.Text = m_oPredicateBetween.Value2
    
    Exit Property
    
errP_SET_PredicateBetween:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    
    Exit Property
    
errP_SET_ColumnDefinition:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateBetween() As SQLStudioMan.predicateBetween
    On Error GoTo errP_Get_PredicateBetween

    Const FUNCTION_NAME = "P_Get predicateBetween"
    
    Set predicateBetween = m_oPredicateBetween
    
    Exit Property
    
errP_Get_PredicateBetween:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    'set old predicate values
    copyPredicate m_oPredicateBetween, m_oPredicateBetweenCopy
    
    Err.Number = cdlCancel
    
    Unload Me '  Unload form
    
    Exit Sub
    
errCmdCancel_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
    
    'check if both betwenn values are valid
    If Len(txtExpression1.Text) < 1 Then
    
        txtExpression1.SetFocus
        cmdOk.Enabled = False
        Exit Sub
    End If
    
    If Len(txtExpression2.Text) < 1 Then
    
        txtExpression2.SetFocus
        cmdOk.Enabled = False
        Exit Sub
    End If
    
    'unload form
    Unload Me
    
    Err.Number = 0
    
    Exit Sub
    
errCmdOk_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"

    Err.Number = cdlCancel
    
    Exit Sub
    
errForm_Unload:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub txtExpression1_Change()
    On Error GoTo errTxtExpression1_Change

    Const FUNCTION_NAME = "txtExpression1_Change"
    
    m_oPredicateBetween.Value1 = txtExpression1.Text
        
    If Len(txtExpression1.Text) < 1 Or Len(txtExpression2.Text) < 1 Then
      cmdOk.Enabled = False
    Else
      cmdOk.Enabled = True
    End If
    
    Exit Sub
    
errTxtExpression1_Change:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtExpression2_Change()
    On Error GoTo errTxtExpression2_Change

    Const FUNCTION_NAME = "txtExpression2_Change"
    
    m_oPredicateBetween.Value2 = txtExpression2.Text
    If Len(txtExpression1.Text) < 1 Or Len(txtExpression2.Text) < 1 Then
      cmdOk.Enabled = False
    Else
      cmdOk.Enabled = True
    End If
    
    Exit Sub
    
errTxtExpression2_Change:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

