Attribute VB_Name = "BitWise"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Type LONG1_TYPE
    l As Long
End Type

Private Type WORD2_TYPE
    wLO As Integer
    wHI As Integer
End Type

Private l1 As LONG1_TYPE
Private w2 As WORD2_TYPE

Public Function LO(ByVal l As Long) As Integer
    l1.l = l
    LSet w2 = l1
    LO = w2.wLO
End Function

Public Function HI(ByVal l As Long) As Integer
    l1.l = l
    LSet w2 = l1
    HI = w2.wHI
End Function

Public Sub HILO(ByVal l As Long, HI As Integer, LO As Integer)
    l1.l = l
    LSet w2 = l1
    HI = w2.wHI
    LO = w2.wLO
End Sub

Public Function HL2L(ByVal HI As Integer, LO As Integer) As Long
    w2.wHI = HI
    w2.wLO = LO
    LSet l1 = w2
    HL2L = l1.l
End Function
