Attribute VB_Name = "SubClassPopup"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oPopup As Popup

Private lPrevHWND As Long
Private lPrevWndFunc As Long

Private lReturn As Long
Private bResult As Boolean

Private bInWindowProc As Boolean
'
' Methodes
'
Public Sub Hook(o As Popup, ByVal hWnd As Long)
    bInWindowProc = False
    
    Set oPopup = o
    lPrevHWND = hWnd
    lPrevWndFunc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub Unhook()
    If lPrevHWND Then
        SetWindowLong lPrevHWND, GWL_WNDPROC, lPrevWndFunc
        lPrevHWND = 0
        lPrevWndFunc = 0
    End If
    Set oPopup = Nothing
End Sub

Public Function WindowProc(ByVal hWnd As Long, _
                           ByVal wMsg As Long, _
                           ByVal wParam As Long, _
                           ByVal lParam As Long) As Long
                         
    On Error Resume Next
       
    lReturn = 1
    bResult = True
    
    If Not bInWindowProc Then
        bInWindowProc = True
        oPopup.MsgProc hWnd, wMsg, wParam, lParam, lReturn, bResult
        bInWindowProc = False
    End If
    
    If bResult = True Then
        WindowProc = CallWindowProc(lPrevWndFunc, hWnd, wMsg, wParam, lParam)
    Else
        WindowProc = lReturn
    End If
End Function
