VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "Richtx32.OCX"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocCommand 
   ClientHeight    =   4350
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6315
   KeyPreview      =   -1  'True
   ScaleHeight     =   4350
   ScaleWidth      =   6315
   ToolboxBitmap   =   "DBMDocCommand.ctx":0000
   Begin VB.PictureBox picCommand 
      Align           =   2  'Align Bottom
      BorderStyle     =   0  'None
      Height          =   516
      Left            =   0
      ScaleHeight     =   510
      ScaleWidth      =   6315
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   3390
      Width           =   6312
      Begin VB.TextBox txtCommand 
         Height          =   264
         Left            =   900
         TabIndex        =   2
         Top             =   120
         Width           =   2352
      End
      Begin VB.Label lblCommand 
         Caption         =   "&Command:"
         Height          =   195
         Left            =   120
         TabIndex        =   1
         Top             =   180
         Width           =   795
      End
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   5700
      Top             =   540
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   5700
      Top             =   180
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   3900
      Width           =   6315
      _ExtentX        =   11139
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   5700
      Top             =   900
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin RichTextLib.RichTextBox txtResult 
      Height          =   2115
      Left            =   60
      TabIndex        =   3
      Top             =   60
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   3731
      _Version        =   393217
      BackColor       =   -2147483633
      BorderStyle     =   0
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      OLEDragMode     =   0
      OLEDropMode     =   0
      TextRTF         =   $"DBMDocCommand.ctx":0532
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSComDlg.CommonDialog dlgSave 
      Left            =   3840
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Save As"
   End
   Begin VB.Menu mnuCommand 
      Caption         =   "Command"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Private Enum DBMDocCommandCommands
    cmdCommand
    cmdCommandExecute
    cmdCommandSave
    cmdCommandCopy
    cmdCommandFind
    cmdCommandFindNext
    cmdCommandClear
    cmdSeperator
End Enum

Const CMD_FIRST = cmdCommand
Const CMD_LAST = cmdSeperator

Private Enum CommandPopupConstants
    popResult = 1
    popCommand
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean


'''

Private sFindString As String
Private lFindPos As Long
Private lFindLen As Long

Private bFindWholeWord As Boolean
Private bFindMatchCase As Boolean

Private lFindOptions As Long

'''

Private lSenderID As Long

'''

Public Event WrongDBState()

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_COMMAND
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_GG_COMMANDLINE)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(ByVal NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get ProtocolFont() As StdFont
    Set ProtocolFont = txtResult.Font
End Property
Public Property Set ProtocolFont(ByVal NewVal As StdFont)
    Set txtResult.Font = NewVal
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
'
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    lSenderID = GetSenderID()

    bToolBar = True
    bEnabled = True
    
    bPopup = True
    
    txtResult.RightMargin = 65535
    
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    iHeight = iHeight - picCommand.Height
    If iHeight < 0 Then iHeight = 0
    
    txtResult.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' picCommand
'
Private Sub picCommand_Resize()
    Dim iWidth As Integer
    lblCommand.Move 120, (picCommand.ScaleHeight - txtCommand.Height) \ 2
    iWidth = picCommand.ScaleWidth - (lblCommand.Left + lblCommand.Width) - 240
    If iWidth < 0 Then iWidth = 0
    txtCommand.Move lblCommand.Left + lblCommand.Width + 120, (picCommand.ScaleHeight - txtCommand.Height) \ 2, iWidth
End Sub
'
' txtCommand
'
Private Sub txtCommand_GotFocus()
    txtCommand.SelStart = 0
    txtCommand.SelLength = Len(txtCommand)
End Sub

Private Sub txtCommand_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    CommandExecute
                    KeyCode = 0
                Case vbKeyF3:
                    If CML.CommandItems.Item(cmdFileFindNext).Enabled Then
                        CommandFindNext
                    End If
            End Select
            
        Case vbCtrlMask:
            Select Case KeyCode
                Case vbKeyF:
                    If CML.CommandItems.Item(cmdFileFind).Enabled Then
                        CommandFind
                    End If
            End Select
    End Select
End Sub

Private Sub txtCommand_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        KeyAscii = 0
    End If
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_CommandExecuted(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Command As String, ByVal Result As String)
    If SenderID <> lSenderID Then Exit Sub
    CommandResult Error, Result
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdCommandExecute:     CommandExecute
        Case cmdCommandSave:        CommandSave
        Case cmdCommandCopy:        CommandCopy
        Case cmdCommandFind:        CommandFind
        Case cmdCommandFindNext:    CommandFindNext
        Case cmdCommandClear:       CommandClear
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdCommand, "&Command", 0
        .Add cmdTypeDefault, cmdCommandExecute, "Execute", oRes.Bitmap16ID(IDB_16_COMMANDEXEUTE)
        .Add cmdTypeDefault, cmdCommandSave, "&Save As", oRes.Bitmap16ID(IDB_16_FILE_SAVE)
        .Add cmdTypeDefault, cmdCommandCopy, "&Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdCommandFind, "&Find", oRes.Bitmap16ID(IDB_16_SEARCH)
        .Add cmdTypeDefault, cmdCommandFindNext, "&Find Next", oRes.Bitmap16ID(IDB_16_SEARCH_NEXT)
        .Add cmdTypeDefault, cmdCommandClear, "Clear", oRes.Bitmap16ID(IDB_16_DELETE)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdCommandExecute)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandSave)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandCopy)
        Set oItem = .Add(cmdCommandFind)
        Set oItem = .Add(cmdCommandFindNext)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandClear)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdCommand)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdCommandExecute)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandSave)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandCopy)
        Set oItem = .Add(cmdCommandFind)
        Set oItem = .Add(cmdCommandFindNext)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandClear)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupResultInit
    PopupCommandInit
End Sub

Private Sub PopupResultInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdCommandSave)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandCopy)
        Set oItem = .Add(cmdCommandFind)
        Set oItem = .Add(cmdCommandFindNext)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdCommandClear)
    End With
End Sub

Private Sub PopupCommandInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdCommandExecute)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute

    With CML.CommandItems
        .Item(cmdCommandExecute).Enabled = Not bExecute
        .Item(cmdCommandSave).Enabled = Not bExecute
        .Item(cmdCommandCopy).Enabled = Not bExecute
        .Item(cmdCommandFind).Enabled = Not bExecute
        .Item(cmdCommandFindNext).Enabled = Not bExecute
        .Item(cmdCommandClear).Enabled = Not bExecute
    End With

    TIBEnabled oTIB, Not bExecute
    txtResult.Locked = bExecute
    
    If bExecute Then
        UserControl.MousePointer = vbHourglass
    Else
        UserControl.MousePointer = vbDefault
    End If
End Sub

'''

Private Sub CommandExecute()
    Dim sCommand As String
    Dim sResult As String
    Dim lPos As Long
    
    If oDB Is Nothing Then Exit Sub
    
    sCommand = Trim(txtCommand.Text)
    
    lPos = Len(txtResult.Text)
    txtResult.SelStart = lPos
    txtResult.SelLength = 0
    
    txtResult.SelColor = RGB(0, 0, 192)
    txtResult.SelText = oDB.Name + "> " + sCommand + vbCrLf
    lPos = Len(txtResult.Text)
    
    Select Case UCase$(sCommand)
        Case "RELEASE", "BYE", "QUIT", "EXIT":
        
            txtResult.SelColor = RGB(192, 0, 0)
            txtResult.SelText = "ERROR" + " - Command not allowed." + vbCrLf
            txtResult.SelStart = Len(txtResult.Text)
            txtResult.SelLength = 0
                    
        Case Else:
            txtResult.SelStart = Len(txtResult.Text)
            txtResult.SelLength = 0
        
            If oDB.Command(sCommand, sResult, True, lSenderID) Then
                CommandsSet True
            End If
    End Select
End Sub

Private Sub CommandResult(ByVal bError As Boolean, sResult As String)
    Dim lPos As Long
    
    If Not bError Then
        txtResult.SelColor = RGB(0, 192, 0)
        txtResult.SelText = "OK" + vbCrLf
        
        lPos = Len(txtResult.Text)
        txtResult.SelStart = lPos
        txtResult.SelLength = 0
        
        txtResult.SelColor = vbWindowText
        txtResult.SelText = sResult
    Else
        With oDB.LastError
            txtResult.SelColor = RGB(192, 0, 0)
            txtResult.SelText = "ERROR" + vbCrLf + CStr(.Number) + " " + .Text + vbCrLf + .Data + vbCrLf
        End With
    End If

    txtResult.SelStart = Len(txtResult.Text)
    txtResult.SelLength = 0
    
    CommandsSet False
End Sub

Private Sub CommandSave()
    With dlgSave
        .DialogTitle = "Save """ + Caption + """"
        .FileName = ""
        .Filter = "Text Commands(*.txt)|*.txt|All Commands|*.*"
        .FilterIndex = 1
        .Flags = cdlOFNHideReadOnly
        .CancelError = True
    End With
    
    On Error Resume Next
    
    dlgSave.ShowSave
    
    If Err.Number = cdlCancel Then
        On Error GoTo 0
        Exit Sub
    Else
        On Error GoTo 0
        txtResult.SaveFile dlgSave.FileName, rtfText
    End If
End Sub

Private Sub CommandFind()
    Dim f As New frmFind
    Dim lActPos As Long
    
    lFindOptions = 0
    
    If f.Find(sFindString, bFindWholeWord, bFindMatchCase) Then
        If bFindWholeWord Then lFindOptions = lFindOptions + rtfWholeWord
        If bFindMatchCase Then lFindOptions = lFindOptions + rtfMatchCase
        
        CommandFindNext
    End If
End Sub

Private Sub CommandFindNext()
    Dim lActPos As Long
    Dim lActlen As Long
    
    lActPos = txtResult.SelStart
    lActlen = txtResult.SelLength
    
    If lActPos = lFindPos And _
       lActlen = lFindLen _
    Then
        lActPos = lActPos + lActlen
    End If
    
    lFindPos = txtResult.Find(sFindString, lActPos, , lFindOptions)
    
    If lFindPos < 0 Then
        If lActPos > 0 Then
            lActPos = 0
            lFindPos = txtResult.Find(sFindString, lActPos, , lFindOptions)
        End If
    End If
    
    If lFindPos >= 0 Then
        lFindLen = txtResult.SelLength
    Else
        lFindLen = 0
    End If
End Sub

Private Sub CommandCopy()
    Clipboard.Clear
    
    If txtResult.SelLength > 0 Then
        Clipboard.SetText txtResult.SelText
    Else
        Clipboard.SetText txtResult.Text
    End If
End Sub

Private Sub CommandClear()
    txtResult.Text = ""
    txtCommand.Text = ""
    txtCommand.SetFocus
End Sub
