VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocInformation 
   ClientHeight    =   3045
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6165
   KeyPreview      =   -1  'True
   ScaleHeight     =   3045
   ScaleWidth      =   6165
   ToolboxBitmap   =   "DBMDocInformation.ctx":0000
   Begin MSComctlLib.ListView lvwInfo 
      Height          =   1635
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   2884
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   0
   End
   Begin DBMCmd.Popup POP 
      Left            =   2820
      Top             =   840
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2820
      Top             =   480
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2820
      Top             =   120
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   2595
      Width           =   6165
      _ExtentX        =   10874
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuInformation 
      Caption         =   "Information"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocInformation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM

Public Enum InformationCommands
    cmdInformation
    cmdInformationRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdInformation
Const CMD_LAST = cmdSeperator

Private Enum InformationPopupConstants
    popInformation = 1
End Enum

Private bPopupInformation As Boolean

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean
Private lInfoType As DBMLib.DBMInfoTypeConstants

'''

Private lColInfoType As DBMLib.DBMInfoTypeConstants

'''

Private iColPos() As Integer
Private iColLen() As Integer
Private iColCount As Integer

'''

Public Event WrongDBState()

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_INFO_INFO
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    
    s = RS(IDS_G_INFO) + " - "
    Select Case lInfoType
        Case dbmInfoCaches:         s = s + RS(IDS_G1_CACHES)
        Case dbmInfoData:           s = s + RS(IDS_G1_DATA)
        Case dbmInfoIO:             s = s + RS(IDS_G1_IO)
        Case dbmInfoLog:            s = s + RS(IDS_G1_LOG)
        Case dbmInfoLocks:          s = s + RS(IDS_G1_LOCKS)
        Case dbmInfoUsers:          s = s + RS(IDS_G1_SESSIONS)
        Case dbmInfoVersions:       s = s + RS(IDS_G1_VERSIONS)
        Case Else:                  s = "?"
    End Select
    
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get InfoType() As DBMLib.DBMInfoTypeConstants
    InfoType = lInfoType
End Property
Public Property Let InfoType(ByVal NewVal As DBMLib.DBMInfoTypeConstants)
    lInfoType = NewVal
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    Dim oInfo As DBMLib.Info
    
    At = Empty
    
    If Not oDB Is Nothing Then
        Set oInfo = oDB.Infos(lInfoType)
        If Not oDB Is Nothing Then
            At = oInfo.At
        End If
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

'''

Public Sub Refresh()
    InfoRefresh
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    lInfoType = -1
    
    ReDim iColPos(1 To 10) As Integer
    ReDim iColLen(1 To 10) As Integer
    
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwInfo.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwInfo
'
Private Sub lvwInfo_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdInformationRefresh).Enabled Then
                        InfoRefresh
                    End If
            End Select
    End Select
End Sub

Private Sub lvwInfo_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbRightButton Then
        POP.Show popInformation
    End If
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub

Private Sub oDB_InfoRefreshed(ByVal Error As Boolean, ByVal InfoType As Long)
    If Not Error Then
        InfoList
    Else
        lvwInfo.ListItems.Clear
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdInformationRefresh: InfoRefresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdInformation, "&Information"
        .Add cmdTypeDefault, cmdInformationRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdInformationRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdInformation)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdInformationRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupInformationInit
End Sub

Private Sub PopupInformationInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdInformationRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
        .Item(cmdInformationRefresh).Enabled = Not bExecute
    End With

    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub InfoRefresh()
    If oDB Is Nothing Then Exit Sub
    If lInfoType <= 0 Then Exit Sub
    
    If oDB.Infos(lInfoType).Refresh(True) Then
        CommandsSet True
    End If
End Sub

Private Sub InfoColumns(ByVal oInfo As DBMLib.Info)
    Dim oColumn As MSComctlLib.ColumnHeader
    Dim iType As DBMLib.DBMInfoColumnTypeConstants
    Dim sCol As String
    Dim iCol As Integer
    Dim iPos As Integer
    Dim iLen As Integer
    Dim iMaxCol As Integer
    
    lvwInfo.ColumnHeaders.Clear
    If Not oInfo Is Nothing Then
        oInfo.BeginReadColumns
        Do While Not oInfo.EndOfReadColumns
            sCol = Trim$(oInfo.ReadColumn(iCol, iType, iPos, iLen))
            If iCol > UBound(iColPos) Then
                iMaxCol = UBound(iColPos) + 10
                ReDim Preserve iColPos(1 To iMaxCol)
                ReDim Preserve iColLen(1 To iMaxCol)
            End If
            iColPos(iCol) = iPos
            iColLen(iCol) = iLen
            Set oColumn = lvwInfo.ColumnHeaders.Add(, , sCol)
            If iType = dbmInfoColTypeNumeric Then
                oColumn.Alignment = lvwColumnRight
            End If
        Loop
        iColCount = iCol
        Set oColumn = lvwInfo.ColumnHeaders.Add()
        oColumn.Alignment = lvwColumnRight
        lColInfoType = lInfoType
    End If
End Sub

Private Sub InfoList()
    Dim oItem As MSComctlLib.ListItem
    Dim oInfo As DBMLib.Info
    Dim sLine As String
    Dim i As Integer

    lvwInfo.ListItems.Clear
    
    If oDB Is Nothing Then Exit Sub
    
    TIBCaption oTIB, Caption
    TIBAt oTIB, At
    
    Set oInfo = oDB.Infos(lInfoType)
    
    If lColInfoType <> lInfoType Then
        InfoColumns oInfo
    End If
    
    oInfo.BeginReadLines
    Do While Not oInfo.EndOfReadLines
        sLine = oInfo.ReadLine
        Set oItem = lvwInfo.ListItems.Add(, , Left$(sLine, iColLen(1)))
        For i = 2 To iColCount
            oItem.SubItems(i - 1) = Trim$(Mid$(sLine, iColPos(i), iColLen(i)))
        Next
        oItem.SubItems(iColCount) = " "
    Loop
    
    ListViewUtil.FitColumnSize lvwInfo, True
    
    CommandsSet False
End Sub
