VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocMedia 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7485
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   7485
   ToolboxBitmap   =   "DBMDocMedia.ctx":0000
   Begin DBMDoc.DBMDocMedium docMedium 
      Height          =   2835
      Left            =   3300
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   3795
      _ExtentX        =   6694
      _ExtentY        =   5001
   End
   Begin MSComctlLib.ListView lvwMedia 
      Height          =   2355
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   4154
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   7
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Location"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Device Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Backup Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Modified"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   5
         Text            =   "Size (KB)"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Text            =   "Overwrite"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   3150
      Width           =   7485
      _ExtentX        =   13203
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   1080
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   720
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   360
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuMedia 
      Caption         =   "Media"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocMedia"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Const PARAM_MAXBACKUPDEVS = "MAXBACKUPDEVS"

' PTS 1108467 >>>
Const PARAM_LOGBACKUPTOPIPE = "LOG_BACKUP_TO_PIPE"
' <<< PTS 1108467

Public Enum MediaCommands
    cmdMedia
    cmdMediaCloseMediaGroup
    cmdMediaCloseMediaGroupSep
    cmdMediaSave
    cmdMediaAutosave
    cmdMediaRestore
    cmdMediaExtCmdSep
    cmdMediaNew
    cmdMediaNewMediaGroup
    cmdMediaNewMedium
    cmdMediaEdit
    cmdMediaCopy
    cmdMediaDelete
    cmdMediaRename
    cmdMediaRefreshSep
    cmdMediaRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdMedia
Const CMD_LAST = cmdSeperator

Private Enum MediaPopupConstants
    popMediaMedia = 1
    popMediaMediaGroup
    popMediaMedium
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''

Public Enum DBMMediaModeConstants
    dbmMediaModeNormal
    dbmMediaModeData
    dbmMediaModePages
    dbmMediaModeLog
    dbmMediaModeAuto
End Enum

Private lMode As DBMMediaModeConstants

'''


Private bMediaGroups As Boolean
Private bAutosaveMedium As Boolean

'''

Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

'''

Private Enum MediaColumnConstants
    mcName
    mcLocation
    mcType
    mcBackupType
    mcModified
    mcSize
    mcOverwrite
End Enum

Private Enum MediaTypeConstants
    mtMediaGroup = 0
    mtMedium
End Enum

Private bMediaGroupOpen As Boolean
Private sMediaGroupOpen As String
Private bMediumOpen As Boolean
Private sMediumOpen As String

Private oItemAct As MSComctlLib.ListItem
Private sItemAct As String
Private bItemClick As Boolean
Private lMaxBackupDevs As Long

' PTS 1108467 >>>
Const LOGTOPIPE_PREFIX_BAC = "BACK"
Const LOGTOPIPE_PREFIX_ADS = "ADSM"
Const LOGTOPIPE_PREFIX_NSR = "NSR"

Private bLogBackupToPipe As Boolean
' <<< PTS 1108467

'''

Private lSenderID As Long

'''

Public Event WrongDBState()

Public Event MediaRefreshed()

Public Event NothingClick()

Public Event MediumClick(ByVal Medium As String)
Public Event MediumCreated(ByVal Medium As String)
Public Event MediumNew(ByVal Medium As String)
Public Event MediumEdit(ByVal Medium As String)
Public Event MediumClose(ByVal Medium As String)
Public Event MediumDeleted(ByVal Medium As String)
Public Event MediumChanged(ByVal Medium As String)

Public Event MediaGroupClick(ByVal MediaGroup As String)
Public Event MediaGroupCreated(ByVal MediaGroup As String)
Public Event MediaGroupOpen(ByVal MediaGroup As String)
Public Event MediaGroupClose(ByVal MediaGroup As String)
Public Event MediaGroupDeleted(ByVal MediaGroup As String)
Public Event MediaGroupChanged(ByVal MediaGroup As String)

Public Event MediaSave(ByVal MediaGroup As String, ByVal Medium As String)
Public Event MediaAutosave(ByVal MediaGroup As String, ByVal Medium As String)
Public Event MediaRestore(ByVal MediaGroup As String, ByVal Medium As String)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_BACKUP_MEDIA
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_Media)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    docMedium.ToolBar = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oDB Is Nothing Then
        At = oDB.Backup.At
    Else
        At = Empty
    End If
End Property

Public Property Get Mode() As DBMMediaModeConstants
    Mode = lMode
End Property
Public Property Let Mode(ByVal NewVal As DBMMediaModeConstants)
    lMode = NewVal
    Select Case lMode
        Case dbmMediaModeNormal:  docMedium.Mode = dbmMediumModeNormal
        Case dbmMediaModeData:    docMedium.Mode = dbmMediumModeDate
        Case dbmMediaModePages:   docMedium.Mode = dbmMediumModePages
        Case dbmMediaModeLog:     docMedium.Mode = dbmMediumModeLog
        Case dbmMediaModeAuto:    docMedium.Mode = dbmMediumModeAuto
    End Select
    PropertyChanged "Mode"
End Property

Public Property Get MediaGroups() As Boolean
    MediaGroups = bMediaGroups
End Property
Public Property Let MediaGroups(ByVal NewVal As Boolean)
    bMediaGroups = NewVal
    PropertyChanged "MediaGroups"
End Property

Public Property Get AutosaveMedium() As Boolean
    AutosaveMedium = bAutosaveMedium
End Property
Public Property Let AutosaveMedium(ByVal NewVal As Boolean)
    bAutosaveMedium = NewVal
    docMedium.AutosaveSaveType = NewVal
End Property

Public Property Get ItemCount() As Long
    ItemCount = lvwMedia.ListItems.Count
End Property

Public Property Get SelectedMediaGroup() As String
    SelectedMediaGroup = ""
    If Not oItemAct Is Nothing Then
        If oItemAct.Tag = mtMediaGroup Then
            SelectedMediaGroup = oItemAct.Text
        End If
    End If
End Property

Public Property Get SelectedMedium() As String
    SelectedMedium = ""
    If Not oItemAct Is Nothing Then
        If oItemAct.Tag = mtMedium Then
            SelectedMedium = oItemAct.Text
        End If
    End If
End Property

'Public Property Get SelectedItem() As MSComctlLib.ListItem
'
'    If Not oItemAct Is Nothing Then
'        Select Case oItemAct.Tag
'            Case mtMediaGroup:
'                Set SelectedItem = oDB.Backup.MediaGroups.ItemByName(oItemAct.Text)
'            Case mtMedium:
'                If oMediaGroupOpen Is Nothing Then
'                    Set SelectedItem = oDB.Backup.Media.ItemByName(oItemAct.Text)
'                Else
'                    Set SelectedItem = oMediaGroupOpen.Media.ItemByName(oItemAct.Text)
'                End If
'            Case Else:
'                Set SelectedItem = Nothing
'        End Select
'    Else
'        Set SelectedItem = Nothing
'    End If
'End Property
'Public Property Set SelectedItem(ByVal NewVal As Object)
'    If Not NewVal Is Nothing Then
'        Set lvwMedia.SelectedItem = ListViewUtil.GetListItemByKey(lvwMedia, NewVal.Key)
'        Set oItemAct = lvwMedia.SelectedItem
'    Else
'        Set lvwMedia.SelectedItem = Nothing
'        Set oItemAct = Nothing
'    End If
'End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub CommandVisible(ByVal Command As MediaCommands, ByVal Visible As Boolean)
    CML.CommandItems(Command).Visible = Visible
End Sub

Public Sub CommandEnabled(ByVal Command As MediaCommands, ByVal Enabled As Boolean)
    CML.CommandItems(Command).Enabled = Enabled
End Sub

Public Sub Refresh()
    MediaRefresh
End Sub

Public Sub Show()
    MediaShow
End Sub

Public Sub ActiveItem(Key As String)
    Dim oItem As MSComctlLib.ListItem
    
    Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, Key)
    
    MediaSelectItem oItem
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwMedia, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    MediumClose False
    Cancel = False
End Sub

Public Sub Reset()
    docMedium.Reset
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    docMedium.CleanUp

    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    lSenderID = GetSenderID()
    
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    bMediaGroupOpen = False
    bMediumOpen = False
    
    lMode = dbmMediaModeNormal
    
    bMediaGroups = True
    bAutosaveMedium = True
    
    lMaxBackupDevs = 0
    bLogBackupToPipe = False

    MediaInit
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwMedia.Move 0, iTop, ScaleWidth, iHeight
    
    docMedium.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
    With PropBag
        MediaGroups = .ReadProperty("MediaGroups", True)
        Mode = .ReadProperty("Mode", dbmMediaModeNormal)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
    With PropBag
        .WriteProperty "MediaGroups", MediaGroups, True
        .WriteProperty "Mode", Mode, dbmMediaModeNormal
    End With
End Sub
'
' lvwMedia
'
Private Sub lvwMedia_BeforeLabelEdit(Cancel As Integer)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMedium Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMedium Is Nothing Then
        MediumNotExistsMsg
        Cancel = True
    Else
        If oMedium.OldDefinition Then
            Cancel = True
        End If
    End If
End Sub

Private Sub lvwMedia_AfterLabelEdit(Cancel As Integer, NewString As String)
    If oDB.Version.Number >= dbmVersion72 Then
        If Len(NewString) > 64 Then
            NewString = Left$(NewString, 64)
        End If
    Else
        If Len(NewString) > 8 Then
            NewString = Left$(NewString, 8)
        End If
    End If
    
    Select Case oItemAct.Tag
        Case mtMediaGroup:   MediaGroupRename Cancel, NewString
        Case mtMedium:       MediumRename Cancel, NewString
    End Select
End Sub

Private Sub lvwMedia_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ListViewUtil.SortColumn lvwMedia, ColumnHeader
End Sub

Private Sub lvwMedia_ItemClick(ByVal Item As MSComctlLib.ListItem)
    MediaSelectItem Item, True
End Sub

Private Sub lvwMedia_DblClick()
    If bItemClick Then
        Select Case oItemAct.Tag
            Case mtMediaGroup:   MediaGroupOpen
            Case mtMedium:       MediumEdit
        End Select
    End If
End Sub

Private Sub lvwMedia_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwMedia.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwMedia_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwMedia.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popMediaMedia
        Else
            Select Case oItem.Tag
                Case mtMediaGroup:   POP.Show popMediaMediaGroup
                Case mtMedium:       POP.Show popMediaMedium
            End Select
        End If
    End If
End Sub

Private Sub lvwMedia_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyEscape:
                    If bMediaGroupOpen Then
                        MediaGroupClose True
                    End If
                Case vbKeyReturn:
                    Select Case oItemAct.Tag
                        Case mtMediaGroup:   MediaGroupOpen
                        Case mtMedium:       MediumEdit
                    End Select
                Case vbKeyDelete:
                    If CML.CommandItems.Item(cmdMediaDelete).Enabled Then
                        Delete
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdMediaRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docMedium
'
Private Sub docMedium_MediumChanged(ByVal MediaGroup As String, ByVal Medium As String, ByVal OldSaveType As DBMLib.DBMBackupTypeConstants)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim oItem As MSComctlLib.ListItem
    
    GetMediaObjects MediaGroup, Medium, oMediaGroup, oMedium

    Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, Medium)
    If Not oItem Is Nothing Then
        MediaFillItemMedium oMedium, oItem
    End If

    If oMedium.SaveType <> OldSaveType Then
        If Not oMediaGroup Is Nothing Then
            MediaOpen True
            MediaGroupList
            Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, Medium)
            MediaSelectItem oItem
        Else
            If oMedium.SaveType = dbmBTAuto And OldSaveType <> dbmBTAuto Then
                MediaOpen True
                MediaList
                Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, Medium)
                MediaSelectItem oItem
            End If
        End If
    End If

    MediumClose True

    CommandsSet False

    RaiseEvent MediumChanged(Medium)
End Sub

Private Sub docMedium_MediumCreated(ByVal MediaGroup As String, ByVal Medium As String)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim oItem As MSComctlLib.ListItem
    
    GetMediaObjects MediaGroup, Medium, oMediaGroup, oMedium
    
    If Not oMedium Is Nothing Then
        Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, oMedium.Name)
        If oItem Is Nothing Then
            Set oItem = lvwMedia.ListItems.Add(, oMedium.Name, oMedium.Name)
        End If
        MediaFillItemMedium oMedium, oItem
        ListViewUtil.FitColumnSize lvwMedia, True
        oItem.Selected = True
    End If
        
    MediumClose True
    
    MediaSelectItem oItem
    
    RaiseEvent MediumCreated(Medium)
End Sub

Private Sub docMedium_MediumCanceled(ByVal MediaGroup As String, ByVal Medium As String)
    MediumClose True
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_MediaAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMLib.DBMMediaActionConstants)
    If SenderID = lSenderID Then
        Select Case Action
            Case dbmMediaActionOpen:  MediaList sItemAct
        End Select
    End If
End Sub

Private Sub oDB_MediaGroupAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMLib.DBMMediaGroupActionConstants, ByVal MediaGroup As DBMLib.MediaGroup)
    If SenderID = lSenderID Then
        Select Case Action
            Case dbmMediaGroupActionDelete: MediaGroupDeleted MediaGroup.Name
            Case dbmMediaGroupActionRename: MediaGroupRenamed MediaGroup.Name
        End Select
    End If
End Sub

Private Sub oDB_MediumAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMLib.DBMMediumActionConstants, ByVal Medium As DBMLib.Medium)
    If SenderID = lSenderID Then
        Select Case Action
            Case dbmMediumActionDelete: MediumDeleted Medium.Name
            Case dbmMediumActionRename: MediumRenamed Medium.Name
        End Select
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdMediaCloseMediaGroup: MediaGroupClose True
        Case cmdMediaNewMediaGroup:   MediaGroupNew
        Case cmdMediaNewMedium:       MediumNew
        Case cmdMediaEdit:            Edit
        Case cmdMediaCopy:            Copy
        Case cmdMediaDelete:          Delete
        Case cmdMediaRename:          Rename
        Case cmdMediaRefresh:         Refresh
        Case cmdMediaSave:            MediaSave
        Case cmdMediaAutosave:        MediaAutosave
        Case cmdMediaRestore:         MediaRestore
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdMedia, "&Media"
        
        Set oItem = .Add(cmdTypeDefault, cmdMediaCloseMediaGroup, "&Close Media Group", oRes.Bitmap16ID(IDB_16_FOLDER_UP))
        oItem.Visible = False
        Set oItem = .Add(cmdTypeSeperator, cmdMediaCloseMediaGroupSep)
        oItem.Visible = False
            
        Set oItem = .Add(cmdTypeDefault, cmdMediaSave, "&Save", oRes.Bitmap16ID(IDB_16_BACKUP_SAVE))
        oItem.Visible = False
        Set oItem = .Add(cmdTypeDefault, cmdMediaAutosave, "&Autosave", oRes.Bitmap16ID(IDB_16_AUTOLOG_ON))
        oItem.Visible = False
        Set oItem = .Add(cmdTypeDefault, cmdMediaRestore, "&Restore", oRes.Bitmap16ID(IDB_16_BACKUP_RESTORE))
        oItem.Visible = False
        Set oItem = .Add(cmdTypeSeperator, cmdMediaExtCmdSep)
        oItem.Visible = False
        
        .Add cmdTypeSubCommand, cmdMediaNew, "&New"
        
        Set oItem = .Add(cmdTypeDefault, cmdMediaNewMediaGroup, "Media &Group", oRes.Bitmap16ID(IDB_16_BACKUP_MEDIAGROUP_NEW))
        Set oItem = .Add(cmdTypeDefault, cmdMediaNewMedium, "&Medium", oRes.Bitmap16ID(IDB_16_BACKUP_MEDIUM_NEW))
        
        .Add cmdTypeDefault, cmdMediaEdit, "&Edit", oRes.Bitmap16ID(IDB_16_EDIT)
        .Add cmdTypeDefault, cmdMediaCopy, "&Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdMediaDelete, "&Delete", oRes.Bitmap16ID(IDB_16_DELETE)
        .Add cmdTypeDefault, cmdMediaRename, "&Rename", oRes.Bitmap16ID(IDB_16_RENAME)
        .Add cmdTypeSeperator, cmdMediaRefreshSep
        .Add cmdTypeDefault, cmdMediaRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
    
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdMediaCloseMediaGroup)
        Set oItem = .Add(cmdMediaCloseMediaGroupSep)
        Set oItem = .Add(cmdMediaNewMediaGroup)
        Set oItem = .Add(cmdMediaNewMedium)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMediaEdit)
        Set oItem = .Add(cmdMediaCopy)
        Set oItem = .Add(cmdMediaDelete)
        Set oItem = .Add(cmdMediaRefreshSep)
        Set oItem = .Add(cmdMediaRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oSubSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdMedia)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdMediaCloseMediaGroup)
        Set oItem = .Add(cmdMediaCloseMediaGroupSep)
        Set oSubSub = .Add(cmdMediaNew)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdMediaNewMediaGroup)
        Set oItem = .Add(cmdMediaNewMedium)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdMediaEdit)
        Set oItem = .Add(cmdMediaCopy)
        Set oItem = .Add(cmdMediaDelete)
        Set oItem = .Add(cmdMediaRename)
        Set oItem = .Add(cmdMediaRefreshSep)
        Set oItem = .Add(cmdMediaRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupMediaInit
    PopupMediaGroupInit
    PopupMediumInit
End Sub

Private Sub PopupMediaInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdMediaCloseMediaGroup)
        Set oItem = .Add(cmdMediaCloseMediaGroupSep)
        Set oSub = .Add(cmdMediaNew)
    End With
    With oSub.PopupItems
        Set oItem = .Add(cmdMediaNewMediaGroup)
        Set oItem = .Add(cmdMediaNewMedium)
    End With
    With oMenu.PopupItems
        Set oItem = .Add(cmdMediaRefreshSep)
        Set oItem = .Add(cmdMediaRefresh)
    End With
End Sub

Private Sub PopupMediaGroupInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdMediaSave)
        Set oItem = .Add(cmdMediaAutosave)
        Set oItem = .Add(cmdMediaRestore)
        Set oItem = .Add(cmdMediaExtCmdSep)
        Set oItem = .Add(cmdMediaCopy)
        Set oItem = .Add(cmdMediaDelete)
        Set oItem = .Add(cmdMediaRename)
    End With
End Sub

Private Sub PopupMediumInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdMediaSave)
        Set oItem = .Add(cmdMediaAutosave)
        Set oItem = .Add(cmdMediaRestore)
        Set oItem = .Add(cmdMediaExtCmdSep)
        Set oItem = .Add(cmdMediaEdit)
        Set oItem = .Add(cmdMediaCopy)
        Set oItem = .Add(cmdMediaDelete)
        Set oItem = .Add(cmdMediaRename)
    End With
End Sub

Private Sub CommandsSet(ByVal bExecute As Boolean)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim bNew As Boolean
    
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            .Item(cmdMediaCloseMediaGroup).Enabled = True
            
            bNew = True
            
            Select Case lMode
                Case dbmMediaModeNormal, dbmMediaModeData, dbmMediaModePages:
                    .Item(cmdMediaNewMediaGroup).Visible = True
                    If Not bMediaGroupOpen Then
                        .Item(cmdMediaCloseMediaGroup).Visible = False
                        .Item(cmdMediaCloseMediaGroupSep).Visible = False
                        
                        .Item(cmdMediaNewMediaGroup).Enabled = True
                        
                        .Item(cmdMediaRefreshSep).Visible = True
                        .Item(cmdMediaRefresh).Visible = True
                    Else
                        .Item(cmdMediaCloseMediaGroup).Visible = True
                        .Item(cmdMediaCloseMediaGroupSep).Visible = True
                        
                        .Item(cmdMediaNewMediaGroup).Enabled = False
                        
                        .Item(cmdMediaRefreshSep).Visible = True
                        .Item(cmdMediaRefresh).Visible = True
                        
                        If lvwMedia.ListItems.Count >= lMaxBackupDevs Then
                            bNew = False
                        End If
                    End If
                    
                Case dbmMediaModeLog, dbmMediaModeAuto:
                    .Item(cmdMediaCloseMediaGroup).Visible = False
                    .Item(cmdMediaCloseMediaGroupSep).Visible = False
                    .Item(cmdMediaNewMediaGroup).Visible = False
            End Select
        
            .Item(cmdMediaNewMedium).Enabled = bNew
            
            If oItemAct Is Nothing Then
                .Item(cmdMediaEdit).Enabled = False
                .Item(cmdMediaCopy).Enabled = False
                .Item(cmdMediaDelete).Enabled = False
                .Item(cmdMediaRename).Enabled = False
                .Item(cmdMediaSave).Enabled = False
                .Item(cmdMediaAutosave).Enabled = False
                .Item(cmdMediaRestore).Enabled = False
            Else
            
                GetActMediaObjects oMediaGroup, oMedium
            
                Select Case oItemAct.Tag
                    Case mtMediaGroup:
                        If Not oMediaGroup Is Nothing Then
                            .Item(cmdMediaEdit).Enabled = False
                            .Item(cmdMediaCopy).Enabled = True
                            .Item(cmdMediaDelete).Enabled = True
                            .Item(cmdMediaRename).Enabled = True
                        Else
                            .Item(cmdMediaEdit).Enabled = False
                            .Item(cmdMediaCopy).Enabled = False
                            .Item(cmdMediaDelete).Enabled = False
                            .Item(cmdMediaRename).Enabled = False
                        End If
                        
                    Case mtMedium:
                        If Not oMedium Is Nothing Then
                            If Not oMedium.OldDefinition Then
                                .Item(cmdMediaEdit).Enabled = True
                                .Item(cmdMediaCopy).Enabled = bNew
                                .Item(cmdMediaDelete).Enabled = True
                                .Item(cmdMediaRename).Enabled = True
                            Else
                                .Item(cmdMediaEdit).Enabled = False
                                .Item(cmdMediaCopy).Enabled = False
                                .Item(cmdMediaDelete).Enabled = False
                                .Item(cmdMediaRename).Enabled = False
                            End If
                        Else
                            .Item(cmdMediaEdit).Enabled = False
                            .Item(cmdMediaCopy).Enabled = False
                            .Item(cmdMediaDelete).Enabled = False
                            .Item(cmdMediaRename).Enabled = False
                        End If
                End Select
                
                If oMediaGroup Is Nothing And oMedium Is Nothing Then
                    .Item(cmdMediaSave).Enabled = True
                    .Item(cmdMediaAutosave).Enabled = True
                    .Item(cmdMediaRestore).Enabled = True
                Else
                    .Item(cmdMediaSave).Enabled = True
                    .Item(cmdMediaAutosave).Enabled = True
                    .Item(cmdMediaRestore).Enabled = True
                End If
            End If
            
            .Item(cmdMediaRefresh).Enabled = True
        Else
            .Item(cmdMediaCloseMediaGroup).Enabled = False
            .Item(cmdMediaNewMediaGroup).Enabled = False
            .Item(cmdMediaNewMedium).Enabled = False
            .Item(cmdMediaEdit).Enabled = False
            .Item(cmdMediaCopy).Enabled = False
            .Item(cmdMediaDelete).Enabled = False
            .Item(cmdMediaRename).Enabled = False
            .Item(cmdMediaRefresh).Enabled = False
            
            .Item(cmdMediaSave).Enabled = False
            .Item(cmdMediaAutosave).Enabled = False
            .Item(cmdMediaRestore).Enabled = False
        End If
    End With
    
    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub MediaInit()
    lvwMedia.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub MediaRefresh()
    Dim sVal As String
        
    MediaGroupClose False
    lvwMedia.ListItems.Clear
    
    lMaxBackupDevs = Val(oDB.Parameters.GetValue(PARAM_MAXBACKUPDEVS))
    If lMaxBackupDevs = 0 Then lMaxBackupDevs = 32
    
    bLogBackupToPipe = False
    sVal = oDB.Parameters.GetValue(PARAM_LOGBACKUPTOPIPE, False)
    If UCase$(sVal) = "YES" Then
        bLogBackupToPipe = True
    End If
    
    If oDB.Backup.OpenMedia(True, True, lSenderID) Then
        CommandsSet True
    End If
End Sub

Private Sub MediaShow()
    Dim sVal As String
    
    MediaGroupClose False
    
    lMaxBackupDevs = Val(oDB.Parameters.GetValue(PARAM_MAXBACKUPDEVS))
    If lMaxBackupDevs = 0 Then lMaxBackupDevs = 32

    bLogBackupToPipe = False
    sVal = oDB.Parameters.GetValue(PARAM_LOGBACKUPTOPIPE, False)
    If UCase$(sVal) = "YES" Then
        bLogBackupToPipe = True
    End If

    MediaList
End Sub

Private Sub MediaEnabled(ByVal bEnabled As Boolean)
    Enabled = bEnabled
End Sub

Private Sub MediaOpen(Optional ByVal bAlways As Boolean)
    oDB.Backup.OpenMedia bAlways
End Sub

Private Sub MediaSelectItem(oItem As MSComctlLib.ListItem, _
                            Optional ByVal bFromClick As Boolean = False)
                            
    Dim sMediaGroup As String
    Dim sMedium As String
    
    Set oItemAct = oItem
    
    If Not bFromClick Then
        Set lvwMedia.SelectedItem = oItemAct
    End If
    
    If Not oItemAct Is Nothing Then
        sItemAct = oItemAct.Text
    
        GetActMedia sMediaGroup, sMedium
        
        Select Case oItemAct.Tag
            Case mtMediaGroup:  RaiseEvent MediaGroupClick(sMediaGroup)
            Case mtMedium:      RaiseEvent MediumClick(sMedium)
        End Select
    Else
        sItemAct = ""
        RaiseEvent NothingClick
    End If
    
    CommandsSet False
End Sub

'''

Private Sub List()
    If bMediaGroupOpen Then
        MediaGroupList
    Else
        MediaList
    End If
End Sub

Private Sub MediaFillItemMediaGroup(oMediaGroup As DBMLib.MediaGroup, _
                                    oItem As MSComctlLib.ListItem)
    Dim oMedium As DBMLib.Medium
    
    If oMediaGroup.Media.Count > 0 Then
        Set oMedium = oMediaGroup.Media(1)
    Else
        Set oMedium = Nothing
    End If
    
    With oItem
        .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MEDIAGROUP)
        .Text = oMediaGroup.Name
        .Tag = mtMediaGroup
        .SubItems(mcType) = "Parallel"
        If Not oMedium Is Nothing Then
            Select Case oMedium.SaveType
                Case dbmBTData:     .SubItems(mcBackupType) = "Complete"
                Case dbmBTPages:    .SubItems(mcBackupType) = "Incremental"
                Case dbmBTLog:      .SubItems(mcBackupType) = "Log"
                Case dbmBTAuto:     .SubItems(mcBackupType) = "AutoLog"
                Case dbmBTUnknown:  .SubItems(mcBackupType) = "Unknown"
            End Select
            .SubItems(mcModified) = oMedium.Modified
        End If
    End With
End Sub

Private Sub MediaFillItemMedium(oMedium As DBMLib.Medium, _
                                oItem As MSComctlLib.ListItem)
    With oItem
        Select Case oMedium.DeviceType
            Case dbmDTFile:     .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MT_FILE)
            Case dbmDTTape:     .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MT_TAPE)
            Case dbmDTPipe:     .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MT_PIPE)
            Case dbmDTUnknown:  .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MT_UNKNOWN)
            Case dbmDTNoRewind: .SmallIcon = oRes.Bitmap16ID(IDB_16_BACKUP_MT_TAPE)
        End Select
        .Text = oMedium.Name
        .Tag = mtMedium
        .SubItems(mcLocation) = oMedium.Location
        .SubItems(mcType) = oMedium.DeviceTypeName
        Select Case oMedium.SaveType
            Case dbmBTData:     .SubItems(mcBackupType) = "Complete"
            Case dbmBTPages:    .SubItems(mcBackupType) = "Incremental"
            Case dbmBTLog:      .SubItems(mcBackupType) = "Log"
            Case dbmBTAuto:     .SubItems(mcBackupType) = "AutoLog"
            Case dbmBTUnknown:  .SubItems(mcBackupType) = "Unknown"
        End Select
        .SubItems(mcModified) = oMedium.Modified
        If oMedium.SizeKB = 0 Then
            .SubItems(mcSize) = ""
        Else
            .SubItems(mcSize) = Format$(oMedium.SizeKB, "#,#") + "KB"
        End If
        If oMedium.Overwrite = dbmOverwriteYes Then
            .SubItems(mcOverwrite) = "Yes"
        Else
            .SubItems(mcOverwrite) = ""
        End If
    End With
End Sub

Private Sub MediaList(Optional ByVal sSelected As String)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim sMediaGroup As String
    Dim sMedium As String
    Dim oItem As MSComctlLib.ListItem
    
    TIBAt oTIB, At
    
    lvwMedia.ListItems.Clear
        
    If bMediaGroups Then
        For Each oMediaGroup In oDB.Backup.MediaGroups
            If (lMode = dbmMediaModeNormal) Or _
               (lMode = dbmMediaModeData And oMediaGroup.SaveType = dbmBTData) Or _
               (lMode = dbmMediaModePages And oMediaGroup.SaveType = dbmBTPages) Or _
               (lMode = dbmMediaModeLog And oMediaGroup.SaveType = dbmBTLog) Or _
               (lMode = dbmMediaModeLog And oMediaGroup.SaveType = dbmBTAuto) Or _
               (lMode = dbmMediaModeAuto And oMediaGroup.SaveType = dbmBTAuto) Or _
               (lMode = dbmMediaModeAuto And oMediaGroup.SaveType = dbmBTLog) Or _
               (lMode = dbmMediaModeNormal And _
                (oDB.InstanceType = dbmInstanceTypeLVC And oDB.Version.Number < dbmversion74) And _
                oMediaGroup.SaveType = dbmBTData) Or _
               (oMediaGroup.SaveType = dbmBTUnknown) _
            Then
                If bAutosaveMedium Or oMediaGroup.SaveType <> dbmBTAuto Then
                    Set oItem = lvwMedia.ListItems.Add(, oMediaGroup.Name, oMediaGroup.Name)
                    MediaFillItemMediaGroup oMediaGroup, oItem
                End If
            End If
        Next
    End If
    
    For Each oMedium In oDB.Backup.Media
        If (lMode = dbmMediaModeNormal) Or _
           (lMode = dbmMediaModeData And oMedium.SaveType = dbmBTData) Or _
           (lMode = dbmMediaModePages And oMedium.SaveType = dbmBTPages) Or _
           (lMode = dbmMediaModeLog And oMedium.SaveType = dbmBTLog) Or _
           (lMode = dbmMediaModeLog And oMedium.SaveType = dbmBTAuto) Or _
           (lMode = dbmMediaModeAuto And oMedium.SaveType = dbmBTAuto) Or _
           (lMode = dbmMediaModeAuto And oMedium.SaveType = dbmBTLog) Or _
           (lMode = dbmMediaModeNormal And _
            (oDB.InstanceType = dbmInstanceTypeLVC And oDB.Version.Number < dbmversion74) And _
            oMedium.SaveType = dbmBTData) Or _
           (oMedium.SaveType = dbmBTUnknown) _
        Then
            If bAutosaveMedium Or oMedium.SaveType <> dbmBTAuto Then
                Set oItem = lvwMedia.ListItems.Add(, oMedium.Name, oMedium.Name)
                MediaFillItemMedium oMedium, oItem
            End If
        End If
    Next
    
    If Len(sSelected) > 0 Then
        Set oItem = ListViewUtil.GetListItemByKey(lvwMedia, sSelected)
        If Not oItem Is Nothing Then
            Set lvwMedia.SelectedItem = ListViewUtil.GetListItemByKey(lvwMedia, sSelected)
        End If
    End If
    
    MediaSelectItem lvwMedia.SelectedItem
    ListViewUtil.FitColumnSize lvwMedia, True
    
    CommandsSet False
End Sub

Private Sub MediaGroupOpen()
    Dim oMedium As DBMLib.Medium

    If oItemAct Is Nothing Then Exit Sub
    If bMediaGroupOpen Then Exit Sub
    
    sMediaGroupOpen = oItemAct.Text
    bMediaGroupOpen = True
    
    MediaGroupList
   
    Set oItemAct = Nothing
    If lvwMedia.ListItems.Count > 0 Then
        Set lvwMedia.SelectedItem = lvwMedia.ListItems(1)
    End If
    MediaSelectItem lvwMedia.SelectedItem
    
    CommandsSet False
    
    RaiseEvent MediaGroupOpen(sMediaGroupOpen)
End Sub

Private Sub MediaGroupList()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim oItem As MSComctlLib.ListItem

    If Not bMediaGroupOpen Then Exit Sub
    
    lvwMedia.ListItems.Clear
    
    Set oMediaGroup = oDB.Backup.MediaGroups.ItemByName(sMediaGroupOpen)
    
    If Not oMediaGroup Is Nothing Then
        For Each oMedium In oMediaGroup.Media
            Set oItem = lvwMedia.ListItems.Add(, oMedium.Name, oMedium.Name)
            MediaFillItemMedium oMedium, oItem
        Next
    End If
    
    ListViewUtil.FitColumnSize lvwMedia, True
End Sub

Private Sub MediaGroupClose(ByVal bList As Boolean)
    If Not bMediaGroupOpen Then Exit Sub
    
    bMediaGroupOpen = False
    
    If bList Then MediaList sMediaGroupOpen
    
    RaiseEvent MediaGroupClose(sMediaGroupOpen)
    
    sMediaGroupOpen = ""
End Sub

Private Sub MediaGroupNew()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim sDefName As String
    Dim sNewName As String
    Dim iNewName As Integer
    Dim oItem As MSComctlLib.ListItem
    
    sDefName = "New Group"
    sNewName = sDefName
    iNewName = 1
    
    Do
        If Not oDB.Backup.MediaGroups.ItemByName(sNewName) Is Nothing Then
            iNewName = iNewName + 1
            sNewName = sDefName & " (" & CStr(iNewName) & ")"
        Else
            Exit Do
        End If
    Loop

    Set oMediaGroup = oDB.Backup.CreateMediaGroup(sNewName)

    If Not oMediaGroup Is Nothing Then
        Set oItem = lvwMedia.ListItems.Add(, oMediaGroup.Name, oMediaGroup.Name)
        MediaFillItemMediaGroup oMediaGroup, oItem
        ListViewUtil.FitColumnSize lvwMedia, True
        lvwMedia.SetFocus
        MediaSelectItem oItem
        lvwMedia.StartLabelEdit
    End If
End Sub

Private Sub MediaGroupCopy()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oNewMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim sDefName As String
    Dim sNewName As String
    Dim iNewName As Integer
    Dim oItem As MSComctlLib.ListItem
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMediaGroup Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMediaGroup Is Nothing Then
        MediaGroupNotExistsMsg
    Else
        sDefName = oMediaGroup.Name
        sNewName = sDefName
        iNewName = 1

        Do
            If Not oDB.Backup.MediaGroups.ItemByName(sNewName) Is Nothing Then
                iNewName = iNewName + 1
                sNewName = sDefName & " (" & CStr(iNewName) & ")"
            Else
                Exit Do
            End If
        Loop
        
        Set oNewMediaGroup = oDB.Backup.CopyMediaGroup(oItemAct.Text, sNewName)
    
        If Not oNewMediaGroup Is Nothing Then
            For Each oMedium In oNewMediaGroup.Media
                oMedium.Save
            Next
            
            Set oItem = lvwMedia.ListItems.Add(, oNewMediaGroup.Name, oNewMediaGroup.Name)
            MediaFillItemMediaGroup oNewMediaGroup, oItem
            ListViewUtil.FitColumnSize lvwMedia, True
            lvwMedia.SetFocus
            MediaSelectItem oItem
            lvwMedia.StartLabelEdit
        End If
    End If
End Sub

Private Sub MediaGroupDelete()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim sMsg As String
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMediaGroup Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMediaGroup Is Nothing Then
        MediaGroupNotExistsMsg
    Else
        sMsg = "Are you sure you want to delete mediagroup '" & oMediaGroup.Name & "' with all included media?"
        
        If MsgBox(sMsg, vbQuestion + vbYesNo, "Confirm Mediagroup Delete") = vbYes Then
            If oMediaGroup.Delete(True, lSenderID) Then
                CommandsSet True
            End If
        End If
    End If
End Sub

Private Sub MediaGroupDeleted(sMediaGroup As String)
    lvwMedia.ListItems.Remove sMediaGroup
    MediaSelectItem lvwMedia.SelectedItem
    RaiseEvent MediaGroupDeleted(sMediaGroup)
End Sub

Private Sub MediaGroupRename(Cancel As Integer, ByVal sNewName As String)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim oExists As DBMLib.MediaGroup
    Dim sMsg As String
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMediaGroup Is Nothing Then
        MediaGroupNotExistsMsg
        Cancel = True
        Exit Sub
    Else
        Set oExists = oDB.Backup.MediaGroups.ItemByName(sNewName)
    
        If Not oExists Is Nothing Then
            If UCase$(oExists.Name) <> UCase$(oMediaGroup.Name) Then
                sMsg = "Cannot rename mediagroup '" + oItemAct.Text + "': "
                sMsg = sMsg & "A mediagroup/medium with the name you specified already exists. "
                sMsg = sMsg & "Specify a different name."
                MsgBox sMsg, vbExclamation, "Error Renaming Mediagroup"
                Cancel = True
                Exit Sub
            End If
        End If
    
        If oMediaGroup.Rename(sNewName, True, lSenderID) Then
            CommandsSet True
        End If
    End If
End Sub

Private Sub MediaGroupRenamed(sMediaGroup As String)
    CommandsSet False
End Sub

Private Sub MediumNew()
    sMediumOpen = ""
    bMediumOpen = True
    
    With docMedium
        Set .Database = oDB
        .MediaGroup = sMediaGroupOpen
        .Medium = sMediumOpen
        .CopyFromMedium = ""
        
        ' PTS 1108467 >>>
        .LogToPipe = bLogBackupToPipe
        ' <<< PTS 1108467
        
        .Refresh
        
        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwMedia.Visible = False
    
    TIBCaption oTIB, Caption
    
    RaiseEvent MediumNew(sMediumOpen)
End Sub

Private Sub MediumEdit()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMedium Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMedium Is Nothing Then
        MediumNotExistsMsg
    Else
        sMediumOpen = oMedium.Name
        bMediumOpen = True
    
        With docMedium
            Set .Database = oDB
            .MediaGroup = sMediaGroupOpen
            .Medium = sMediumOpen
            .CopyFromMedium = ""
            
            ' PTS 1108467 >>>
            .LogToPipe = bLogBackupToPipe
            ' <<< PTS 1108467
    
            .Refresh
            
            .Visible = True
            .ZOrder 0
            
            .SetFocus
        End With
            
        lvwMedia.Visible = False
        
        TIBCaption oTIB, Caption
        
        RaiseEvent MediumEdit(sMediumOpen)
    End If
End Sub

Private Sub MediumCopy()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMedium Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMedium Is Nothing Then
        MediumNotExistsMsg
    Else
        sMediumOpen = ""
        bMediumOpen = True
    
        With docMedium
            Set .Database = oDB
            .MediaGroup = sMediaGroupOpen
            .Medium = sMediumOpen
            .CopyFromMedium = oMedium.Name
            
            ' PTS 1108467 >>>
            .LogToPipe = bLogBackupToPipe
            ' <<< PTS 1108467
            
            .Refresh
            
            .Visible = True
            .ZOrder 0
            
            .SetFocus
        End With
        
        lvwMedia.Visible = False
        
        TIBCaption oTIB, Caption
        
        RaiseEvent MediumNew(sMediumOpen)
    End If
End Sub

Private Sub MediumDelete()
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim sMsg As String
    
    If oItemAct Is Nothing Then Exit Sub
    If oItemAct.Tag <> mtMedium Then Exit Sub
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMedium Is Nothing Then
        MediumNotExistsMsg
    Else
        sMsg = "Are you sure you want to delete medium '" & oMedium.Name & "'?"
        
        If MsgBox(sMsg, vbQuestion + vbYesNo, "Confirm Medium Delete") = vbYes Then
            If oMedium.Delete(True, lSenderID) Then
                CommandsSet True
            End If
        End If
    End If
End Sub

Private Sub MediumDeleted(sMedium As String)
    lvwMedia.ListItems.Remove sMedium
    MediaSelectItem lvwMedia.SelectedItem
    RaiseEvent MediumDeleted(sMedium)
End Sub

Private Sub MediumRename(Cancel As Integer, ByVal sNewName As String)
    Dim oMediaGroup As DBMLib.MediaGroup
    Dim oMedium As DBMLib.Medium
    Dim oExists As DBMLib.Medium
    Dim sMsg As String
    
    GetActMediaObjects oMediaGroup, oMedium
    
    If oMedium Is Nothing Then
        MediumNotExistsMsg
        Cancel = True
        Exit Sub
    Else
        If Not oMediaGroup Is Nothing Then
            Set oExists = oMediaGroup.Media.ItemByName(sNewName)
        Else
            Set oExists = oDB.Backup.Media.ItemByName(sNewName)
        End If
    
        If Not oExists Is Nothing Then
            If UCase$(oExists.Name) <> UCase$(oMedium.Name) Then
                sMsg = "Cannot rename medium '" + oItemAct.Text + "': "
                sMsg = sMsg + "A mediagroup/medium with the name you specified already exists. "
                sMsg = sMsg + "Specify a different name."
                MsgBox sMsg, vbExclamation, "Error Renaming Medium"
                Cancel = True
                Exit Sub
            End If
        End If
    
        ' PTS 1108467 >>>
        If oMedium.DeviceType = dbmDTPipe And _
           oMedium.SaveType = dbmBTLog _
        Then
            If Not bLogBackupToPipe Then
                If Left$(UCase$(sNewName), Len(LOGTOPIPE_PREFIX_BAC)) <> LOGTOPIPE_PREFIX_BAC And _
                   Left$(UCase$(sNewName), Len(LOGTOPIPE_PREFIX_ADS)) <> LOGTOPIPE_PREFIX_ADS And _
                   Left$(UCase$(sNewName), Len(LOGTOPIPE_PREFIX_NSR)) <> LOGTOPIPE_PREFIX_NSR _
                Then
                    sMsg = "Cannot rename medium '" & oItemAct.Text & "': "
                    sMsg = sMsg + "Invalid name for this device and backup type." + vbCrLf
                    sMsg = sMsg + "The name must begin with "
                    sMsg = sMsg + LOGTOPIPE_PREFIX_BAC + ", "
                    sMsg = sMsg + LOGTOPIPE_PREFIX_ADS + " or "
                    sMsg = sMsg + LOGTOPIPE_PREFIX_NSR + "." + vbCrLf
                    sMsg = sMsg + "Specify a different name."
                    MsgBox sMsg, vbExclamation, "Error Renaming Medium"
                    Cancel = True
                    Exit Sub
                End If
            End If
        End If
        ' <<< PTS 1108467
    
        If oMedium.Rename(sNewName, True, lSenderID) Then
            CommandsSet True
        End If
    End If
End Sub

Private Sub MediumRenamed(sMedium As String)
    CommandsSet False
End Sub

Private Sub MediumClose(ByVal bSetFocus As Boolean)
    If Not bMediumOpen Then Exit Sub
    
    bMediumOpen = False
    
    TIBCaption oTIB, Caption
    
    docMedium.Visible = False
    lvwMedia.Visible = True
    If bSetFocus Then
        lvwMedia.SetFocus
    End If
    
    RaiseEvent MediumClose(sMediumOpen)
    
    sMediumOpen = ""
End Sub

Private Sub Edit()
    If oItemAct Is Nothing Then Exit Sub
    Select Case oItemAct.Tag
        Case mtMedium:       MediumEdit
    End Select
End Sub

Private Sub Copy()
    If oItemAct Is Nothing Then Exit Sub
    Select Case oItemAct.Tag
        Case mtMediaGroup:  MediaGroupCopy
        Case mtMedium:      MediumCopy
    End Select
End Sub

Private Sub Delete()
    If oItemAct Is Nothing Then Exit Sub
    Select Case oItemAct.Tag
        Case mtMediaGroup:   MediaGroupDelete
        Case mtMedium:       MediumDelete
    End Select
End Sub

Private Sub Rename()
    If oItemAct Is Nothing Then Exit Sub
    Select Case oItemAct.Tag
        Case mtMediaGroup: lvwMedia.StartLabelEdit
        Case mtMedium:     lvwMedia.StartLabelEdit
    End Select
End Sub

Private Sub MediaSave()
    Dim sMediaGroup As String
    Dim sMedium As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    GetActMedia sMediaGroup, sMedium
    
    RaiseEvent MediaSave(sMediaGroup, sMedium)
End Sub

Private Sub MediaAutosave()
    Dim sMediaGroup As String
    Dim sMedium As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    GetActMedia sMediaGroup, sMedium
    
    RaiseEvent MediaAutosave(sMediaGroup, sMedium)
End Sub

Private Sub MediaRestore()
    Dim sMediaGroup As String
    Dim sMedium As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    GetActMedia sMediaGroup, sMedium
    
    RaiseEvent MediaRestore(sMediaGroup, sMedium)
End Sub

Private Sub GetActMedia(sMediaGroup As String, sMedium As String)
    sMediaGroup = ""
    sMedium = ""
    
    If oItemAct Is Nothing Then Exit Sub
    
    Select Case oItemAct.Tag
        Case mtMediaGroup:
            sMediaGroup = oItemAct.Text
            sMedium = ""
        Case mtMedium:
            If bMediaGroupOpen Then
                sMediaGroup = sMediaGroupOpen
            End If
            sMedium = oItemAct.Text
    End Select
End Sub

Private Sub GetMediaObjects(sMediaGroup As String, _
                            sMedium As String, _
                            oMediaGroup As DBMLib.MediaGroup, _
                            oMedium As DBMLib.Medium)
    
    If Len(sMediaGroup) > 0 Then
        Set oMediaGroup = oDB.Backup.MediaGroups.ItemByName(sMediaGroup)
    End If
    
    If Len(sMedium) > 0 Then
        If Not oMediaGroup Is Nothing Then
            Set oMedium = oMediaGroup.Media.ItemByName(sMedium)
        Else
            Set oMedium = oDB.Backup.Media.ItemByName(sMedium)
        End If
    End If
End Sub

Private Sub GetActMediaObjects(oMediaGroup As DBMLib.MediaGroup, oMedium As DBMLib.Medium)
    Dim sMediaGroup As String
    Dim sMedium As String
    
    GetActMedia sMediaGroup, sMedium
    GetMediaObjects sMediaGroup, sMedium, oMediaGroup, oMedium
End Sub

Private Sub MediaGroupNotExistsMsg()
    Dim sMsg As String
    sMsg = "Mediagroup not exists!" + vbCrLf + "Please refesh the list of Media."
    MsgBox sMsg, vbExclamation, "Mediagroup Not Exists"
End Sub

Private Sub MediumNotExistsMsg()
    Dim sMsg As String
    sMsg = "Medium not exists!" + vbCrLf + "Please refesh the list of Media."
    MsgBox sMsg, vbExclamation, "Medium Not Exists"
End Sub
