VERSION 5.00
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Object = "{DB79B724-D86D-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMInp.ocx"
Object = "{86428C3F-D876-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMSpl.ocx"
Object = "{36A3B78D-F377-11D4-B32D-0050DADEFE1A}#1.1#0"; "DBMInf.ocx"
Begin VB.UserControl DBMDocRestartUntil 
   ClientHeight    =   3225
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6390
   ScaleHeight     =   3225
   ScaleWidth      =   6390
   ToolboxBitmap   =   "DBMDocRestartUntil.ctx":0000
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   2775
      Width           =   6390
      _ExtentX        =   11271
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMSpl.SplitterBox spbRestart 
      Height          =   2655
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   5895
      _ExtentX        =   10398
      _ExtentY        =   4683
      Begin VB.PictureBox picRestart 
         BorderStyle     =   0  'None
         Height          =   2475
         Left            =   2220
         ScaleHeight     =   2475
         ScaleWidth      =   3495
         TabIndex        =   1
         TabStop         =   0   'False
         Top             =   60
         Visible         =   0   'False
         Width           =   3495
         Begin DBMInp.DateInput inpUntilDate 
            Height          =   255
            Left            =   600
            TabIndex        =   3
            Top             =   180
            Width           =   1080
            _ExtentX        =   1905
            _ExtentY        =   450
            BorderStyle     =   2
            BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
               Name            =   "MS Sans Serif"
               Size            =   8.25
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
         End
         Begin DBMInp.TimeInput inpUntilTime 
            Height          =   255
            Left            =   600
            TabIndex        =   5
            Top             =   540
            Width           =   900
            _ExtentX        =   1588
            _ExtentY        =   450
            BorderStyle     =   2
            DateValue       =   0.576921296296296
            BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
               Name            =   "MS Sans Serif"
               Size            =   8.25
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
         End
         Begin VB.Label lblUntilDate 
            AutoSize        =   -1  'True
            Caption         =   "&Date:"
            Height          =   195
            Left            =   120
            TabIndex        =   2
            Top             =   180
            Width           =   390
         End
         Begin VB.Label lblUntilTime 
            AutoSize        =   -1  'True
            Caption         =   "&Time:"
            Height          =   195
            Left            =   120
            TabIndex        =   4
            Top             =   540
            Width           =   390
         End
      End
      Begin DBMInf.InfoPanel panInfo 
         Height          =   2475
         Left            =   60
         Top             =   60
         Width           =   2055
         _ExtentX        =   3625
         _ExtentY        =   4366
      End
   End
   Begin DBMCmd.CommandList CML 
      Left            =   6000
      Top             =   60
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   6000
      Top             =   420
      _ExtentX        =   529
      _ExtentY        =   529
   End
End
Attribute VB_Name = "DBMDocRestartUntil"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_COLD

Private Enum RestartCommands
    cmdRestart
    
    cmdRestartUntil
    
    cmdSeperator
End Enum

Const CMD_FIRST = cmdRestart
Const CMD_LAST = cmdSeperator

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''

Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

'''

Private lSenderID As Long

'''

Public Event WrongDBState()

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_CLOCK
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_GG_RESTARTUNTIL)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property

'''

Public Sub Init()
    bPopup = True

    Set oDB = Nothing
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    RestartUntilRefresh
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    spbRestart.UnSplit
    
    MBR.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    lSenderID = GetSenderID()
    
    bToolBar = True
    bEnabled = True
    
    Init
    RestartInit
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    spbRestart.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
'
'
Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdRestartUntil: RestartUntil
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        Set oItem = .Add(cmdTypeSubCommand, cmdRestart, "&Restart")
        
        Set oItem = .Add(cmdTypeDefault, cmdRestartUntil, "&Restart Until", oRes.Bitmap16ID(IDB_16_OK))
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdRestartUntil)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdRestart)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdRestartUntil)
    End With
End Sub

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
       .Item(cmdRestartUntil).Enabled = Not bExecute
    End With
    
    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub RestartInit()
    spbRestart.Split "panInfo", "picRestart", 20, 80, "INF", "OUT", spbSplitTypeVerticaly, 4
End Sub

Private Sub RestartUntilRefresh()
    Dim s As String
    Dim dUntil As Date
    
    s = "Enter date and time to restart the database until a specific time."
    s = s + vbCrLf + vbCrLf
    s = s + "Data after the specified time will be lost."
    s = s + vbCrLf + vbCrLf
    s = s + "Choose 'Restart Until' to restart the database."
    
    panInfo.Text = s
    
    dUntil = Now()

    inpUntilDate.DateValue = dUntil
    inpUntilTime.TimeValue = dUntil
    
    CommandsSet False
End Sub

Private Sub RestartUntil()
    Dim s As String
    Dim dUntil As Date
    
    dUntil = inpUntilDate.DateValue + inpUntilTime.TimeValue
    
    s = "Are you sure you want to restart database '" + oDB.DatabaseName + "' "
    If Len(oDB.ServerName) > 0 Then
        s = s + "on " + oDB.ServerName + " "
    End If
    s = s + "until " & dUntil & "?"
    s = s + vbCrLf + vbCrLf
    s = s + "Data after the specified time will be lost."
    
    If MsgBox(s, vbQuestion + vbYesNo, "Confirm Restart Until") = vbYes Then
        panInfo.Text = "Restart database until " & dUntil & ". Please wait..."
        
        If oDB.OnlineDB(True, dUntil, True) Then
            CommandsSet True
        End If
    End If
End Sub
