VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "Richtx32.OCX"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocShow 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "DBMDocShow.ctx":0000
   Begin MSComDlg.CommonDialog dlgSave 
      Left            =   3360
      Top             =   1740
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Save As"
   End
   Begin RichTextLib.RichTextBox txtShow 
      Height          =   2715
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2775
      _ExtentX        =   4895
      _ExtentY        =   4789
      _Version        =   393217
      BorderStyle     =   0
      HideSelection   =   0   'False
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      OLEDragMode     =   0
      OLEDropMode     =   0
      TextRTF         =   $"DBMDocShow.ctx":0532
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2940
      Top             =   600
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2940
      Top             =   240
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   456
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3144
      Width           =   4800
      _ExtentX        =   8467
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuShow 
      Caption         =   "Show"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocShow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Public Enum ShowCommands
    cmdShow
    cmdShowBack
    cmdShowSave
    cmdShowCopy
    cmdShowFind
    cmdShowFindNext
    cmdShowRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdShow
Const CMD_LAST = cmdSeperator

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

Private oShow As DBMLib.Show

Private bDirty As Boolean

'''

Private sFindString As String
Private lFindPos As Long
Private lFindLen As Long

Private bFindWholeWord As Boolean
Private bFindMatchCase As Boolean

Private lFindOptions As Long

'''

Public Event WrongDBState()

Public Event Command(ByVal Command As ShowCommands)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_SHOW
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CHECK) + " - " + RS(IDS_G5_SERVER)
    If Not oDB Is Nothing Then
        s = s + " - " + oDB.Name
        If Not oShow Is Nothing Then
            s = s + " - " + oShow.Name
        End If
    End If
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Set Show(ByVal NewVal As DBMLib.Show)
    Set oShow = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get ProtocolFont() As StdFont
    Set ProtocolFont = txtShow.Font
End Property
Public Property Set ProtocolFont(ByVal NewVal As StdFont)
    Set txtShow.Font = NewVal
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oShow Is Nothing Then
        At = oShow.At
    Else
        At = Empty
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    ShowRefresh
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
    Set oShow = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub

'''

Public Sub Command(ByVal Command As MediumCommands)
    Select Case Command
        Case cmdShowBack:       ShowBack
        Case cmdShowSave:       ShowSave
        Case cmdShowCopy:       ShowCopy
        Case cmdShowFind:       ShowFind
        Case cmdShowFindNext:   ShowFindNext
        Case cmdShowRefresh:    Refresh
    End Select
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oDB = Nothing
    Set oShow = Nothing
    
    txtShow.RightMargin = 65535
    
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    Dim iWidth As Integer
    Dim iTab As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    
    If iHeight < 0 Then iHeight = 0
    
    txtShow.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyEscape:
                    If CML.CommandItems.Item(cmdShowBack).Enabled Then
                        ShowBack
                    End If
                Case vbKeyF3:
                    If CML.CommandItems.Item(cmdShowFindNext).Enabled Then
                        ShowFindNext
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdShowRefresh).Enabled Then
                        Refresh
                    End If
            End Select
            
        Case vbCtrlMask:
            Select Case KeyCode
                Case vbKeyF:
                    If CML.CommandItems.Item(cmdShowFind).Enabled Then
                        ShowFind
                    End If
                    KeyCode = 0
                    Shift = 0
            End Select
    End Select
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_ShowRefreshed(ByVal Error As Boolean, ByVal Show As DBMLib.Show)
    ShowReady
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Command Item.Key
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdShow, "&CheckServer"
        .Add cmdTypeDefault, cmdShowBack, "&Back", oRes.Bitmap16ID(IDB_16_WEB_PREV)
        .Add cmdTypeDefault, cmdShowSave, "&Save As", oRes.Bitmap16ID(IDB_16_FILE_SAVE)
        .Add cmdTypeDefault, cmdShowCopy, "&Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdShowFind, "&Find", oRes.Bitmap16ID(IDB_16_SEARCH)
        .Add cmdTypeDefault, cmdShowFindNext, "&Find Next", oRes.Bitmap16ID(IDB_16_SEARCH_NEXT)
        .Add cmdTypeDefault, cmdShowRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdShowBack)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowSave)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowCopy)
        Set oItem = .Add(cmdShowFind)
        Set oItem = .Add(cmdShowFindNext)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdShow)
    End With
    
    With oSub.MenuBarItems
        Set oItem = .Add(cmdShowBack)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowSave)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowCopy)
        Set oItem = .Add(cmdShowFind)
        Set oItem = .Add(cmdShowFindNext)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdShowRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
       .Item(cmdShowBack).Enabled = Not bExecute
       .Item(cmdShowSave).Enabled = Not bExecute
       .Item(cmdShowCopy).Enabled = Not bExecute
       .Item(cmdShowFind).Enabled = Not bExecute
       .Item(cmdShowFindNext).Enabled = Not bExecute
       .Item(cmdShowRefresh).Enabled = Not bExecute
    End With
    
    TIBEnabled oTIB, Not bExecute
    txtShow.Locked = bExecute
End Sub

Private Sub ShowReset()
    txtShow.Text = ""
End Sub

Private Sub ShowRefresh()
    ShowReset

    If oShow Is Nothing Then Exit Sub
    
    If oShow.Refresh(True) Then
        CommandsSet True
    End If
End Sub

Private Sub ShowReady()
    If oShow Is Nothing Then Exit Sub
    
    TIBAt oTIB, oShow.At
    txtShow.Text = oShow.Text
    
    CommandsSet False
End Sub

Private Sub ShowBack()
    RaiseEvent Command(cmdShowBack)
End Sub

Private Sub ShowSave()
    With dlgSave
        .DialogTitle = "Save """ + Caption + """"
        .FileName = oDB.Name + "_" + RES.RS(IDS_CHECKSERVER) + "_" + oShow.Name + ".txt"
        .Filter = "Text Files(*.txt)|*.txt|All Files|*.*"
        .FilterIndex = 1
        .Flags = cdlOFNHideReadOnly + cdlOFNOverwritePrompt
        .CancelError = True
    End With
    
    On Error Resume Next
    
    dlgSave.ShowSave
    
    If Err.Number = cdlCancel Then
        On Error GoTo 0
        Exit Sub
    Else
        On Error GoTo 0
        txtShow.SaveFile dlgSave.FileName, rtfText
    End If
    
End Sub

Private Sub ShowFind()
    Dim f As New frmFind
    Dim lActPos As Long
    
    lFindOptions = 0
    
    If f.Find(sFindString, bFindWholeWord, bFindMatchCase) Then
        If bFindWholeWord Then lFindOptions = lFindOptions + rtfWholeWord
        If bFindMatchCase Then lFindOptions = lFindOptions + rtfMatchCase
        
        ShowFindNext
    End If
End Sub

Private Sub ShowFindNext()
    Dim lActPos As Long
    Dim lActlen As Long
    
    lActPos = txtShow.SelStart
    lActlen = txtShow.SelLength
    
    If lActPos = lFindPos And _
       lActlen = lFindLen _
    Then
        lActPos = lActPos + lActlen
    End If
    
    lFindPos = txtShow.Find(sFindString, lActPos, , lFindOptions)
    
    If lFindPos < 0 Then
        If lActPos > 0 Then
            lActPos = 0
            lFindPos = txtShow.Find(sFindString, lActPos, , lFindOptions)
        End If
    End If
    
    If lFindPos >= 0 Then
        lFindLen = txtShow.SelLength
    Else
        lFindLen = 0
    End If
End Sub

Private Sub ShowCopy()
    Clipboard.Clear
    
    If txtShow.SelLength > 0 Then
        Clipboard.SetText txtShow.SelText
    Else
        Clipboard.SetText txtShow.Text
    End If
End Sub

