VERSION 5.00
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocTermcharSet 
   ClientHeight    =   5250
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6015
   KeyPreview      =   -1  'True
   ScaleHeight     =   5250
   ScaleWidth      =   6015
   ToolboxBitmap   =   "DBMDocTermcharSet.ctx":0000
   Begin VB.PictureBox picGeneral 
      BorderStyle     =   0  'None
      Height          =   3495
      Left            =   60
      ScaleHeight     =   3495
      ScaleWidth      =   3015
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   3015
      Begin DBMDoc.ctlTermChar ctrTermchar 
         Height          =   2175
         Left            =   60
         TabIndex        =   9
         Top             =   1260
         Width           =   2895
         _ExtentX        =   5106
         _ExtentY        =   3836
      End
      Begin VB.CheckBox chkEnabled 
         Height          =   255
         Left            =   1080
         TabIndex        =   8
         Top             =   960
         Width           =   1815
      End
      Begin VB.Frame fraType 
         Height          =   495
         Left            =   1080
         TabIndex        =   4
         Top             =   360
         Width           =   1815
         Begin VB.OptionButton optType 
            Caption         =   "ASCII"
            Height          =   252
            Index           =   0
            Left            =   60
            TabIndex        =   5
            Top             =   180
            Width           =   735
         End
         Begin VB.OptionButton optType 
            Caption         =   "EBCDIC"
            Height          =   255
            Index           =   1
            Left            =   840
            TabIndex        =   6
            Top             =   180
            Width           =   915
         End
      End
      Begin VB.TextBox txtName 
         BorderStyle     =   0  'None
         Height          =   255
         Left            =   1080
         TabIndex        =   2
         Top             =   120
         Width           =   1815
      End
      Begin VB.Label lblEnabled 
         Caption         =   "Enabled:"
         Height          =   195
         Left            =   60
         TabIndex        =   7
         Top             =   960
         Width           =   945
      End
      Begin VB.Label lblType 
         Caption         =   "Code Type:"
         Height          =   195
         Left            =   60
         TabIndex        =   3
         Top             =   540
         Width           =   945
      End
      Begin VB.Label lbName 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   60
         TabIndex        =   1
         Top             =   120
         Width           =   705
      End
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   3360
      Top             =   420
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   3360
      Top             =   60
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   4800
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuTermcharSet 
      Caption         =   "TermcharSet"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocTermcharSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM

Const ERR_SAVETERMCHARS = "Error while saving termchar set!"

Public Enum TermcharSetCommands
    cmdTermcharSet
    cmdTermcharSetOK
    cmdTermcharSetCancel
    cmdSeperator
End Enum

Const CMD_FIRST = cmdTermcharSet
Const CMD_LAST = cmdSeperator

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean
Private oTermcharSet As DBMLib.TermcharSet
Private oCopyFromTermcharSet As DBMLib.TermcharSet

Private bDirty As Boolean

'''

Public Event WrongDBState()

Public Event TermcharSetCreated(ByVal TermcharSet As DBMLib.TermcharSet)
Public Event TermcharSetChanged(ByVal TermcharSet As DBMLib.TermcharSet)
Public Event Command(ByVal Command As TermcharSetCommands)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_TERMCHARSETS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_TERMCHARSET)
    If Not oDB Is Nothing Then
        s = s + " - " + oDB.Name
        If Not oTermcharSet Is Nothing Then
            s = s + " - " + oTermcharSet.Name
        End If
    End If
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Set TermcharSet(ByVal NewVal As DBMLib.TermcharSet)
    Set oTermcharSet = NewVal
End Property

Public Property Set CopyFromTermcharSet(ByVal NewVal As DBMLib.TermcharSet)
    Set oCopyFromTermcharSet = NewVal
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    UserControl.MousePointer = vbHourglass
    FillForm
    UserControl.MousePointer = vbDefault
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
    Set oTermcharSet = Nothing
    Set oCopyFromTermcharSet = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oDB = Nothing
    Set oTermcharSet = Nothing
    Set oCopyFromTermcharSet = Nothing
    
    optType(0).Tag = DBMLib.TermcharCodeTypeConstants.dbmTermcharCodeTypeASCII
    optType(1).Tag = DBMLib.TermcharCodeTypeConstants.dbmTermcharCodeTypeEBCDIC
    
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    picGeneral.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyEscape:
                    If CML.CommandItems.Item(cmdTermcharSetCancel).Enabled Then
                        TermcharSetBack
                    End If
            End Select
    End Select
End Sub
'
' picGeneral
'
Private Sub picGeneral_Resize()
    Dim iHeight As Integer
    
    iHeight = picGeneral.ScaleHeight - ctrTermchar.Top - 2 * iDY
    If iHeight < 0 Then iHeight = 0
    ctrTermchar.Height = iHeight
    ctrTermchar.Width = picGeneral.ScaleWidth
End Sub
'
' txtName
'
Private Sub txtName_Change()
    SetForm
End Sub

Private Sub txtName_GotFocus()
    txtName.SelStart = 0
    txtName.SelLength = Len(txtName.Text)
End Sub
'
' optType
'
Private Sub optType_Click(Index As Integer)
    fraType.Tag = optType(Index).Tag
    
    If Not oTermcharSet Is Nothing Then
        If fraType.Tag <> oTermcharSet.CodeType Then
            bDirty = True
        End If
    End If
    
    SetForm
End Sub
'
' ctrTermchar
'
Private Sub ctrTermchar_Change()
    bDirty = True
    SetForm
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdTermcharSetCancel: TermcharSetBack
        Case cmdTermcharSetOK:     TermcharSetSave
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdTermcharSet, "&TermcharSet"
        .Add cmdTypeDefault, cmdTermcharSetOK, "&Save", oRes.Bitmap16ID(IDB_16_OK)
        .Add cmdTypeDefault, cmdTermcharSetCancel, "&Cancel", oRes.Bitmap16ID(IDB_16_CANCEL)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdTermcharSetOK)
        Set oItem = .Add(cmdTermcharSetCancel)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oSubSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdTermcharSet)
    End With
    
    With oSub.MenuBarItems
        Set oItem = .Add(cmdTermcharSetOK)
        Set oItem = .Add(cmdTermcharSetCancel)
    End With
End Sub

'''

Private Sub ClearForm()
    bDirty = False
    txtName.Text = ""
    optType(0).Value = True
    chkEnabled.Value = vbUnchecked
    ctrTermchar.Grid_Clear
End Sub

Private Sub FillForm()
    ClearForm
    
    If oTermcharSet Is Nothing Then
        txtName.Text = ""
        txtName.BackColor = vbWindowBackground
        txtName.Locked = False
        
        If Not oCopyFromTermcharSet Is Nothing Then
            With oCopyFromTermcharSet
                Select Case .CodeType
                    Case dbmTermcharCodeTypeASCII:  optType(0).Value = True
                    Case dbmTermcharCodeTypeEBCDIC: optType(1).Value = True
                End Select
                ctrTermchar.Grid_Setup oCopyFromTermcharSet
            End With
            bDirty = True
        End If
    Else
        With oTermcharSet
            txtName.Text = .Name
            txtName.BackColor = vbButtonFace
            txtName.Locked = True
            
            Select Case .CodeType
                Case dbmTermcharCodeTypeASCII:  optType(0).Value = True
                Case dbmTermcharCodeTypeEBCDIC: optType(1).Value = True
            End Select
            
            If .Enabled Then chkEnabled.Value = vbChecked
            
            ctrTermchar.Grid_Setup oTermcharSet
        End With
    End If
    
    SetForm
End Sub

Private Sub TermcharSetBack()
    RaiseEvent Command(cmdTermcharSetCancel)
End Sub

Private Sub TermcharSetSave()
    Dim bCreated As Boolean
    Dim bChanged As Boolean
    Dim sName As String
    Dim lType As DBMLib.TermcharCodeTypeConstants
    Dim bEnabled As Boolean
    
    bCreated = False
    bChanged = False
    
    sName = Trim(txtName.Text)
    lType = fraType.Tag
    bEnabled = (chkEnabled.Value = vbChecked)
    
    If Not oTermcharSet Is Nothing Then
        bChanged = True
    Else
        Set oTermcharSet = oDB.TermcharSets.AddNewSet(sName)
        bCreated = True
    End If
    
    With oTermcharSet
        .Name = sName
        .CodeType = lType
        .Enabled = bEnabled
    End With
    ctrTermchar.Grid_PutTermchars oTermcharSet
    
    If Not oTermcharSet.Save() Then
        MsgBox ERR_SAVETERMCHARS + vbCrLf + vbCrLf + "(" + Trim(oDB.LastError.Text) + ")", vbExclamation
    Else
        If bCreated Then RaiseEvent TermcharSetCreated(oTermcharSet)
        If bChanged Then RaiseEvent TermcharSetChanged(oTermcharSet)
    End If
    
    RaiseEvent Command(cmdTermcharSetOK)
End Sub

Private Sub SetForm()
    Dim bSave As Boolean
    
    bSave = False
    
    If Len(Trim(txtName.Text)) > 0 And bDirty Then
        bSave = True
    End If
    
    CML.CommandItems.Item(cmdTermcharSetOK).Enabled = bSave
End Sub





