VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocTermcharSets 
   ClientHeight    =   3135
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6360
   KeyPreview      =   -1  'True
   ScaleHeight     =   3135
   ScaleWidth      =   6360
   ToolboxBitmap   =   "DBMDocTermcharSets.ctx":0000
   Begin MSComctlLib.ListView lvwTermcharSets 
      Height          =   1755
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2775
      _ExtentX        =   4895
      _ExtentY        =   3096
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Code Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Enabled"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMDoc.DBMDocTermcharSet docTermcharSet 
      Height          =   1635
      Left            =   3300
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   2884
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   480
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   120
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   840
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   2685
      Width           =   6360
      _ExtentX        =   11218
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuTermcharSets 
      Caption         =   "TermcharSets"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocTermcharSets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM

Const ERR_LOADTERMCHARS = "Error while loading termchar sets!"
Const ERR_SAVETERMCHARS = "Error while saving termchar set!"

Private Enum TermcharsetsCommands
    cmdTermcharsets
    cmdTermcharSetNew
    cmdTermcharSetEdit
    cmdTermcharSetCopy
    cmdTermcharSetDelete
    cmdTermcharSetsRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdTermcharsets
Const CMD_LAST = cmdSeperator

Private Enum MediaPopupConstants
    popTermcharSets = 1
    popTermcharSet
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''

Private Enum TermcharSetsColumnConstants
    mcName
    mcType
    mcEnabled
End Enum

'''
Private oTIB As Object
Attribute oTIB.VB_VarHelpID = -1
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

Private oTermcharSets As DBMLib.TermcharSets
Private oTermcharSet As DBMLib.TermcharSet

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean
Private oEditTermcharSet As DBMLib.TermcharSet
Private bFitColumnSize As Boolean
Private bTermcharSetOpen As Boolean

'''

Public Event WrongDBState()

Public Event TermcharsChanged(oDatabase As Object)
Public Event TermcharSetClick(ByVal TermcharSet As DBMLib.TermcharSet)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_TERMCHARSETS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_TERMCHARSETS)
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    UserControl.MousePointer = vbHourglass
    TermcharSetsRefresh
    UserControl.MousePointer = vbDefault
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwTermcharSets, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    docTermcharSet.Reset
    
    Set oDB = Nothing
    Set oTermcharSet = Nothing
    Set oTermcharSets = Nothing
End Sub

Public Sub CleanUp()
    docTermcharSet.CleanUp

    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub

Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    bTermcharSetOpen = False
    
    bFitColumnSize = True

    TermcharSetsInit
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwTermcharSets.Move 0, iTop, ScaleWidth, iHeight
    
    iHeight = ScaleHeight
    If iHeight < 0 Then iHeight = 0
    
    docTermcharSet.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwTermcharSets
'
Private Sub lvwTermcharSets_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ListViewUtil.SortColumn lvwTermcharSets, ColumnHeader
End Sub

Private Sub lvwTermcharSets_ItemClick(ByVal Item As MSComctlLib.ListItem)
    TermcharSetsSelectItem Item
End Sub

Private Sub lvwTermcharSets_DblClick()
    If bItemClick Then TermcharSetEdit
End Sub

Private Sub lvwTermcharSets_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwTermcharSets.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwTermcharSets_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwTermcharSets.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popTermcharSets
        Else
            POP.Show popTermcharSet
        End If
    End If
End Sub

Private Sub lvwTermcharSets_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdTermcharSetEdit).Enabled Then
                        TermcharSetEdit
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdTermcharSetsRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docTermcharSet
'
Private Sub docTermcharSet_Command(ByVal Command As TermcharSetCommands)
    Select Case Command
        Case cmdTermcharSetCancel:
            bTermcharSetOpen = False
            TIBCaption oTIB, Caption
            
            docTermcharSet.Visible = False
            lvwTermcharSets.SetFocus
    End Select
End Sub

Private Sub docTermcharSet_TermcharSetChanged(ByVal TermcharSet As DBMLib.TermcharSet)
    Dim oItem As MSComctlLib.ListItem

    Set oItem = ListViewUtil.GetListItemByKey(lvwTermcharSets, TermcharSet.Name)
    
    If Not oItem Is Nothing Then
        oItem.SubItems(mcType) = oTermcharSet.CodeTypeStr
    End If

    bTermcharSetOpen = False
    TIBCaption oTIB, Caption
    
    docTermcharSet.Visible = False
    lvwTermcharSets.SetFocus
End Sub

Private Sub docTermcharSet_TermcharSetCreated(ByVal TermcharSet As DBMLib.TermcharSet)
    Dim oItem As MSComctlLib.ListItem
    
    Set oItem = lvwTermcharSets.ListItems.Add(, TermcharSet.Name, TermcharSet.Name, , oRes.Bitmap16ID(IDB_16_TERMCHARSETS))
    oItem.SubItems(mcType) = TermcharSet.CodeTypeStr
    
    TermcharSetsSelectItem oItem

    bTermcharSetOpen = False
    TIBCaption oTIB, Caption
    
    docTermcharSet.Visible = False
    lvwTermcharSets.SetFocus
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdTermcharSetNew:         TermcharSetNew
        Case cmdTermcharSetCopy:        TermcharSetCopy
        Case cmdTermcharSetEdit:        TermcharSetEdit
        Case cmdTermcharSetDelete:      TermcharSetDelete
        Case cmdTermcharSetsRefresh:    TermcharSetsRefresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdTermcharsets, "&TermcharSets", 0
        .Add cmdTypeDefault, cmdTermcharSetNew, "New", oRes.Bitmap16ID(IDB_16_TERMCHARSET_NEW)
        .Add cmdTypeDefault, cmdTermcharSetCopy, "Copy", oRes.Bitmap16ID(IDB_16_COPY)
        .Add cmdTypeDefault, cmdTermcharSetEdit, "Edit", oRes.Bitmap16ID(IDB_16_EDIT)
        .Add cmdTypeDefault, cmdTermcharSetDelete, "Delete", oRes.Bitmap16ID(IDB_16_DELETE)
        .Add cmdTypeDefault, cmdTermcharSetsRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdTermcharSetNew)
        Set oItem = .Add(cmdTermcharSetCopy)
        Set oItem = .Add(cmdTermcharSetEdit)
        Set oItem = .Add(cmdTermcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdTermcharSetsRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdTermcharsets)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdTermcharSetNew)
        Set oItem = .Add(cmdTermcharSetCopy)
        Set oItem = .Add(cmdTermcharSetEdit)
        Set oItem = .Add(cmdTermcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdTermcharSetsRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupTermcharSetsInit
    PopupTermcharSetInit
End Sub

Private Sub PopupTermcharSetsInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdTermcharSetNew)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdTermcharSetsRefresh)
    End With
End Sub

Private Sub PopupTermcharSetInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdTermcharSetNew)
        Set oItem = .Add(cmdTermcharSetCopy)
        Set oItem = .Add(cmdTermcharSetEdit)
        Set oItem = .Add(cmdTermcharSetDelete)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdTermcharSetsRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    Dim oTermcharSet As DBMLib.TermcharSet
    
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            If oItemAct Is Nothing Then
                .Item(cmdTermcharSetCopy).Enabled = False
                .Item(cmdTermcharSetEdit).Enabled = False
                .Item(cmdTermcharSetDelete).Enabled = False
            Else
                .Item(cmdTermcharSetCopy).Enabled = True
                .Item(cmdTermcharSetEdit).Enabled = True
                .Item(cmdTermcharSetDelete).Enabled = True
            End If
            .Item(cmdTermcharSetsRefresh).Enabled = True
        Else
            .Item(cmdTermcharSetCopy).Enabled = False
            .Item(cmdTermcharSetEdit).Enabled = False
            .Item(cmdTermcharSetDelete).Enabled = False
            .Item(cmdTermcharSetsRefresh).Enabled = False
        End If
    End With
    
    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub TermcharSetsInit()
    lvwTermcharSets.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub TermcharSetsRefresh()
    If Not oDB Is Nothing Then
        If Not oDB.TermcharSets.Refresh() Then
            MsgBox ERR_LOADTERMCHARS + vbCrLf + vbCrLf + "(" + Trim(oDB.LastError.Text) + ")", vbExclamation
        End If
        TermcharSetsList
    End If
End Sub

Private Sub TermcharSetsList()
    Dim oTermcharSet As DBMLib.TermcharSet
    Dim oItem As MSComctlLib.ListItem
    
    If oDB Is Nothing Then Exit Sub
        
    lvwTermcharSets.ListItems.Clear
        
    For Each oTermcharSet In oDB.TermcharSets
        Set oItem = lvwTermcharSets.ListItems.Add(, oTermcharSet.Name, oTermcharSet.Name, , oRes.Bitmap16ID(IDB_16_TERMCHARSETS))
        oItem.SubItems(mcType) = oTermcharSet.CodeTypeStr
        Select Case oTermcharSet.Enabled
            Case True: oItem.SubItems(mcEnabled) = "YES"
            Case False: oItem.SubItems(mcEnabled) = "NO"
        End Select
    Next
    
    If bFitColumnSize Then
        ListViewUtil.FitColumnSize lvwTermcharSets, True
        bFitColumnSize = False
    End If
    
    Set oItemAct = lvwTermcharSets.SelectedItem
    
    CommandsSet False
End Sub

Private Sub TermcharSetsSelectItem(ByVal oItem As MSComctlLib.ListItem)
    Dim oTermcharSet As DBMLib.TermcharSet
    
    Set oItemAct = oItem
    
    Set oTermcharSet = Nothing
    
    If Not oItemAct Is Nothing Then
        Set oTermcharSet = oDB.TermcharSets(oItemAct.Text)
        RaiseEvent TermcharSetClick(oTermcharSet)
    End If
    
    CommandsSet False
End Sub

Private Sub TermcharSetNew()
    bTermcharSetOpen = True
    
    With docTermcharSet
        Set .Database = oDB
        Set .TermcharSet = Nothing
        Set .CopyFromTermcharSet = Nothing
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub TermcharSetCopy()
    Dim oTermcharSet As DBMLib.TermcharSet
    
    If oItemAct Is Nothing Then Exit Sub
    
    bTermcharSetOpen = True
    
    Set oTermcharSet = oDB.TermcharSets(oItemAct.Text)
    
    With docTermcharSet
        Set .Database = oDB
        Set .TermcharSet = Nothing
        Set .CopyFromTermcharSet = oTermcharSet
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub TermcharSetEdit()
    Dim oTermcharSet As DBMLib.TermcharSet
    
    If oItemAct Is Nothing Then Exit Sub
    
    bTermcharSetOpen = True
    
    Set oTermcharSet = oDB.TermcharSets(oItemAct.Text)
    
    With docTermcharSet
        Set .Database = oDB
        Set .TermcharSet = oTermcharSet
        Set .CopyFromTermcharSet = Nothing
        .Refresh
        
        .Visible = True
        .ZOrder 0
    End With
    
    TIBCaption oTIB, Caption
End Sub

Private Sub TermcharSetDelete()
    Dim oTermcharSet As DBMLib.TermcharSet
    Dim sMsg As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    Set oTermcharSet = oDB.TermcharSets(oItemAct.Text)

    sMsg = "Delete Termcharset '" & oTermcharSet.Name & "'?"
    
    If MsgBox(sMsg, vbQuestion + vbOKCancel) = vbOK Then
        oTermcharSet.ToDelete = True
        If oTermcharSet.Save() Then
            lvwTermcharSets.ListItems.Remove oItemAct.Index
            Set oItemAct = Nothing
        Else
            MsgBox ERR_SAVETERMCHARS + vbCrLf + vbCrLf + "(" + Trim(oDB.LastError.Text) + ")", vbExclamation
        End If
    End If

    CommandsSet False
End Sub
