VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Event BusyStateChanged( _
                ByVal Database As Object, _
                ByVal Busy As Boolean)
                              
'''

Public Event DatabaseSessionOpen(ByVal Database As Object)
Public Event DatabaseSessionClosed(ByVal Database As Object)

Public Event DatabaseStateRefreshed(ByVal Database As Object)

Public Event DatabaseEvent( _
                ByVal Database As Object, _
                ByVal EventType As Long, _
                ByVal Name As String, _
                ByVal Priority As String, _
                ByVal Occurrence As Date, _
                ByVal Count As Long, _
                ByVal Value1 As String, _
                ByVal Value2 As String, _
                ByVal Text As String, _
                ByVal Description As String)

'''

Public Event BackupStateStart(ByVal Database As Object)
Public Event BackupStateRefresh(ByVal Database As Object)
Public Event BackupStateStop(ByVal Database As Object)

'''

Public Event AutosaveAction(ByVal Database As Object, ByVal Action As Long)

'''

Public Event Error( _
                ByVal Database As Object, _
                ByVal Number As Long, _
                ByVal Source As String, _
                ByVal Description As String, _
                ByVal HelpFile As String, _
                ByVal HelpContext As Long)
                           
                            
'''

Public Sub BusyStateChanged( _
                ByVal Database As Object, _
                ByVal Busy As Boolean)
                
    RaiseEvent BusyStateChanged(Database, Busy)
End Sub
                            
'''

Public Sub DatabaseSessionOpen(ByVal Database As Object)
    RaiseEvent DatabaseSessionOpen(Database)
End Sub
Public Sub DatabaseSessionClosed(ByVal Database As Object)
    RaiseEvent DatabaseSessionClosed(Database)
End Sub
Public Sub DatabaseStateRefreshed(ByVal Database As Object)
    RaiseEvent DatabaseStateRefreshed(Database)
End Sub

Public Sub DatabaseEvent( _
                ByVal Database As Object, _
                ByVal EventType As Long, _
                ByVal Name As String, _
                ByVal Priority As String, _
                ByVal Occurrence As Date, _
                ByVal Count As Long, _
                ByVal Value1 As String, _
                ByVal Value2 As String, _
                ByVal Text As String, _
                ByVal Description As String)
                
    RaiseEvent DatabaseEvent(Database, EventType, Name, Priority, Occurrence, Count, Value1, Value2, Text, Description)
End Sub

'''

Public Sub BackupStateStart(ByVal Database As Object)
    RaiseEvent BackupStateStart(Database)
End Sub
Public Sub BackupStateRefresh(ByVal Database As Object)
    RaiseEvent BackupStateRefresh(Database)
End Sub
Public Sub BackupStateStop(ByVal Database As Object)
    RaiseEvent BackupStateStop(Database)
End Sub

'''

Public Sub AutosaveAction(ByVal Database As Object, ByVal Action As Long)
    RaiseEvent AutosaveAction(Database, Action)
End Sub

'''

Public Sub Error(ByVal Database As Object, _
                 ByVal Number As Long, _
                 ByVal Source As String, _
                 ByVal Description As String, _
                 ByVal HelpFile As String, _
                 ByVal HelpContext As Long)
    
    RaiseEvent Error(Database, Number, Source, Description, HelpFile, HelpContext)
End Sub
