VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSComCtl.ocx"
Begin VB.Form frmFiles 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Database Manager - Files"
   ClientHeight    =   3690
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6510
   Icon            =   "Files.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3690
   ScaleWidth      =   6510
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOK 
      Cancel          =   -1  'True
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   5340
      TabIndex        =   0
      Top             =   3240
      Width           =   1095
   End
   Begin MSComctlLib.ListView lvwFiles 
      Height          =   3015
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   5318
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   0   'False
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   16777215
      Appearance      =   0
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   1764
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Version"
         Object.Width           =   917
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Date"
         Object.Width           =   1905
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Location"
         Object.Width           =   25400
      EndProperty
   End
End
Attribute VB_Name = "frmFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const MAX_FILES = 18

Private aFiles(1 To MAX_FILES) As String

'''

Private Sub Form_Load()
    Dim oFile As New File
    Dim oItem As ListItem
    Dim iFile As Integer
    
    FileList
    
    For iFile = 1 To MAX_FILES
        oFile.Filename = aFiles(iFile)
        oFile.Refresh
        
        Set oItem = lvwFiles.ListItems.Add(, , oFile.Name)
        
        With oItem
            .SubItems(1) = oFile.VersionString
            .SubItems(2) = oFile.FileDateString
            .SubItems(3) = oFile.Path
        End With
    Next
End Sub

Private Sub Form_Resize()
    Dim iWidth As Integer
    Dim iHeight As Integer
    
    iWidth = ScaleWidth - 120
    If iWidth < 0 Then iWidth = 0
    
    iHeight = ScaleHeight - cmdOK.Height - 180
    If iHeight < 0 Then iHeight = 0
    
    lvwFiles.Move 60, 60, iWidth, iHeight
    
    cmdOK.Move ScaleWidth - cmdOK.Width - 60, lvwFiles.Height + 120
End Sub

Private Sub cmdOK_Click()
    Unload Me
End Sub

Private Sub FileList()
    aFiles(1) = App.Path & "\DBMGui.exe"
    aFiles(2) = App.Path & "\DBMApp.exe"
    aFiles(3) = App.Path & "\DBMWiz.exe"
    aFiles(4) = App.Path & "\DBMLib.dll"
    aFiles(5) = App.Path & "\DBMSob.dll"
    aFiles(6) = App.Path & "\DBMReg.dll"
    aFiles(7) = App.Path & "\DBMEve.dll"
    aFiles(8) = App.Path & "\DBMRes.dll"
    aFiles(9) = App.Path & "\DBMDoc.ocx"
    aFiles(10) = App.Path & "\DBMScr.ocx"
    aFiles(11) = App.Path & "\DBMSpl.ocx"
    aFiles(12) = App.Path & "\DBMInp.ocx"
    aFiles(13) = App.Path & "\DBMCmd.ocx"
    aFiles(14) = App.Path & "\DBMSep.ocx"
    aFiles(15) = App.Path & "\DBMTib.ocx"
    aFiles(16) = App.Path & "\DBMInf.ocx"
    aFiles(17) = App.Path & "\DBMFlb.ocx"
    aFiles(18) = App.Path & "\DBMDrt.ocx"
End Sub

