VERSION 5.00
Begin VB.Form frmRegName 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Register Database"
   ClientHeight    =   1380
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4605
   Icon            =   "RegName.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1380
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox picForm 
      BorderStyle     =   0  'None
      Height          =   795
      Left            =   120
      ScaleHeight     =   795
      ScaleWidth      =   4395
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   480
      Width           =   4395
      Begin VB.TextBox txtName 
         Height          =   315
         Left            =   600
         TabIndex        =   4
         Top             =   0
         Width           =   3795
      End
      Begin VB.CommandButton cmdCancel 
         Cancel          =   -1  'True
         Caption         =   "&Cancel"
         Height          =   375
         Left            =   3180
         TabIndex        =   3
         Top             =   420
         Width           =   1215
      End
      Begin VB.CommandButton cmdOK 
         Caption         =   "&OK"
         Default         =   -1  'True
         Enabled         =   0   'False
         Height          =   375
         Left            =   1920
         TabIndex        =   2
         Top             =   420
         Width           =   1155
      End
      Begin VB.Label lblName 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   0
         TabIndex        =   5
         Top             =   60
         Width           =   615
      End
   End
   Begin VB.Label lblInfo 
      AutoSize        =   -1  'True
      Caption         =   "<Info>"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4395
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmRegName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Integer

'''

Public Function RegName(Server As String, _
                        Database As String, _
                        Name As String) As Boolean
    Dim s As String
    
    RegName = False
    
    s = "Database instance '" + Database + "'"
    If Len(Server) > 0 Then
        s = s + " on server '" + Server + "'"
    End If
    s = s + " has been installed."
    s = s + " Enter a definite registration name."
    
    lblInfo.Caption = s
    
    picForm.Top = lblInfo.Top + lblInfo.Height + 180
    
    Height = picForm.Top + picForm.Height + 120 + (Height - ScaleHeight)
    
    txtName.Text = Name
    
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            Name = Trim(txtName.Text)
            RegName = True
    End Select
    
    Unload Me
End Function

'''

Private Sub Form_Activate()
    txtName.SetFocus
End Sub

'''

Private Sub txtName_Change()
    EnabledOK
End Sub

Private Sub txtName_GotFocus()
    txtName.SelStart = 0
    txtName.SelLength = Len(txtName.Text)
End Sub

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = vbOK
    Me.Hide
End Sub

Private Sub EnabledOK()
    cmdOK.Enabled = (Len(Trim(txtName.Text)) > 0)
End Sub


