VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmRegister 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Register Database"
   ClientHeight    =   3720
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6735
   ForeColor       =   &H80000008&
   Icon            =   "Register.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3720
   ScaleWidth      =   6735
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ListView lvwDatabases 
      Height          =   1695
      Left            =   120
      TabIndex        =   5
      Top             =   1020
      Width           =   6495
      _ExtentX        =   11456
      _ExtentY        =   2990
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      Checkboxes      =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Version"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Path"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.CommandButton cmdInfo 
      Caption         =   "&Info"
      Height          =   315
      Left            =   5100
      TabIndex        =   3
      Top             =   180
      Width           =   795
   End
   Begin VB.ComboBox comServer 
      Height          =   315
      ItemData        =   "Register.frx":000C
      Left            =   2400
      List            =   "Register.frx":000E
      TabIndex        =   1
      Top             =   180
      Width           =   2235
   End
   Begin VB.CommandButton cmdServer 
      Caption         =   "!"
      Height          =   315
      Left            =   4680
      TabIndex        =   2
      Top             =   180
      Width           =   315
   End
   Begin VB.CommandButton cmdRegister 
      Caption         =   "&Register"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   3240
      Width           =   1155
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   5460
      TabIndex        =   7
      Top             =   3240
      Width           =   1155
   End
   Begin VB.Label lblError 
      Caption         =   "<Errro>"
      Height          =   195
      Left            =   960
      TabIndex        =   10
      Top             =   1560
      Visible         =   0   'False
      Width           =   5595
   End
   Begin VB.Image imgError 
      Height          =   480
      Left            =   300
      Picture         =   "Register.frx":0010
      Top             =   1380
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Label lblIsReg 
      Caption         =   "= Database already registered."
      Height          =   195
      Left            =   4320
      TabIndex        =   9
      Top             =   2880
      Visible         =   0   'False
      Width           =   2235
   End
   Begin VB.Image imgIsReg 
      Height          =   240
      Left            =   4020
      Top             =   2880
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Label lblInfo 
      Caption         =   "Select the database(s) to be registered."
      Enabled         =   0   'False
      Height          =   195
      Left            =   180
      TabIndex        =   8
      Top             =   2880
      Width           =   3015
   End
   Begin VB.Label lblDBs 
      Caption         =   "&Databases:"
      Enabled         =   0   'False
      Height          =   195
      Left            =   180
      TabIndex        =   4
      Top             =   660
      Width           =   2175
   End
   Begin VB.Label lblServer 
      Caption         =   "&List databases from server:"
      Height          =   195
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   2115
   End
End
Attribute VB_Name = "frmRegister"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const LOCAL_ITEM = "<Local>"
Const MAX_SERVER = 10

Private Enum DatabaseColumnConstants
    dbcName
    dbcVersion
    dbcPath
End Enum

Private sServer As String

Private oServer As New DBMLib.Server

'''

Private Sub Form_Initialize()
    Dim iServer As Integer
    
    comServer.AddItem LOCAL_ITEM
    
    For iServer = 1 To MAX_SERVER
        If Len(REG.Settings.Server(iServer)) > 0 Then
            comServer.AddItem REG.Settings.Server(iServer)
        End If
    Next
    
    sServer = ""
    comServer.Text = LOCAL_ITEM
    Set imgIsReg.Picture = RES.Bitmap16(IDB_16_DB_REGISTERED)
End Sub

Private Sub Form_Load()
    DatabasesInit
    NewServer
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim iServer As Integer
    
    For iServer = 1 To MAX_SERVER
        REG.Settings.Server(iServer) = ""
    Next
    
    For iServer = 1 To comServer.ListCount - 1
        REG.Settings.Server(iServer) = comServer.List(iServer)
    Next
End Sub

Private Sub comServer_Change()
    cmdServer.Enabled = (Len(Trim(comServer.Text)) > 0)
End Sub

Private Sub comServer_Click()
    NewServer
End Sub

Private Sub comServer_GotFocus()
    comServer.SelStart = 0
    comServer.SelLength = Len(comServer.Text)
    cmdServer.Default = True
End Sub

Private Sub comServer_LostFocus()
    cmdClose.Default = True
End Sub

Private Sub cmdServer_Click()
    NewServer
End Sub

Private Sub cmdInfo_Click()
    InfoServer
End Sub


Private Sub cmdRegister_Click()
    Register
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

'''

Private Sub DatabasesInit()
    lvwDatabases.SmallIcons = RES.Bitmaps16
End Sub

Private Sub DatabasesList(ByVal sServer As String)
    Dim oEnumDB As DBMLib.EnumDatabase
    Dim oDB As DBMLib.Database
    Dim oItem As MSComctlLib.ListItem
    Dim bExists As Boolean
        
    Dim oDBKey As DBMReg.Key
    Dim oFileDB As FileDatabase
    
    Screen.MousePointer = vbHourglass
    
    lvwDatabases.ListItems.Clear
    
    oServer.Name = sServer
    
    If oServer.EnumerateDatabases() Then
        lblDBs.Visible = True
        lvwDatabases.Visible = True
        imgError.Visible = False
        lblError.Visible = False
        
        For Each oEnumDB In oServer.EnumDatabases
            If Not DatabaseItemExists(oEnumDB.Name) Then
                bExists = False
                
                Select Case GUI.Mode
                    Case dbmGUIModeDefault:
                        For Each oDBKey In REG.Databases.Key.Keys
                            If UCase$(sServer) = UCase$(oDBKey.Values.Item(REG_DB_VAL_SERVER).Value) And _
                               UCase$(oEnumDB.Name) = UCase$(oDBKey.Values.Item(REG_DB_VAL_NAME).Value) _
                            Then
                                bExists = True
                                Exit For
                            End If
                        Next
                    Case dbmGUIModeConfigFile:
                        For Each oFileDB In GUI.FileDatabases
                            If UCase$(sServer) = UCase$(oFileDB.Servername) And _
                               UCase$(oEnumDB.Name) = UCase$(oFileDB.Databasename) _
                            Then
                                bExists = True
                                Exit For
                            End If
                        Next
                End Select
                
                If oEnumDB.Version.Number >= dbmVersion71 Then
                    Set oItem = lvwDatabases.ListItems.Add(, oEnumDB.Name, oEnumDB.Name, , RES.Bitmap16ID(IDB_16_DB))
                    oItem.SubItems(dbcVersion) = oEnumDB.Version.Text
                    oItem.SubItems(dbcPath) = oEnumDB.InstRoot
                    If bExists Then
                        oItem.SmallIcon = RES.Bitmap16ID(IDB_16_DB_REGISTERED)
                    End If
                End If
            End If
        Next
    Else
        lblDBs.Visible = False
        lvwDatabases.Visible = False
        imgError.Visible = True
        lblError.Caption = CStr(oServer.LastError.Number) + " " + oServer.LastError.Text
        lblError.Visible = True
    End If
    
    If lvwDatabases.ListItems.Count > 0 Then
        lblDBs.Enabled = True
        lblInfo.Enabled = True
        cmdRegister.Enabled = True
        imgIsReg.Visible = True
        lblIsReg.Visible = True
        lvwDatabases.Enabled = True
    Else
        lblDBs.Enabled = False
        lblInfo.Enabled = False
        cmdRegister.Enabled = False
        imgIsReg.Visible = False
        lblIsReg.Visible = False
        lvwDatabases.Enabled = False
        If comServer.Visible Then
            comServer.SetFocus
        End If
    End If
    
    Screen.MousePointer = vbDefault
End Sub

Function DatabaseItemExists(ByVal sName As String) As Boolean
    Dim oItem As MSComctlLib.ListItem
    Set oItem = ListViewUtil.GetListItemByKey(lvwDatabases, sName)
    DatabaseItemExists = Not oItem Is Nothing
End Function

Private Sub NewServer()
    Dim sNewServer As String
    Dim i As Integer
    Dim s As String
    Dim bExists As Boolean
    
    sNewServer = Trim(comServer.Text)
    
    If sNewServer = LOCAL_ITEM Then sNewServer = ""
    
    If sServer = "" Or sNewServer <> sServer Then
        DatabasesList sNewServer
    End If
    
    If Len(sNewServer) > 0 Then
        bExists = False
        
        For i = 1 To comServer.ListCount - 1
            s = comServer.List(i)
            If UCase(s) = UCase(sNewServer) Then
                bExists = True
                Exit For
            End If
        Next
        
        If Not bExists Then
            If comServer.ListCount > 1 Then
                comServer.AddItem sNewServer, 1
            Else
                comServer.AddItem sNewServer
            End If
            
            If comServer.ListCount > MAX_SERVER + 1 Then
                comServer.RemoveItem comServer.ListCount - 1
            End If
        End If
    End If
    
    sServer = sNewServer
End Sub

Private Sub Register()
    Dim oEnumDB As DBMLib.EnumDatabase
    Dim oItem As MSComctlLib.ListItem
    Dim i As Integer
    
    Dim bRefresh As Boolean
    Dim bCancel As Boolean
    
    bRefresh = False
    
    For i = 1 To lvwDatabases.ListItems.Count
        Set oItem = lvwDatabases.ListItems(i)
        If oItem.Checked Then
            Set oEnumDB = oServer.EnumDatabases.Find(oItem.Text, dbmFastKernel)
            If oEnumDB Is Nothing Then
                Set oEnumDB = oServer.EnumDatabases.Find(oItem.Text, dbmQuickKernel)
            End If
            If oEnumDB Is Nothing Then
                Set oEnumDB = oServer.EnumDatabases.Find(oItem.Text, dbmSlowKernel)
            End If
        
            RegisterOne sServer, oItem.Text, oItem.SubItems(dbcVersion), oEnumDB.Kernel, dbmInstanceTypeOLTP, bCancel
            
            If Not bCancel Then
                bRefresh = True
            Else
                Exit For
            End If
        End If
    Next
    
    If bRefresh Then
        DatabasesList sServer
    End If
End Sub

Private Sub RegisterOne(sServer As String, _
                        sDatabase As String, _
                        sVersion As String, _
                        lKernel As DBMLib.DBMDatabaseKernelConstants, _
                        lInstanceType As DBMLib.DBMDatabaseInstanceTypeConstants, _
                        bCancel As Boolean)
    Dim bRegistered As Boolean
    Dim sName As String
    Dim sUsername As String
    Dim sPassword As String
    Dim oKey As DBMReg.Key
    Dim oFileDB As FileDatabase
    
    bRegistered = False
    bCancel = False
    
    Do
        sName = sDatabase
        
        frmRegParams.RegParams sServer, sDatabase, sName, sUsername, sPassword, bCancel
    
        If Not bCancel Then
            Select Case GUI.Mode
                Case dbmGUIModeDefault:
                    If REG.Databases.Exists(sName) Then
                        MsgBox "Cannot register database: The name you specified already exists. Specify a different name.", vbExclamation, "Register"
                    Else
                        Set oKey = REG.Databases.Add(sName, sServer, sDatabase, sUsername, sPassword, sVersion, lKernel, lInstanceType)
                        FRM.TreeFolderAddDB oKey.Name
                        bRegistered = True
                    End If
                
                Case dbmGUIModeConfigFile:
                    If GUI.FileDatabases.Exists(sName) Then
                        MsgBox "Cannot register database: The name you specified already exists. Specify a different name.", vbExclamation, "Register"
                    Else
                        Set oFileDB = GUI.FileDatabases.Add(sName, sServer, sDatabase, sUsername, sPassword, sVersion, lKernel, lInstanceType)
                        FRM.DBListFillOne oFileDB.Name
                        FRM.DBListRefreshOne oFileDB.Name
                        bRegistered = True
                    End If
            End Select
        End If
    Loop Until bCancel Or bRegistered
End Sub

Private Sub InfoServer()
    Dim f As New frmServerProperties
    
    If oServer.GetInfos() Then
        Set f.Server = oServer
    
        f.Show vbModal, Me
    End If
End Sub
