Attribute VB_Name = "DBMSRVAutosave"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Function AutosaveShow(oServerObject As DBMSOB.ServerObject, sState As String) As Boolean
    Dim sData As String
    Dim lPos1 As Long
    
    AutosaveShow = False
    
    If oServerObject.Command(DBMSRV_CMD_AUTOSAVE_SHOW, sData) Then
        lPos1 = 1
        sState = Trim(oServerObject.GetLine(sData, lPos1))
        AutosaveShow = True
    End If
End Function

Public Function AutosaveOn(oServerObject As DBMSOB.ServerObject, ByVal sMediumName As String) As Boolean
    Dim sData As String
    
    AutosaveOn = False
    
    If oServerObject.Command(DBMSRV_CMD_AUTOSAVE_ON + " """ + sMediumName + """", sData) Then
        AutosaveOn = True
    End If
End Function

Public Function AutosaveOff(oServerObject As DBMSOB.ServerObject) As Boolean
    Dim sData As String
    
    AutosaveOff = False
    
    If oServerObject.Command(DBMSRV_CMD_AUTOSAVE_OFF, sData) Then
        AutosaveOff = True
    End If
End Function

Public Function AutosaveCancel(oServerObject As DBMSOB.ServerObject) As Boolean
    Dim sData As String
    
    AutosaveCancel = False
    
    If oServerObject.Command(DBMSRV_CMD_AUTOSAVE_CANCEL, sData) Then
        AutosaveCancel = True
    End If
End Function
