VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LastError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Number As Long
Public Text As String
Public ShortText As String
Public Value As String
Public SQLNumber As Long
Public SQLText As String
Public Data As String
Public Canceled As Boolean

Friend Sub SetByServerObject(oServerObject As DBMSOB.ServerObject)
    With oServerObject
        Number = .ReturnCode
        Value = .ErrorValue
        Text = .ErrorText
        ShortText = .ErrorShortText
        SQLNumber = .SQLErrorNumber
        SQLText = .SQLErrorText
        Data = .ErrorData
        Canceled = .Canceled
    End With
End Sub

Friend Sub SetByApplication(sText As String)
    Number = -24100
    Value = "ERR_DBMLIB"
    Text = sText
    ShortText = ""
    SQLNumber = 0
    SQLText = ""
    Data = ""
    Canceled = False
End Sub

