VERSION 5.00
Object = "{8A774550-D889-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMDoc.ocx"
Begin VB.UserControl ctlDevSpaces 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin DBMDoc.DBMDocDevSpaces docDevSpaces 
      Height          =   2895
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   4275
      _ExtentX        =   7541
      _ExtentY        =   5106
      Mode            =   1
      Asynchron       =   0   'False
   End
End
Attribute VB_Name = "ctlDevSpaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private iMinWidth As Integer
Private iMinHeight As Integer

'''

Public Property Get StepName() As String
    StepName = "Devspaces"
End Property

Public Property Get Info() As String
    Info = INFO_DEVSPACES
End Property

Public Property Get Document() As DBMDocDevSpaces
    Set Document = docDevSpaces
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property

'''

Public Sub SetCommands()
    With FRM
        .cmdPrev.Enabled = True
        .cmdNext.Enabled = docDevSpaces.Complete
    End With
End Sub

'''

Private Sub UserControl_Initialize()
    iMinWidth = -1
    iMinHeight = -1
End Sub

Private Sub UserControl_Resize()
     docDevSpaces.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

'''

Private Sub docDevSpaces_DevSpaceEdit(ByVal DevSpace As dbmlib.DevSpace)
    With FRM
        .cmdPrev.Enabled = False
        .cmdNext.Enabled = False
    End With
End Sub

Private Sub docDevSpaces_DevSpaceDelete(ByVal DevSpace As dbmlib.DevSpace)
    SetCommands
End Sub

Private Sub docDevSpaces_DevSpaceOK(ByVal DevSpace As dbmlib.DevSpace)
    SetCommands
End Sub

Private Sub docDevSpaces_DevSpaceCancel(ByVal DevSpace As dbmlib.DevSpace)
    SetCommands
End Sub


