VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Files"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection

'''

Public Property Get count() As Long
    count = oItems.count
End Property

Public Property Get item(ByVal index As Variant) As File
Attribute item.VB_UserMemId = 0
    Set item = oItems(index)
End Property

Public Property Get newEnum()
Attribute newEnum.VB_UserMemId = -4
Attribute newEnum.VB_MemberFlags = "40"
    Set newEnum = oItems.[_NewEnum]
End Property

'''

Public Function add(ByVal name As String, _
                    ByVal path As String) As File
                    
    Dim oFile As New File
    
    With oFile
        .name = name
        .path = path
    End With
    
    oItems.add oFile
    
    Set add = oFile
End Function

Public Function remove(ByVal index As Variant)
    oItems.remove index
End Function

Public Function clear()
    Dim i As Integer
    For i = 1 To oItems.count
        oItems.remove 1
    Next
End Function
