VERSION 5.00
Object = "{6FBA474E-43AC-11CE-9A0E-00AA0062BB4C}#1.0#0"; "sysinfo.ocx"
Begin VB.Form GenMsgBox 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dialog Caption"
   ClientHeight    =   3195
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   10050
   Icon            =   "GenMsgBox.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   10050
   ShowInTaskbar   =   0   'False
   Begin SysInfoLib.SysInfo sysInfo 
      Left            =   6600
      Top             =   1080
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "Button4"
      Height          =   325
      Index           =   3
      Left            =   5520
      TabIndex        =   4
      Top             =   2640
      Visible         =   0   'False
      Width           =   1500
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "Button3"
      Height          =   325
      Index           =   2
      Left            =   3720
      TabIndex        =   3
      Top             =   2640
      Visible         =   0   'False
      Width           =   1500
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "Button2"
      Height          =   325
      Index           =   1
      Left            =   1920
      TabIndex        =   2
      Top             =   2640
      Visible         =   0   'False
      Width           =   1500
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "Button1"
      Default         =   -1  'True
      Height          =   325
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   2640
      Visible         =   0   'False
      Width           =   1500
   End
   Begin VB.Label lblText 
      Caption         =   "Label1"
      Height          =   1335
      Left            =   250
      TabIndex        =   1
      Top             =   250
      Width           =   5535
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "GenMsgBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      GenMsgBox.frm
'
'========================================================================================
'
' responsible:    RalfS
'
' special area:   Common
'
' description:    Form of the generic message box dialog.
'
'========================================================================================

Option Explicit

Const MODULE_NAME = "SQLStudio.GenericMsgBoxForm"
Const MAX_BUTTONS = 4

Private mDefault      As Integer
Private mEscape       As Integer
Private mSelection    As Integer

'=========================================================================================
'    property:      Button (Let)
'    description:   Sets the text of the button with the given index.
'    arguments:     [in] index - index of the button
'                   [in] value - new value of the label
'    return value:  -
'=========================================================================================
Public Property Let button(index As Integer, value As String)
    On Error GoTo errP_Let_Button

    Const FUNCTION_NAME = "P_LET_Button"

    cmdButton(index).Visible = True
    cmdButton(index).caption = value

    Exit Property

errP_Let_Button:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Button (Get)
'    description:   Gets the text of the button with the given index.
'    arguments:     [in] index - index of the button
'    return value:  String
'=========================================================================================
Public Property Get button(index As Integer) As String
    On Error GoTo errP_Get_Button

    Const FUNCTION_NAME = "P_GET_Button"

    button = cmdButton(index).caption
    
    Exit Property

errP_Get_Button:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      defaultButton (Let)
'    description:   Sets the private member mDefault to the given value.
'    arguments:     [in] index - index of the button
'    return value:  -
'=========================================================================================
Public Property Let defaultButton(index As Integer)
    On Error GoTo errP_Let_DefaultButton

    Const FUNCTION_NAME = "P_LET_DefaultButton"

    mDefault = index
    
    Exit Property

errP_Let_DefaultButton:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      EscapeButton (Let)
'    description:   Sets the private member mEscape to the given value.
'    arguments:     [in] index - index of the button
'    return value:  -
'=========================================================================================
Public Property Let escapeButton(index As Integer)
    On Error GoTo errP_Let_EscapeButton

    Const FUNCTION_NAME = "P_LET_EscapeButton"

    mEscape = index
    
    Exit Property

errP_Let_EscapeButton:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Selection (Get)
'    description:   Gets the value of the private member mSelection.
'    arguments:     -
'    return value:  Integer
'=========================================================================================
Public Property Get selection() As Integer
    On Error GoTo errP_Get_Selection

    Const FUNCTION_NAME = "P_GET_Selection"

    selection = mSelection
    
    Exit Property

errP_Get_Selection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Text (Let)
'    description:   Sets the text of the label.
'    arguments:     [in] value - new value of the label
'    return value:  -
'=========================================================================================
Public Property Let text(value As String)
    On Error GoTo errP_Let_Text

    Const FUNCTION_NAME = "P_LET_Text"

    lblText.caption = value

    Exit Property

errP_Let_Text:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Text (Get)
'    description:   Gets the text of the label.
'    arguments:     -
'    return value:  String
'=========================================================================================
Public Property Get text() As String
    On Error GoTo errP_Get_Text

    Const FUNCTION_NAME = "P_GET_Text"

    text = lblText.caption

    Exit Property

errP_Get_Text:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    function:      cmdButton_Click
'    description:   Handle the Click event of the buttons.
'    arguments:     [in] index - Index of the button
'    return value:  -
'=========================================================================================
Private Sub cmdButton_Click(index As Integer)
    On Error GoTo ErrcmdButton_Click

    Const FUNCTION_NAME = "cmdButton_Click"
    
    mSelection = index
    Unload Me
    
    Exit Sub

ErrcmdButton_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_KeyDown
'    description:   Handles the KeyDown event of the form.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errForm_KeyDown

    Const FUNCTION_NAME = "form_KeyDown"

    If KeyCode = vbKeyEscape Then
        mSelection = mEscape
        Unload Me
    End If
    
    Exit Sub

errForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_Load
'    description:   Handle the Load event of the form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load

    Const FUNCTION_NAME = "form_Load"
    
    '=variables====================================================================
    Dim hSysMenu As Long
    Dim lMenu    As Long
    '==============================================================================

    
    'don't ask why this offset is necessary!
    Me.Left = sysInfo.WorkAreaWidth / 2 - 2000
    Me.Top = sysInfo.WorkAreaHeight / 2 - 1000
        
    'disable some system menus
    'get handle to form's system menu (Restore, Maximize, Move, close etc.)
    hSysMenu = GetSystemMenu(Me.hWnd, False)
    If hSysMenu Then
        'Get system menu's menu count
        lMenu = GetMenuItemCount(hSysMenu)
        If lMenu Then
            'menu count is based on 0
            RemoveMenu hSysMenu, lMenu - 1, MF_BYPOSITION Or MF_REMOVE
            RemoveMenu hSysMenu, lMenu - 2, MF_BYPOSITION Or MF_REMOVE ' Remove the seperator

            'force caption bar's refresh. disabling close button
            DrawMenuBar Me.hWnd
        End If
    End If
    
    Exit Sub

errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_Resize
'    description:   Handle the Resize event of the form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "form_Resize"

    Dim i      As Integer
    Dim x      As Integer
    Dim tw     As Integer
    Dim lines  As Integer
    
    If cmdButton(mDefault).Visible = True Then
        cmdButton(mDefault).SetFocus
    End If
    
    '--------------------------------------------------------------------------
    ' Set the horizontal size and position of the controls.
    '--------------------------------------------------------------------------
    x = 200
    For i = 0 To MAX_BUTTONS - 1
        If cmdButton(i).Visible = True Then
            cmdButton(i).Left = x
            x = x + cmdButton(i).Width + 200
        End If
    Next
    
    Me.Width = x + 80
    lblText.Width = Me.Width - 580
    
    '--------------------------------------------------------------------------
    ' Set the vertical size and position of the controls.
    '--------------------------------------------------------------------------
    tw = Me.TextWidth(lblText.caption)
    lines = tw / lblText.Width
    lblText.Height = lines * Me.TextHeight(lblText.caption)
    
    For i = 0 To MAX_BUTTONS - 1
        cmdButton(i).Top = lblText.Height + 600
    Next
    Me.Height = cmdButton(0).Top + cmdButton(0).Height + 550
    
    Exit Sub

errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
