VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl QTable 
   ClientHeight    =   2580
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1965
   FillStyle       =   0  'Solid
   ScaleHeight     =   172
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   131
   ToolboxBitmap   =   "QTable.ctx":0000
   Begin MSComctlLib.ImageList imgKey 
      Left            =   210
      Top             =   75
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16777215
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   1
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "QTable.ctx":0532
            Key             =   "Key"
            Object.Tag             =   "Key"
         EndProperty
      EndProperty
   End
   Begin SQLStudioCCon.PicButton btnClose 
      Height          =   255
      Left            =   1620
      TabIndex        =   3
      Top             =   60
      Width           =   255
      _ExtentX        =   450
      _ExtentY        =   450
      PictureUp       =   "QTable.ctx":0A84
      PictureDown     =   "QTable.ctx":0F16
      PictureDisabled =   "QTable.ctx":13A8
   End
   Begin VB.PictureBox picScroll 
      BackColor       =   &H80000005&
      Height          =   2055
      Left            =   60
      MousePointer    =   1  'Arrow
      ScaleHeight     =   133
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   117
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   420
      Width           =   1815
      Begin VB.VScrollBar scrV 
         Height          =   1935
         Left            =   1500
         TabIndex        =   1
         TabStop         =   0   'False
         Top             =   0
         Visible         =   0   'False
         Width           =   255
      End
      Begin VB.PictureBox picColumns 
         BackColor       =   &H80000005&
         BorderStyle     =   0  'None
         FillStyle       =   0  'Solid
         Height          =   1215
         Left            =   240
         MousePointer    =   1  'Arrow
         ScaleHeight     =   81
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   53
         TabIndex        =   2
         Top             =   360
         Width           =   795
      End
   End
End
Attribute VB_Name = "QTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum QTableBorderStyleConstants
    qtaBorderStyleNone = 0
    qtaBorderStyleSingle
    qtaBorderStyleRaised
    qtaBorderStyleSunken
End Enum

Private lBorderStyle As QTableBorderStyleConstants
Private iBorderSize As Integer

Public Enum QTableAutoSizeConstants
    qtaAutoSizeNone = 0
    qtaAutoSizeWidth
    qtaAutoSizeHeight
    qtaAutoSizeBoth
End Enum

Private lAutoSize As QTableAutoSizeConstants

Private m_sCaption As String

Private bHideSelection As Boolean
Private bMultiSelect As Boolean

Private oColumns As columns

Private iMinHeight As Integer
Private iMinWidth As Integer
Private bFocus As Boolean
Private iVisibleColumns As Integer

Private Enum QTableRegionConstants
    qtaRegionNone = 0
    qtaRegionLT
    qtaRegionT
    qtaRegionRT
    qtaRegionL
    qtaRegionR
    qtaRegionLB
    qtaRegionB
    qtaRegionRB
    qtaRegionMove
End Enum

Private rRegionNoBorder As RECT
Private rRegionMove As RECT

Private lRegionMouseDown As QTableRegionConstants

Private bSize As Boolean
Private iSizeX As Integer
Private iSizeY As Integer

Private bMove As Boolean
Private iMoveX As Integer
Private iMoveY As Integer

Private bDrag As Boolean

Private oColumnAct As Column
Private oColumnMouseDown As Column
Private oColumnShift As Column

'for windows 95 and 98 use A Functions
Private m_bUseAFunctions           As Boolean

Private bRedraw As Boolean
'
' Public
'
' Events
'
Public Event Move()
Attribute Move.VB_Description = "Occurs when the position of QTable control changes."
Public Event Moved()
Attribute Moved.VB_Description = "Occurs when the position of QTable control have changed."
Public Event Resize()
Attribute Resize.VB_Description = "Occurs when the size of QTable control changes."
Public Event Resized()
Attribute Resized.VB_Description = "Occurs when the size of QTable control have changed."
Public Event ColumnClick(ByVal Column As Column)
Attribute ColumnClick.VB_Description = "Occurs when some column was click."
Public Event ColumnDblClick(ByVal Column As Column)
Attribute ColumnDblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again on a column."
Public Event ColumnMouseDown(ByVal Column As Column, button As Integer, Shift As Integer)
Attribute ColumnMouseDown.VB_Description = "Occurs when the user presses the mouse button on a column."
Public Event ColumnMouseMove(ByVal Column As Column, button As Integer, Shift As Integer)
Attribute ColumnMouseMove.VB_Description = "Occurs when the user moves the mouse on a column."
Public Event ColumnMouseUp(ByVal Column As Column, button As Integer, Shift As Integer)
Attribute ColumnMouseUp.VB_Description = "Occurs when the user releases the mouse button on a column."
Public Event CloseClick()
Attribute CloseClick.VB_Description = "Occurs when the close button was click."
Public Event Scroll()
Attribute Scroll.VB_Description = "Occurs when the user scroll in list of Column objects."
'
' Properties
'
Public Property Get borderStyle() As QTableBorderStyleConstants
Attribute borderStyle.VB_Description = "Returns/sets the border style for the control."
    borderStyle = lBorderStyle
End Property
Public Property Let borderStyle(ByVal NewVal As QTableBorderStyleConstants)
    lBorderStyle = NewVal
    PropertyChanged "BorderStyle"
    Select Case lBorderStyle
        Case qtaBorderStyleNone:    iBorderSize = 0
        Case qtaBorderStyleSingle:  iBorderSize = 1
        Case qtaBorderStyleRaised:  iBorderSize = 2
        Case qtaBorderStyleSunken:  iBorderSize = 2
    End Select
    UserControl_Resize
End Property

Public Property Get caption() As String
Attribute caption.VB_Description = "Returns/sets the text displayed in the control's title bar."
Attribute caption.VB_UserMemId = 0
    caption = m_sCaption
End Property
Public Property Let caption(ByVal NewVal As String)
    m_sCaption = NewVal
    PropertyChanged "Caption"
    drawCaption
End Property

Public Property Get columns() As columns
Attribute columns.VB_Description = "Returns a reference to a collection of Column objects in a QTable control."
    If oColumns Is Nothing Then
        Set oColumns = New columns
        Set oColumns.qTable = Me
    End If
    Set columns = oColumns
End Property

Public Property Get enabled() As Boolean
Attribute enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    enabled = UserControl.enabled
End Property
Public Property Let enabled(ByVal NewVal As Boolean)
    UserControl.enabled = NewVal
    PropertyChanged "Enabled"
End Property

Public Property Get font() As font
Attribute font.VB_Description = "Returns/Set a Font object for a QTable Control."
    Set font = UserControl.font
End Property
Public Property Set font(ByVal NewFont As font)
    Set UserControl.font = NewFont
    Set picColumns.font = NewFont
    PropertyChanged "Font"
End Property

Public Property Get hideSelection() As Boolean
Attribute hideSelection.VB_Description = "Determines whether the selected Column object(s)  will display as selected when the QTable loses focus."
    hideSelection = bHideSelection
End Property
Public Property Let hideSelection(ByVal NewVal As Boolean)
    bHideSelection = NewVal
    PropertyChanged "HideSelection"
End Property

Public Property Get multiSelect() As Boolean
Attribute multiSelect.VB_Description = "Returns/sets a value indicating whether a user can make multiple selections in the QTable control."
    multiSelect = bMultiSelect
End Property
Public Property Let multiSelect(ByVal NewVal As Boolean)
    bMultiSelect = NewVal
    PropertyChanged "MultiSelect"
End Property

Public Property Get autoSize() As QTableAutoSizeConstants
Attribute autoSize.VB_Description = "Determines whether a control is automatically resized to display its entire contents."
    autoSize = lAutoSize
End Property
Public Property Let autoSize(ByVal NewVal As QTableAutoSizeConstants)
    lAutoSize = NewVal
    PropertyChanged "AutoSize"
End Property

Public Property Get selectedColumn() As Column
Attribute selectedColumn.VB_Description = "Returns a reference to the currently selected Column object."
    Dim oColumn As Column
    Set selectedColumn = Nothing
    For Each oColumn In oColumns
        If oColumn.selected Then
            Set selectedColumn = oColumn
            Exit For
        End If
    Next
End Property
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns the window handle to the QTable control."

    hWnd = UserControl.hWnd
    
End Property
Public Property Get redraw() As Boolean

    redraw = bRedraw
    
End Property
Public Property Let redraw(ByVal NewVal As Boolean)

    bRedraw = NewVal
    
End Property
'
' Methods
'
Public Function sizeToFit(ByVal autoSize As QTableAutoSizeConstants)
Attribute sizeToFit.VB_Description = "Size the QTable control to fit size to show all column objects."
    fitSize autoSize
End Function

Public Function hitTest(ByVal x As Single, ByVal y As Single) As Column
Attribute hitTest.VB_Description = "Returns a reference to the Column object located at the oordinates of x and y."
    Set hitTest = testHit(ScaleX(x, vbTwips, vbPixels), ScaleY(y, vbTwips, vbPixels))
End Function

Public Function getColumnPos(ByVal index As Variant, _
                        X1 As Single, _
                        X2 As Single, _
                        y As Single)
Attribute getColumnPos.VB_Description = "Returns the position of a specified Column object."
                        
    Dim iYOffset As Integer
    Dim iY As Integer
    
    iYOffset = iMinHeight + iBorderSize + (iMinHeight \ 2) + 6
    
    iY = iYOffset + ((oColumns.item(index).index - 1) * iMinHeight) - (scrV.value * iMinHeight)
    
    If iY < 0 Then iY = 0
    If iY > ScaleHeight Then iY = ScaleHeight
    
    X1 = Extender.Left
    X2 = Extender.Left + Extender.Width
    y = Extender.Top + ScaleY(iY, vbPixels, getScaleMode())
End Function
Public Function refresh()
Attribute refresh.VB_Description = "Forces a complete repaint of a QTable control."

    draw
    
End Function
Public Function cleanUp()

    If Not oColumns Is Nothing Then
        oColumns.cleanUp
        Set oColumns = Nothing
    End If
    Set oColumnAct = Nothing
    Set oColumnMouseDown = Nothing
    Set oColumnShift = Nothing
        
End Function
'
' Private
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    Dim tm As TEXTMETRIC
    
    scrV.Top = 0
    scrV.Width = getSystemMetrics(SM_CXVSCROLL)
    
    picColumns.Move 0, 0, 0, 0
    
    getTextMetrics hDC, tm
    iMinHeight = tm.tmHeight
    iMinWidth = 2 * iMinHeight
    
    btnClose.Width = iMinHeight - 1
    btnClose.Height = iMinHeight - 1
    
    lBorderStyle = qtaBorderStyleRaised
    iBorderSize = 2
    m_sCaption = "Table"
    bHideSelection = True
    bMultiSelect = False
    lAutoSize = qtaAutoSizeNone
    
    Set oColumns = Nothing
    Set oColumnAct = Nothing
    Set oColumnMouseDown = Nothing
    Set oColumnShift = Nothing
    
    'use a functions for win95/98
    If m_oComFunc.getPlatformID() = Win95_98 Then
    
        m_bUseAFunctions = True
    Else
        m_bUseAFunctions = False
    End If
    
    bRedraw = True
    
End Sub
Private Sub UserControl_Resize()


    Dim iWidth As Integer
    Dim iHeight As Integer
    
    'just resize if we have a valid control filled with columns
    If oColumns Is Nothing Then Exit Sub
    
    iWidth = ScaleWidth - 2 * iBorderSize - 2
    If iWidth < 0 Then iWidth = 0
    
    iHeight = ScaleHeight - iMinHeight - 2 * iBorderSize - 4
    If iHeight < 0 Then iHeight = 0
    
    btnClose.Move ScaleWidth - iBorderSize - btnClose.Width - 2, iBorderSize + 2
    
    picScroll.Move iBorderSize + 1, iMinHeight + iBorderSize + 3, iWidth, iHeight
    picScroll.Visible = (iWidth > 0) And (iHeight > 0)
    
    setRegions
    
    RaiseEvent Resize
End Sub

Private Sub UserControl_Paint()
    drawBorder
    drawCaption
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    
    With PropBag
        borderStyle = .ReadProperty("BorderStyle", qtaBorderStyleRaised)
        caption = .ReadProperty("Caption", "Table")
        enabled = .ReadProperty("Enabled")
        Set font = .ReadProperty("Font")
        hideSelection = .ReadProperty("HideSelection", True)
        multiSelect = .ReadProperty("MultiSelect", False)
        autoSize = .ReadProperty("AutoSize", qtaAutoSizeNone)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "BorderStyle", borderStyle, qtaBorderStyleRaised
        .WriteProperty "Caption", caption, "Table"
        .WriteProperty "Enabled", enabled
        .WriteProperty "Font", font
        .WriteProperty "HideSelection", hideSelection, True
        .WriteProperty "MultiSelect", multiSelect, False
        .WriteProperty "AutoSize", autoSize, qtaAutoSizeNone
    End With
End Sub

Private Sub UserControl_EnterFocus()
    Dim oColumn As Column
    
    If Not Ambient.UserMode Then Exit Sub
    
    If oColumns Is Nothing Then Exit Sub
    
    bFocus = True
    drawBorder
    drawCaption
    
    If bHideSelection Then
        For Each oColumn In oColumns
            If oColumn.selected Then
                drawColumn oColumn
            End If
        Next
    End If
End Sub

Private Sub UserControl_ExitFocus()
    Dim oColumn As Column

    If Not Ambient.UserMode Then Exit Sub

    If oColumns Is Nothing Then Exit Sub

    bFocus = False
    drawBorder
    drawCaption

    If bHideSelection Then
        For Each oColumn In oColumns
            If oColumn.selected Then
                drawColumn oColumn, True
            End If
        Next
    End If
End Sub

Private Sub UserControl_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    If Not Ambient.UserMode Then Exit Sub
    
    Extender.ZOrder 0
    
    If (button And vbLeftButton) = vbLeftButton Then
        bSize = False
        bMove = False
        lRegionMouseDown = findRegion(x, y)
        Select Case lRegionMouseDown
            Case qtaRegionLT:
                iSizeX = x
                iSizeY = y
                bSize = True
            Case qtaRegionT
                If (lAutoSize And qtaAutoSizeHeight) = 0 Then
                    iSizeY = y
                    bSize = True
                End If
            Case qtaRegionRT:
                iSizeX = ScaleWidth - x
                iSizeY = y
                bSize = True
            Case qtaRegionL
                If (lAutoSize And qtaAutoSizeWidth) = 0 Then
                    iSizeX = x
                    bSize = True
                End If
            Case qtaRegionR
                If (lAutoSize And qtaAutoSizeWidth) = 0 Then
                    iSizeX = ScaleWidth - x
                    bSize = True
                End If
            Case qtaRegionLB:
                iSizeX = x
                iSizeY = ScaleHeight - y
                bSize = True
            Case qtaRegionB
                If (lAutoSize And qtaAutoSizeHeight) = 0 Then
                    iSizeY = ScaleHeight - y
                    bSize = True
                End If
            Case qtaRegionRB:
                iSizeX = ScaleWidth - x
                iSizeY = ScaleHeight - y
                bSize = True
            Case qtaRegionMove:
                iMoveX = x
                iMoveY = y
                bMove = True
            Case qtaRegionNone:
        End Select
    End If
End Sub

Private Sub UserControl_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    Dim iX As Integer
    Dim iY As Integer
    Dim iW As Integer
    Dim iH As Integer
    Dim iScaleMode As Integer
    
    If Not Ambient.UserMode Then Exit Sub
    
    If Not (bSize Or bMove) Then
        Select Case findRegion(x, y)
            Case qtaRegionLT:
                If (lAutoSize And qtaAutoSizeBoth) = 0 Then
                    MousePointer = vbSizeNWSE
                End If
            Case qtaRegionRT:
                If (lAutoSize And qtaAutoSizeBoth) = 0 Then
                    MousePointer = vbSizeNESW
                End If
            Case qtaRegionLB:
                If (lAutoSize And qtaAutoSizeBoth) = 0 Then
                    MousePointer = vbSizeNESW
                End If
            Case qtaRegionRB:
                If (lAutoSize And qtaAutoSizeBoth) = 0 Then
                    MousePointer = vbSizeNWSE
                End If
            Case qtaRegionL, qtaRegionR:
                If (lAutoSize And qtaAutoSizeWidth) = 0 Then
                    MousePointer = vbSizeWE
                End If
            Case qtaRegionT, qtaRegionB:
                If (lAutoSize And qtaAutoSizeHeight) = 0 Then
                    MousePointer = vbSizeNS
                End If
            Case qtaRegionNone:
                MousePointer = vbArrow
            Case qtaRegionMove:
                MousePointer = vbCustom
        End Select
    End If
    
    If bMove Then
        iX = x - iMoveX
        iY = y - iMoveY
        With Extender
            .Move .Left + iX, .Top + iY
        End With
        RaiseEvent Move
    End If
    
    If bSize Then
        iScaleMode = getScaleMode()
        
        iX = ScaleX(x - iSizeX, vbPixels, iScaleMode)
        iY = ScaleY(y - iSizeY, vbPixels, iScaleMode)
        iW = ScaleX(x + iSizeX, vbPixels, iScaleMode)
        iH = ScaleY(y + iSizeY, vbPixels, iScaleMode)
        
        With Extender
            If .Width - iX < (iMinWidth + 2 * iBorderSize + 2) Then iX = 0
            If .Height - iY < (iMinHeight + 2 * iBorderSize + 3) Then iY = 0
            If iW < (iMinWidth + 2 * iBorderSize + 2) Then iW = (iMinWidth + 2 * iBorderSize + 2)
            If iH < (iMinHeight + 2 * iBorderSize + 3) Then iH = (iMinHeight + 2 * iBorderSize + 3)
                        
            If (lAutoSize And qtaAutoSizeWidth) = qtaAutoSizeWidth Then
                iX = 0
                iW = .Width
            End If

            If (lAutoSize And qtaAutoSizeHeight) = qtaAutoSizeHeight Then
                iY = 0
                iH = .Height
            End If

            Select Case lRegionMouseDown
                Case qtaRegionLT:   .Move .Left + iX, .Top + iY, .Width - iX, .Height - iY
                Case qtaRegionL:    .Move .Left + iX, .Top, .Width - iX
                Case qtaRegionLB:   .Move .Left + iX, .Top, .Width - iX, iH
                Case qtaRegionRT:   .Move .Left, .Top + iY, iW, .Height - iY
                Case qtaRegionR:    .Width = iW
                Case qtaRegionRB:   .Move .Left, .Top, iW, iH
                Case qtaRegionT:    .Move .Left, .Top + iY, .Width, .Height - iY
                Case qtaRegionB:    .Height = iH
            End Select
        End With
    End If
End Sub

Private Sub UserControl_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    
    If Not Ambient.UserMode Then Exit Sub
    
    If bMove Then
        RaiseEvent Moved
        bMove = False
    End If
    If bSize Then
        RaiseEvent Resized
        bSize = False
    End If
End Sub
'
' btnClose
'
Private Sub btnClose_Click()
    If Not Ambient.UserMode Then Exit Sub
    
    RaiseEvent CloseClick
End Sub
'
' picScroll
'
Private Sub picScroll_Resize()
    Dim iWidth As Integer
        
    iWidth = picScroll.ScaleWidth
    If iWidth < 0 Then iWidth = 0
    picColumns.Width = iWidth
    
    scrV.Left = picScroll.ScaleWidth - scrV.Width
    scrV.Height = picScroll.ScaleHeight
    
    iVisibleColumns = picScroll.ScaleHeight \ iMinHeight
    
    setScrollBar
End Sub

Private Sub picScroll_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    Extender.ZOrder 0
End Sub
'
' picColumns
'
Private Sub picColumns_Paint()
    drawColumns
End Sub

Private Sub picColumns_Resize()
    drawColumns
End Sub

Private Sub picColumns_DblClick()
    If Not Ambient.UserMode Then Exit Sub
    
    If Not oColumnAct Is Nothing Then
        RaiseEvent ColumnDblClick(oColumnAct)
    End If
End Sub

Private Sub picColumns_MouseDown(button As Integer, Shift As Integer, x As Single, y As Single)
    If Not Ambient.UserMode Then Exit Sub
    
    Extender.ZOrder 0
    
    Set oColumnMouseDown = findColumnByPos(x, y)
    If Not oColumnMouseDown Is Nothing Then
        If Not bMultiSelect Then
            If Not oColumnAct Is Nothing Then
                If oColumnAct.index <> oColumnMouseDown.index Then
                    oColumnAct.selected = False
                End If
            End If
            oColumnMouseDown.selected = True
        Else
            If (Shift And vbShiftMask) = vbShiftMask Then
                If Not oColumnAct Is Nothing Then
                    If oColumnShift Is Nothing Then
                        Set oColumnShift = oColumnAct
                    End If
                    selectColumns oColumnShift.index, oColumnMouseDown.index
                End If
            ElseIf (Shift And vbCtrlMask) = vbCtrlMask Then
                oColumnMouseDown.selected = Not oColumnMouseDown.selected
            Else
                Set oColumnShift = Nothing
                unselectAll
                oColumnMouseDown.selected = True
            End If
        End If
        
        RaiseEvent ColumnMouseDown(oColumnMouseDown, button, Shift)
    
        Set oColumnAct = oColumnMouseDown
    End If
End Sub

Private Sub picColumns_MouseMove(button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oColumnMouseMove As Column
    
    If Not Ambient.UserMode Then Exit Sub
    
    Set oColumnMouseMove = findColumnByPos(x, y)
    If Not oColumnMouseMove Is Nothing Then
        RaiseEvent ColumnMouseMove(oColumnMouseMove, button, Shift)
    End If
    
    picColumns.MousePointer = vbArrow
End Sub

Private Sub picColumns_MouseUp(button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oColumnMouseUp As Column
   
    If Not Ambient.UserMode Then Exit Sub
   
    Set oColumnMouseUp = findColumnByPos(x, y)
    If Not oColumnMouseUp Is Nothing Then
        RaiseEvent ColumnMouseUp(oColumnMouseUp, button, Shift)
    End If
    
    If Not oColumnMouseDown Is Nothing Then
        RaiseEvent ColumnClick(oColumnMouseDown)
        Set oColumnMouseDown = Nothing
    End If
End Sub

Private Sub picColumns_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim iColumnAct As Integer
    Dim oColumnNew As Column
    
    If Not Ambient.UserMode Then Exit Sub
    
    If oColumns Is Nothing Then Exit Sub
    If oColumns.count = 0 Then Exit Sub
    
    If (Shift And vbCtrlMask) = vbCtrlMask Then
        If KeyCode = vbKeyA Then
            Set oColumnAct = oColumns.item(1)
            selectAll
            Exit Sub
        End If
    End If
    
    If oColumnAct Is Nothing Then
        Set oColumnAct = oColumns.item(1)
        oColumnAct.selected = True
        Exit Sub
    End If
    
    iColumnAct = oColumnAct.index

    Select Case KeyCode
        Case vbKeyDown:
            If iColumnAct < oColumns.count Then
                iColumnAct = iColumnAct + 1
            End If
        Case vbKeyUp:
            If iColumnAct > 1 Then
                iColumnAct = iColumnAct - 1
            End If
        Case vbKeyHome:
            iColumnAct = 1
        Case vbKeyEnd:
            iColumnAct = oColumns.count
        Case vbKeyPageDown:
            If iColumnAct < (oColumns.count - (iVisibleColumns - 1)) Then
                iColumnAct = iColumnAct + iVisibleColumns - 1
            Else
                iColumnAct = oColumns.count
            End If
        Case vbKeyPageUp:
            If iColumnAct > (iVisibleColumns - 1) Then
                iColumnAct = iColumnAct - (iVisibleColumns - 1)
            Else
                iColumnAct = 1
            End If
        
        Case Else:      Exit Sub
    End Select
    
    If iColumnAct <= scrV.value Then
        scrV.value = iColumnAct - 1
    Else
        If iColumnAct > scrV.value + iVisibleColumns Then
            scrV.value = iColumnAct - iVisibleColumns
        End If
    End If
            
    If iColumnAct >= 1 And iColumnAct <= oColumns.count Then
        Set oColumnNew = oColumns.item(iColumnAct)
        If Not bMultiSelect Then
            oColumnAct.selected = False
        Else
            If (Shift And vbShiftMask) = vbShiftMask Then
                If oColumnShift Is Nothing Then
                    Set oColumnShift = oColumnAct
                End If
                selectColumns oColumnShift.index, oColumnNew.index
            Else
                Set oColumnShift = Nothing
                unselectAll
            End If
        End If
        Set oColumnAct = oColumnNew
        oColumnAct.selected = True
    End If
End Sub
'
' Events Vertical Scroll
'
Private Sub scrV_Change()
    If Not Ambient.UserMode Then Exit Sub
    
    picColumns.Top = -scrV.value * iMinHeight
    RaiseEvent Scroll
End Sub

Private Sub scrV_Scroll()
    If Not Ambient.UserMode Then Exit Sub
    
    picColumns.Top = -scrV.value * iMinHeight
    RaiseEvent Scroll
End Sub
'
' Sub/Functions
'
Private Function draw()
    If Not bRedraw Then Exit Function
    drawBorder
    drawCaption
    drawColumns
End Function

Private Function drawBorder()
    Dim r As RECT
    
    If Not bRedraw Then Exit Function
    
    'just DrawBorder if we have a valid control filled with columns
    If oColumns Is Nothing Then Exit Function
    
    Cls
    
    Select Case lBorderStyle
        Case qtaBorderStyleNone:
        Case qtaBorderStyleSingle:
            r.Left = 0
            r.Top = 0
            r.Right = ScaleWidth
            r.Bottom = ScaleHeight
            DrawEdge hDC, r, BDR_RAISEDOUTER, BF_RECT + BF_MONO
        Case qtaBorderStyleRaised:
            r.Left = 0
            r.Top = 0
            r.Right = ScaleWidth
            r.Bottom = ScaleHeight
            DrawEdge hDC, r, EDGE_RAISED, BF_RECT + BF_SOFT
        Case qtaBorderStyleSunken:
            r.Left = 0
            r.Top = 0
            r.Right = ScaleWidth
            r.Bottom = ScaleHeight
            DrawEdge hDC, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
    End Select
End Function

Private Function drawCaption()

    Dim r As RECT
    Dim lBackColor As Long
    Dim lForeColor As Long
    Dim bCaption() As Byte
    
    If Not bRedraw Then Exit Function
    
    'just resize if we have a valid control filled with columns
    If oColumns Is Nothing Then Exit Function
    
    If bFocus Then
        lBackColor = vbActiveTitleBar
        lForeColor = vbTitleBarText
    Else
        lBackColor = vbInactiveTitleBar
        lForeColor = vbInactiveCaptionText
    End If
    
    r.Left = iBorderSize + 1
    r.Top = iBorderSize + 1
    r.Right = ScaleWidth - 2 * iBorderSize
    r.Bottom = r.Top + iMinHeight
    
    foreColor = lBackColor
    FillColor = lBackColor
    rectangle hDC, r.Left, r.Top, r.Right, r.Bottom

    r.Left = r.Left + 2
    r.Right = r.Right - btnClose.Width - 4
    
    foreColor = lForeColor
    
    '// Unicode problem: DrawText hdc, m_sCaption, Len(m_sCaption), r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    '// CSS[0120024545 0000639817 2000]
    If m_bUseAFunctions Then
    
        DrawTextA hDC, m_sCaption, -1, r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    Else
        bCaption = m_sCaption + vbNullChar
        DrawTextW hDC, bCaption(0), -1, r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    End If
    
    FillColor = vbButtonFace
End Function

Private Function drawColumns(Optional ByVal bHide As Boolean)
    Dim oColumn As Column
    
    If Not bRedraw Then Exit Function
    
    On Error Resume Next
    
    If oColumns Is Nothing Then Exit Function
    If oColumns.count = 0 Then Exit Function
    
    fitSize lAutoSize
    
    setScrollBar
    
    If picColumns.Height <> oColumns.count * iMinHeight Then
        picColumns.Height = oColumns.count * iMinHeight
    End If
    
    picColumns.Cls
    
    For Each oColumn In oColumns
        drawColumn oColumn, bHide
    Next
End Function

Friend Function drawColumn(ByVal oColumn As Column, Optional ByVal bHide As Boolean)

    Dim r As RECT
    Dim lBackColor As Long
    Dim lForeColor As Long
    Dim iPicWidth As Integer
    Dim iPicHeight As Integer
    Dim x As Long
    Dim y As Long
    Dim bCaption() As Byte
    
    If Not bRedraw Then Exit Function
    
    On Error Resume Next
    
    r.Left = 0
    r.Right = picColumns.ScaleWidth
    
    If scrV.Visible Then
        r.Right = r.Right - scrV.Width
    End If
    
    r.Top = iMinHeight * (oColumn.index - 1)
    r.Bottom = r.Top + iMinHeight
    
    If oColumn.selected And Not bHide Then
        lBackColor = oColumn.selectedBackColor 'vbHighlight
        lForeColor = oColumn.selectedForeColor 'vbHighlightText
    Else
        lBackColor = oColumn.backColor 'vbWindowBackground
        lForeColor = oColumn.foreColor 'vbWindowText
    End If
    
    picColumns.foreColor = lBackColor
    picColumns.FillColor = lBackColor
    rectangle picColumns.hDC, r.Left, r.Top, r.Right, r.Bottom
    
    r.Left = r.Left + 2
    r.Right = r.Right - 2
    
    If Not imgKey Is Nothing Then
        iPicWidth = imgKey.ImageWidth
        iPicHeight = imgKey.ImageHeight
        If Not IsMissing(oColumn.image) Then
            x = r.Left
            y = r.Top + ((r.Bottom - r.Top) - iPicHeight) \ 2
            ImageList_Draw imgKey.hImageList, _
                           imgKey.ListImages(oColumn.image).index - 1, _
                           picColumns.hDC, x, y, ILD_TRANSPARENT

        End If
        r.Left = r.Left + iPicWidth + 2
    End If
    
    picColumns.foreColor = lForeColor
    
    
    '// Unicode problem: DrawText picColumns.hdc, oColumn.Text, Len(oColumn.Text), r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    '// CSS[0120024545 0000639817 2000]
    If m_bUseAFunctions Then
    
        DrawTextA picColumns.hDC, oColumn.text, -1, r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    Else
        bCaption = oColumn.text + vbNullChar
        DrawTextW picColumns.hDC, bCaption(0), -1, r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_NOPREFIX + DT_WORD_ELLIPSIS
    End If
    
End Function

Private Function findColumnByPos(ByVal x As Integer, ByVal y As Integer) As Column
    Dim i As Integer
    
    Set findColumnByPos = Nothing
    
    If oColumns Is Nothing Then Exit Function
    If oColumns.count = 0 Then Exit Function
    
    i = y \ iMinHeight
    If y Mod iMinHeight > 0 Then i = i + 1
    
    If i >= 1 And i <= oColumns.count Then
        Set findColumnByPos = oColumns.item(i)
    End If
End Function

Private Function setRegions()
    With rRegionNoBorder
        .Left = iBorderSize + 1
        .Top = iBorderSize + 1
        .Right = ScaleWidth - iBorderSize - 1
        .Bottom = ScaleHeight - iBorderSize - 1
    End With
    
    With rRegionMove
        .Left = iBorderSize + 1
        .Top = iBorderSize + 1
        .Right = ScaleWidth - 2 * iBorderSize
        .Bottom = .Top + iMinHeight
    End With
End Function

Private Function findRegion(ByVal x As Integer, ByVal y As Integer) As QTableRegionConstants
    Dim lRegion As QTableRegionConstants
    
    lRegion = qtaRegionNone
    
    If inRect(rRegionMove, x, y) Then
        lRegion = qtaRegionMove
    Else
        If Not inRect(rRegionNoBorder, x, y) Then
            If x < scrV.Width Then                          ' left
                If y < scrV.Width Then                      '   top
                    lRegion = qtaRegionLT
                ElseIf y > ScaleHeight - scrV.Width Then    '   bottom
                    lRegion = qtaRegionLB
                Else                                        '   left
                    lRegion = qtaRegionL
                End If
            ElseIf x > ScaleWidth - scrV.Width Then         ' right
                If y < scrV.Width Then                      '   top
                    lRegion = qtaRegionRT
                ElseIf y > ScaleHeight - scrV.Width Then    '   bottom
                    lRegion = qtaRegionRB
                Else                                        '   right
                    lRegion = qtaRegionR
                End If
            Else                                            ' top/bottom
                If y < scrV.Width Then                      '   top
                    lRegion = qtaRegionT
                ElseIf y > ScaleHeight - scrV.Width Then    '   bottom
                    lRegion = qtaRegionB
                End If
            End If
        End If
    End If
    
    findRegion = lRegion
End Function

Private Function inRect(r As RECT, ByVal x As Integer, ByVal y As Integer)
    If x >= r.Left And x <= r.Right And _
       y >= r.Top And y <= r.Bottom Then
        inRect = True
    Else
        inRect = False
    End If
End Function

Private Function setScrollBar()
    If oColumns Is Nothing Then Exit Function
    If oColumns.count = 0 Then Exit Function
    
    If oColumns.count > iVisibleColumns Then
        scrV.Visible = True
        scrV.Max = oColumns.count - iVisibleColumns
        If iVisibleColumns > 0 Then
            scrV.LargeChange = iVisibleColumns
        End If
    Else
        scrV.Visible = False
        scrV.Max = 0
    End If
End Function

Private Function selectAll()
    Dim oColumn As Column
    
    If oColumns Is Nothing Then Exit Function
    
    For Each oColumn In oColumns
        If Not oColumn.selected Then
            oColumn.selected = True
        End If
    Next
End Function

Private Sub unselectAll()


    Dim oColumn As Column
    
    If oColumns Is Nothing Then Exit Sub
    
    For Each oColumn In oColumns
        If oColumn.selected Then
            oColumn.selected = False
        End If
    Next
    
End Sub

Private Function selectColumns(ByVal Index1 As Long, ByVal Index2 As Long)
    Dim oColumn As Column
    Dim l As Long
    
    If oColumns Is Nothing Then Exit Function
    
    If Index2 < Index1 Then
        l = Index1
        Index1 = Index2
        Index2 = l
    End If
    
    For l = 1 To Index1 - 1
        If oColumns.item(l).selected Then
            oColumns.item(l).selected = False
        End If
    Next
        
    For l = Index1 To Index2
        oColumns.item(l).selected = True
    Next
    
    For l = Index2 + 1 To oColumns.count
        If oColumns.item(l).selected Then
            oColumns.item(l).selected = False
        End If
    Next
End Function

Private Function fitSize(ByVal lFitSize As QTableAutoSizeConstants)
    Dim iWidth As Long
    Dim iHeight As Integer
    Dim oColumn As Column
    Dim iMax As Integer
    Dim r As RECT
    Dim iTW As Integer
    
    If oColumns Is Nothing Then Exit Function
    
    If (lFitSize And qtaAutoSizeWidth) = qtaAutoSizeWidth Then
        r.Left = 0
        r.Top = 0
        
        iMax = 0
        
        iTW = UserControl.TextWidth(m_sCaption)
        If iMax < iTW Then iMax = iTW
        
        For Each oColumn In oColumns
            iTW = picColumns.TextWidth(oColumn.text)
            If iMax < iTW Then iMax = iTW
        Next
        
        If Not imgKey Is Nothing Then
            iMax = iMax + imgKey.ImageWidth + 2
        End If
            
        iWidth = (2 * iBorderSize + 10 + iMax + scrV.Width) * Screen.TwipsPerPixelX
        If iWidth <> Width Then
            Width = iWidth
        End If
    End If

    If (lFitSize And qtaAutoSizeHeight) = qtaAutoSizeHeight Then
        iHeight = (2 * iBorderSize + 8 + oColumns.count * iMinHeight + iMinHeight) * Screen.TwipsPerPixelY
        If iHeight <> Height Then
            Height = iHeight
        End If
    End If
End Function
Private Function testHit(ByVal x As Integer, ByVal y As Integer) As Column

    Dim iX As Integer
    Dim iY As Integer
    Dim i As Integer
    
    Set testHit = Nothing
    
    If oColumns Is Nothing Then Exit Function
    If oColumns.count = 0 Then Exit Function
    
    If x < picScroll.Left Or x > picScroll.Left + picScroll.Width Or _
       y < picScroll.Top Or y > picScroll.Top + picScroll.Height Then
        Exit Function
    End If
    
    iX = x - picScroll.Left
    iY = y - picScroll.Top + scrV.value * iMinHeight
    
    i = iY \ iMinHeight
    If (iY Mod iMinHeight) > 0 Then i = i + 1
        
    If i > 0 And i <= oColumns.count Then
        Set testHit = oColumns.item(i)
    End If
    
End Function
Private Function getScaleMode() As Integer
    On Error Resume Next
    
    getScaleMode = Extender.Container.ScaleMode
    If Err.Number Then
        getScaleMode = vbTwips
    End If
    
End Function
