VERSION 5.00
Begin VB.UserControl MiscDefinition 
   ClientHeight    =   2760
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   12750
   ClipControls    =   0   'False
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   2760
   ScaleWidth      =   12750
   Begin VB.Frame fraOthers 
      Caption         =   "Others"
      Height          =   1590
      Left            =   8924
      OLEDropMode     =   1  'Manual
      TabIndex        =   11
      Top             =   1050
      Width           =   3460
      Begin VB.CheckBox chkIdentUpperCase 
         Caption         =   "Identifiers uppercase"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   14
         TabStop         =   0   'False
         Top             =   1100
         Width           =   2535
      End
      Begin VB.CheckBox chkIgnoreRollback 
         Caption         =   "Ignore Rollback"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   13
         TabStop         =   0   'False
         Top             =   700
         Width           =   1800
      End
      Begin VB.CheckBox chkTemporary 
         Caption         =   "Temporary Table"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   12
         TabStop         =   0   'False
         Top             =   300
         Width           =   1800
      End
   End
   Begin VB.Frame fraDuplicates 
      Caption         =   "Duplicates"
      Height          =   2640
      Left            =   6739
      OLEDropMode     =   1  'Manual
      TabIndex        =   2
      Top             =   0
      Width           =   2004
      Begin VB.OptionButton rbUpdate 
         Caption         =   "Update"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   6
         TabStop         =   0   'False
         Top             =   1900
         Width           =   1505
      End
      Begin VB.OptionButton rbIgnore 
         Caption         =   "Ignore"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   1400
         Width           =   1505
      End
      Begin VB.OptionButton rbReject 
         Caption         =   "Reject"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   4
         TabStop         =   0   'False
         Top             =   900
         Width           =   1505
      End
      Begin VB.OptionButton rbNothing 
         Caption         =   "Nothing Defined"
         Height          =   330
         Left            =   250
         OLEDropMode     =   1  'Manual
         TabIndex        =   3
         TabStop         =   0   'False
         Top             =   400
         Value           =   -1  'True
         Width           =   1505
      End
   End
   Begin VB.Frame fraComment 
      Caption         =   "Comment"
      ClipControls    =   0   'False
      Height          =   2640
      Left            =   0
      OLEDropMode     =   1  'Manual
      TabIndex        =   0
      Top             =   0
      Width           =   6557
      Begin VB.TextBox txtComment 
         Height          =   2050
         Left            =   200
         MultiLine       =   -1  'True
         OLEDropMode     =   1  'Manual
         ScrollBars      =   2  'Vertical
         TabIndex        =   1
         TabStop         =   0   'False
         Top             =   350
         Width           =   6050
      End
   End
   Begin VB.Frame fraStatistics 
      Caption         =   "Statistics"
      Height          =   960
      Left            =   8924
      OLEDropMode     =   1  'Manual
      TabIndex        =   7
      Top             =   0
      Width           =   3460
      Begin VB.ComboBox cbSampleUnit 
         Height          =   330
         ItemData        =   "MiscDefinition.ctx":0000
         Left            =   2200
         List            =   "MiscDefinition.ctx":0002
         OLEDropMode     =   1  'Manual
         Style           =   2  'Dropdown List
         TabIndex        =   10
         TabStop         =   0   'False
         Top             =   380
         Width           =   1000
      End
      Begin VB.TextBox txtSampleValue 
         Alignment       =   2  'Center
         Height          =   315
         Left            =   1500
         MaxLength       =   5
         OLEDropMode     =   1  'Manual
         TabIndex        =   9
         TabStop         =   0   'False
         Top             =   380
         Width           =   600
      End
      Begin VB.Label lblSampleValue 
         Caption         =   "Sample Value:"
         Height          =   330
         Left            =   255
         OLEDropMode     =   1  'Manual
         TabIndex        =   8
         Top             =   420
         Width           =   1380
      End
   End
End
Attribute VB_Name = "MiscDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      MiscDefinition.ctl
'
'========================================================================================
'
' responsible:    WolfgangA
'
' special area:   SQLStudio
'
' description:    Control for defining misc attributes of a table.
'
'========================================================================================

Option Explicit

Const MODULE_NAME = "SQLStudio.MiscDefinitionControl"

'==============================================================================
' Event declarations
'==============================================================================
Event popupTableMenu()
Event ResetFocus()
Event Dropped()

Event IdentifiersUpperCase(bUpperCase As Boolean)

'==============================================================================
' Private member variables.
'==============================================================================
Private m_cTableDef                 As Long
Private m_cOldTableDef              As Long
Private m_lOldWidth                 As Long
Private m_lOldHeight                As Long

Private m_bReadOnly                 As Boolean

'=========================================================================================
'    property:      tableDef (Let)
'    description:   Sets the value of the private member m_cTableDef to the given value.
'    arguments:     [in] vData - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let tableDef(vData As Long)
    On Error GoTo errP_SET_TableDef

    Const FUNCTION_NAME = "p_Set tableDef"
    
    Dim bArray()        As Byte
    
    m_cTableDef = vData
    
    '--------------------------------------------------------------------------
    ' Init the sample unit member of the table definition object.
    '--------------------------------------------------------------------------
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setSampleUnit m_cTableDef, StrPtr(LoadResString(141))
    'convert string to ucs2 byte array and pass it to function
    bArray = LoadResString(141) & vbNullChar
    table_setSampleUnit m_cTableDef, bArray(0)
    cbSampleUnit.ListIndex = 1
    
    If table_mode(m_cTableDef) = AlterTable Then
        chkTemporary.Enabled = False
    End If
    
    Exit Property
    
errP_SET_TableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      tableDef (Get)
'    description:   Gets the value of the private member m_cTableDef.
'    arguments:     -
'    return value:  Long
'=========================================================================================
Public Property Get tableDef() As Long
    On Error GoTo errP_Get_TableDef

    Const FUNCTION_NAME = "G_Get tableDef"
    
    tableDef = m_cTableDef
    
    Exit Property
    
errP_Get_TableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      oldTableDef (Let)
'    description:   Sets the value of the private member m_cOldTableDef to the given value.
'    arguments:     [in] vData - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let oldTableDef(vData As Long)
    On Error GoTo errP_SET_OldTableDef

    Const FUNCTION_NAME = "p_Set oldTableDef"
    
    m_cOldTableDef = vData
    
    Exit Property
    
errP_SET_OldTableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      oldTableDef (Get)
'    description:   Gets the value of the private member m_cOldTableDef.
'    arguments:     -
'    return value:  Long
'=========================================================================================
Public Property Get oldTableDef() As Long
    On Error GoTo errP_Get_OldTableDef

    Const FUNCTION_NAME = "G_Get oldTableDef"
    
    oldTableDef = m_cOldTableDef
    
    Exit Property
    
errP_Get_OldTableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      cbSampleUnit_Click
'    description:   Handles the Click event of the combobox cbSampleUnit. Stores the
'                   selected item when an entry of the combo box is selected.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub cbSampleUnit_Click()
    On Error GoTo errCbSampleUnit_Click
    
    Const FUNCTION_NAME = "cbSampleUnit_Click"

    Dim bArray() As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setSampleUnit m_cTableDef, StrPtr(cbSampleUnit.text)
    'convert string to ucs2 byte array and pass it to function
    bArray = cbSampleUnit.text & vbNullChar
    table_setSampleUnit m_cTableDef, bArray(0)
    
    Exit Sub
    
errCbSampleUnit_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      cbSampleUnit_KeyDown
'    description:   Handles the KeyDown event of the combobox cbSampleUnit.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub cbSampleUnit_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errCbSampleUnit_KeyDown
    
    Const FUNCTION_NAME = "cbSampleUnit_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the Temporary Table check button.
            '------------------------------------------------------------------
            chkTemporary.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the Sample Value entry.
            '------------------------------------------------------------------
            txtSampleValue.SetFocus
        End If
    End If
    
    Exit Sub
    
errCbSampleUnit_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cbSampleUnit_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the combobox cbSampleUnit. The event
'                   is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub cbSampleUnit_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errCbSampleUnit_OLEDragDrop
    
    Const FUNCTION_NAME = "cbSampleUnit_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errCbSampleUnit_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIgnoreRollback_Click
'    description:   Handles the Click event of the check button "Ignore Rollback".
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub chkIgnoreRollback_Click()
    On Error GoTo errChkIgnoreRollback_Click
    
    Const FUNCTION_NAME = "chkIgnoreRollback_Click"

    If chkIgnoreRollback.value = 1 Then
        table_setIgnoreRollback m_cTableDef, SAPDB_TRUE
    Else
        table_setIgnoreRollback m_cTableDef, SAPDB_FALSE
    End If
    
    Exit Sub
    
errChkIgnoreRollback_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIgnoreRollback_KeyDown
'    description:   Handles the KeyDown event of the check button "Ignore Rollback".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub chkIgnoreRollback_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkIgnoreRollback_KeyDown
    
    Const FUNCTION_NAME = "chkIgnoreRollback_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the CaseSensitive check button.
            '------------------------------------------------------------------
            chkIdentUpperCase.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the Temporary Table check button.
            '------------------------------------------------------------------
            chkTemporary.SetFocus
        End If
    End If
    
    Exit Sub
    
errChkIgnoreRollback_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIgnoreRollback_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the check button "Ignore Rollback".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub chkIgnoreRollback_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkIgnoreRollback_OLEDragDrop
    
    Const FUNCTION_NAME = "chkIgnoreRollback_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errChkIgnoreRollback_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIdentUpperCase_Click
'    description:   Handles the Click event of the check button "Casesensitive Names".
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub chkIdentUpperCase_Click()
    On Error GoTo errchkIdentUpperCase_Click
    
    Const FUNCTION_NAME = "chkIdentUpperCase_Click"

    If chkIdentUpperCase.value = vbUnchecked Then
        table_setCaseSensitive m_cTableDef, SAPDB_TRUE
        RaiseEvent IdentifiersUpperCase(False)
    Else
        table_setCaseSensitive m_cTableDef, SAPDB_FALSE
        RaiseEvent IdentifiersUpperCase(True)
    End If
    
    
    Exit Sub
    
errchkIdentUpperCase_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIdentUpperCase_KeyDown
'    description:   Handles the KeyDown event of the check button "Casesensitive Names".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub chkIdentUpperCase_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errchkIdentUpperCase_KeyDown
    
    Const FUNCTION_NAME = "chkIdentUpperCase_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the tablename entry.
            '------------------------------------------------------------------
            RaiseEvent ResetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the Ignore Rollback check button.
            '------------------------------------------------------------------
            If chkIgnoreRollback.Enabled = True Then
                chkIgnoreRollback.SetFocus
            Else
                chkTemporary.SetFocus
            End If
        End If
    End If
    
    Exit Sub
    
    
errchkIdentUpperCase_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkIdentUpperCase_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the check button "Casesensitive Names".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub chkIdentUpperCase_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errchkIdentUpperCase_OLEDragDrop
    
    Const FUNCTION_NAME = "chkIdentUpperCase_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errchkIdentUpperCase_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkTemporary_Click
'    description:   Handles the Click event of the check button "Temporary". When the
'                   check button is marked the Ignore Rollback check button will be
'                   disabled.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub chkTemporary_Click()
    On Error GoTo errChkTemporary_Click
    
    Const FUNCTION_NAME = "chkTemporary_Click"

    If chkTemporary.value = 1 Then
        chkIgnoreRollback.Enabled = True
        table_setTemporary m_cTableDef, SAPDB_TRUE
    Else
        chkIgnoreRollback.Enabled = False
        table_setTemporary m_cTableDef, SAPDB_FALSE
    End If
    
    Exit Sub
    
errChkTemporary_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkTemporary_KeyDown
'    description:   Handles the KeyDown event of the check button "Temporary".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub chkTemporary_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkTemporary_KeyDown
    
    Const FUNCTION_NAME = "chkTemporary_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus either to the Ignore Rollback check button or (if
            ' it is disabled) to the tablename entry.
            '------------------------------------------------------------------
            If chkIgnoreRollback.Enabled = True Then
                chkIgnoreRollback.SetFocus
            Else
                chkIdentUpperCase.SetFocus
            End If
        Else
            '------------------------------------------------------------------
            ' Move the focus to the sample unit combo box.
            '------------------------------------------------------------------
            cbSampleUnit.SetFocus
        End If
    End If
    
    Exit Sub
    
errChkTemporary_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      chkTemporary_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the check button "Temporary".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub chkTemporary_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkTemporary_OLEDragDrop
    
    Const FUNCTION_NAME = "chkTemporary_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errChkTemporary_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      fraComment_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the frame fraComment.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub fraComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_OLEDragDrop
    
    Const FUNCTION_NAME = "fraComment_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrfraComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      fraDuplicates_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the frame fraDuplicates.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub fraDuplicates_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraDuplicates_OLEDragDrop
    
    Const FUNCTION_NAME = "fraDuplicates_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrfraDuplicates_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      fraOthers_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the frame fraOthers.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub fraOthers_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraOthers_OLEDragDrop
    
    Const FUNCTION_NAME = "fraOthers_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrfraOthers_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      fraStatistics_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the frame fraStatistics.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub fraStatistics_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraStatistics_OLEDragDrop
    
    Const FUNCTION_NAME = "fraStatistics_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrfraStatistics_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblSampleValue_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the label "Sample Value".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub lblSampleValue_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblSampleValue_OLEDragDrop
    
    Const FUNCTION_NAME = "lblSampleValue_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errLblSampleValue_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      rbIgnore_Click
'    description:   Handles the Click event of the radio button "Ignore". Stores the text
'                   of the radio button when it is selected.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub rbIgnore_Click()
    On Error GoTo errRbIgnore_Click
    
    Const FUNCTION_NAME = "rbIgnore_Click"

    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setDuplicates m_cTableDef, StrPtr(rbIgnore.Caption)
    'convert string to ucs2 byte array and pass it to function
    bArray = rbIgnore.Caption & vbNullChar
    table_setDuplicates m_cTableDef, bArray(0)
    
    Exit Sub
    
errRbIgnore_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      rbIgnore_KeyDown
'    description:   Handles the KeyDown event of the radio button "Ignore".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub rbIgnore_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errRbIgnore_KeyDown
    
    Const FUNCTION_NAME = "rbIgnore_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the sample value entry.
            '------------------------------------------------------------------
            txtSampleValue.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the comment entry.
            '------------------------------------------------------------------
            txtComment.SetFocus
            txtComment.selStart = 0
            txtComment.SelLength = Len(txtComment.text)
        End If
    End If
    
    Exit Sub
    
errRbIgnore_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbIgnore_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the radio button "Ignore".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub rbIgnore_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errRbIgnore_OLEDragDrop
    
    Const FUNCTION_NAME = "rbIgnore_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errRbIgnore_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbNothing_Click
'    description:   Handles the Click event of the radio button "Nothing". Stores the text
'                   of the radio button when it is selected.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub rbNothing_Click()
    On Error GoTo errRbNothing_Click
    
    Const FUNCTION_NAME = "rbNothing_Click"

    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setDuplicates m_cTableDef, StrPtr(rbNothing.Caption)
    'convert string to ucs2 byte array and pass it to function
    bArray = rbNothing.Caption & vbNullChar
    
    table_setDuplicates m_cTableDef, bArray(0)
    
    Exit Sub
    
errRbNothing_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbNothing_KeyDown
'    description:   Handles the KeyDown event of the radio button "Nothing".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub rbNothing_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errRbNothing_KeyDown
    
    Const FUNCTION_NAME = "rbNothing_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the sample value entry.
            '------------------------------------------------------------------
            txtSampleValue.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the comment entry.
            '------------------------------------------------------------------
            txtComment.SetFocus
            txtComment.selStart = 0
            txtComment.SelLength = Len(txtComment.text)
        End If
    End If
    
    Exit Sub
    
errRbNothing_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbNothing_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the radio button "Nothing".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub rbNothing_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errRbNothing_OLEDragDrop
    
    Const FUNCTION_NAME = "rbNothing_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errRbNothing_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbReject_Click
'    description:   Handles the Click event of the radio button "Reject". Stores the text
'                   of the radio button when it is selected.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub rbReject_Click()
    On Error GoTo errRbReject_Click
    
    Const FUNCTION_NAME = "rbReject_Click"

    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setDuplicates m_cTableDef, StrPtr(rbReject.Caption)
    'convert string to ucs2 byte array and pass it to function
    bArray = rbReject.Caption & vbNullChar
    
    table_setDuplicates m_cTableDef, bArray(0)
    
    Exit Sub
    
errRbReject_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbReject_KeyDown
'    description:   Handles the KeyDown event of the radio button "Reject".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub rbReject_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errRbReject_KeyDown
    
    Const FUNCTION_NAME = "rbReject_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the sample value entry.
            '------------------------------------------------------------------
            txtSampleValue.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the comment entry.
            '------------------------------------------------------------------
            txtComment.SetFocus
            txtComment.selStart = 0
            txtComment.SelLength = Len(txtComment.text)
        End If
    End If
    
    Exit Sub
    
errRbReject_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbReject_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the radio button "Reject".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub rbReject_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errRbReject_OLEDragDrop
    
    Const FUNCTION_NAME = "rbReject_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errRbReject_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbUpdate_Click
'    description:   Handles the Click event of the radio button "Update". Stores the text
'                   of the radio button when it is selected.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub rbUpdate_Click()
    On Error GoTo errRbUpdate_Click
    
    Const FUNCTION_NAME = "rbUpdate_Click"

    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setDuplicates m_cTableDef, StrPtr(rbUpdate.Caption)
    'convert string to ucs2 byte array and pass it to function
    bArray = rbUpdate.Caption & vbNullChar
    
    table_setDuplicates m_cTableDef, bArray(0)
    
    
    Exit Sub
    
errRbUpdate_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbUpdate_KeyDown
'    description:   Handles the KeyDown event of the radio button "Update".
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub rbUpdate_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errRbUpdate_KeyDown
    
    Const FUNCTION_NAME = "rbUpdate_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the sample value entry.
            '------------------------------------------------------------------
            txtSampleValue.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the comment entry.
            '------------------------------------------------------------------
            txtComment.SetFocus
            txtComment.selStart = 0
            txtComment.SelLength = Len(txtComment.text)
        End If
    End If
    
    Exit Sub
    
errRbUpdate_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      rbUpdate_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the radio button "Update".
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub rbUpdate_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errRbUpdate_OLEDragDrop
    
    Const FUNCTION_NAME = "rbUpdate_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errRbUpdate_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtComment_KeyDown
'    description:   Handles the KeyDown event of the text field txtComment.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub txtComment_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtComment_KeyDown
    
    Const FUNCTION_NAME = "txtComment_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the selected Duplicates radio button.
            '------------------------------------------------------------------
            If rbNothing.Enabled = True Then
                If rbNothing.value = True Then rbNothing.SetFocus
                If rbReject.value = True Then rbReject.SetFocus
                If rbIgnore.value = True Then rbIgnore.SetFocus
                If rbUpdate.value = True Then rbUpdate.SetFocus
            Else
                txtSampleValue.SetFocus
            End If
        Else
            '------------------------------------------------------------------
            ' Move the focus to the tablename entry.
            '------------------------------------------------------------------
            RaiseEvent ResetFocus
        End If
        KeyCode = 0
    End If
    
    Exit Sub
    
ErrtxtComment_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtComment_KeyPress
'    description:   Handles the KeyPress event of the text field txtComment.
'    arguments:     [in] KeyAscii - code of the pressed key
'    return value:  -
'=========================================================================================
Private Sub txtComment_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtComment_KeyPress
    
    Const FUNCTION_NAME = "txtComment_KeyPress"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyAscii = 9 Then KeyAscii = 0
    
    Exit Sub
    
ErrtxtComment_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtComment_KeyUp
'    description:   Handles the KeyUp event of the text field txtComment.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub txtComment_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtComment_KeyUp
    
    Const FUNCTION_NAME = "txtComment_KeyUp"

    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setComment m_cTableDef, StrPtr(txtComment.text)
    'convert string to ucs2 byte array and pass it to function
    bArray = txtComment.text & vbNullChar
    
    table_setComment m_cTableDef, bArray(0)
    
    Exit Sub
    
ErrtxtComment_KeyUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtComment_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the text field txtComment.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub txtComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtComment_OLEDragDrop
    
    Const FUNCTION_NAME = "txtComment_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrtxtComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtSampleValue_KeyDown
'    description:   Handles the KeyDown event of the text field txtSampleValue.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub txtSampleValue_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtSampleValue_KeyDown
    
    Const FUNCTION_NAME = "txtSampleValue_KeyDown"

    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyCode = vbKeyTab Then
        If Shift = 0 Then
            '------------------------------------------------------------------
            ' Move the focus to the sample unit combo box.
            '------------------------------------------------------------------
            cbSampleUnit.SetFocus
        Else
            '------------------------------------------------------------------
            ' Move the focus to the active Duplicates radio button.
            '------------------------------------------------------------------
            If rbNothing.Enabled = True Then
                If rbNothing.value = True Then rbNothing.SetFocus
                If rbReject.value = True Then rbReject.SetFocus
                If rbIgnore.value = True Then rbIgnore.SetFocus
                If rbUpdate.value = True Then rbUpdate.SetFocus
            Else
                txtComment.SetFocus
                txtComment.selStart = 0
                txtComment.SelLength = Len(txtComment.text)
            End If
        End If
    End If
    
    Exit Sub
    
ErrtxtSampleValue_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtSampleValue_LostFocus
'    description:   Handles the LostFocus event of the text field txtSampleValue. Stores
'                   the content of the entry field when it looses the focus.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub txtSampleValue_LostFocus()
    On Error GoTo ErrtxtSampleValue_LostFocus
    
    Const FUNCTION_NAME = "txtSampleValue_LostFocus"

    Dim value  As Integer
    
    If txtSampleValue.text = "" Then Exit Sub
    If Not IsNumeric(txtSampleValue) Then Exit Sub
    
    value = CInt(txtSampleValue.text)
    If (value < 0 Or value > 100) And cbSampleUnit.ListIndex = 0 Then
        MsgBox LoadResString(196), vbExclamation, LoadResString(195)
        txtSampleValue.SetFocus
        txtSampleValue.selStart = 0
        txtSampleValue.SelLength = Len(txtSampleValue.text)
    Else
        table_setSampleValue m_cTableDef, value
    End If
    
    Exit Sub
    
ErrtxtSampleValue_LostFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtSampleValue_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the text field txtSampleValue.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub txtSampleValue_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtSampleValue_OLEDragDrop
    
    Const FUNCTION_NAME = "txtSampleValue_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
ErrtxtSampleValue_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_Initialize
'    description:   Initializes the user control (e.g. load string resources).
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Initialize()
    On Error GoTo errUserContol_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    Dim i    As Integer
    
    '--------------------------------------------------------------------------
    ' Initialize the strings.
    '--------------------------------------------------------------------------
    fraComment.Caption = LoadResString(116)
    fraDuplicates.Caption = LoadResString(142)
    rbNothing.Caption = LoadResString(143)
    rbReject.Caption = LoadResString(144)
    rbIgnore.Caption = LoadResString(145)
    rbUpdate.Caption = LoadResString(146)
    fraStatistics.Caption = LoadResString(138)
    lblSampleValue.Caption = LoadResString(139)
    fraOthers.Caption = LoadResString(147)
    chkTemporary.Caption = LoadResString(148)
    chkIgnoreRollback.Caption = LoadResString(149)
    cbSampleUnit.AddItem LoadResString(140)
    cbSampleUnit.AddItem LoadResString(141)
    
    rbNothing.Enabled = False
    rbReject.Enabled = False
    rbIgnore.Enabled = False
    rbUpdate.Enabled = False
    chkIgnoreRollback.Enabled = False
    
    Exit Sub
    
errUserContol_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_MouseUp
'    description:   Handles the MouseUp event of the user control.
'    arguments:     [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseUp
    
    Const FUNCTION_NAME = "UserControl_MouseUp"
    
    '--------------------------------------------------------------------------
    ' Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    'Case vbLeftButton:
    '    EnterCell this.row, this.col
    Case vbRightButton:
        RaiseEvent popupTableMenu
    End Select
    
    Exit Sub
    
errUserControl_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the user control.
'                   The event is forwarded to the parent control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - mouse button that was pressed
'                   [in] Shift  - flag if the shift key was pressed
'                   [in] X      - X position of the mouse event
'                   [in] Y      - Y position of the mouse event
'    return value:  -
'=========================================================================================
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_OLEDragDrop
    
    Const FUNCTION_NAME = "UserControl_OLEDragDrop"

    RaiseEvent Dropped
    
    Exit Sub
    
errUserControl_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_Resize
'    description:   Handles the Resize event of the user control.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      enterFocusBackward
'    description:   Sets the focus to the last widget when entering the focus.
'    arguments:     -
'    return value:  -
'=========================================================================================
Public Function enterFocusBackward()
    On Error GoTo errEnterFocusBackward
    
    Const FUNCTION_NAME = "enterFocusBackward"
        
    If chkIdentUpperCase.Visible = True Then chkIdentUpperCase.SetFocus
    
    Exit Function
    
errEnterFocusBackward:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      enterFocusForward
'    description:   Sets the focus to the first widget when entering the focus.
'    arguments:     -
'    return value:  -
'=========================================================================================
Public Function enterFocusForward()
    On Error GoTo errEnterFocusForward
    
    Const FUNCTION_NAME = "enterFocusForward"
    
    Dim i        As Integer
    Dim col      As Long
    Dim out(512) As Byte
    Dim length   As Integer
    
    initByteArray out
    
    If txtComment.Visible = True And txtComment.Enabled = True Then txtComment.SetFocus
    txtComment.selStart = 0
    txtComment.SelLength = Len(txtComment.text)
    
    For i = 0 To table_columnCount(m_cTableDef) - 1
        col = table_column(m_cTableDef, i)
        
        length = column_dataType(col, out(0))
        If Left(out, length) = "Long" Then
            chkTemporary.value = 0
            chkTemporary.Enabled = False
            Exit For
        End If
    Next
    
    Exit Function
    
errEnterFocusForward:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      ResizeControls
'    description:   Resize the single widgets according to the enclosing form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    Dim i         As Integer
    Dim offset    As Integer
    Dim dist      As Integer
    
    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> UserControl.ScaleWidth Then
        If UserControl.ScaleWidth - fraDuplicates.Width - fraStatistics.Width - 800 > 0 Then
            fraComment.Width = UserControl.ScaleWidth - fraDuplicates.Width - fraStatistics.Width - 400
            txtComment.Width = fraComment.Width - 400
            fraDuplicates.Left = UserControl.ScaleWidth - fraStatistics.Width - fraDuplicates.Width - 200
            fraStatistics.Left = UserControl.ScaleWidth - fraStatistics.Width
            fraOthers.Left = UserControl.ScaleWidth - fraOthers.Width
        End If
                
        m_lOldWidth = UserControl.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> UserControl.ScaleHeight Then
        m_lOldHeight = UserControl.ScaleHeight
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UpdateMiscDefinition
'    description:   Update the display of the misc definitions.
'    arguments:     -
'    return value:  -
'=========================================================================================
Public Function updateMiscDefinition()
    On Error GoTo errUpdateMiscDefinition

    Const FUNCTION_NAME = "updateMiscDefinition"
    
    Dim out(512) As Byte
    Dim length   As Integer
    
    initByteArray out
    
    length = table_comment(m_cTableDef, out(0))
    txtComment.text = Left(out, length)
    txtSampleValue.text = CStr(table_sampleValue(m_cTableDef))
    
    length = table_sampleUnit(m_cTableDef, out(0))
    If Left(out, length) = "Percent" Then
        cbSampleUnit.ListIndex = 0
    Else
        cbSampleUnit.ListIndex = 1
    End If
    
    If table_temporary(m_cTableDef) = SAPDB_TRUE Then
        chkTemporary.value = vbChecked
    Else
        chkTemporary.value = vbUnchecked
    End If
    
    If table_caseSensitive(m_cTableDef) = SAPDB_FALSE Then
        chkIdentUpperCase.value = vbChecked
    Else
        chkIdentUpperCase.value = vbUnchecked
    End If
    
    If table_mode(m_cTableDef) = CreateFromQuery Then
        rbNothing.Enabled = Not m_bReadOnly
        rbReject.Enabled = Not m_bReadOnly
        rbIgnore.Enabled = Not m_bReadOnly
        rbUpdate.Enabled = Not m_bReadOnly
    ElseIf table_mode(m_cTableDef) = AlterTable Then
    
        chkIgnoreRollback.Enabled = False
        chkTemporary.Enabled = False
        rbNothing.Enabled = False
        rbReject.Enabled = False
        rbIgnore.Enabled = False
        rbUpdate.Enabled = False
    Else
        rbNothing.Enabled = False
        rbReject.Enabled = False
        rbIgnore.Enabled = False
        rbUpdate.Enabled = False
    End If
    
    Exit Function
      
errUpdateMiscDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    property:      ReadOnly
'    description:   enable or disable all input
'    arguments:     [in] bNewReadOnly, set input read only
'
'
'    return value:
'
'=========================================================================================
Public Property Let readOnly(bNewReadOnly As Boolean)
    On Error GoTo errLetReadOnly

    Const FUNCTION_NAME = "let readOnly"
        
    m_bReadOnly = bNewReadOnly
    
    If table_mode(m_cTableDef) = AlterTable And table_caseSensitive(m_cTableDef) Then
    
        chkIdentUpperCase.Enabled = False
    Else
        chkIdentUpperCase.Enabled = Not m_bReadOnly
    End If
    chkIgnoreRollback.Enabled = Not m_bReadOnly
    chkTemporary.Enabled = Not m_bReadOnly
    cbSampleUnit.Enabled = Not m_bReadOnly
    txtSampleValue.Enabled = Not m_bReadOnly
    txtComment.Enabled = Not m_bReadOnly
    
        
    Exit Property
    
errLetReadOnly:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      txtSampleValue_KeyUp
'    description:   Handles the KeyUp event of the text field txtComment.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub txtSampleValue_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtSampleValue_KeyUp
    
    Const FUNCTION_NAME = "txtComment_KeyUp"

    txtSampleValue.text = Trim(txtSampleValue.text)
    If Not IsNumeric(txtSampleValue) Then
        
             MsgBox LoadResString(161), vbCritical
             Exit Sub
    End If
    table_setSampleValue m_cTableDef, CInt(txtSampleValue.text)
    
    Exit Sub
    
ErrtxtSampleValue_KeyUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      columnsCaseSensitiv
'
'    !!! This property is not valid any more '''
'    !!! Just kept for binary compatibility
'
'
'    return value:
'
'=========================================================================================
Public Property Let columnsCaseSensitiv(bNewCaseSensitiv As Boolean)
    On Error GoTo err_Let_ColumnsCaseSensitiv
    
    Const FUNCTION_NAME = "P_LET ColumnsCaseSensitiv"
    
    
    Exit Property
    
err_Let_ColumnsCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      identifiersCaseSensitiv
'    description:   are identifiers like tablename columnname ... case sensitiv
'
'    arguments:     [in] bNewReadOnly, set input read only
'
'
'    return value:
'
'=========================================================================================
Public Property Let identifiersCaseSensitiv(bNewCaseSensitiv As Boolean)
    On Error GoTo err_Let_ColumnsCaseSensitiv
    
    Const FUNCTION_NAME = "P_LET ColumnsCaseSensitiv"
    
    'let property
    If bNewCaseSensitiv Then
    
        table_setCaseSensitive m_cTableDef, SAPDB_TRUE
        chkIdentUpperCase.value = vbUnchecked
        'if dialog is in alter table mode and table is case sensitiv
        'changes to chkIdentUpperCase are not allowed
        If table_mode(m_cTableDef) = AlterTable Then
            chkIdentUpperCase.Enabled = False
        End If
    Else
        table_setCaseSensitive m_cTableDef, SAPDB_FALSE
        chkIdentUpperCase.value = vbChecked
    End If
    
    Exit Property
    
err_Let_ColumnsCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
