VERSION 5.00
Object = "{BDC217C8-ED16-11CD-956C-0000C04E4C0A}#1.1#0"; "TABCTL32.OCX"
Begin VB.UserControl TableDefinition 
   ClientHeight    =   6750
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   12930
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   6750
   ScaleWidth      =   12930
   Begin TabDlg.SSTab tabTableProperties 
      Height          =   5295
      Left            =   120
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   1320
      Width           =   12720
      _ExtentX        =   22437
      _ExtentY        =   9340
      _Version        =   393216
      Tabs            =   4
      TabsPerRow      =   4
      TabHeight       =   520
      OLEDropMode     =   1
      TabCaption(0)   =   "Columns"
      TabPicture(0)   =   "TableDefinition.ctx":0000
      Tab(0).ControlEnabled=   -1  'True
      Tab(0).Control(0)=   "ctlColumnDefinition"
      Tab(0).Control(0).Enabled=   0   'False
      Tab(0).ControlCount=   1
      TabCaption(1)   =   "Constraints"
      TabPicture(1)   =   "TableDefinition.ctx":001C
      Tab(1).ControlEnabled=   0   'False
      Tab(1).Control(0)=   "ctlConstraintDefinition"
      Tab(1).ControlCount=   1
      TabCaption(2)   =   "Ref. Integrity"
      TabPicture(2)   =   "TableDefinition.ctx":0038
      Tab(2).ControlEnabled=   0   'False
      Tab(2).Control(0)=   "ctlRefIntegrityDefinition"
      Tab(2).ControlCount=   1
      TabCaption(3)   =   "Misc"
      TabPicture(3)   =   "TableDefinition.ctx":0054
      Tab(3).ControlEnabled=   0   'False
      Tab(3).Control(0)=   "ctlMiscDefinition"
      Tab(3).ControlCount=   1
      Begin SQLStudioCDCon.MiscDefinition ctlMiscDefinition 
         Height          =   4215
         Left            =   -74800
         TabIndex        =   9
         TabStop         =   0   'False
         Top             =   600
         Width           =   11055
         _ExtentX        =   19500
         _ExtentY        =   7435
      End
      Begin SQLStudioCDCon.RefIntegrityDefinition ctlRefIntegrityDefinition 
         Height          =   3975
         Left            =   -74800
         TabIndex        =   8
         TabStop         =   0   'False
         Top             =   600
         Width           =   11175
         _ExtentX        =   19711
         _ExtentY        =   7011
      End
      Begin SQLStudioCDCon.ConstraintDefinition ctlConstraintDefinition 
         Height          =   3615
         Left            =   -74800
         TabIndex        =   7
         TabStop         =   0   'False
         Top             =   600
         Width           =   10935
         _ExtentX        =   19288
         _ExtentY        =   6376
      End
      Begin SQLStudioCDCon.ColumnDefinition ctlColumnDefinition 
         Height          =   3975
         Left            =   200
         TabIndex        =   6
         TabStop         =   0   'False
         Top             =   500
         Width           =   11175
         _ExtentX        =   19711
         _ExtentY        =   7011
      End
   End
   Begin VB.Frame fraFrame 
      Height          =   1050
      Left            =   120
      OLEDropMode     =   1  'Manual
      TabIndex        =   1
      Top             =   60
      Width           =   10095
      Begin VB.TextBox txtTablename 
         Height          =   315
         Left            =   1320
         MousePointer    =   3  'I-Beam
         OLEDropMode     =   1  'Manual
         TabIndex        =   0
         TabStop         =   0   'False
         Top             =   240
         Width           =   8655
      End
      Begin VB.Label lblTemplate 
         Caption         =   "<none>"
         Height          =   255
         Left            =   1320
         OLEDropMode     =   1  'Manual
         TabIndex        =   4
         Top             =   700
         Width           =   8655
      End
      Begin VB.Label lblTemplateLabel 
         Caption         =   "Template:"
         Height          =   255
         Left            =   150
         OLEDropMode     =   1  'Manual
         TabIndex        =   3
         Top             =   700
         Width           =   1095
      End
      Begin VB.Label lblTablename 
         Caption         =   "Table Name:"
         Height          =   255
         Left            =   150
         OLEDropMode     =   1  'Manual
         TabIndex        =   2
         Top             =   255
         Width           =   975
      End
   End
   Begin VB.Menu mnuTable 
      Caption         =   "&Table Definition"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuCreateTable 
         Caption         =   "&Create Table"
      End
      Begin VB.Menu mnuShowSQL 
         Caption         =   "Export to DirectS&QL"
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSaveDefinition 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As ..."
      End
   End
End
Attribute VB_Name = "TableDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      TableDefinition.ctl
'
'========================================================================================
'
' responsible:    WolfgangA
'
' special area:   SQLStudio
'
' description:    Control for creating a new or editing an existing table definition.
'
'========================================================================================

Option Explicit

'==============================================================================
' Constant definitions
'==============================================================================
Const MODULE_NAME = "SQLStudio.TableDefinitionControl"
Const MX_COLUMN_NAME = 256

'==============================================================================
' Event declarations
'==============================================================================
Event CloseMe()

Event ShowSQLInDirectSQL(oSFC As SQLStudioMan.storedFileContent)

Event SaveMe(oSFC As SQLStudioMan.storedFileContent, bSaveAs As Boolean)


'==============================================================================
' Private members
'==============================================================================
Private m_lParentWnd                As Long
Private m_oGlobalInfo               As SQLStudioMan.globalInfo
Private m_oConnection               As SQLStudioDBLayer.connection
Private m_oSFC                      As New SQLStudioMan.storedFileContent
Private m_lOldWidth                 As Long
Private m_lOldHeight                As Long
Private m_sCreateAs                 As String
Private m_bNoImport                 As Boolean
Private m_sAlterTableName           As String
Private m_sAlterTableOwner          As String       'the actual app version, is checked against the oSFC version
Private m_lAppVersion               As Long
Private m_cTableDef                 As Long
Private m_cOldTableDef              As Long
Private m_bExecutionAborted         As Boolean      'switch if storing of object will use a database file system

Private m_oSQLStatement             As New BreakStatement
'only show information
Private m_bReadOnly                 As Boolean



'=========================================================================================
'    property:      AppVersion (Let)
'    description:   Sets the private member m_lAppVersion to the given value.
'    arguments:     [in] NewAppVersion - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let appVersion(NewAppVersion As Long)
    On Error GoTo errP_LET_AppVersion

    Const FUNCTION_NAME = "p_let appVersion"
    
    m_lAppVersion = NewAppVersion
    
    Exit Property
    
errP_LET_AppVersion:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      CallingWindow (Let)
'    description:   Sets the private member m_lParentWnd to the given value.
'    arguments:     [in] hWnd - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let callingWindow(hWnd As Long)
    On Error GoTo errP_LET_CallingWindow

    Const FUNCTION_NAME = "p_LET CallingWindow"

    m_lParentWnd = hWnd

    Exit Property

errP_LET_CallingWindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      globalInfo (Set)
'    description:   Sets the private member m_oGlobalInfo to the given value and
'                   initialize it.
'    arguments:     [in] newGlobalInfo - new value of the property
'    return value:  -
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "p_SET globalInfo"
    

    Set m_oGlobalInfo = newGlobalInfo
    
    '--------------------------------------------------------------------------
    ' Initializations
    '--------------------------------------------------------------------------
    Set ctlRefIntegrityDefinition.globalInfo = m_oGlobalInfo
    
    'set if connections work on unicode database
    ctlColumnDefinition.unicodeDatabase = m_oGlobalInfo.conMan.unicodeDatabase
    'set initial value if special identifiers are uppercase or not
    ctlMiscDefinition.identifiersCaseSensitiv = m_oGlobalInfo.UserProfile.identifiersCaseSensitiv
    
    Exit Property

errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Connection (Set)
'    description:   xet the private member m_oConnection to the given value.
'    arguments:     [in] NewConnection - new value of the property
'    return value:  -
'=========================================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "p_SET Connection"
    
    Set m_oConnection = NewConnection
    Set ctlRefIntegrityDefinition.connection = m_oConnection
    Set ctlColumnDefinition.connection = m_oConnection
    
    table_setConnection m_cTableDef, m_oConnection.hdbc, m_oConnection.henv
    
    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      connection (Get)
'    description:   Gets the value of the private member m_oConnection.
'    arguments:     -
'    return value:  sqlstudiodblayer.Connection
'=========================================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "G_GET Connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      ParentControl (Get)
'    description:   Gets parent of the current control as object.
'    arguments:     -
'    return value:  Object
'=========================================================================================
Public Property Get parentControl() As Object
    On Error GoTo errP_Get_ParentControl

    Const FUNCTION_NAME = "G_GET ParentControl"

    Set parentControl = Parent

    Exit Property

errP_Get_ParentControl:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      storedFileContent (Set)
'    description:   Sets the private member m_oSFC to the given value or create
'                   a new storedfilecontent object if argument is Nothing.
'    arguments:     [in] newSFC - new value of the property
'    return value:  -
'=========================================================================================
Public Property Set storedFileContent(newSFC As storedFileContent)
    On Error GoTo errP_SET_StoredFileContent

    Const FUNCTION_NAME = "p_SET_StoredFileContent"

    Dim org_mode       As Integer
    Dim out(512)       As Byte
    Dim length         As Integer
    Dim bArray()       As Byte
    
    initByteArray out
    
    If newSFC Is Nothing Then Exit Property
    
    Set m_oSFC = Nothing
    Set m_oSFC = newSFC
    If m_oSFC.tableData <> "" Then
        org_mode = table_mode(m_cTableDef)
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'table_parseDescription m_cTableDef, StrPtr(m_oSFC.tableData)
        'convert string to ucs2 byte array and pass it to function
        bArray = m_oSFC.tableData & vbNullChar
        table_parseDescription m_cTableDef, bArray(0)
        table_setMode m_cTableDef, org_mode
    End If
    
    length = table_name(m_cTableDef, out(0))
    txtTablename.text = Left(out, length)
    length = table_basedOn(m_cTableDef, out(0))
    
    If table_mode(m_cTableDef) = OpenDraft Then
        lblTemplate.Caption = Left(out, length)
    Else
        lblTemplate.Caption = LoadResString(102)
    End If
    
    ctlColumnDefinition.updateColumnDefinition
    ctlConstraintDefinition.updateConstraintDefinition
    ctlRefIntegrityDefinition.updateRefIntegrityDefinition
    ctlMiscDefinition.updateMiscDefinition
    
    If table_hasValidColumns(m_cTableDef) = SAPDB_TRUE Then
        tabTableProperties.TabEnabled(1) = True
        tabTableProperties.TabEnabled(2) = True
    End If
        
    table_resetDirty m_cTableDef
    
    Exit Property

errP_SET_StoredFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      storedFileContent (Get)
'    description:   Gets the value of the private member m_oSFC.
'    arguments:     -
'    return value:  storedfilecontent
'=========================================================================================
Public Property Get storedFileContent() As storedFileContent
    On Error GoTo errP_Get_StoredFileContent

    Const FUNCTION_NAME = "p_GET_StoredFileContent"

    Set storedFileContent = m_oSFC

    Exit Property

errP_Get_StoredFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      mode (Let)
'    description:   Sets the mode property of the table definition object to the
'                   given value.
'    arguments:     [in] vData - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let mode(vData As Variant)
    On Error GoTo errP_SET_Mode

    Const FUNCTION_NAME = "p_SET_Mode"

    table_setMode m_cTableDef, vData
    
    Exit Property

errP_SET_Mode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      mode (Get)
'    description:   Gets the mode property of the table definition object.
'    arguments:     -
'    return value:  Variant
'=========================================================================================
Public Property Get mode() As Variant
    On Error GoTo errP_Get_Mode

    Const FUNCTION_NAME = "p_GET_Mode"

    mode = table_mode(m_cTableDef)

    Exit Property

errP_Get_Mode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      ctlColumnDefinition_CheckValidColumns
'    description:   Handles the CheckValidColumns event of the user control
'                   ColumnDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_CheckValidColumns()
    On Error GoTo errCtlColumnDefinition_CheckValidColumns
    
    Const FUNCTION_NAME = "ctlColumnDefinition_CheckValidColumns"
    
    If table_hasValidColumns(m_cTableDef) = SAPDB_TRUE Then
        tabTableProperties.TabEnabled(1) = True
        tabTableProperties.TabEnabled(2) = True
    Else
        tabTableProperties.TabEnabled(1) = False
        tabTableProperties.TabEnabled(2) = False
    End If
    
    Exit Sub
    
errCtlColumnDefinition_CheckValidColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ctlColumnDefinition_UpdateConstraint
'    description:   Handles the UpdateConstraint event of the user control
'                   ColumnDefinition.
'    arguments:     [in] Index - index of the constraint
'                   [in] value - new string in the combo box
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_UpdateConstraint(Index As Integer, value As String)
    On Error GoTo errCtlColumnDefinition_UpdateConstraint
    
    Const FUNCTION_NAME = "ctlColumnDefinition_UpdateConstraint"
    
    ctlConstraintDefinition.columnNameChanged Index, value
    
    Exit Sub
    
errCtlColumnDefinition_UpdateConstraint:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlColumnDefinition_UpdateForeignKey
'    description:   Handles the UpdateForeignKey event of the user control
'                   ColumnDefinition.
'    arguments:     [in] Index - index of the foreign key
'                   [in] value - new string in the text field
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_UpdateForeignKey(Index As Integer, value As String)
    On Error GoTo errCtlColumnDefinition_UpdateForeignKey
    
    Const FUNCTION_NAME = "ctlColumnDefinition_UpdateForeignKey"
    
    ctlRefIntegrityDefinition.columnNameChanged Index, value
    
    Exit Sub
    
errCtlColumnDefinition_UpdateForeignKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlColumnDefinition_Dropped
'    description:   Handles the Dropped event of the user control ColumnDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_Dropped()
    On Error GoTo errCtlColumnDefinition_Dropped
    
    Const FUNCTION_NAME = "ctlColumnDefinition_Dropped"
    
    dragDropActions
    
    Exit Sub
    
errCtlColumnDefinition_Dropped:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlColumnDefinition_ImportDefinition
'    description:   Handles the ImportDefinition event of the user control
'                   ColumnDefinition.
'    arguments:     [in] Mode - mode of the import dialog
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_ImportDefinition(mode As String)
    On Error GoTo errCtlColumnDefinition_ImportDefinition
    
    Const FUNCTION_NAME = "ctlColumnDefinition_ImportDefinition"
    
    showImportWindow mode
    
    If m_bNoImport = False Then ctlColumnDefinition.updateColumnDefinition
    
    Exit Sub
    
errCtlColumnDefinition_ImportDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlColumnDefinition_PopupTableMenu
'    description:   Handles the PopupTableMenu event of the user control ColumnDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_PopupTableMenu()
    On Error GoTo errCtlColumnDefinition_PopupTableMenu
    
    Const FUNCTION_NAME = "ctlColumnDefinition_PopupTableMenu"
        
    popupTableMenu
    
    Exit Sub
    
errCtlColumnDefinition_PopupTableMenu:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlColumnDefinition_ResetFocus
'    description:   Handles the ResetFocus event of the user control ColumnDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlColumnDefinition_ResetFocus()
    On Error GoTo errCtlColumnDefinition_ResetFocus
    
    Const FUNCTION_NAME = "ctlColumnDefinition_ResetFocus"
    
    If txtTablename.Enabled = True Then txtTablename.SetFocus
    
    Exit Sub
    
errCtlColumnDefinition_ResetFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlConstraintDefinition_Dropped
'    description:   Handles the Dropped event of the user control ConstraintDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlConstraintDefinition_Dropped()
    On Error GoTo errCtlConstraintDefinition_Dropped
    
    Const FUNCTION_NAME = "ctlConstraintDefinition_Dropped"
    
    dragDropActions
    
    Exit Sub
    
errCtlConstraintDefinition_Dropped:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlConstraintDefinition_ImportDefinition
'    description:   Handles the ImportDefinition event of the user control
'                   ConstraintDefinition.
'    arguments:     [in] Mode - mode of the import dialog
'    return value:  -
'=========================================================================================
Private Sub ctlConstraintDefinition_ImportDefinition(mode As String)
    On Error GoTo errCtlConstraintDefinition_ImportDefinition
    
    Const FUNCTION_NAME = "ctlConstraintDefinition_ImportDefinition"
    
    showImportWindow mode
    If m_bNoImport = False Then ctlConstraintDefinition.updateConstraintDefinition
    
    Exit Sub
    
errCtlConstraintDefinition_ImportDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlConstraintDefinition_ResetFocus
'    description:   Handles the ResetFocus event of the user control ConstraintDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlConstraintDefinition_ResetFocus()
    On Error GoTo errCtlConstraintDefinition_ResetFocus
    
    Const FUNCTION_NAME = "ctlConstraintDefinition_ResetFocus"
    
    If txtTablename.Enabled = True Then txtTablename.SetFocus
    
    Exit Sub
    
errCtlConstraintDefinition_ResetFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlMiscDefinition_Dropped
'    description:   Handles the Dropped event of the user control MiscDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlMiscDefinition_Dropped()
    On Error GoTo errCtlMiscDefinition_Dropped
    
    Const FUNCTION_NAME = "ctlMiscDefinition_Dropped"
    
    dragDropActions
    
    Exit Sub
    
errCtlMiscDefinition_Dropped:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ctlMiscDefinition_Dropped
'    description:   Handles the Dropped event of the user control MiscDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlMiscDefinition_IdentifiersUpperCase(bUpperCase As Boolean)
    On Error GoTo errCtlMiscDefinition_IdentifiersUpperCase
    
   Const FUNCTION_NAME = "ctlMiscDefinition_IdentifiersUpperCase"
    
   If bUpperCase Then
        makeAllIdentifiersUpperCase
   End If
    
   Exit Sub
    
errCtlMiscDefinition_IdentifiersUpperCase:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlMiscDefinition_PopupTableMenu
'    description:   Handles the PopupTableMenu event of the user control MiscDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlMiscDefinition_PopupTableMenu()
    On Error GoTo errCtlMiscDefinition_PopupTableMenu

    Const FUNCTION_NAME = "ctlMiscDefinition_PopupTableMenu"
    
    popupTableMenu
    
    Exit Sub
    
errCtlMiscDefinition_PopupTableMenu:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlMiscDefinition_ResetFocus
'    description:   Handles the ResetFocus event of the user control MiscDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlMiscDefinition_ResetFocus()
    On Error GoTo errCtlMiscDefinition_ResetFocus
    
    Const FUNCTION_NAME = "ctlMiscDefinition_ResetFocus"
    
    If txtTablename.Enabled = True Then txtTablename.SetFocus
    
    Exit Sub
    
errCtlMiscDefinition_ResetFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlRefIntegrityDefinition_Dropped
'    description:   Handles the Dropped event of the user control RefIntegrityDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlRefIntegrityDefinition_Dropped()
    On Error GoTo errCtlRefIntegrityDefinition_Dropped
    
    Const FUNCTION_NAME = "ctlRefIntegrityDefinition_Dropped"
    
    dragDropActions
    
    Exit Sub
    
errCtlRefIntegrityDefinition_Dropped:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlRefIntegrityDefinition_ImportDefinition
'    description:   Handles the ImportDefinition event of the user control
'                   RefIntegrityDefinition.
'    arguments:     [in] Mode - mode of the import dialog
'    return value:  -
'=========================================================================================
Private Sub ctlRefIntegrityDefinition_ImportDefinition(mode As String)
    On Error GoTo errCtlRefIntegrityDefinition_ImportDefinition
    
    Const FUNCTION_NAME = "ctlRefIntegrityDefinition_ImportDefinition"
    
    showImportWindow mode
    If m_bNoImport = False Then ctlRefIntegrityDefinition.updateRefIntegrityDefinition
    
    Exit Sub
    
errCtlRefIntegrityDefinition_ImportDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlRefIntegrityDefinition_ResetFocus
'    description:   Handles the ResetFocus event of the user control
'                   RefIntegrityDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlRefIntegrityDefinition_ResetFocus()
    On Error GoTo errCtlRefIntegrityDefinition_ResetFocus
    
    Const FUNCTION_NAME = "ctlRefIntegrityDefinition_ResetFocus"
    
    If txtTablename.Enabled = True Then txtTablename.SetFocus
    
    Exit Sub
    
errCtlRefIntegrityDefinition_ResetFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlConstraintDefinition_PopupTableMenu
'    description:   Handles the PopupTableMenu event of the user control
'                   ConstraintDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlConstraintDefinition_PopupTableMenu()
    On Error GoTo errCtlConstraintDefinition_PopupTableMenu

    Const FUNCTION_NAME = "ctlConstraintDefinition_PopupTableMenu"
    
    popupTableMenu
    
    Exit Sub
    
errCtlConstraintDefinition_PopupTableMenu:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ctlRefIntegrityDefinition_PopupTableMenu
'    description:   Handles the PopupTableMenu event of the user control
'                   RefIntegrityDefinition.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub ctlRefIntegrityDefinition_PopupTableMenu()
    On Error GoTo errCtlRefIntegrityDefinition_PopupTableMenu

    Const FUNCTION_NAME = "ctlRefIntegrityDefinition_PopupTableMenu"
    
    popupTableMenu
    
    Exit Sub
    
errCtlRefIntegrityDefinition_PopupTableMenu:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      fraFrame_MouseUp
'    description:   Handles the MouseUp event of the frame fraFrame.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub fraFrame_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraFrame_MouseUp
    
    Const FUNCTION_NAME = "fraFrame_MouseUp"
    
    '--------------------------------------------------------------------------
    '  Check which button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    End Select
    
    Exit Sub
    
ErrfraFrame_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      fraFrame_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the frame fraFrame.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub fraFrame_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraFrame_OLEDragDrop
    
    Const FUNCTION_NAME = "fraFrame_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
ErrfraFrame_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTablename_MouseUp
'    description:   Handles the MouseUp event of the label lblTablename.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTablename_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTablename_MouseUp
    
    Const FUNCTION_NAME = "lblTablename_MouseUp"
    
    '--------------------------------------------------------------------------
    '  Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    End Select
    
    Exit Sub
    
errLblTablename_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTablename_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the label lblTablename.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTablename_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTablename_OLEDragDrop
    
    Const FUNCTION_NAME = "lblTablename_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
errLblTablename_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTemplate_MouseUp
'    description:   Handles the MouseUp event of the label lblTemplate.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTemplate_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTemplate_MouseUp
    
    Const FUNCTION_NAME = "lblTemplate_MouseUp"
    
    '--------------------------------------------------------------------------
    ' Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    End Select
    
    Exit Sub
    
errLblTemplate_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTemplate_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the label lblTemplate.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTemplate_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTemplate_OLEDragDrop
    
    Const FUNCTION_NAME = "lblTemplate_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
errLblTemplate_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTemplateLabel_MouseUp
'    description:   Handles the MouseUp event of the label lblTemplateLabel.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTemplateLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTemplateLabel_MouseUp
    
    Const FUNCTION_NAME = "lblTemplateLabel_MouseUp"
    
    '--------------------------------------------------------------------------
    ' Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    End Select
    
    Exit Sub
    
errLblTemplateLabel_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      lblTemplateLabel_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the label lblTemplateLabel.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub lblTemplateLabel_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTemplateLabel_OLEDragDrop
    
    Const FUNCTION_NAME = "lblTemplateLabel_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
errLblTemplateLabel_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      mnuCreateTable_Click
'    description:   Handles the Click event of the menu item "Create Table". The content
'                   of the control will be used to create a new table.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub mnuCreateTable_Click()
    On Error GoTo errMnuCreateTable_Click
    
    Const FUNCTION_NAME = "mnuCreateTable_Click"
    
    execute
    
    Exit Sub
    
errMnuCreateTable_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      mnuSaveAs_Click
'    description:   Handles the Click event of the menu item "Save As". The current state
'                   of the table definition object will be saved as a draft in the
'                   database under a new name.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub mnuSaveAs_Click()
    On Error GoTo errMnuSaveAs_Click
    
    Const FUNCTION_NAME = "mnuSaveAs_Click"
    
    '--------------------------------------------------------------------------
    ' Save the table definition object without confirmation and update the
    ' title bar ror message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    If saveTableDefObject(True, True) = Saved Then table_resetDirty m_cTableDef
    
    Exit Sub
    
errMnuSaveAs_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      mnuSaveDefinition_Click
'    description:   Handles the Click event of the menu item "Save". The current state
'                   of the table definition object will be saved as a draft in the
'                   database under the current name (if already defined).
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub mnuSaveDefinition_Click()
    On Error GoTo errMnuSaveDefinition_Click
    
    Const FUNCTION_NAME = "mnuSaveDefinition_Click"
    
    '--------------------------------------------------------------------------
    ' Save the table definition object without confirmation and update the
    ' title bar ror message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    If saveTableDefObject(False, True) = Saved Then table_resetDirty m_cTableDef
    
    Exit Sub
    
errMnuSaveDefinition_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      getSQLStatement
'    description:   get the sql statment provided by table def dialog
'
'    arguments:     -
'    return value:  sql statment as string
'=========================================================================================
Private Function getSQLStatement()
    On Error GoTo errGetSQLStatement
    
    Const FUNCTION_NAME = "getSQLStatement"
    
    Dim sStatement  As String
    Dim sIncomplete As String
    Dim out(65536)  As Byte
    Dim length      As Integer
        
    initByteArray out
    
    length = table_findIncompleteDefs(m_cTableDef, out(0))
    sIncomplete = Left(out, length)
    If sIncomplete <> "" Then table_setIgnoreIncomplete m_cTableDef, SAPDB_TRUE
    
    If table_mode(m_cTableDef) = AlterTable Then
        length = table_genAlterStatement(m_cTableDef, m_cOldTableDef, out(0))
    Else
        length = table_genCreateStatement(m_cTableDef, out(0))
    End If
    sStatement = Left(out, length)
    
    If sStatement <> "Error" And sStatement <> "Incomplete" And (table_hasValidColumns(m_cTableDef) = SAPDB_TRUE) Then
        getSQLStatement = sStatement
    Else
     getSQLStatement = ""
    End If
    
    Exit Function
    
errGetSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      mnuShowSQL_Click
'    description:   Handles the Click event of the menu item "Show SQL". Compose an SQL
'                   statement with the currently entered values.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub mnuShowSQL_Click()
    On Error GoTo errMnuShowSQL_Click
    
    Const FUNCTION_NAME = "mnuShowSQL_Click"
    
    Dim sStatement  As String
    Dim sIncomplete As String
    Dim lRow        As Long
    Dim lCol        As Long
    Dim pos         As Integer
    Dim out(65536)  As Byte
    Dim length      As Integer
        
    initByteArray out
    
    '--------------------------------------------------------------------------
    ' Check if there are incomplete definition and request a user decision.
    '--------------------------------------------------------------------------
    length = table_findIncompleteDefs(m_cTableDef, out(0))
    sIncomplete = Left(out, length)
    
    If sIncomplete <> "" Then
        If MsgBox(LoadResString(233), vbOKCancel, LoadResString(232)) = vbOK Then
            table_setIgnoreIncomplete m_cTableDef, SAPDB_TRUE
        Else
            table_setIgnoreIncomplete m_cTableDef, SAPDB_FALSE
            tabTableProperties.Tab = CStr(Left(sIncomplete, 1))
            pos = InStr(3, sIncomplete, " ")
            lRow = CInt(Mid(sIncomplete, 3, pos - 3))
            lCol = CInt(Mid(sIncomplete, pos + 1, Len(sIncomplete) - pos))
            
            Select Case tabTableProperties.Tab
            Case 0
                ctlColumnDefinition.enterFocusAfterWarning lRow, lCol
            Case 1
                ctlConstraintDefinition.enterFocusAfterWarning lRow, lCol
            Case 2
                ctlRefIntegrityDefinition.enterFocusAfterWarning lRow, lCol
            End Select
            Exit Sub
        End If
    End If
    
    If (table_hasValidColumns(m_cTableDef) = SAPDB_FALSE) Then
        MsgBox LoadResString(245)
        Exit Sub
    End If
    
    '--------------------------------------------------------------------------
    ' Generate the SQL statements depending on the input of the user.
    '--------------------------------------------------------------------------
    If table_mode(m_cTableDef) = AlterTable Then
        length = table_genAlterStatement(m_cTableDef, m_cOldTableDef, out(0))
    Else
        length = table_genCreateStatement(m_cTableDef, out(0))
    End If
    sStatement = Left(out, length)
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no table name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    Select Case sStatement
    Case ""
        If table_mode(m_cTableDef) <> AlterTable Then
            MsgBox LoadResString(150), vbExclamation, LoadResString(158)
        Else
            MsgBox LoadResString(219), vbExclamation, LoadResString(218)
        End If
        
    Case "Error"
        If table_mode(m_cTableDef) <> AlterTable Then
            MsgBox LoadResString(173), vbExclamation, LoadResString(174)
        End If
    
    Case "Incomplete"
        tabTableProperties.Tab = m_tIncompleteDef.iPage
        Select Case m_tIncompleteDef.iPage
        Case 0
            ctlColumnDefinition.enterFocusAfterWarning m_tIncompleteDef.lRow, _
                                                       m_tIncompleteDef.lCol
        Case 1
            ctlConstraintDefinition.enterFocusAfterWarning m_tIncompleteDef.lRow, _
                                                       m_tIncompleteDef.lCol
        Case 2
            ctlRefIntegrityDefinition.enterFocusAfterWarning m_tIncompleteDef.lRow, _
                                                       m_tIncompleteDef.lCol
        End Select
        
    Case Else
        showSQLStatement (sStatement)
    End Select
    
    Exit Sub
    
errMnuShowSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuTable_Click()
    On Error GoTo errMnuTable_Click

    Const FUNCTION_NAME = "mnumnuTable_Click"
    
    'Check menus
    checkMenus
    
    Exit Sub
    
errMnuTable_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      tabTableProperties_MouseUp
'    description:   Handles the MouseUp event of the tab widget tabTableProperties.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub tabTableProperties_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtabTableProperties_MouseUp
    
    Const FUNCTION_NAME = "tabTableProperties_MouseUp"
    
    '--------------------------------------------------------------------------
    ' Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    Case vbLeftButton:
        Select Case tabTableProperties.Tab
        Case 0:
            ctlColumnDefinition.disablePopup = True
            ctlColumnDefinition.enterFocusForward
            ctlColumnDefinition.disablePopup = False
        Case 1:
            ctlConstraintDefinition.enterFocusForward
        Case 2:
            ctlRefIntegrityDefinition.enterFocusForward
        Case 3:
            ctlMiscDefinition.enterFocusForward
        End Select
    End Select
    
    Exit Sub
    
ErrtabTableProperties_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      tabTableProperties_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the tab widget tabTableProperties.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub tabTableProperties_OLEDragDrop(Data As TabDlg.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtabTableProperties_OLEDragDrop
    
    Const FUNCTION_NAME = "tabTableProperties_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
ErrtabTableProperties_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtTablename_Click
'    description:   Handles the Click event of the text field txtTablename. Close all open
'                   input windows.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub txtTablename_Click()
    On Error GoTo ErrtxtTablename_Click
    
    Const FUNCTION_NAME = "txtTablename_Click"

    ctlColumnDefinition.closeInputWidgets
    
    Exit Sub
    
ErrtxtTablename_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtTablename_KeyDown
'    description:   Handles the KeyDown event of the text field txtTablename.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub txtTablename_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtTablename_KeyDown
    
    Const FUNCTION_NAME = "txtTablename_KeyDown"


    Select Case KeyCode
    Case vbKeyTab
        '----------------------------------------------------------------------
        ' The TAB key was pressed.
        '----------------------------------------------------------------------
        Select Case tabTableProperties.Tab
        Case 0:
            If Shift = 0 Then
                ctlColumnDefinition.enterFocusForward
            Else
                ctlColumnDefinition.enterFocusBackward
            End If
        Case 1:
            If Shift = 0 Then
                ctlConstraintDefinition.enterFocusForward
            Else
                ctlConstraintDefinition.enterFocusBackward
            End If
        Case 2:
            If Shift = 0 Then
                ctlRefIntegrityDefinition.enterFocusForward
            Else
                ctlRefIntegrityDefinition.enterFocusBackward
            End If
        Case 3:
            If Shift = 0 Then
                ctlMiscDefinition.enterFocusForward
            Else
                ctlMiscDefinition.enterFocusBackward
            End If
        End Select
    End Select
    
    Exit Sub
    
ErrtxtTablename_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtTablename_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtTablename_KeyPress
    
    Const FUNCTION_NAME = "txtTablename_KeyPress"

    If table_caseSensitive(m_cTableDef) = SAPDB_FALSE Then
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
    
    Exit Sub
    
ErrtxtTablename_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtTablename_KeyUp
'    description:   Handles the KeyUp event of the text field txtTablename. Store the
'                   entered tablename in the table definition object.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub txtTablename_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtTablename_KeyUp
    
    Const FUNCTION_NAME = "txtTablename_KeyUp"
        
    Dim bArray()   As Byte
    
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setName m_cTableDef, StrPtr(txtTablename.text)
    'convert string to ucs2 byte array and pass it to function
    bArray = txtTablename.text & vbNullChar
    table_setName m_cTableDef, bArray(0)
    
    'txtTablename.Text = txtTablename.Text + vbNullChar
    
    Exit Sub
    
ErrtxtTablename_KeyUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      txtTablename_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the text field txtTablename.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub txtTablename_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtTablename_OLEDragDrop
    
    Const FUNCTION_NAME = "txtTablename_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
ErrtxtTablename_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_OLEDragDrop
'    description:   Handles the OLEDragDrop event of the user control.
'    arguments:     [in] Data   - data object of the drag&drop operation
'                   [in] Effect -
'                   [in] Button - used mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_OLEDragDrop
    
    Const FUNCTION_NAME = "UserControl_OLEDragDrop"
    
    dragDropActions
    
    Exit Sub
    
errUserControl_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_Initialize
'    description:   Initialize the user control (e.g. load string resources).
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Initialize()
    On Error GoTo errUserContol_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    '--------------------------------------------------------------------------
    ' Initialize the private member variables
    '--------------------------------------------------------------------------
    m_lOldWidth = 0
    m_lOldHeight = 0
    
    m_cTableDef = table_new
            
    If m_cTableDef = 0 Then
        MsgBox LoadResString(236), vbExclamation, LoadResString(235)
        Exit Sub
    End If
    
    '--------------------------------------------------------------------------
    ' Initialize the strings of the control
    '--------------------------------------------------------------------------
    lblTablename.Caption = LoadResString(100)
    lblTemplateLabel.Caption = LoadResString(101)
    lblTemplate.Caption = LoadResString(102)
    
    '--------------------------------------------------------------------------
    ' Tab 0 (Columns)
    '--------------------------------------------------------------------------
    tabTableProperties.TabCaption(0) = LoadResString(104)

    '--------------------------------------------------------------------------
    ' Tab 1 (Constraints)
    '--------------------------------------------------------------------------
    tabTableProperties.TabCaption(1) = LoadResString(105)
    tabTableProperties.TabEnabled(1) = False
    
    '--------------------------------------------------------------------------
    ' Tab 2 (Ref. Integrity)
    '--------------------------------------------------------------------------
    tabTableProperties.TabCaption(2) = LoadResString(106)
    tabTableProperties.TabEnabled(2) = False
    
    '--------------------------------------------------------------------------
    ' Tab 3 (Misc)
    '--------------------------------------------------------------------------
    tabTableProperties.TabCaption(3) = LoadResString(107)
    
    '--------------------------------------------------------------------------
    ' Show the first tab
    '--------------------------------------------------------------------------
    tabTableProperties.Tab = 0
    
    '--------------------------------------------------------------------------
    ' Initialize the TableDef properties of the enclosed user controls.
    '--------------------------------------------------------------------------
    ctlColumnDefinition.tableDef = m_cTableDef
    ctlConstraintDefinition.tableDef = m_cTableDef
    ctlRefIntegrityDefinition.tableDef = m_cTableDef
    ctlMiscDefinition.tableDef = m_cTableDef
    
    m_lAppVersion = 72200
    m_oSFC.fileType = fileTypeDraftTable
    'if it is a new storedFileContent set version number
    m_oSFC.version = m_lAppVersion
    m_oSFC.appVersion = m_lAppVersion
    
    table_resetDirty m_cTableDef
    
    m_oSQLStatement.addComment "//"
    m_oSQLStatement.addComment "--"
    
    Exit Sub
    
errUserContol_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_MouseUp
'    description:   Handles the MouseUp event of the user control.
'    arguments:     [in] Button - user mouse button
'                   [in] Shift  - flag if shift key was pressed
'                   [in] X      - X position of mouse event
'                   [in] Y      - Y position of mouse event
'    return value:  -
'=========================================================================================
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserContol_MouseUp
    
    Const FUNCTION_NAME = "UserControl_MouseUp"
    
    '--------------------------------------------------------------------------
    ' Check which mouse button was pressed.
    '--------------------------------------------------------------------------
    Select Case Button
    Case vbRightButton:
        popupTableMenu
    End Select
    
    Exit Sub
    
errUserContol_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_Resize
'    description:   Handles the Resize event of the user control.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      UserControl_Show
'    description:   Set the focus to the tablename entry field when the form is displayed
'                   for the first time.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Show()
    On Error GoTo errUserControl_Show

    Const FUNCTION_NAME = "UserControl_Show"
    
    If txtTablename.Enabled = True Then
        txtTablename.SetFocus
    Else
        ctlColumnDefinition.disablePopup = True
        ctlColumnDefinition.enterFocusForward
        ctlColumnDefinition.disablePopup = False
    End If
    
    Exit Sub
    
errUserControl_Show:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      UserControl_Terminate
'    description:   Clean up when the user control terminates.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub UserControl_Terminate()
    On Error GoTo errUserControl_Terminate

    Const FUNCTION_NAME = "UserControl_Terminate"
    
    table_delete m_cTableDef
    
    If Not m_oConnection Is Nothing Then m_oConnection.disconnect
    
    Exit Sub
    
errUserControl_Terminate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      dragDropActions
'    description:   Actions to be done when a table or query is dropped on the user
'                   control.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Function dragDropActions()
    On Error GoTo ErrDragDropActions
    
    Const FUNCTION_NAME = "dragDropActions"
    
    Dim s           As String
    Dim oDragObject As Object
    Dim sOwner      As String
    Dim sTable      As String
    Dim sQuery      As String
    Dim sKey        As String
    Dim sfilename As String
    Dim eType       As cvItemType
    Dim org_mode    As Integer
    Dim out(512)    As Byte
    Dim length      As Integer
    Dim bArray()    As Byte
    Dim bArray2()   As Byte
    
    'no drag drop in read only mode
    If m_bReadOnly Then Exit Function
    'no drag drop in alter table mode
    If table_mode(m_cTableDef) = AlterTable Then Exit Function
    
    initByteArray out
    
    For Each oDragObject In m_oGlobalInfo.dragObjects
    
        If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then
            
            Select Case oDragObject.fileType

                Case fileTypeStatement
                    eType = cmStoredDSQL
                Case fileTypeQueryByExample
                    eType = cmStoredQBE
                Case fileTypeVisualQuery
                    eType = cmStoredVIQ
                Case Else
                    Exit Function
            End Select
            
            Exit For
        Else
            If oDragObject.Format = DBOTable Or oDragObject.Format = DBOStoredObject Then
                Exit For
            End If
        End If
    Next

    '--------------------------------------------------------------------------
    ' If no table or DirectSQL object was dropped, an error message is
    ' displayed.
    '--------------------------------------------------------------------------
    If oDragObject Is Nothing Then
        MsgBox LoadResString(198), vbExclamation, LoadResString(197)
        Exit Function
    End If
    
    m_oGlobalInfo.clearDragObjects

    If Not TypeOf oDragObject Is SQLStudioMan.storedFileContent Then
    
        If oDragObject.Format = DBOTable Then
            If Not m_oGlobalInfo.splitCatalogDragInfo(oDragObject.objectName, sOwner, sTable, eType) Then Exit Function
        Else
            sQuery = oDragObject.Storedfilename
            sOwner = oDragObject.storedObjectOwner
            sKey = Mid(oDragObject.storedObjectKey, 2)
            eType = cmStoredDSQL
        End If
    End If
    '--------------------------------------------------------------------------
    ' If the dropped item is a table, the table definition is loaded from the
    ' database into the table definition object.
    '--------------------------------------------------------------------------
    If eType = cmTable Then
    
        If table_mode(m_cTableDef) = CreateNew Then table_setMode m_cTableDef, CreateFromTable
        
        org_mode = table_mode(m_cTableDef)
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'table_readTableDefinition(m_cTableDef, StrPtr(sTable), StrPtr(sOwner))
        'convert string to ucs2 byte array and pass it to function
        bArray = sTable & vbNullChar
        bArray2 = sOwner & vbNullChar
        If table_readTableDefinition(m_cTableDef, bArray(0), bArray2(0)) > 0 Then
            MsgBox LoadResString(203), vbExclamation, LoadResString(202)
            Exit Function
        End If
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'table_setName m_cTableDef, StrPtr(txtTablename.text)
        'convert string to ucs2 byte array and pass it to function
        bArray = "" & vbNullChar
        table_setName m_cTableDef, bArray(0)
        
        table_setMode m_cTableDef, org_mode
        
        If table_mode(m_cTableDef) = CreateFromTable Then
            lblTemplate.Caption = sTable + "           (" + LoadResString(199) + ")"
            lblTemplate.ToolTipText = ""
            
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'table_setBasedOn m_cTableDef, StrPtr(lblTemplate.Caption)
            'convert string to ucs2 byte array and pass it to function
            bArray = lblTemplate.Caption & vbNullChar
            table_setBasedOn m_cTableDef, bArray(0)
        Else
            length = table_name(m_cTableDef, out(0))
            txtTablename.text = Left(out, length)
        End If
        
        tabTableProperties.TabEnabled(1) = True
        tabTableProperties.TabEnabled(2) = True
        
        'check if there are lower case identifiers and check upper case option
        If lowerColumnNames(m_cTableDef) = False Then
            
            If lowerConstraintNames(m_cTableDef) = False Then
            
                ctlMiscDefinition.identifiersCaseSensitiv = lowerRefIntegrity(m_cTableDef)
            Else
                ctlMiscDefinition.identifiersCaseSensitiv = True
            End If
        Else
            ctlMiscDefinition.identifiersCaseSensitiv = True
        End If
    End If
    
    '--------------------------------------------------------------------------
    ' If the dropped item is a stored DirectSQL statement, the structure of the
    ' result of the query will be loaded into the table definition object.
    '--------------------------------------------------------------------------
    If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then
    
        table_setMode m_cTableDef, CreateFromQuery
        
        If setFromSQL(oDragObject.sqlData) = False Then Exit Function
        
        lblTemplate.Caption = oDragObject.FileName + "           (" + LoadResString(200) + ")"
        lblTemplate.ToolTipText = m_sCreateAs
        
        tabTableProperties.TabEnabled(1) = False
        tabTableProperties.TabEnabled(2) = False
    Else
        If eType = cmStoredDSQL Then
        
            table_setMode m_cTableDef, CreateFromQuery
            
            If loadQueryDefinition(sKey, sOwner) = False Then Exit Function
            
            lblTemplate.Caption = sQuery + "           (" + LoadResString(200) + ")"
            lblTemplate.ToolTipText = m_sCreateAs
            
            tabTableProperties.TabEnabled(1) = False
            tabTableProperties.TabEnabled(2) = False
        End If
    End If
    ctlColumnDefinition.updateColumnDefinition
    ctlConstraintDefinition.updateConstraintDefinition
    ctlRefIntegrityDefinition.updateRefIntegrityDefinition
    ctlMiscDefinition.updateMiscDefinition
    tabTableProperties.Tab = 0
    
    Exit Function
    
ErrDragDropActions:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      execute
'    description:   Execute the resulting SQL statement.
'    arguments:     -
'    return value:  -
'=========================================================================================
Public Function execute()
    On Error GoTo errExecute
    
    Const FUNCTION_NAME = "execute"
    
    Dim sSQL            As String
    Dim oResult         As SQLStudioDBLayer.Result
    Dim sIncomplete     As String
    Dim out(65536)      As Byte
    Dim length          As Integer
    Dim pos             As Integer
    Dim lRow            As Long
    Dim lCol            As Long
    
    initByteArray out
    
    
    '=sql statement can't be executed in read only mode==============
    If m_bReadOnly Then Exit Function
    '================================================================
    
    '--------------------------------------------------------------------------
    ' Check if there are incomplete definition and request a user decision.
    '--------------------------------------------------------------------------
    length = table_findIncompleteDefs(m_cTableDef, out(0))
    sIncomplete = Left(out, length)
    
    If sIncomplete <> "" Then
        If MsgBox(LoadResString(233), vbOKCancel, LoadResString(232)) = vbOK Then
            table_setIgnoreIncomplete m_cTableDef, SAPDB_TRUE
        Else
            table_setIgnoreIncomplete m_cTableDef, SAPDB_FALSE
            tabTableProperties.Tab = CStr(Left(sIncomplete, 1))
            pos = InStr(3, sIncomplete, " ")
            lRow = CInt(Mid(sIncomplete, 3, pos - 3))
            lCol = CInt(Mid(sIncomplete, pos + 1, Len(sIncomplete) - pos))
            
            Select Case tabTableProperties.Tab
            Case 0
                ctlColumnDefinition.enterFocusAfterWarning lRow, lCol
            Case 1
                ctlConstraintDefinition.enterFocusAfterWarning lRow, lCol
            Case 2
                ctlRefIntegrityDefinition.enterFocusAfterWarning lRow, lCol
            End Select
            m_bExecutionAborted = True
            Exit Function
        End If
    End If
    
    If (table_hasValidColumns(m_cTableDef) = SAPDB_FALSE) Then
        MsgBox LoadResString(245)
        Exit Function
    End If
    
    '--------------------------------------------------------------------------
    ' Generate the SQL statements depending on the input of the user.
    '--------------------------------------------------------------------------
    If table_mode(m_cTableDef) = AlterTable Then
        length = table_genAlterStatement(m_cTableDef, m_cOldTableDef, out(0))
    Else
        length = table_genCreateStatement(m_cTableDef, out(0))
    End If
    sSQL = Left(out, length)
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no table name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be sent to the database.
    '--------------------------------------------------------------------------
    Select Case sSQL
    Case ""
        If table_mode(m_cTableDef) = AlterTable Then
            RaiseEvent CloseMe
        Else
            MsgBox LoadResString(150), vbExclamation, LoadResString(158)
        End If
    
    Case "Error"
        If table_mode(m_cTableDef) = AlterTable Then
        Else
            MsgBox LoadResString(173), vbExclamation, LoadResString(174)
        End If
        
    Case Else
        '----------------------------------------------------------------------
        ' Initialize the SQL statement object
        '----------------------------------------------------------------------
        Set m_oSQLStatement.connection = m_oConnection
        m_oSQLStatement.resultMode = sapdbSimpleMode
        m_oSQLStatement.callingWindow = m_lParentWnd
        m_oSQLStatement.statement = sSQL

        '----------------------------------------------------------------------
        ' In ALTER TABLE mode display a warning if more then one ALTER
        ' statement is created because they are very time consuming.
        '----------------------------------------------------------------------
        If table_mode(m_cTableDef) = AlterTable And numberOfStatements(sSQL) > 1 Then
            If MsgBox(LoadResString(217), vbYesNo, LoadResString(216)) = vbNo Then
                m_bExecutionAborted = True
                Exit Function
            End If
        End If
        
        '----------------------------------------------------------------------
        ' Execute each SQL statement of the given string.
        '----------------------------------------------------------------------
        While Not m_oSQLStatement.eos And _
              Len(Trim$(m_oSQLStatement.currentStatement)) > 0 And _
              Trim$(m_oSQLStatement.currentStatement) <> vbCrLf
            If m_oSQLStatement.execute(oResult, Internal) Then
                m_oSQLStatement.nextStatement
            Else
                m_oConnection.Error.showError
                m_oSQLStatement.statement = "ROLLBACK"
                m_oSQLStatement.execute oResult, Internal
                m_bExecutionAborted = True
                Exit Function
            End If
        Wend
                
        m_oSQLStatement.statement = "COMMIT"
        m_oSQLStatement.execute oResult, Internal
        
        '----------------------------------------------------------------------
        ' Display a feedback messagebox.
        '----------------------------------------------------------------------
        If table_mode(m_cTableDef) = AlterTable Then
            MsgBox LoadResString(229), vbInformation, LoadResString(218)
        Else
            MsgBox LoadResString(228), vbInformation, LoadResString(213)
        End If
        
        table_resetDirty m_cTableDef
    
        RaiseEvent CloseMe
    End Select
    
    m_bExecutionAborted = False
    
    Exit Function
    
errExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      initializeAlterTable
'    description:   Initialize the control for altering the table definition, i.e. load
'                   the table definition of the given table.
'    arguments:     [in] Tablename - name of the table to be loaded
'                   [in] owner     - owner of the table to be loaded
'                   [in] itemTpye, if itemTpye is cmTable the control is read onyl but all
'                                  information is shown
'                                  if itemTpye is cmSystem just the columninformation is shown
'    return value:  -
'=========================================================================================
Public Function initializeAlterTable(tablename As String, _
                                owner As String, _
                                Optional itemType As cvItemType)
    On Error GoTo errInitializeAlterTable
    
    Const FUNCTION_NAME = "initializeAlterTable"
    
    Dim bArray()    As Byte
    Dim bArray2()   As Byte
    
    If itemType = cmTable Or itemType = cmSystem Then
    
        m_bReadOnly = True
    Else
        m_bReadOnly = False
    End If
    
    '--------------------------------------------------------------------------
    ' Load the definition of the table that should be altered.
    '--------------------------------------------------------------------------
    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_readTableDefinition(m_cTableDef, StrPtr(sTable), StrPtr(sOwner))
    'convert string to ucs2 byte array and pass it to function
    bArray = tablename & vbNullChar
    bArray2 = owner & vbNullChar
    If table_readTableDefinition(m_cTableDef, bArray(0), bArray2(0)) > 0 Then
        MsgBox LoadResString(203), vbExclamation, LoadResString(202)
        Exit Function
    End If
    
    table_setMode m_cTableDef, AlterTable
    
    '--------------------------------------------------------------------------
    ' Search for a columnnames with lower letter
    ' check constraints just if value is false
    '--------------------------------------------------------------------------
    If lowerColumnNames(m_cTableDef) = False Then
        
        If lowerConstraintNames(m_cTableDef) = False Then
        
            ctlMiscDefinition.identifiersCaseSensitiv = lowerRefIntegrity(m_cTableDef)
        Else
            ctlMiscDefinition.identifiersCaseSensitiv = True
        End If
    Else
        ctlMiscDefinition.identifiersCaseSensitiv = True
    End If
    
        
    txtTablename.text = tablename
    txtTablename.Enabled = False
    ctlColumnDefinition.updateColumnDefinition
    ctlConstraintDefinition.updateConstraintDefinition
    ctlRefIntegrityDefinition.updateRefIntegrityDefinition
    ctlMiscDefinition.updateMiscDefinition
    
    table_setAlterType m_cTableDef, AlterNoChange
    
    tabTableProperties.Tab = 0
    tabTableProperties.TabEnabled(1) = True
    tabTableProperties.TabEnabled(2) = True
    
    '--------------------------------------------------------------------------
    ' Modify the menu items to reflect the ALTER TABLE case.
    '--------------------------------------------------------------------------
    mnuCreateTable.Caption = LoadResString(215)
    mnuSaveAs.Enabled = False
    mnuSaveDefinition.Enabled = False
    lblTemplate.Enabled = False
    lblTemplateLabel.Enabled = False
    ctlColumnDefinition.initializeAlterTable
    ctlConstraintDefinition.initializeAlterTable
    
    '--------------------------------------------------------------------------
    ' Make a copy of the original state of the table definition object for
    ' later comparing it with the changed object.
    '--------------------------------------------------------------------------
    m_cOldTableDef = table_copy(m_cTableDef)
    
    ctlColumnDefinition.oldTableDef = m_cOldTableDef
    ctlConstraintDefinition.oldTableDef = m_cOldTableDef
    ctlRefIntegrityDefinition.oldTableDef = m_cOldTableDef
    ctlMiscDefinition.oldTableDef = m_cOldTableDef
    
            
    'set read only after all columns are loaded
    setControlReadOnly m_bReadOnly
    
    table_resetDirty m_cTableDef
    
    Exit Function
    
errInitializeAlterTable:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      lowerColumnNames
'    description:   check if some columnnames are lower case
'
'    arguments:     [in] tabledef, handle for tabledef
'    return value:
'=========================================================================================
Private Function lowerColumnNames(tableDef As Long) As Boolean
    On Error GoTo errLowerColumnNames
    
    Const FUNCTION_NAME = "lowerColumnNames"
    
    Dim out(512)    As Byte
    Dim column      As Long
    Dim sColName    As String
    Dim i           As Integer
    Dim namelen     As Long
    
    'rc
    lowerColumnNames = False
    
    initByteArray out

    For i = 0 To table_columnCount(tableDef) - 1
    
        column = table_column(tableDef, i)
        namelen = column_name(column, out(0))
        sColName = Left(out, namelen)
        If sColName <> UCase(sColName) Then
            'rc
            lowerColumnNames = True
            'exit for
            Exit For
        End If
    Next
    
    Exit Function
    
errLowerColumnNames:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      lowerRefIntegrity
'    description:   check if some RefIntegrity are lower case
'
'    arguments:     [in] tabledef, handle for tabledef
'    return value:
'=========================================================================================
Private Function lowerRefIntegrity(tableDef As Long) As Boolean
    On Error GoTo errlowerRefIntegrity
    
    Const FUNCTION_NAME = "lowerRefIntegrity"
    
    Dim out(512)           As Byte
    Dim foreignkey         As Long
    Dim sRefIntegrity    As String
    Dim i                  As Integer
    Dim length             As Long
    
    'rc
    lowerRefIntegrity = False
    
    initByteArray out

    For i = 0 To table_foreignKeyCount(tableDef) - 1
    
        foreignkey = table_foreignKey(tableDef, i)
        length = foreignkey_name(foreignkey, out(0))
        sRefIntegrity = Left(out, length)
        If sRefIntegrity <> UCase(sRefIntegrity) And sRefIntegrity <> LoadResString(103) Then
            'rc
            lowerRefIntegrity = True
            'exit for
            Exit For
        End If
        
    Next
    
    Exit Function
    
errlowerRefIntegrity:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      lowerConstraintNames
'    description:   check if some constraintnames are lower case
'
'    arguments:     [in] tabledef, handle for tabledef
'    return value:
'=========================================================================================
Private Function lowerConstraintNames(tableDef As Long) As Boolean
    On Error GoTo errlowerConstraintNames
    
    Const FUNCTION_NAME = "lowerConstraintNames"
    
    Dim out(512)           As Byte
    Dim constr             As Long
    Dim cond               As Long
    Dim sConstraintName    As String
    Dim i                  As Integer
    Dim j                  As Integer
    Dim namelen            As Long
    
    'rc
    lowerConstraintNames = False
    
    initByteArray out

    For i = 0 To table_constraintCount(tableDef) - 1
        constr = table_constraint(tableDef, i)
        
        For j = 0 To constraint_conditionCount(constr) - 1
            cond = constraint_condition(constr, j)
    
            constr = table_constraint(tableDef, i)
            namelen = constraint_name(constr, out(0))
            sConstraintName = Left(out, namelen)
            If sConstraintName <> UCase(sConstraintName) And sConstraintName <> LoadResString(103) Then
                'rc
                lowerConstraintNames = True
                'exit for
                Exit For
            End If
        Next
    Next
    
    Exit Function
    
errlowerConstraintNames:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      LoadQueryDefinition
'    description:   Load the query definition of the query identiefied by the given key
'                   into the table definition object.
'    arguments:     [in] sKey   - key of the query definition to be loaded
'                   [in] sOwner - owner of the query definition to be loaded
'    return value:  -
'=========================================================================================
Private Function loadQueryDefinition(sKey As String, sOwner As String) As Boolean
    On Error GoTo errLoadQueryDefinition

    Const FUNCTION_NAME = "loadQueryDefinition"
        
    
    Dim s               As String
    Dim pos             As Integer
    Dim statement       As String
    Dim oResult         As New SQLStudioDBLayer.Result
    
    loadQueryDefinition = False
    
    
    Set oResult.connection = m_oConnection
    
    '--------------------------------------------------------------------------
    ' Load the stored statement from the database.
    '--------------------------------------------------------------------------
    s = "SELECT objdesc FROM SYSDBA.sysqp_my_objects " + _
        "WHERE  id = '" + sKey + "' AND owner = '" + sOwner + "'"
    
    If Not oResult.openResult(s, Internal) Then Exit Function
        
    If Not oResult.noRows Then
        If Not oResult.fetch() Then Exit Function
        If Not oResult.GetData() Then Exit Function
        statement = oResult.Columns(1).colValue
    End If

    pos = InStr(statement, m_oComFunc.getTokenSeperator(qplObjectLevel1))
    If pos < 1 Then Exit Function
    statement = Left(statement, pos - 1)
    
    If setFromSQL(statement) = False Then Exit Function
    
    'rc
    loadQueryDefinition = True
    
    
    Exit Function
    
errLoadQueryDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
    
'=========================================================================================
'    function:      setFromSQL
'    description:   Load the structure of the result of the given SQL statement into the
'                   table definition object.
'    arguments:     [in] statement - SQL statement for the result
'    return value:  Boolean
'=========================================================================================
Private Function setFromSQL(statement As String) As Boolean
    On Error GoTo errSetFromSQL

    Const FUNCTION_NAME = "setFromSQL"
    
    Dim i               As Integer
    Dim nColCount       As Integer
    Dim sColName        As String
    Dim nColNameLen     As Integer
    Dim sColType        As String
    Dim nColLength      As Long
    Dim nColDecimal     As Integer
    Dim bColNotNull     As Boolean
    
    Dim hStmt           As Long
    Dim rc              As Long
    Dim line            As String
    Dim col             As Long
    Dim lines           As New Collection
    Dim out(512)        As Byte
    Dim length          As Integer
    
    Dim oDBFunc            As New SQLStudioDBLayer.Functions
    Dim oBreakStatement    As New BreakStatement
    Dim bArray()           As Byte
    
    initByteArray out
    
    '--------------------------------------------------------------------------
    '   delete all columns
    '--------------------------------------------------------------------------
    table_reset m_cTableDef
    
    oBreakStatement.addComment "//"
    oBreakStatement.addComment "--"
    oBreakStatement.statement = statement
     
    m_sCreateAs = ""
    
    line = oBreakStatement.currentStatement
    If Len(line) > 0 Then
    
        If UCase(Left(line, 6)) <> "SELECT" Then
            MsgBox LoadResString(205), vbExclamation, LoadResString(204)
            Exit Function
        End If

        m_sCreateAs = Trim(line)
    End If
    
    '--------------------------------------------------------------------------
    ' Load the column description of the result of the query. This is done
    ' by preparing the SQL statement and requesting the column description
    ' after that.
    '--------------------------------------------------------------------------
    Set oDBFunc.connection = m_oConnection
    If Not oDBFunc.allocStmt(hStmt) Then Exit Function

    m_oConnection.Error.statement = m_sCreateAs
    If Not oDBFunc.prepareStmt(hStmt, m_sCreateAs, Internal) Then
        oDBFunc.freeStmt hStmt
        MsgBox LoadResString(207), vbExclamation, LoadResString(206)
        Exit Function
    End If

    nColCount = oDBFunc.numberOfCols(hStmt)
    If nColCount = -1 Then Exit Function
    
    sColName = Space$(MX_COLUMN_NAME)
    
    For i = 1 To nColCount
        col = table_addColumn(m_cTableDef)

        If oDBFunc.getColumnDescription(hStmt, i, sColName, nColNameLen, sColType, _
                                        nColLength, nColDecimal, bColNotNull) = False Then
            Exit Function
        End If

        If nColNameLen > 0 Then
            'column_setName col, StrPtr(Left(sColName, nColNameLen))
            bArray = Left(sColName, nColNameLen) & vbNullChar
            column_setName col, bArray(0)
        Else
            'column_setName col, StrPtr("")
            bArray = "" & vbNullChar
            column_setName col, bArray(0)
        End If
    
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'column_setDataType col, StrPtr(StrConv(sColType, vbProperCase))
        'convert string to ucs2 byte array and pass it to function
        bArray = StrConv(sColType, vbProperCase) & vbNullChar
        column_setDataType col, bArray(0)
        length = column_dataType(col, out(0))
        If Left(out, length) = "Long" Then
            MsgBox LoadResString(208), vbExclamation, LoadResString(206)
            table_reset m_cTableDef
            Exit Function
        End If
        
        If bColNotNull Then
            column_setNotNull col, SAPDB_TRUE
        Else
            column_setNotNull col, SAPDB_FALSE
        End If
        
        Select Case Left(out, length)
        Case "Char", "Varchar", "Float":
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setDimension col, StrPtr(CStr(nColLength))
            'convert string to ucs2 byte array and pass it to function
            bArray = CStr(nColLength) + vbNullChar
            column_setDimension col, bArray(0)
        Case "Fixed":
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setDimension col, StrPtr(CStr(nColLength) + "," + CStr(nColDecimal))
            'convert string to ucs2 byte array and pass it to function
            bArray = CStr(nColLength) + "," + CStr(nColDecimal) + vbNullChar
            column_setDimension col, bArray(0)
        End Select
    Next

    'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
    'table_setSampleUnit m_cTableDef, StrPtr("Rows")
    'convert string to ucs2 byte array and pass it to function
    bArray = "Rows" & vbNullChar
    table_setSampleUnit m_cTableDef, bArray(0)

    setFromSQL = True
    
    Exit Function
    
errSetFromSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      numberOfStatements
'    description:   Determine the number of SQL statements in the given string.
'    arguments:     [in] sSQL - SQL statement
'    return value:  Integer
'=========================================================================================
Private Function numberOfStatements(sSQL As String) As Integer
    On Error GoTo errNumberOfStatements

    Const FUNCTION_NAME = "NumberOfStatements"
        
    Dim iStart   As Integer
    Dim iEnd     As Integer
    
    numberOfStatements = 0
    
    iStart = 1
    iEnd = InStr(iStart, sSQL, "//")
    
    If sSQL = "" Then Exit Function
    
    numberOfStatements = 1
    
    If iEnd = 0 Then Exit Function
    
    While iEnd > 0
        numberOfStatements = numberOfStatements + 1
        iStart = iEnd + 2
        iEnd = InStr(iStart, sSQL, "//")
    Wend
    
    Exit Function
    
errNumberOfStatements:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      popupTableMenu
'    description:   Popup the table menu to offer the table specific commands. This
'                   routine is called, when the right mouse button is clicked inside
'                   the control.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Function popupTableMenu()
    On Error GoTo errPopupTableMenu

    Const FUNCTION_NAME = "popupTableMenu"
            
    checkMenus
    
    PopupMenu mnuTable, vbPopupMenuRightButton
    
    Exit Function
    
errPopupTableMenu:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      queryUnload
'    description:   Ask the user if he wants to save the current definition as a draft.
'    arguments:     [out] Cancel     - flag if user canceled the save action
'                   [in]  UnloadMode - unused
'    return value:  -
'=========================================================================================
Public Function queryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error GoTo ErrQueryUnload
    
    Const FUNCTION_NAME = "QueryUnload"
    
    Dim Answer  As Integer
    Dim dlg     As New GenericMsgBox
    
    If m_oGlobalInfo Is Nothing Then Exit Function
    
    If table_isDirty(m_cTableDef) And m_oGlobalInfo.UserProfile.confirmation = True Then
        If table_mode(m_cTableDef) = AlterTable Then
            dlg.Caption = LoadResString(218)
            dlg.Button(0) = LoadResString(244)
        Else
            dlg.Caption = LoadResString(213)
            dlg.Button(0) = LoadResString(242)
            dlg.Button(1) = LoadResString(239)
        End If
        dlg.text = LoadResString(243)
        dlg.Button(2) = LoadResString(240)
        dlg.Button(3) = LoadResString(241)
        dlg.defaultButton = 0
        dlg.escapeButton = 3
        
        Select Case dlg.Show(Me)
        Case 0:
            execute
            If m_bExecutionAborted = True Then
                Cancel = 1
                m_oGlobalInfo.disconnectCanceled = True
            End If
        Case 1:
            If saveTableDefObject(False, False) = SaveCanceled Then
                Cancel = 1
                m_oGlobalInfo.disconnectCanceled = True
            End If
        Case 2:
            Cancel = 0
        Case 3:
            Cancel = 1
            m_oGlobalInfo.disconnectCanceled = True
        End Select
    End If
    
    Exit Function
    
ErrQueryUnload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      resetDirty
'    description:   Reset the dirty flag of the table definition object.
'    arguments:     -
'    return value:  -
'=========================================================================================
Public Function resetDirty()
    On Error GoTo errResetDirty
    
    Const FUNCTION_NAME = "ResetDirty"
    
    table_resetDirty m_cTableDef
    
    Exit Function
    
errResetDirty:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      resizeControls
'    description:   Resize the single widgets according to the enclosing form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Function resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "resizeControls"
    
    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> UserControl.ScaleWidth Then
        fraFrame.Width = UserControl.ScaleWidth - 220
        txtTablename.Width = fraFrame.Width - 1450
        lblTemplate.Width = fraFrame.Width - 1450
        tabTableProperties.Width = UserControl.ScaleWidth - 220
        ctlColumnDefinition.Width = UserControl.ScaleWidth - 640
        ctlConstraintDefinition.Width = UserControl.ScaleWidth - 640
        ctlRefIntegrityDefinition.Width = UserControl.ScaleWidth - 640
        ctlMiscDefinition.Width = UserControl.ScaleWidth - 640
        m_lOldWidth = UserControl.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> UserControl.ScaleHeight Then
        tabTableProperties.Height = UserControl.ScaleHeight - 1450
        ctlColumnDefinition.Height = UserControl.ScaleHeight - 2300
        ctlConstraintDefinition.Height = UserControl.ScaleHeight - 2200
        ctlRefIntegrityDefinition.Height = UserControl.ScaleHeight - 2200
        ctlMiscDefinition.Height = UserControl.ScaleHeight - 2200
        m_lOldHeight = UserControl.ScaleHeight
    End If
    
    Exit Function
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      saveTableDefObject
'    description:   Save the current content of the table definition object as a draft in
'                   the database.
'    arguments:     [in] bConfirmation - flag if save action has to be confirmed
'                   [in] bSetCaption   - unused
'    return value:  fileSaveState
'=========================================================================================
Private Function saveTableDefObject(bConfirmation As Boolean, bSetCaption As Boolean) As fileSaveState
    On Error GoTo errSaveTableDefObject

    Const FUNCTION_NAME = "saveTableDefObject"
    
    Dim SaveState       As fileSaveState
    Dim oConnection     As SQLStudioDBLayer.connection
    Dim out(65536)      As Byte
    Dim length          As Integer
    
    saveTableDefObject = NotSave
    
    'just save if control is not read only
    If m_bReadOnly Then Exit Function

    initByteArray out
        
    m_oSFC.fileType = fileTypeDraftTable
    m_oSFC.storedIcon = cmStoredDraft
    
    'for a new object set actual app version
    m_oSFC.appVersion = m_lAppVersion
    m_oSFC.version = m_lAppVersion
    
    '--------------------------------------------------------------------------
    ' Request the table definition from the table definition object and store
    ' it in the storedFileContent object.
    '--------------------------------------------------------------------------
    length = table_genDescription(m_cTableDef, out(0))
    m_oSFC.tableData = Left(out, length)
    
    m_oSFC.sqlData = getSQLStatement()
    
    'bConfirmation is used to flag save as or save action
    If Len(m_oSFC.FileName) < 1 Then bConfirmation = True

    'raise event for saving
    RaiseEvent SaveMe(m_oSFC, bConfirmation)
    
    Exit Function
    
errSaveTableDefObject:
    If Err.number = 398 Then Resume Next
    m_oGlobalInfo.Hourglass.State = qpHourglassOff
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      ShowSQLStatement
'    description:   Show the resulting SQL statement in a separate window.
'    arguments:     [in] statement - SQL statement to be displayed
'    return value:  -
'=========================================================================================
Private Sub showSQLStatement(sStatement As String)
    On Error GoTo errShowSQLStatement

    Const FUNCTION_NAME = "showSQLStatement"
    
    Dim oSFC As New SQLStudioMan.storedFileContent
    
    oSFC.sqlData = sStatement
    'the saved object has to have actual version numbers
    oSFC.appVersion = m_lAppVersion
    oSFC.version = m_lAppVersion
    oSFC.storedIcon = cmStoredDSQL
    
    oSFC.FileName = ""
    
    RaiseEvent ShowSQLInDirectSQL(oSFC)

    Exit Sub

errShowSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      showImportWindow
'    description:   Show the window for selecting columns, constraints or foreign keys for
'                   importing them.
'    arguments:     [in] Mode - mode of the import dialog
'    return value:  -
'=========================================================================================
Private Function showImportWindow(mode As String)
    On Error GoTo errShowImportWindow

    Const FUNCTION_NAME = "showImportWindow"
        
    Dim NewForm    As New frmImportTableDefinition

    Set NewForm.globalInfo = m_oGlobalInfo
    Set NewForm.connection = m_oConnection
    Load NewForm
    
    Select Case mode
    Case "Columns":
        NewForm.Caption = LoadResString(209)
        NewForm.Width = 12000
    Case "Constraints":
        NewForm.Caption = LoadResString(210)
        NewForm.Width = 12000
    Case "ForeignKeys":
        NewForm.Caption = LoadResString(211)
        NewForm.Width = 12000
    End Select
    
    NewForm.tableDef = m_cTableDef
    
    If NewForm.importDefinitions(mode) = False Then
        Unload NewForm
        Exit Function
    End If
      
    NewForm.Show 1
    If NewForm.Visible Then NewForm.SetFocus
    
    m_bNoImport = NewForm.noAction
    
    Exit Function
    
errShowImportWindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      checkMenus
'    description:   enable all menus due to the actual conditions of the control
'    arguments:     /
'
'
'    return value: /
'
'=========================================================================================
Private Sub checkMenus()
    On Error GoTo errCheckMenus

    Const FUNCTION_NAME = "checkMenus"
    
    mnuCreateTable.Enabled = Not m_bReadOnly
    mnuSaveAs.Enabled = Not m_bReadOnly
    mnuSaveDefinition.Enabled = Not m_bReadOnly
    mnuShowSQL.Enabled = Not m_bReadOnly
    mnuTable.Enabled = Not m_bReadOnly
        
    Exit Sub
    
errCheckMenus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      setControlReadOnly
'    description:   enable or disable all input
'    arguments:     [in] bReadOnly, set input read only
'
'
'    return value: /
'
'=========================================================================================
Private Sub setControlReadOnly(bReadOnly As Boolean)
    On Error GoTo errSetControlReadOnly

    Const FUNCTION_NAME = "setControlReadOnly"
    
    ctlColumnDefinition.readOnly = bReadOnly
    ctlConstraintDefinition.readOnly = bReadOnly
    ctlMiscDefinition.readOnly = bReadOnly
    ctlRefIntegrityDefinition.readOnly = bReadOnly
        
    Exit Sub
    
errSetControlReadOnly:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      makeAllIdentifiersUpperCase
'    description:   make all identifiers like column names upper case
'    arguments:     [in] bReadOnly, set input read only
'
'
'    return value: /
'
'=========================================================================================
Private Sub makeAllIdentifiersUpperCase()
    On Error GoTo errMakeAllIdentifiersUpperCase

    Const FUNCTION_NAME = "makeAllIdentifiersUpperCase"
    
    txtTablename = UCase(txtTablename)
    ctlColumnDefinition.makeColumnNamesUpperCase
    ctlConstraintDefinition.makeConstraintNamesUpperCase
    ctlRefIntegrityDefinition.makeReferenceUpperCase
        
    Exit Sub
    
errMakeAllIdentifiersUpperCase:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
