VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TableObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      TableObject
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "TableObject"

'local property copies
Private m_lWnd      As Long
Private m_emFormat     As DBObjectType
Private m_sTableName  As String

'structure tableinfo
'
'  Chr$ (34) + sOwner + Chr$(34) +
'  m_oComFunc.GetTokenSeperator(qplObjectLevel5) + _
'  Chr$(34) + sName + Chr$(34) + _
'   m_oComFunc.GetTokenSeperator(qplObjectLevel5) + _
'  Trim$(Str$(ItemType)), _
'  DBOTable


Public Property Let hWnd(NewhWnd As Long)
    On Error GoTo errP_Let_hWnd

    Const FUNCTION_NAME = "P_LET hWnd"
    
    m_lWnd = NewhWnd
    
    Exit Property
    
errP_Let_hWnd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get hWnd() As Long
    On Error GoTo errP_Get_hWnd

    Const FUNCTION_NAME = "P_Get hWnd"
    
    hWnd = m_lWnd
    
    Exit Property
    
errP_Get_hWnd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let format(NewFormat As DBObjectType)
    On Error GoTo errP_Let_Format

    Const FUNCTION_NAME = "P_LET Format"
    
    m_emFormat = NewFormat
    
    Exit Property
    
errP_Let_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get format() As DBObjectType
    On Error GoTo errP_Get_Format

    Const FUNCTION_NAME = "P_Get format"
    
    format = m_emFormat
    
    Exit Property
    
errP_Get_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let objectName(NewTableName As String)
    On Error GoTo errP_Let_ObjectName

    Const FUNCTION_NAME = "P_Let objectName"
    
    m_sTableName = NewTableName
    
    Exit Property
    
errP_Let_ObjectName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get objectName() As String
    On Error GoTo errP_Get_ObjectName

    Const FUNCTION_NAME = "P_GET ObjectName"
    
    objectName = m_sTableName
    
    Exit Property
    
errP_Get_ObjectName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property



