VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmCommandHistory 
   Caption         =   "Command History"
   ClientHeight    =   4305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7290
   Icon            =   "CommandHistory.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4305
   ScaleWidth      =   7290
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lstCommands 
      Height          =   2925
      Left            =   210
      TabIndex        =   2
      Top             =   165
      Width           =   6825
      _ExtentX        =   12039
      _ExtentY        =   5159
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   1
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Command"
         Object.Width           =   17639
      EndProperty
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   5790
      TabIndex        =   1
      Top             =   3750
      Width           =   1305
   End
   Begin VB.CommandButton cmdGet 
      Caption         =   "&Get"
      Height          =   375
      Left            =   4395
      TabIndex        =   0
      Top             =   3750
      Width           =   1305
   End
End
Attribute VB_Name = "frmCommandHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'//////////////////////////////////////////////////////////////////
'
' Module:      frmCommandHistory
'
'
'-----------------------------------------------------------------------
'
' responsible: WolfgangA
'
' special area: SQLStudio
'
' description:  Dialog for command history
'
'//////////////////////////////////////////////////////////////////

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmCommandHistory"

Private pImport         As String

'buffer for statements
Private m_sStatements()         As String

'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "resizeControls"
    
    If Me.ScaleHeight > 2 * cmdCancel.Height And Me.ScaleWidth > 2 * cmdCancel.Width Then
    
    
        cmdCancel.Move Me.ScaleWidth - cmdCancel.Width - 10, _
                       Me.ScaleHeight - cmdCancel.Height - 10
                       
        cmdGet.Move cmdCancel.Left - 5 * cmdGet.Width / 4, _
                    cmdCancel.Top
                    
        lstCommands.Move 10, 10, Me.ScaleWidth - 10, Me.ScaleHeight - 5 * cmdCancel.Height / 4
        
        If lstCommands.ColumnHeaders.Count > 0 Then
        
            lstCommands.ColumnHeaders.Item(1).Width = lstCommands.Width
        End If
    End If
    
    Exit Sub
    
errResizeControls:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    pImport = ""
    
    Unload Me
    
    Exit Sub
    
errCmdCancel_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyUp
'    description:   Occurs when the user releases (KeyUp) a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errCmdCancel_KeyUp
   
    Const FUNCTION_NAME = "cmdCancel_KeyUp"
    
    If KeyCode = vbKeyEscape Then cmdCancel_Click
    
    Exit Sub
    
errCmdCancel_KeyUp:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdGet_Click()
    On Error GoTo errCmdGet_Click

    Const FUNCTION_NAME = "cmdGet_Click"
    
    Dim lKey As Long
    Dim sKey As String
     
     If Not lstCommands.SelectedItem Is Nothing Then
    
        sKey = lstCommands.SelectedItem.Key
        'remove K from Key
        lKey = CLng(Right(sKey, Len(sKey) - 1))
        pImport = m_sStatements(lKey)
        Unload Me
    End If
    
    Exit Sub
    
errCmdGet_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyUp
'    description:   Occurs when the user releases (KeyUp) a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdGet_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errCmdGet_KeyUp
   
    Const FUNCTION_NAME = "cmdGet_KeyUp"
    
    If KeyCode = vbKeyEscape Then cmdCancel_Click
    
    Exit Sub
    
errCmdGet_KeyUp:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyUp
'    description:   Occurs when the user releases (KeyUp) a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
   On Error GoTo errForm_KeyUp
   
    Const FUNCTION_NAME = "Form_KeyUp"
    
    If KeyCode = vbKeyEscape Then cmdCancel_Click
    
    Exit Sub
    
errForm_KeyUp:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"
    
    resizeControls
    
    Exit Sub
    
errForm_Resize:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Property Get import() As String
    On Error GoTo errP_Get_Import

    Const FUNCTION_NAME = "P_Get_Import"
    
    import = pImport
    
    Exit Property
    
errP_Get_Import:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
'================================================================
'set the History object
'================================================================
Public Property Set commands(clsCommands As SQLStudioUtil.History)
    On Error GoTo errP_SET_Commands

    Const FUNCTION_NAME = "P_SET_Commands"
    
    Dim lPos       As Long
    Dim lMax       As Long
    Dim lRun       As Long
    Dim sCommand   As String
    
    
    lMax = 100
    
    ReDim m_sStatements(clsCommands.Count)
    
    
    For lRun = 1 To clsCommands.Count
    
        sCommand = clsCommands.GetNext
        
        m_sStatements(lRun) = sCommand
        '==============================================
        'cut the string to the first cr or lf or pos 16
        '==============================================
        lPos = InStr(sCommand, vbCr)
        If lPos > 0 Then
        
            If lPos > lMax Then lPos = lMax
            sCommand = Left(sCommand, lPos - 1)
            sCommand = sCommand + "..."
        Else
            lPos = InStr(sCommand, vbLf)
            If lPos > 0 Then
        
                If lPos > lMax Then lPos = lMax
                sCommand = Left(sCommand, lPos - 1)
                sCommand = sCommand + " ..."
            Else
            
                sCommand = Left(sCommand, lMax)
                sCommand = sCommand + " ..."
            End If
        End If
        
        'Add K for a valid Key String
        lstCommands.ListItems.Add , "K" + CStr(lRun), sCommand
    Next
    
    Exit Property
    
errP_SET_Commands:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub lstCommands_DblClick()
    On Error GoTo errLstCommands_DblClick

    Const FUNCTION_NAME = "lstCommands_DblClick"

'    If Not lstCommands.SelectedItem Is Nothing Then
'
'        pImport = lstCommands.SelectedItem.Text
'        Unload Me
'    End If
    
    cmdGet_Click
    
    Exit Sub
    
errLstCommands_DblClick:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lstCommands_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    On Error GoTo errLstCommands_ColumnClick

    Const FUNCTION_NAME = "lstCommands_ColumnClick"

    If Not lstCommands.SelectedItem Is Nothing Then
    
        pImport = lstCommands.SelectedItem.Text
    End If
    
    Exit Sub
    
errLstCommands_ColumnClick:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyUp
'    description:   Occurs when the user releases (KeyUp) a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub lstCommands_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errLstCommands_KeyUp
   
    Const FUNCTION_NAME = "lstCommands_KeyUp"
    
    If KeyCode = vbKeyEscape Then cmdCancel_Click
    
    Exit Sub
    
errLstCommands_KeyUp:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
