VERSION 5.00
Begin VB.Form frmPredicateLike 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Like Predicate"
   ClientHeight    =   2745
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4665
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "PredicateLike.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2745
   ScaleWidth      =   4665
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   150
      Width           =   1200
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   570
      Width           =   1200
   End
   Begin VB.Frame fraPredicate 
      Caption         =   "Like Predicate"
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   3150
      Begin VB.CheckBox chkSounds 
         Caption         =   "Sounds"
         Height          =   225
         Left            =   90
         TabIndex        =   1
         Top             =   270
         Width           =   1305
      End
      Begin VB.CheckBox chkEscape 
         Caption         =   "Escape"
         Height          =   225
         Left            =   90
         TabIndex        =   3
         Top             =   1350
         Width           =   2955
      End
      Begin VB.TextBox txtEscapeExpression 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   90
         TabIndex        =   4
         Top             =   1965
         Width           =   2955
      End
      Begin VB.TextBox txtLikeExpression 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   90
         TabIndex        =   2
         Top             =   870
         Width           =   2955
      End
      Begin VB.Label lblEscapeExpression 
         Caption         =   "Escape Expression"
         Height          =   255
         Left            =   90
         TabIndex        =   8
         Top             =   1680
         Width           =   3000
      End
      Begin VB.Label lblLikeExpression 
         Caption         =   "Like Expression"
         Height          =   255
         Left            =   90
         TabIndex        =   7
         Top             =   600
         Width           =   3000
      End
   End
End
Attribute VB_Name = "frmPredicateLike"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmPredicateLike - Form for Like Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmPredicateLike"
 
'local copy of properties
Dim m_oPredicateLike          As SQLStudioMan.predicateLike
Dim m_oColDef       As SQLStudioDBLayer.Column

'local variables
Dim m_oPredicateLikeCopy      As New SQLStudioMan.predicateLike
Private Sub copyPredicate(DestPredicate As SQLStudioMan.predicateLike, SrcPredicate As SQLStudioMan.predicateLike)
    On Error GoTo errCopyPredicate

    Const FUNCTION_NAME = "copyPredicate"
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.IsNot = SrcPredicate.IsNot
    DestPredicate.SoundsLike = SrcPredicate.SoundsLike
    DestPredicate.LikeValue = SrcPredicate.LikeValue
    DestPredicate.Escape = SrcPredicate.Escape
    DestPredicate.EscapeValue = SrcPredicate.EscapeValue
    
    Exit Sub
    
errCopyPredicate:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Property Set predicateLike(NewPredicateLike As SQLStudioMan.predicateLike)
    On Error GoTo errP_SET_PredicateLike

    Const FUNCTION_NAME = "P_SET PredicateLike"
    
    If NewPredicateLike Is Nothing Then Exit Property
    
    Set m_oPredicateLike = NewPredicateLike
    
    '  Copy predicate
    copyPredicate m_oPredicateLikeCopy, NewPredicateLike
    
    If m_oPredicateLike.Escape Then
        chkEscape.Value = 1
    Else
        chkEscape.Value = 0
    End If
    
    If m_oPredicateLike.SoundsLike Then
        chkSounds.Value = 1
    Else
        chkSounds.Value = 0
    End If
    
    txtEscapeExpression.Text = m_oPredicateLike.EscapeValue
    txtLikeExpression.Text = m_oPredicateLike.LikeValue
    
    Exit Property
    
errP_SET_PredicateLike:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    Set m_oPredicateLike.columnDefinition = NewColumnDefinition
    
    Exit Property
    
errP_SET_ColumnDefinition:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateLike() As SQLStudioMan.predicateLike
    On Error GoTo errP_Get_PredicateLike

    Const FUNCTION_NAME = "P_Get predicateLike"
    
    Set predicateLike = m_oPredicateLike
    
    Exit Property
    
errP_Get_PredicateLike:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub chkEscape_Click()
    On Error GoTo errChkEscape_Click
    
    Const FUNCTION_NAME = "chkEscape_Click"
    
    'set use predicate flag
    Select Case chkEscape.Value
        Case 0:
            m_oPredicateLike.Escape = False
             If Len(txtLikeExpression.Text) < 1 Then
                cmdOk.Enabled = False
             Else
                cmdOk.Enabled = True
             End If
        Case 1:
            m_oPredicateLike.Escape = True
            If Len(txtEscapeExpression.Text) < 1 Then
                cmdOk.Enabled = False
            End If
    End Select
    
    Exit Sub
    
errChkEscape_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkSounds_Click()
    On Error GoTo errChkSounds_Click
    
    Const FUNCTION_NAME = "chkSounds_Click"
    
    'set sounds flag
    Select Case chkSounds.Value
        Case 0:
            m_oPredicateLike.SoundsLike = False
        Case 1:
            m_oPredicateLike.SoundsLike = True
    End Select
    
    Exit Sub
    
errChkSounds_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    'set old predicate values
    copyPredicate m_oPredicateLike, m_oPredicateLikeCopy
    
    Err.Number = cdlCancel
    
    '  Unload form
    Unload Me
    
    Exit Sub
    
errCmdCancel_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
    
    If Len(txtLikeExpression.Text) < 1 Then
        cmdOk.Enabled = False
        txtLikeExpression.SetFocus
        Exit Sub
    End If
    
    
    '  Unload form
    Unload Me
    
    Err.Number = 0
    
    Exit Sub
    
errCmdOk_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub



Private Sub txtEscapeExpression_Change()
    On Error GoTo errTxtEscapeExpression_Change

    Const FUNCTION_NAME = "txtEscapeExpression_Change"
    
    m_oPredicateLike.EscapeValue = txtEscapeExpression.Text
        
    If (Len(txtEscapeExpression.Text) > 0 And Len(txtLikeExpression.Text) > 0) Or (m_oPredicateLike.Escape = False) Then
        cmdOk.Enabled = True
    Else
        cmdOk.Enabled = False
    End If
    
    Exit Sub
    
errTxtEscapeExpression_Change:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtLikeExpression_Change()
    On Error GoTo errTxtLikeExpression_Change

    Const FUNCTION_NAME = "txtLikeExpression_Change"
    
    m_oPredicateLike.LikeValue = txtLikeExpression.Text
    
    If Len(txtLikeExpression.Text) < 1 Then
       cmdOk.Enabled = False
    Else
       cmdOk.Enabled = True
    End If
    
    Exit Sub
    
errTxtLikeExpression_Change:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"

    Err.Number = cdlCancel
    
    Exit Sub
    
errForm_Unload:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

