VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "Richtx32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.UserControl Zoom 
   ClientHeight    =   4680
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5640
   ScaleHeight     =   4680
   ScaleWidth      =   5640
   ToolboxBitmap   =   "Zoom.ctx":0000
   Begin MSComctlLib.ProgressBar gauHex 
      Height          =   325
      Left            =   60
      TabIndex        =   5
      Top             =   3945
      Width           =   2280
      _ExtentX        =   4022
      _ExtentY        =   582
      _Version        =   393216
      Appearance      =   1
   End
   Begin RichTextLib.RichTextBox txtZoomValue 
      Height          =   2055
      Left            =   0
      TabIndex        =   4
      Top             =   0
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   3625
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      OLEDragMode     =   0
      OLEDropMode     =   0
      TextRTF         =   $"Zoom.ctx":0312
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin RichTextLib.RichTextBox txtZoomValueHex 
      Height          =   1815
      Left            =   0
      TabIndex        =   3
      Top             =   2040
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   3201
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      OLEDragMode     =   0
      OLEDropMode     =   0
      TextRTF         =   $"Zoom.ctx":03EC
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   325
      Left            =   2535
      TabIndex        =   1
      Top             =   4155
      Visible         =   0   'False
      Width           =   1260
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   325
      Left            =   4290
      TabIndex        =   0
      Top             =   4185
      Width           =   1260
   End
   Begin VB.Label lblOffset 
      Caption         =   "Offset: 0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   255
      TabIndex        =   2
      Top             =   4365
      Visible         =   0   'False
      Width           =   2115
   End
   Begin VB.Menu mnuZoom 
      Caption         =   "&Zoom"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuZoomCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuZoomHex 
         Caption         =   "&Hex"
      End
   End
End
Attribute VB_Name = "Zoom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  ActiveX:    Zoom Control
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


Const MODULE_NAME = "Zoom"

Event CloseMe()

'  Private copy of properties
Private m_bCancel         As Boolean
Private m_bValid          As Boolean

Private m_sZoomValue      As String

Public Property Let zoomText(ByRef NewZoomText As String)
    On Error GoTo errP_LET_ZoomText

    Const FUNCTION_NAME = "P_LET ZoomText"
    
    m_sZoomValue = NewZoomText
    
    'set text controls
    txtZoomValue.TextRTF = getRTFDefaultLanguage
    
    txtZoomValue.Text = m_sZoomValue
    
    If Len(m_sZoomValue) < 1 Then
    
        mnuZoomHex.Enabled = False
    Else
        mnuZoomHex.Enabled = True
    End If
        
    Exit Property
    
errP_LET_ZoomText:
    If Err.Number = 7 And Val(Left(m_sZoomValue, 1)) = 0 Then
    
	'mnuZoomHex_Click
    Else
        internalError Err, MODULE_NAME, FUNCTION_NAME
    End If
End Property
Public Property Get zoomText() As String
    On Error GoTo errP_Get_ZoomText

    Const FUNCTION_NAME = "P_Get zoomText"
    
    zoomText = txtZoomValue.Text
    
    Exit Property
    
errP_Get_ZoomText:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get zoomTextHex() As String
    On Error GoTo errP_Get_ZoomTextHex

    Const FUNCTION_NAME = "P_Get zoomTextHex"
    
    zoomTextHex = txtZoomValueHex.Text
    
    Exit Property
    
errP_Get_ZoomTextHex:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    m_bCancel = True
    
    Exit Sub
    
errCmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdClose_Click()
    On Error GoTo errCmdClose_Click

    Const FUNCTION_NAME = "cmdClose_Click"
    
    txtZoomValue.Text = ""
    txtZoomValueHex.Text = ""
    
    m_bValid = False
    
    RaiseEvent CloseMe
    
    Exit Sub
    
errCmdClose_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuZoomCopy_Click()
    On Error GoTo errMnuZoomCopy_Click

    Const FUNCTION_NAME = "mnuZoomCopy_Click"
    
    If ActiveControl.Name <> "txtZoomValueHex" Or ActiveControl.Name <> "txtZoomValue" Then Exit Sub
    
    'copy into clipboard
    Clipboard.clear
    If Len(ActiveControl.SelText) < 1 Then
    
        Clipboard.SetText ActiveControl.Text
    Else
        Clipboard.SetText ActiveControl.SelText
    End If
    
    Exit Sub
    
errMnuZoomCopy_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuZoomHex_Click()
    On Error GoTo errMnuZoomHex_Click

    Const FUNCTION_NAME = "mnuZoomHex_Click"
           
    txtZoomValueHex.TextRTF = getRTFDefaultLanguage
    
    mnuZoomHex.Checked = Not mnuZoomHex.Checked
    If (mnuZoomHex.Checked) Then
    
        'convert text in hex text
        txtZoomValueHex.Text = ascToHex(m_sZoomValue)
    Else
        txtZoomValueHex.Text = ""
        'init m_bCancel again for loop
        m_bCancel = False
    End If
    
    'show hex textbox
    resizeControls
    
    Exit Sub
    
errMnuZoomHex_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtZoomValue_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errTxtSQL_MouseUp
    
    Const FUNCTION_NAME = "ctrRichTextSQL_MouseUp"
    
    'hich button is pressed
    Select Case Button
        'right button is pressed
        Case vbRightButton:
            'popup VisualQuery menu
            PopupMenu mnuZoom
       Case vbLeftButton
          zoomValueSelChange
    End Select
    
    Exit Sub
    
errTxtSQL_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub txtZoomValue_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errTxtZoomValue_KeyUp
    
    Const FUNCTION_NAME = "txtZoomValue_KeyUp"
      
    If KeyCode = vbKeyLeft Or _
       KeyCode = vbKeyRight Or _
       KeyCode = vbKeyUp Or _
       KeyCode = vbKeyDown Or _
       KeyCode = vbKeyEnd Or _
       KeyCode = vbKeyBack Or _
       KeyCode = vbKeyHome _
    Then zoomValueSelChange
    
    Exit Sub
    
errTxtZoomValue_KeyUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function zoomValueSelChange()
    On Error GoTo ErrZoomValueSelChange

    Const FUNCTION_NAME = "ZoomValueSelChange"

    If m_bValid = False Then Exit Function


    If ActiveControl.hWnd = txtZoomValue.hWnd Then

        If txtZoomValueHex.Visible Then
        
            If Len(txtZoomValueHex.Text) >= txtZoomValue.SelStart * 3 Then
            
                txtZoomValueHex.SelStart = txtZoomValue.SelStart * 3
                txtZoomValueHex.SelLength = 2
                txtZoomValueHex.refresh
                txtZoomValueHex.SetFocus
            End If
       End If
    End If

    lblOffset.Caption = LoadResString(99) + LoadResString(97) + " " + Trim$(Str$(txtZoomValue.SelStart))

    Exit Function

ErrZoomValueSelChange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub txtZoomValueHex_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errTxtZoomValueHex_KeyUp
    
    Const FUNCTION_NAME = "txtZoomValueHex_KeyUp"
      
     If KeyCode = vbKeyLeft Or _
       KeyCode = vbKeyRight Or _
       KeyCode = vbKeyUp Or _
       KeyCode = vbKeyDown Or _
       KeyCode = vbKeyEnd Or _
       KeyCode = vbKeyBack Or _
       KeyCode = vbKeyHome _
    Then zoomValueHexSelChange
    
    Exit Sub
    
errTxtZoomValueHex_KeyUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtZoomValueHex_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errTxtZoomValueHex_MouseUp
    
    Const FUNCTION_NAME = "txtZoomValueHex_MouseUp"
    
    '  Which button is pressed
    Select Case Button
        '  Right button is pressed
        Case vbRightButton:
            '  Popup VisualQuery menu
            PopupMenu mnuZoom
        Case vbLeftButton
          zoomValueHexSelChange
    End Select
    
    Exit Sub
    
errTxtZoomValueHex_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Function zoomValueHexSelChange()
    On Error GoTo ErrZoomValueHexSelChange

    Const FUNCTION_NAME = "ZoomValueHexSelChange"
    
    If m_bValid = False Then Exit Function
    
    If ActiveControl.hWnd = txtZoomValueHex.hWnd Then
    
        If txtZoomValue.Visible Then
            
            If Len(txtZoomValue.Text) >= txtZoomValueHex.SelStart * 3 Then
            
                txtZoomValue.SelStart = txtZoomValueHex.SelStart \ 3
                txtZoomValue.SelLength = 1
                txtZoomValue.refresh
            End If
        End If
    End If
    
    lblOffset.Caption = LoadResString(99) + LoadResString(97) + " " + Trim$(Str$(txtZoomValueHex.SelStart) \ 3)
       
    
    Exit Function
    
ErrZoomValueHexSelChange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub UserControl_Hide()
    On Error GoTo errUserControl_Hide
    
    Const FUNCTION_NAME = "UserControl_Hide"
    
    m_bValid = False
    
    Exit Sub
    
errUserControl_Hide:
End Sub
Private Sub UserControl_Initialize()
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    m_bCancel = False
    
    gauHex.Visible = False
    cmdCancel.Visible = False
    lblOffset.Visible = True
    
    m_bValid = True
    
    Exit Sub
    
errUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    'horizontal adjustment
    If UserControl.ScaleWidth > 4 * cmdClose.Width Then
    
        txtZoomValue.Width = UserControl.ScaleWidth
        txtZoomValueHex.Width = UserControl.ScaleWidth
        cmdClose.Left = UserControl.ScaleWidth - 100 * cmdClose.Width \ 99
        
        cmdCancel.Left = cmdClose.Left - 6 * cmdCancel.Width \ 5
        gauHex.Left = 10
        gauHex.Width = cmdCancel.Left - cmdCancel.Width \ 5
        
        lblOffset.Left = 10
        lblOffset.Width = cmdClose.Left - cmdClose.Width \ 5
    End If

    'vertical adjustment
    If UserControl.ScaleHeight > 3 * cmdClose.Height Then
    
        
        If mnuZoomHex.Checked Then
            txtZoomValue.Top = 0
            txtZoomValue.Height = (UserControl.ScaleHeight \ 2) - 60 - 5 * cmdClose.Height \ 4
            
            txtZoomValueHex.Visible = True
            txtZoomValueHex.Top = txtZoomValue.Height + 60
            txtZoomValueHex.Height = UserControl.ScaleHeight - txtZoomValueHex.Top - 5 * cmdClose.Height \ 4
        Else
            txtZoomValue.Height = UserControl.ScaleHeight - 5 * cmdClose.Height \ 4
            txtZoomValueHex.Visible = False
        End If
        
        cmdClose.Top = UserControl.ScaleHeight - cmdClose.Height
        gauHex.Top = UserControl.ScaleHeight - 10 * cmdClose.Height \ 9
        cmdCancel.Top = UserControl.ScaleHeight - cmdClose.Height
        lblOffset.Top = UserControl.ScaleHeight - cmdClose.Height
    End If
    
    
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function ascToHex(ByRef AscStr As String) As String
    On Error GoTo errAscToHex

    Const FUNCTION_NAME = "AscToHex"
    
    
    Dim lRun        As Long
    Dim lLen        As Long
    Dim NewAscStr   As String
    Dim Conv        As ConvertData
        
    'some security
    If Not UserControl.Parent Is Nothing Then _
       UserControl.Parent.MousePointer = vbArrowHourglass
    cmdClose.Enabled = False
    
    Conv.iSegmentSize = SEGMENT_SIZE
    Conv.iCurrentPos = 0
    Conv.iLength = Len(AscStr)
    Conv.sInString = AscStr
    Conv.sOutString = String(3 * SEGMENT_SIZE, vbNullChar)
    
    gauHex.Max = Len(AscStr)
    gauHex.Value = 0
    gauHex.Min = 0
    
    gauHex.Visible = True
    cmdCancel.Visible = True
    lblOffset.Visible = False
    
    lRun = asciiToHexSegmented(Conv)

    Do While lRun > 0

        'add the converted string
        NewAscStr = NewAscStr + Left$(Conv.sOutString, lRun * 3)

        gauHex.Value = gauHex.Value + lRun
        lRun = asciiToHexSegmented(Conv)

        DoEvents

        'Check if the Cancel button was pressed by the user
        If m_bCancel = True Then
            lRun = -1 'set variable > lLen because usercontrol may not terminate
            Exit Do
        End If
    Loop
    
    gauHex.Visible = False
    cmdCancel.Visible = False
    lblOffset.Visible = True
    
    ascToHex = NewAscStr
    
    If Not UserControl.Parent Is Nothing Then _
       UserControl.Parent.MousePointer = vbArrow
    cmdClose.Enabled = True
    
    Exit Function
    
errAscToHex:
    If Not UserControl.Parent Is Nothing Then _
       UserControl.Parent.MousePointer = vbArrow
    cmdClose.Enabled = True
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub UserControl_Terminate()
    On Error GoTo errUserControl_Terminate
    
    Const FUNCTION_NAME = "UserControl_Terminate"
    
    'set value before because txtZoomValue.Text = "" triggers selchange
    m_bValid = False
    
    txtZoomValue.Text = ""
    txtZoomValueHex.Text = ""
    
    Exit Sub
    
errUserControl_Terminate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      getRTFDefaultLanguage
'    description:   Get the format string for a rtf text box in the current languag settings
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Private Function getRTFDefaultLanguage() As String
    On Error GoTo errGetRTFDefaultLanguage

    Const FUNCTION_NAME = "getRTFDefaultLanguage"
    
    Dim nLang           As Integer
    Dim bLang           As Byte
    Dim nParam          As Long
    Dim lpvParam        As Long
    Dim nRet            As Long
    Dim sFormat         As String
    Dim sX              As String
    Dim sY              As String
    
    Dim lMainLang       As Long
    Dim lSubLang        As Long
               
    'Standard Language Setzen
    sX = "{\rtf1\ansi\ansicpg1252\deff0\deftab{\fonttbl}\deflang"
    sY = "{\*\fchars }\pard\plain\f2\fs17\par }"
        
    nRet = SystemParametersInfoA(SPI_GETDEFAULTINPUTLANG, nParam, lpvParam, 0)
    If nRet Then
        nLang = m_oComFunc.loWord(lpvParam)
        bLang = m_oComFunc.loByte(nLang)
        
        sFormat = sX + Trim$(Str$(nLang)) + sY
        getRTFDefaultLanguage = sFormat
    End If
    
    Exit Function

errGetRTFDefaultLanguage:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

