VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Values"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oRegistry As registry

Private oItems As New Collection
'
' Properties
'
Friend Property Get registry() As registry
    Set registry = oRegistry
End Property
Friend Property Set registry(ByVal newVal As registry)
    Set oRegistry = newVal
End Property

Public Property Get count() As Integer
    count = oItems.count
End Property

Public Property Get item(ByVal Index As Variant) As Value
Attribute item.VB_UserMemId = 0
    Set item = oItems(Index)
End Property

Public Property Get newEnum()
Attribute newEnum.VB_UserMemId = -4
Attribute newEnum.VB_MemberFlags = "40"
    Set newEnum = oItems.[_NewEnum]
End Property
'
' Methods
'
Public Function add(ByVal name As String, _
                    Optional ByVal Value As Variant, _
                    Optional ByVal ValueType As RegistryTypeConstants) As Value
               
    Dim oItem As New Value
               
    With oItem
        Set .registry = oRegistry
        .name = name
        .Value = Value
        .ValueType = ValueType
    End With
               
    oItems.add oItem, name
    
    Set add = oItem
End Function

Public Function remove(ByVal Index As Variant)
    oItems.remove Index
End Function

Public Function exists(ByVal Index As Variant) As Boolean
    Dim oItem As Value
    On Error Resume Next
    Set oItem = oItems.item(Index)
    exists = (Err.Number = 0)
End Function

Public Function clear()
    Dim i As Integer
    For i = 1 To oItems.count
        oItems.remove 1
    Next
End Function

Public Function rename(ByVal Index As Variant, ByVal name As String)
    Dim oValue As Value
        
    Set oValue = oItems(Index)
    
    oItems.remove Index
    
    oValue.name = name
    
    oItems.add oValue, name
End Function



